 /******************************************************************************
APPLICATION: HomeTvApp.js
OWNER:
DESCRIPTION:	Questa applicazione permette all'utente di:
							-) effettuare la normale navigazione delle sezioni
							-) seguire in background un canale e fare zapping
							-) aprire/chiudere la guida tv e lo zapperone
							-) aprire/chiudere la short epg del canale associato
							-) aprire/chiudere la short epg del setting della lingua
								e dei sottotitoli 

FEATURES: Gestione unificata delle applicazioni di MenuApp, TvfullScreen
					TvfullScreenSky, Zapperone.

POSSIBILI POSIZIONI DEL FOCUS: valori possibili della variabile activity
															- fullScreen 	: full screen - deve stare al primo screen di modo che 
		allo spegnimento viene scorllato di default e facilmente
															- menu 				: menu bar in alpha blending sul fullScreen
															- menuSecond		:	menu di secondo livello
															- epgGrid 			: griglia di programmazione dei canali con barra dei canali in alpha blending 
															- zapper				:	griglia dei canali senza programmazione	
															- sepg					:	barra di descirizone del programma
															- setting 			:	barra per impostare sottotitoli e lingua del flusso

******************************************************************************/
//Eredito i metodi della BaseApp.js
HomeTvApp.prototype=top.getFramework().createBaseApp();
/*****************************************************
FUNCTION: 		HomeTvApp
PARAMETRI: 		nessuno
DESCRIPTION:  costruttore dell'oggetto che definisce le
							costanti dell'applicazione
*****************************************************/
function HomeTvApp(){
	this.firstLevelSize = 8;  //dichiaro la dimensione massima degli elementi del menu di primo livello
	this.secondLevelSize = 7; //dichiaro la dimensione massima degli elementi del menu di secondo livello
	this.zapperGridSize = 8; //dichiaro la dimensione massima degli elementi dello zapper
// 	this.zapperGridSizeVod = 8; //dichiaro la dimensione massima degli elementi dello zapperVod

	this.vSize = 576; //dichiaro la dimensione del layout html di riferimento (servir� per lo scroll del frame che
			  // contiene i layout)
	this.fullScreen = 1; //posizione rispetto al frame del layout di fullScreen
	this.zapper = 3;//posizione rispetto al frame del layout di zapper
	this.sepg = 2;//posizione rispetto al frame del layout di sepg
	this.menu = 0;//posizione rispetto al frame del layout di menu
	this.navigationMenu = 4;
	this.messaggioScansione = 5;
	
	this.cssSrcSepg = './sepg.css'; //percorso nel nuovo CSS per le scritte
	this.cssPush = './push.css';
	
	this.startStringaUscitaTag = '<span class="descrizione">'; //descrizione 

	this.xMenuPos = 0; // 0 --> a sx (0, 1, 2, 3, 4, 5)
	// 0 --> tv
	// 8 --> opzioni
	// gli altrisono tutti spenti

	this.startTitoloTag = '<span class="titolo">'; //titolo
	this.startStringaUscitaTag = '<span align="center"  class="descrizione">'; //descrizione 
	this.startStringaUscitaTagAlignLeft = '<span align="left"  class="descrizione">'; //descrizione 
	this.startOraTag = '<span class="orario">'; //orario sepg
	this.zappingIdTag = '<span align="right" class="labelCortesia">';
	this.zappingIdTagAlignLeft = '<span align="left" class="labelCortesia">';
	this.endTag = '</span>';// fine style orari sepg

	this.leftPanel ="sx";
	this.rightPanel ="dx";
	this.navigationMenuPanel = this.leftPanel; 	
//	this.posLista = 0;
	this.firstLevelSize = 8;
	this.rootMenuIndex = 0;
//
//	this.fw.menuArray = new Array();
//	this.fw.menuArray = new InserisciLista();

	this.headerNavigationMenuImagesPath = '/ovaImages/menuRes/'; 		
	
	this.horizontalImageString = 'node_';
	this.absoluteImageString = 'path_';
	this.listImageString = 'list_';
	this.leafListingImageString = 'node_listing_';
	this.counterVodString = 'count_';
	this.listMonthString = 'mese_';

	this.leftPanelUpperArrow = 'leftPanelUpperArrow';
	this.leftPanelLowerArrow = 'leftPanelLowerArrow';
	this.rightPanelUpperArrow = 'rightPanelUpperArrow';
	this.rightPanelLowerArrow = 'rightPanelLowerArrow';
	
	this.numeroCanale = 0 ;
	
	this.listaFavEmpty = false;
	
	
	this.timerGuidaPreferiti = null;
	
	
}

//function InserisciLista(){
//	try{
//		this.listaDx = new Array();
//		this.listaSx = new Array();
//	}catch(ecc){
//		this._objErrorInfo._methodName = "InserisciLista";
//		this._objErrorInfo._obException = ecc;
//		this.handleError();
//	}
//	return true;
//};

/*****************************************************
FUNCTION: 		deactivateLayout
PARAMETRI: 		isSendTrap - boolean
DESCRIPTION: 	callback dei timer di tutte le attivit�
							setto a fullScreen il layout e specifico se
							devono essere inviate le trap di attivit�
							per sepg e fullScreen
*****************************************************/
HomeTvApp.prototype.ripulisciZapperone = function ()
{
	try
	{
		var onePixClear = '/ovaImages/1pixelclear.gif';
		var size = this.zapperGridSize;
	
		this._lockEpgGrid();
		
	}
	catch(ecc){
		this._objErrorInfo._methodName = "ripulisciZapperone";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

HomeTvApp.prototype.deactivateLayout=function(){	
	try
	{
		
		if (this.getActivity()==this.sepg){			
			this.ripulisciSEPG();		
		}else if (this.getActivity() == this.zapper ){
			this.ripulisciZapperone();
		}

		if (this.getActivity()!=this.fullScreen){
			this.hidePopUp();
			
			this.activateLayout(this.fullScreen);
		}

	}catch(ecc){
		this._objErrorInfo._methodName = "deactivateLayout";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

HomeTvApp.prototype.getActivity= function(){
	try
	{
		
		return this.fw._myActivity;
	}
	catch(ecc){
		this._objErrorInfo._methodName = "getActivity";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

HomeTvApp.prototype.hidePopUp= function(){
	try
	{
		this.fw.getLayoutManager().setLayoutVisible("listaPreferitiEmpty",false);
		this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", false);
		this.fw.getLayoutManager().setLayoutVisible("attivatoListaPreferiti", false);
		this.attivatoListaPreferiti = false;
		
	}
	catch(ecc){
		this._objErrorInfo._methodName = "hidePopUp";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*****************************************************
FUNCTION: activateTimer
PARAMETRI: nessuno
DESCRIPTION: 	la funzione attiva il timer relativo 
							all'attivit� corrente
*****************************************************/
HomeTvApp.prototype.activateTimer= function(){
	try
	{
		var delay = 60000;
		
		if (this.getActivity() == this.zapper)
		{
			delay = this._myZapperTimer;
		}
		
		else if (this.getActivity() == this.messaggioScansione)
		{
			delay = 90000000;
		}
		else if (this.getActivity() == this.sepg)
		{
			delay = this._mySepgTimer;
		}
		else if (this.getActivity() == this.menu )
		{
			delay = this._myMenuTimer;
		}
		else if (this.getActivity() == this.fullScreen) 
		{
			delay = -1;
		} 
		else if (this.getActivity() == this.navigationMenu) 
		{
			delay = -1;
		}
		
		else
		{
			delay = -1;
		}
		
		if (this._myIdTimer)
		{
			this.fw.getTimer().clearTimeout(this._myIdTimer);
		}
		if (delay != -1)
		{
			this._myIdTimer = this.fw.getTimer().setTimeout(delay, this.deactivateLayout , this);
		}
		
	}
	catch(ecc){
		this._objErrorInfo._methodName = "activateTimer";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*****************************************************
FUNCTION: activateLayout
PARAMETRI: activity (numeric)
					 isSendTrap (boolean)
DESCRIPTION: 	la funzione attiva il layout corrispondente 
							alla attivit� richiesta.
							i parametri passati alla funzione rappresentano 
							le varie attivit�,
							che possono essere chiamate anche  da tab della menu.
							Il parametro isSendTrap specifica se devono essere
							inviate le trap per l'apertura delle sepg o per
							la fullScreen (per evitare che vengano inviate durante zapping).
*****************************************************/
HomeTvApp.prototype.activateLayout=function(activity){
	try
	{
		if(activity == 0 ){//sono nel caso di reume standby
			this.fw.getLayoutManager().setLayoutVisible("salvaListaPreferiti", false);
			this.fw.getLayoutManager().setLayoutVisible("exitWithoutSave",false);
			this.fw.getLayoutManager().setLayoutVisible("attivatoListaPreferiti", false);
		}	
				
		this._videoControl = this.fw.getVideoControl();
	    	this._videoControl.background(0x00FF00,0xF0F0F0);
		//salvo la vecchia activity in oldActivity
		this.oldActivity=this.getActivity();
		
		try{
			var scrollActivity = parseInt(activity);
		}catch(e){
		
		  activity=0;
		  var scrollActivity = 0;
		}		


		this.fw.getLayoutManager().getElement(this._layoutId, "layout").scroll(0, scrollActivity * this.vSize);	
		this.fw._myActivity = scrollActivity;	

		this.deactivateTimer();
		switch(activity){					
			case this.zapper:
				this.activateZapper();
				break;		
			case this.navigationMenu:
			
				/*
				this.fw.myIndex = 0;				
				this.fw.verticalMenuIndex = 0;
				this.fw.menuArray[this.fw.myIndex].lastChildIndexSelected = 0;
				this.setNavigationPositionPanel(this.leftPanel);
				this.drawLeftPanelItemsList("down",true);
				*/
				if(this.navigationMenuPanel == this.leftPanel)
					this.drawLeftPanelItemsList("down",true);
				this.checkItem();				
				
				break;		
			case this.sepg:					
			
				break;
			
			case this.menu:
//			
				break;
		}
		this.activateTimer();
	}catch(ecc){
		this._objErrorInfo._methodName = "activateLayout";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*****************************************************
FUNCTION: activityToString
PARAMETRI: activity (numeric)
OUTPUT:		 stringaRet (string)
DESCRIPTION: la funzione restituisce la stringa corrispondente
						 alla attivit� passata in input
*****************************************************/
HomeTvApp.prototype.activityToString=function(activity){
	try{
			var stringaRet = "";	
			switch(activity){
				case this.menu:
					stringaRet="MENU";
					break;				
				case this.zapper:
					stringaRet="ZAPPER";
					break;
				case this.sepg:
					stringaRet="SEPG";
					break;				
				case this.fullScreen:
					stringaRet="FULLSCREEN";
					break;
				case this.navigationMenu:
					stringaRet="NAVIGATIONMENU";
					break;		
				case this.messaggioScansione:
					stringaRet="MESSAGGIOSCANSIONE";
					break;
			}
			return stringaRet;
	}catch(ecc){
		this._objErrorInfo._methodName = "activityToString";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return "";
	}
};

HomeTvApp.prototype.create=function(){
	try
	{
		this._objErrorInfo = new Object();
		this._objErrorInfo._applicationName = "HomeTvApp.js";	
		this._objErrorInfo._methodName = "";
		this._objErrorInfo._obException = new Object();

		// ------ iniziliazzione dei TIMER
		
		// timer per i layout Menu
		/* di default MENU_TIMER: '15000'*/
		this._myMenuTimer = (this.fw.getConfig().MENU_TIMER != null) ? parseInt(this.fw.getConfig().MENU_TIMER) : 120000;

		this.reloadRightPanelTimer = 150 ;
		
		// timer per il layout dello zapper 
		this._myZapperTimer = (this.fw.getConfig().ZAPPER_TIMER != null) ? parseInt(this.fw.getConfig().EPG_GRID_TIMER) : 15000;
		
		// timer per i layout per il setting e sepg 
		this._mySepgTimer = (this.fw.getConfig().SEPG_MENU != null) ? parseInt(this.fw.getConfig().SEPG_MENU) : 5000;
		
		this._myGuidaFavoritiTimer = (this.fw.getConfig().TIMER_GUIDA_FROM_TO_FAVORITI != null) ? parseInt(this.fw.getConfig().TIMER_GUIDA_FROM_TO_FAVORITI) : 1000;
		
		
	
		// id di timer per la deattivazione dei layout
		this._myIdTimer = null;
	
		// timer zapperone
		this.timerZapperID = null;

		this.fw._myActivity = this.menu;
		

		
		this.fw.external = 1;	// indica se andiamo al contenuto tramite il banner oppure dal catalogo
		this.fw.createPVR = 1;  // indica che la prima volta deve creare ngc.pvr.init

		
		this._layoutId = 'homeTvLayout';
		this._ui = this.fw.createSimpleFormUI(this._layoutId);
		/* preleva l'iframe da layoutMod.html */
		/* Oppure prende da layoutMod.html homeTvLayout che corrisponde al frame che
		   contiene homeTVLayout.html */
		this.pageLayout = this.fw.getLayoutManager().getLayout(this._layoutId);
		/* inizializza OvaForm */
		this._ui.setForm(this.createForm());
		
		this.pageLayout.document.bgColor = '#00000000';
		/* In homeTVLayout.html è definito un frame con il nome "layout" */
		this.pageLayout.frames["layout"].document.bgColor = '#00000000';

		/* Messo qui perchè viene eseguito una volta sola, in fase di inizializzazione, mentre init viene eseguito
		   anche quando ritorno da un'altra applicazione e quindi perdevo l'informazione se era 1 perchè
		   tornava da un'altra applicazione */

		this.xMenuPos = 0; // 0 --> a sx (0, 1, 2)
		
		this.fw.rootMenuItem = 0;
		
		this.setZapperSaved(this.fw.zapper);

		this.FirstTimeHTV = 1; // indica la prima volta di esecuzione di HomeTVApp, se 1 è la prima volta
				       // questa viene istanziata una volta solo, essendo in create
		return true;
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "create";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		
	}	
};

HomeTvApp.prototype.createForm=function() {  
	try
	{	/* dichiarazione ed implementazione di OvaForm.js, passando come parametro il nome della form:
		   "helpForm" */	
		this._form = this.fw.createForm("helpForm"); 
		// aggiungo un field all'oggetto helpForm appena creato		
		this._form.addField({ name: 'hidd', type: this._form.TYPE_HIDDEN });
		this._form.setHandler(this);
		return this._form;
	}catch(ecc){ 
		this._objErrorInfo._methodName = 'createForm';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}	
};

//aggiungere un ulteriore parametro goStandby
HomeTvApp.prototype.init=function(section,activity,zappingId,goStandby,forceRedraw){
	try
	{
		if(this.isAggiornaPrefDopoScansione())
			this.aggiornaPrefDopoScansione();
		switch(this.fw.VERSIONE_MOD_CANALI){
		case 0:
			this.headerNavigationMenuImagesPath = '/ovaImages/menuRes/0/';
			break;
		case 1:
			this.headerNavigationMenuImagesPath = '/ovaImages/menuRes/1/';
			break;
		case 2:
			this.headerNavigationMenuImagesPath = '/ovaImages/menuRes/2/';
			break;
		case 3:
			this.headerNavigationMenuImagesPath = '/ovaImages/menuRes/3/';
			break;
		}
		omc.logger.addEntry("#################### HomeTvApp.init this.fw.firstTimeBootBox: "+this.fw.firstTimeBootBox);
		if(this.fw.firstTimeBootBox)//salvaFileBootHTML
			//if(!this.fw.SCRITTO_FILE_BOOT_HTML){
				this.salvaFileBootHTML();
			//	this.fw.SCRITTO_FILE_BOOT_HTML = true;		
			//}
		
		this.fromZapper=false;
		this.sepgIndex = 0;
		this.fromInitOrReboot=false; //flag per mandare le trap di activity in ogni caso quando passo dalla init
		this.fw.forceJumpToSameRecId=false; //flag per forzare la jumpByRecId allo stesso canale attuale (per eventi
	
		
		
		/* Questo mi evita il ritardo sul menu al primo avvio */

		if (activity != null)
		{
			this.fw._myActivity = activity;
		} else if (this.fw._myActivity != null){
			/* Attivo il Timer per il primo accesso sulla prima attività */
			this.activateTimer();
			
		}

		/* se commento vedo che non ci sono più le scritte bianche */
		var vc = this.fw.getVideoControl();
		this._videoControl=vc;
// 		/* funzione definita in OvaVideoControl */
		vc.background(0x00FF00, 0xF0F0F0);
		this.attivaSepg=false;
        omc.video.background();
        omc.video.visible(true);
        
		/* Se commento non cambia nulla */
		if(!goStandby){			
			if(zappingId){				
				this.jumpToChannelByZappingId(zappingId);
			} else {/* entro qui */
				//sono già dopo le scritte bianche
				/* chiamo jumpToChannelByZappingId in BaseApp.js */
				var urlVideo = this.fw.getLastUrlVideo();
				if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.init - urlVideo: "+urlVideo);
				if (urlVideo != null){
					try{
						omc.stream.load(urlVideo, true, 0, 0);
					} catch(err){
						omc.logger.addEntry("Error: "+err.message);	
					}
				} else {
					this.jumpToChannelByZappingId();
				}	
			}
				
		}
		
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("this.xMenuPos: "+this.xMenuPos);
		
		this.refreshHourSEPG();
		
		this.setTimeInRootMenu();
		
		//if(this.getActivity()==this.navigationMenu){
		if(this.fw.backFromExApp){
   			this.activateLayout(this.navigationMenu);
   			if (forceRedraw!=null && forceRedraw!=undefined && forceRedraw==true){
   				this.setNavigationPositionPanel(this.leftPanel);
   				this.drawLeftPanelItemsList("down",true);		
   			}
   			this.checkItem();
   			
   			//return true;
		}
		if(this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("###### HomeTvApp INIT this.fw.ShowPreferiti: "+this.fw.ShowPreferiti);
		if (this.fw.ShowPreferiti == 1){
			if (this.fw.ListaFavoriti.length != 0){
				this.fw.zapper = this.fw.ListaFavoriti;								
			}else { 
				this.fw.ShowPreferiti = 0;
				this.fw.zapper = this.getZapperSaved();
			}	
		} else {
			this.fw.ShowPreferiti = 0;
			this.fw.zapper = this.getZapperSaved();			
		}	
		this.createZapper();
		
		//Il portale deve venire su a fullscreen e non con il menu
		try{
			var l = omc.dvb.getServices().length;
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("###### HomeTvApp INIT VADO A FULLSCREEN: "+omc.dvb.getServices().length);
			if(this.fw.backFromExApp){
				this.fw.backFromExApp = false;
				this._ui.redraw();
				this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", false);
				return true;
			}
			this.activateLayout(this.fullScreen);			
		}catch(e){
			if(this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("########### HomeTvApp INIT VISUALIZZA MSG DTT SCAN :");	
			//this.activateLayout(this.messaggioScansione);
			this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", true);
			this.writeOnPopUp( "caricamentoInCorso",null , "/ovaImages/caricamentoInCorso.gif",0 );
			this.loadApp("/ovaServices/getapp/ScanDTTSettingsVirginApp.html?urlapp=impostazioni&app1=ScanDTTSettingsVirginApp");
		}
		/* Se commento questo non parte, quindi prima ha settato le impostazioni ed ora la carica */
		this._ui.redraw();
		this.hidePopUp();
		return true;

	}catch(ecc){
		this._objErrorInfo._methodName = "init";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	
};


HomeTvApp.prototype.setTimeInRootMenu = function(){
	try{
		var now=this.fw.getOSD().getTime();
		var dnow=new Date();
	//	dnow.setTime(now);
		var giornoS=""+dnow.getUTCDate();		
		if (giornoS.length==1)
		{
			var giorno="0"+giornoS;
		}
		else
		{
			var giorno=giornoS;	      
		}
		
		var meseS=""+(dnow.getUTCMonth()+1);
		if (meseS.length==1)
		{
			var mese="0"+meseS;
		}
		else
		{
			var mese=meseS;	      
		}
		var anno=dnow.getUTCFullYear();
		nomegiorno = this.getNameDay(dnow);
		mese = this.getMonthName(mese,true);
		var oggi =giorno+" "+mese+" "+anno+" - ";
//TODO REGOLARE L'ORA SOLARE
		
		//var hours = parseInt(dnow.getUTCHours()+2);
		var hours = parseInt(dnow.getHours());
		var minutes = parseInt(dnow.getUTCMinutes());

		if(minutes>=0 && minutes<=9)
			minutes = "0"+minutes;

		if(hours>=0 && hours<=9)
			hours = "0"+hours;
		
		var label_orario = oggi+hours+":"+minutes;
		if(this.fw.DATA_ORA_ENABLED)
			this.replaceFrameContents(this._layoutId,"rootMenuTime",this.zappingIdTag+'<font size="4" color="#c5c4c3">'+label_orario+'</font>'+this.endTag,null);
		else
			this.replaceFrameContents(this._layoutId,"rootMenuTime","",null);
		if(this.reloadTimeMenuRootTimer){
			this.fw.getTimer().clearTimeout(this.reloadTimeMenuRootTimer);
		}
		this.reloadTimeMenuRootTimer = this.fw.getTimer().setTimeout(60000,this.setTimeInRootMenu,this);
	}catch(ecc){
		this._objErrorInfo._methodName = 'setTimeInRootMenu'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};


HomeTvApp.prototype.getMonthName = function(mese,inLauncher)
{
	var nomemese ="";
	try
	{	
		if(inLauncher!=null && inLauncher==true){
			switch(mese)
			{
				case 1:
				case '1':
				case '01':
				nomemese = "Gennaio";
				break;
				case 2:
				case '2':
				case '02':
				nomemese = "Febbraio";
				break;
				case 3:
				case '3':
				case '03':
				nomemese = "Marzo";
				break;
				case 4:
				case '4':
				case '04':
				nomemese = "Aprile";
				break;
				case 5:
				case '5':
				case '05':
				nomemese = "Maggio";
				break;
				case 6:
				case '6':
				case '06':
				nomemese = "Giugno";
				break;
				case 7:
				case '7':
				case '07':
				nomemese = "Luglio";
				break;
				case 8:
				case '8':
				case '08':
				nomemese = "Agosto";
				break;
				case 9:
				case '9':
				case '09':
				nomemese = "Settembre";
				break;
				case 10:
				case '10':
				nomemese = "Ottobre";
				break;
				case 11:
				case '11':
				nomemese = "Novembre";
				break;
				case 12:
				case '12':
				nomemese = "Dicembre";
				break;
			}
		}else{
		switch(mese)
		{
			case 1:
				case '1':
			nomemese = "gen";
			break;
			case 2:
				case '2':
			nomemese = "feb";
			break;
			case 3:
				case '3':
			nomemese = "mar";
			break;
			case 4:
				case '4':
			nomemese = "apr";
			break;
			case 5:
				case '5':
			nomemese = "mag";
			break;
			case 6:
				case '6':
			nomemese = "giu";
			break;
			case 7:
				case '7':
			nomemese = "lug";
			break;
			case 8:
				case '8':
			nomemese = "ago";
			break;
			case 9:
				case '9':
			nomemese = "set";
			break;
			case 10:
				case '10':
			nomemese = "ott";
			break;
			case 11:
				case '11':
			nomemese = "nov";
			break;
			case 12:
				case '12':
			nomemese = "dic";
			break;
		}
	}
	}
	catch(ecc)
	{
			this._objErrorInfo._methodName = 'getMonthName';
			this._objErrorInfo._obException = ecc;
			this.handleError();
	}
	return nomemese;

};

/*****************************************************
FUNCTION: manageSectionActivity
PARAMETRI: action (stringa)
DESCRIPTION: 	la funzione gestisce in maniera centralizzata
							gli eventi lanciati dal telecomando
*****************************************************/
HomeTvApp.prototype.manageSectionActivity = function (action)
{
	
	try{	
		//if(this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("HomeTvApp.manageSectionActivity action:"+action);
		if(this.listaFavEmpty){
			this.listaFavEmpty = false;
			this.fw.getLayoutManager().setLayoutVisible("listaPreferitiEmpty", false);
			this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", false);
			return true;
		}
		if(this.attivatoListaPreferiti){
			switch(action){
			case 'enter':
				this.attivatoListaPreferiti = false;
				this.fw.getLayoutManager().setLayoutVisible("attivatoListaPreferiti", false);
				return true;
				break;
			default:
				return true;
				break;
			}
			
		}
		
		this.activateTimer();
		/* precarico una prima volta lo zapperone (anche le cgi) e vedo se è più veloce */
		this.canali = this.getZapper();
		switch(action)
		{
		case 'left':
			switch(this.getActivity()){			
				case this.menu:
					if (this.xMenuPos == 0){
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Tv_off.png');
						this.xMenuPos=1;
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Opzioni_on.png');
					} else if (this.xMenuPos == 1){
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Opzioni_off.png');
						this.xMenuPos=0;
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Tv_on.png');
					}
					if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.manageSectionActivity LEFT- this.xMenuPos: "+this.xMenuPos);

					break;			
				case this.fullScreen:
					this.setSEPGIndex(this.fw._currIndexForZapping);
					this.takeInfoSEPG();
					this.creaInfoSlot();
					break;
				case this.sepg:
					this.prevZappingChannel();	
					this.creaInfoSlot();
					break;							
				case this.zapper:
					/*
					if (this._isEpgGridLocked() != true) {	
								var initIndex = Math.floor((this.canali.length / this.zapperGridSize)) * this.zapperGridSize;	
								var diff = this.canali.length - this._mySelectedChannel;
								// caso particoalre, l'ultima pagina è intera 
								if (this.canali.length-initIndex == 0){
									initIndex = initIndex - this.zapperGridSize;
								}
								// sono nella prima pagina e voglio andare nell'ultima 
								if(diff>(this.canali.length-this.zapperGridSize)){
									// entra qui se l'ultima pagina è spezzata 
									if (this._mySelectedChannel < (this.canali.length-initIndex)){
										this._myPrevSelectedChannel = initIndex + this._mySelectedChannel -1;
										this._mySelectedChannel=initIndex+this._mySelectedChannel;
									} else {
										this._myPrevSelectedChannel = initIndex-1;
										this._mySelectedChannel=initIndex;
									}
									this._mySelectedProgram = 0;
								} else {
									this._myPrevSelectedChannel = this._mySelectedChannel-this.zapperGridSize-1;
									this._mySelectedChannel=this._mySelectedChannel-this.zapperGridSize;
									this._mySelectedProgram = 0;

									if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.manageSectionActivity - mychannel: "+this._mySelectedChannel);
								}
								this.fillEpgGridLayers(action, true);
					}
					*/
					break;
				case this.navigationMenu:
					if(this.getNavigationPositionPanel()==this.rightPanel){
						this.fw.myIndex = this.fw.menuArray[this.fw.myRightPanelIndex].menuParent;
						this.fw.verticalMenuIndex = this.fw.menuArray[this.fw.myIndex].lastChildIndexSelected;
						this.fw.verticalMenuRightPanelIndex = 0;
						this.fw.menuArray[this.fw.myRightPanelIndex].lastChildIndexSelected = 0;
						this.drawRightPanelItemsList('down',false,false,true);
						if(this.fw.menuArray[this.fw.menuArray[this.fw.myIndex].menuChilds[this.fw.verticalMenuIndex]].menuChilds.length > 0){
							this.referImageToIFrame(this._layoutId,"layout","ok","/ovaImages/1pixelclear.gif");
							this.referImageToIFrame(this._layoutId,"layout","Arrow_"+this.leftPanel+"_"+parseInt((this.fw.verticalMenuIndex%this.firstLevelSize)+1),"/ovaImages/restyling/arrows/left_item_arrow.png");
							this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.leftPanel+"_"+parseInt((this.fw.verticalMenuRightIndex%this.firstLevelSize)+1),"/ovaImages/restyling/arrows/red.png");							
							this.referImageToIFrame(this._layoutId,"layout","ok_menu","/ovaImages/1pixelclear.gif");
						}else{
							this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.leftPanel+"_"+parseInt((this.fw.verticalMenuRightIndex%this.firstLevelSize)+1),"/ovaImages/restyling/arrows/red.png");
							this.referImageToIFrame(this._layoutId,"layout","Arrow_"+this.leftPanel+"_"+parseInt((this.fw.verticalMenuIndex%this.firstLevelSize)+1),"/ovaImages/restyling/arrows/red.png");
							this.referImageToIFrame(this._layoutId,"layout","ok","/ovaImages/restyling/buttons/ok_footer.png");
							
						}
						this.checkVodCounterArray();
					}
					break;
				default :
					return true;
					break;	
			}
			break;
			
		case 'right':
			switch(this.getActivity()){
				case this.menu:					
					if (this.xMenuPos == 0){
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Tv_off.png');
						this.xMenuPos=1;
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Opzioni_on.png');
					} else if (this.xMenuPos == 1){
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Opzioni_off.png');
						this.xMenuPos=0;
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Tv_on.png');
					}
					if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.manageSectionActivity RIGHT - this.xMenuPos: "+this.xMenuPos);
					break;
				case this.fullScreen:	
					this.setSEPGIndex(this.fw._currIndexForZapping);
					this.takeInfoSEPG();
					this.creaInfoSlot();
					break;					
				case this.zapper:
					/*
					this.fromZapper=true;
					if (this._isEpgGridLocked() != true) {		
								var initIndex = Math.floor((this.canali.length / this.zapperGridSize)) * this.zapperGridSize;
								var diff = this.canali.length - this._mySelectedChannel;
								// caso particoalre, l'ultima pagina è intera 
								if ((this.canali.length-initIndex)==0){
									initIndex = initIndex - this.zapperGridSize;
								}

								// sono nell'ultima pagina 
								if(diff<=(this.canali.length-initIndex)){

									this._myPrevSelectedChannel =this._mySelectedChannel - initIndex - 1;
									this._mySelectedChannel=this._mySelectedChannel-initIndex;
									this._mySelectedProgram = 0;

								} else if (this._mySelectedChannel > (this.canali.length-this.zapperGridSize-1)){
										this._myPrevSelectedChannel = initIndex-1;
										this._mySelectedChannel=initIndex;
								} else {
										this._myPrevSelectedChannel =  this._mySelectedChannel+this.zapperGridSize-1;
 										this._mySelectedChannel=this._mySelectedChannel+this.zapperGridSize;
										this._mySelectedProgram = 0;
								}
								this.fillEpgGridLayers(action, true);
					}
			*/
					break;

				case this.navigationMenu:
					if(this.getNavigationPositionPanel()==this.leftPanel){
						omc.logger.addEntry("this.fw.menuArray[this.fw.menuArray[this.fw.myIndex].menuChilds[this.fw.verticalMenuIndex]].menuChilds.length: "+this.fw.menuArray[this.fw.menuArray[this.fw.myIndex].menuChilds[this.fw.verticalMenuIndex]].menuChilds.length);
						if(this.fw.menuArray[this.fw.menuArray[this.fw.myIndex].menuChilds[this.fw.verticalMenuIndex]].menuChilds.length > 0){
							this.fw.menuArray[this.fw.myIndex].lastChildIndexSelected = this.fw.verticalMenuIndex;
							this.fw.verticalMenuRightPanelIndex = 0;
							this.drawSelectedLeftPanelItemsList('down');
							this.setNavigationPositionPanel(this.rightPanel);
							this.checkItem();
						}
					}
					break;
				case this.sepg:					
					this.nextZappingChannel();	
					this.numeroCanale = this.numeroCanale+1;
					this.creaInfoSlot();
					break;			
				default:
					return true;
					break;
					
			}
			break;		
		case 'fwd':
			switch(this.getActivity()){
				case this.zapper:
					this.fromZapper=true;
					if (this._isEpgGridLocked() != true) {		
								var initIndex = Math.floor((this.canali.length / this.zapperGridSize)) * this.zapperGridSize;
								var diff = this.canali.length - this._mySelectedChannel;
								/* caso particoalre, l'ultima pagina è intera */
								if ((this.canali.length-initIndex)==0){
									initIndex = initIndex - this.zapperGridSize;
								}
	
								/* sono nell'ultima pagina */
								if(diff<=(this.canali.length-initIndex)){
	
									this._myPrevSelectedChannel =this._mySelectedChannel - initIndex - 1;
									this._mySelectedChannel=this._mySelectedChannel-initIndex;
									this._mySelectedProgram = 0;
	
								} else if (this._mySelectedChannel > (this.canali.length-this.zapperGridSize-1)){
										this._myPrevSelectedChannel = initIndex-1;
										this._mySelectedChannel=initIndex;
								} else {
										this._myPrevSelectedChannel =  this._mySelectedChannel+this.zapperGridSize-1;
											this._mySelectedChannel=this._mySelectedChannel+this.zapperGridSize;
										this._mySelectedProgram = 0;
								}
								this.fillEpgGridLayers(action, true);
					}
					break;
				
				default:
					return true;
					break;
			}
			break;
		case 'rwd':
			switch(this.getActivity()){
				case this.zapper:
					if (this._isEpgGridLocked() != true) {	
								var initIndex = Math.floor((this.canali.length / this.zapperGridSize)) * this.zapperGridSize;	
								var diff = this.canali.length - this._mySelectedChannel;
								/* caso particoalre, l'ultima pagina è intera */
								if (this.canali.length-initIndex == 0){
									initIndex = initIndex - this.zapperGridSize;
								}
								/* sono nella prima pagina e voglio andare nell'ultima */
								if(diff>(this.canali.length-this.zapperGridSize)){
									/* entra qui se l'ultima pagina è spezzata */
									if (this._mySelectedChannel < (this.canali.length-initIndex)){
										this._myPrevSelectedChannel = initIndex + this._mySelectedChannel -1;
										this._mySelectedChannel=initIndex+this._mySelectedChannel;
									} else {
										this._myPrevSelectedChannel = initIndex-1;
										this._mySelectedChannel=initIndex;
									}
									this._mySelectedProgram = 0;
								} else {
									this._myPrevSelectedChannel = this._mySelectedChannel-this.zapperGridSize-1;
									this._mySelectedChannel=this._mySelectedChannel-this.zapperGridSize;
									this._mySelectedProgram = 0;
	
									if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.manageSectionActivity - mychannel: "+this._mySelectedChannel);
								}
								this.fillEpgGridLayers(action, true);
					}
					break;
			
				default:
					return true;
					break;
			}
			break;
		case 'down':
			switch(this.getActivity()){
				case this.zapper:
					if (this._isEpgGridLocked() != true)
						{		
								if (this._mySelectedChannel < this.canali.length-1)
								{	
									this._myPrevSelectedChannel = this._mySelectedChannel;
									this._mySelectedChannel++;
									this._mySelectedProgram = 0;
								}
								else
								{
									this._myPrevSelectedChannel = this._mySelectedChannel;
									this._mySelectedChannel = 0;
									this._mySelectedProgram = 0;
								}						
								this.fillEpgGridLayers(action, false);
					}
					break;
					
				case this.menu:
					if (this.xMenuPos == 0){
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Tv_off.png');
						this.xMenuPos=1;
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Opzioni_on.png');
					} else if (this.xMenuPos == 1){
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Opzioni_off.png');
						this.xMenuPos=0;
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Tv_on.png');
					}
					if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.manageSectionActivity DOWN- this.xMenuPos: "+this.xMenuPos);
					break;
					
				case this.fullScreen:
					this.setSEPGIndex(this.fw._currIndexForZapping);
					this.takeInfoSEPG();
					this.creaInfoSlot();
					break;	
					
				case this.navigationMenu:
					if(this.checkItemTimer){
						this.fw.getTimer().clearTimeout(this.checkItemTimer);
					}
					//
					if(this.getNavigationPositionPanel()==this.leftPanel){
						this.drawEmptyRightPanelItemsList();
						this.getNextMenuDown();
						if( this.fw.menuArray[this.fw.myIndex] ){
							if( (this.fw.verticalMenuIndex%this.firstLevelSize) == 0 ){						
								this.fw.menuArray[this.fw.myIndex].lastChildIndexSelected = this.fw.verticalMenuIndex;
								this.drawLeftPanelItemsList('down',true);
							}else{
								var newIdxOff = ( this.fw.verticalMenuIndex-1 < 0 ) ? (this.fw.menuArray[ this.fw.myIndex ].menuChilds.length-1) : (this.fw.verticalMenuIndex-1);
								this.switchFocusImageOff(newIdxOff);
								this.switchFocusImageOn(this.fw.verticalMenuIndex);	
							}
						}
					}else{
						this.getNextMenuDownRightPanel();
						if( this.fw.menuArray[this.fw.myRightPanelIndex] ){
							if( (this.fw.verticalMenuRightPanelIndex%this.firstLevelSize) == 0 ){
								this.fw.menuArray[this.fw.myRightPanelIndex].lastChildIndexSelected = this.fw.verticalMenuRightPanelIndex;
								this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.rightPanel+"_"+parseInt((this.fw.verticalMenuRightIndex%this.firstLevelSize)+1),"/ovaImages/1pixelclear.gif");						
								this.drawRightPanelItemsList('down',true);
							}else{
								var newIdxOff = ( this.fw.verticalMenuRightPanelIndex-1 < 0 ) ? (this.fw.menuArray[ this.fw.myRightPanelIndex ].menuChilds.length-1) : (this.fw.verticalMenuRightPanelIndex-1);
								this.switchFocusImageOff(newIdxOff);
								this.switchFocusImageOn(this.fw.verticalMenuRightPanelIndex);	
							}
							
						}
					}
					
					this.checkItem();
					break;					
				case this.sepg:
					// gestione dello scroll della programmazione 
					this.aggiornaInfoSEPG('sx'); //slot successivo se disponibile
					break;					
				default:
					return true;
					break;
			}
			break;
			
		case 'up':
			switch(this.getActivity()){
				case this.zapper:
				if (this._isEpgGridLocked() != true)
					{
						if (this._mySelectedChannel > 0)
						{	
							this._myPrevSelectedChannel = this._mySelectedChannel;
							this._mySelectedChannel--;
							this._mySelectedProgram = 0;
							this.fillEpgGridLayers(action,false);
						}
						else
						{
							this._mySelectedChannel = this.canali.length - 1;
							this.fillEpgGridLayers(action,true);
						}
					}
					break;
					
				case this.menu:		
					if (this.xMenuPos == 0){
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Tv_off.png');
						this.xMenuPos=1;
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Opzioni_on.png');
					} else if (this.xMenuPos == 1){
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Opzioni_off.png');
						this.xMenuPos=0;
						this.referImageToIFrame( this._layoutId ,'layout', 'pos'+this.xMenuPos, '/ovaImages/restyling/frames/Tv_on.png');
					}
					omc.logger.addEntry("this.xMenuPos: "+this.xMenuPos);					
					break;
					
				case this.fullScreen:
					this.setSEPGIndex(this.fw._currIndexForZapping);
					this.takeInfoSEPG();
					this.creaInfoSlot();
					break;

				case this.navigationMenu:					
					if(this.checkItemTimer){
						this.fw.getTimer().clearTimeout(this.checkItemTimer);
					}
					//
					if(this.getNavigationPositionPanel()==this.leftPanel){
						this.getNextMenuUp();
						this.drawEmptyRightPanelItemsList();
						if( this.fw.menuArray[this.fw.myIndex] ){
							if( (this.fw.verticalMenuIndex%this.firstLevelSize) == parseInt(this.firstLevelSize-1) || this.fw.verticalMenuIndex == this.fw.menuArray[ this.fw.myIndex ].menuChilds.length-1 ){
								//in ogni caso prendo il prossimo elemento
								this.fw.menuArray[this.fw.myIndex].lastChildIndexSelected = this.fw.verticalMenuIndex;
								this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.leftPanel+"_"+parseInt((this.fw.verticalMenuIndex%this.firstLevelSize)+1),"/ovaImages/1pixelclear.gif");							
								this.drawLeftPanelItemsList('up',false);
							}else{
								var newIdxOff = ( this.fw.verticalMenuIndex == (this.fw.menuArray[ this.fw.myIndex ].menuChilds.length-1) ) ? 0 : (this.fw.verticalMenuIndex+1);
								this.switchFocusImageOff(newIdxOff);
								this.switchFocusImageOn(this.fw.verticalMenuIndex);	
							}
						}
						
					}else{
						this.getNextMenuUpRightPanel();
						if( this.fw.menuArray[this.fw.myRightPanelIndex] ){
							if( (this.fw.verticalMenuRightPanelIndex%this.firstLevelSize) == parseInt(this.firstLevelSize-1) || this.fw.verticalMenuRightPanelIndex == this.fw.menuArray[ this.fw.myRightPanelIndex].menuChilds.length-1 ){
								//in ogni caso prendo il prossimo elemento
								this.fw.menuArray[this.fw.myRightPanelIndex].lastChildIndexSelected = this.fw.verticalMenuRightPanelIndex;
								this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.rightPanel+"_"+parseInt((this.fw.verticalMenuRightIndex%this.firstLevelSize)+1),"/ovaImages/1pixelclear.gif");						
								this.drawRightPanelItemsList('up',true,false,false);
							}else{
								var newIdxOff = ( this.fw.verticalMenuRightPanelIndex == (this.fw.menuArray[ this.fw.myRightPanelIndex ].menuChilds.length-1) ) ? 0 : (this.fw.verticalMenuRightPanelIndex+1);
								this.switchFocusImageOff(newIdxOff);
								this.switchFocusImageOn(this.fw.verticalMenuRightPanelIndex);	
							}
							
						}
					}
					this.checkItem();
					break;					
				case this.sepg:
					// gestione dello scroll della programmazione 
					this.aggiornaInfoSEPG('dx'); //prossimo slot se disponibile
					break;	
				default:
					return true;
					break;
			}
			break;
			
		case 'enter':
		if(this.BoxChangeChannel == true){
				this.EnterNumericDigit();
		}else{
			switch(this.getActivity()){
				case this.menu:
					if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.manageSectionActivity ENTER - this.xMenuPos: "+this.xMenuPos);
					if (this.xMenuPos == 0){
						this.activateLayout(this.zapper);
					} else if (this.xMenuPos == 1){
						this.activateLayout(this.navigationMenu);
					}
					break;
				
				case this.fullScreen:
						//this.activateLayout(this.sepg);
					this.attivaSepg = true;
					this.takeInfoSEPG(); //vado sulla sepg
					this.creaInfoSlot();
					break;

				case this.navigationMenu:
					
					
					if(this.getNavigationPositionPanel()==this.rightPanel){
						var url = this.fw.menuArray[this.fw.menuArray[this.fw.myRightPanelIndex].menuChilds[this.fw.verticalMenuRightPanelIndex]].applicationConfig.url;
						if(url)
							if (url != ""){								
								this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", true);
								this.writeOnPopUp( "caricamentoInCorso",null , "/ovaImages/caricamentoInCorso.gif",0 );
								if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("carico URL : "+url);
								this.loadApp(url);
							}
							
					} else if (this.getNavigationPositionPanel()==this.leftPanel){
						var url = this.fw.menuArray[this.fw.menuArray[this.fw.myIndex].menuChilds[this.fw.verticalMenuIndex]].applicationConfig.url;
						if(url)
							if (url != ""){
								this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", true);
								this.writeOnPopUp( "caricamentoInCorso",null , "/ovaImages/caricamentoInCorso.gif",0 );
								if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("carico URL : "+url);
								this.loadApp(url);
							}
					}
					
					break;
					
				case this.sepg:
					
					this.jumpToChannelByZappingId(this.chanId);
					if(this.fw.skyPopupStatus==0){	
						this.takeInfoSEPG();
						this.creaInfoSlot();
						if(this.timerINFOSEPG!=null){
							this.fw.getTimer().clearTimeout(this.timerINFOSEPG);
							this.timerINFOSEPG=null;
						}
						this.timerINFOSEPG = this.fw.getTimer().setTimeout(2500,this.aggiornaSEPG,this);
						/*
						this.takeInfoSEPG();
						this.creaInfoSlot();
						*/
					}else
						if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("PREMO ENTER IN SEPG E NON AGGIORNO LA SEPG");
					break;	
					
				case this.zapper:			
					this.jumpToChannelByZappingId(this.canali[this._mySelectedChannel].ZappingId);
					this.takeInfoSEPG();
					this.creaInfoSlot();
					if(this.timerINFOSEPG!=null){
						this.fw.getTimer().clearTimeout(this.timerINFOSEPG);
						this.timerINFOSEPG=null;
					}
					this.timerINFOSEPG = this.fw.getTimer().setTimeout(2500,this.aggiornaSEPG,this);
					/*
					this.takeInfoSEPG();
					this.creaInfoSlot(); //vado sulla sepg
					*/
					break;
			
				default:
					return true;
					break;
			}
			}
			break;
			
		case 'scrollUp':
			switch(this.getActivity()){			
				default:
					this.numeroCanale = this.numeroCanale+1;
					this.nextZappingChannel(true);
					this.takeInfoSEPG();
					this.creaInfoSlot();
					if(this.timerINFOSEPG!=null){
						this.fw.getTimer().clearTimeout(this.timerINFOSEPG);
						this.timerINFOSEPG=null;
					}
					this.timerINFOSEPG = this.fw.getTimer().setTimeout(2500,this.aggiornaSEPG,this);
					/*
					this.takeInfoSEPG();
					this.creaInfoSlot();
					*/
					break;
			}
			break;
			
		case 'scrollDown':
			switch(this.getActivity()){
			
				default:
					this.numeroCanale = this.numeroCanale-1;
					this.prevZappingChannel(true);
					this.takeInfoSEPG();
					this.creaInfoSlot();
					if(this.timerINFOSEPG!=null){
						this.fw.getTimer().clearTimeout(this.timerINFOSEPG);
						this.timerINFOSEPG=null;
					}
					this.timerINFOSEPG = this.fw.getTimer().setTimeout(2500,this.aggiornaSEPG,this);
					/*
					this.takeInfoSEPG();
					this.creaInfoSlot();
					*/
					break;
			}
			break;
			
		case 'hot1':			
			switch(this.getActivity()){	
			case this.messaggioScansione:
				this.loadApp("/ovaServices/getapp/ScanDTTSettingsApp.html?urlapp=impostazioni&app1=ScanDTTSettingsApp",null);
			break;
			default:
  			break;
  					
  			}
  			
			break;
		case 'hot2':
			switch(this.getActivity()){
			case this.zapper:
			case this.menu:
				//this.fw.verticalMenuIndex = 1;
				this.fw.menuArray[this.fw.myIndex].lastChildIndexSelected = 1;
				this.setNavigationPositionPanel(this.leftPanel);
				this.activateLayout(this.navigationMenu);
				break;
			default:
				break;
		}
			
			break;
			
		case 'hot3':
			switch(this.getActivity()){
				case this.menu:
					break;
				default:
					break;
			}
			break;
			
		case 'hot4':
			
			switch(this.getActivity()){		
			case this.zapper:	
				
				switch(this.fw.VERSIONE_MOD_CANALI){
				case 0:
					
					break;
				case 1:
					this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", true);	
					this.writeOnPopUp( "caricamentoInCorso",null , "/ovaImages/caricamentoInCorso.gif",0 );
					
					if(this.timerGuidaPreferiti){
						this.fw.getTimer().clearTimeout(this.timerGuidaPreferiti);
					}
					this.timerGuidaPreferiti = this.fw.getTimer().setTimeout(this._myGuidaFavoritiTimer,this.lanciaGuidaPreferiti,this);
					
					
					break;
				case 2:
					
					break;
				case 3:
					this.writeOnPopUp( "caricamentoInCorso",null , "/ovaImages/caricamentoInCorso.gif",0 );
					this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", true);	
					
					if(this.timerGuidaPreferiti){
						this.fw.getTimer().clearTimeout(this.timerGuidaPreferiti);
					}
					this.timerGuidaPreferiti = this.fw.getTimer().setTimeout(this._myGuidaFavoritiTimer,this.lanciaGuidaPreferiti,this);
					
				
					break;
				}			
			
			break;
				case this.sepg:
					this.deactivateLayout(); 	//tolgo la sepg e vado a tutto schermo
					break;
				default:
					this.attivaSepg = true;
					this.takeInfoSEPG(); //vado sulla sepg
					this.creaInfoSlot();
					break;
			}
			break;
			
			
		case 'info':
			switch(this.getActivity()){						
				case this.sepg:
					this.deactivateLayout(); 	//tolgo la sepg e vado a tutto schermo
					break;
				default:
					this.attivaSepg = true;
					this.takeInfoSEPG(); //vado sulla sepg
					this.creaInfoSlot();
					break;
			}
			break;
		
		case 'esc':
				if(this.BoxChangeChannel == true){
	 				this.DeleteNumericDigit();
				}else if (this.getActivity() == this.navigationMenu){
					if(this.getNavigationPositionPanel()==this.rightPanel){						
						this.fw.myIndex = this.fw.menuArray[this.fw.myRightPanelIndex].menuParent;
						this.fw.verticalMenuIndex = this.fw.menuArray[this.fw.myIndex].lastChildIndexSelected;
						this.fw.verticalMenuRightPanelIndex = 0;
						this.fw.menuArray[this.fw.myRightPanelIndex].lastChildIndexSelected = 0;
						this.drawRightPanelItemsList('down',false,false,true);
						this.referImageToIFrame(this._layoutId,"layout","Arrow_"+this.leftPanel+"_"+parseInt((this.fw.verticalMenuIndex%this.firstLevelSize)+1),"/ovaImages/restyling/arrows/left_item_arrow.png");
						this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.leftPanel+"_"+parseInt((this.fw.verticalMenuIndex%this.firstLevelSize)+1),"/ovaImages/restyling/arrows/red.png");			
						
						return true;
					}
					this.fw.myIndex = 0;				
					this.fw.verticalMenuIndex = 0;
					this.fw.menuArray[this.fw.myIndex].lastChildIndexSelected = 0;
					this.setNavigationPositionPanel(this.leftPanel);
					this.activateLayout(this.menu);
				} else {
					this.deactivateLayout();
				}
			break;
			
		case 'eye':
				if(this.getActivity() == this.menu){
					this.deactivateLayout();					
				}else {
					this.activateLayout(this.menu);
				}
			break;
		case 'options':			
			this.activateLayout(this.navigationMenu);			
			break;
		
			
			
		case 'guida':
		switch(this.getActivity()){			
			case this.fullScreen:
					this.activateLayout(this.zapper);
				break;
			case this.zapper:			
				this.deactivateLayout();
				break;
			default:
				this.activateLayout(this.zapper);				
				break;
		}
	}
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "manageSectionActivity";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};



HomeTvApp.prototype.lanciaGuidaPreferiti = function() 
{
	try
	{
		if ( this.fw.ShowPreferiti==1 ){	
			this.fw.ShowPreferiti=0;
			this.fw.zapper = this.getZapperSaved();
			this.createZapper();				
			this.canali = this.getZapper();				
		} else if (this.fw.ShowPreferiti==0) {
			if (this.fw.ListaFavoriti.length != 0 ){
				this.fw.ShowPreferiti=1;								
				this.fw.zapper = this.fw.ListaFavoriti;						
				this.createZapper();
				this.canali = this.getPreferiti();
		
			}else{
				this.listaFavEmpty = true;
				this.fw.getLayoutManager().setLayoutVisible("listaPreferitiEmpty", true);
				this.writeOnPopUp( "listaPreferitiEmpty",null , "/ovaImages/listaPreferitiEmpty.png",0 );
				return true;
			}
		}				
		this.fw._currIndexForZapper=0;
		this._mySelectedChannel=0;
		this.jumpToChannelByZappingId(this.canali[this._mySelectedChannel].ZappingId);				
		this.takeInfoSEPG();
		this.creaInfoSlot(); //vado sulla sepg
		this.activateLayout(this.zapper);
		this.salvaFileBootHTML();
		if(this.fw.ShowPreferiti == 1){
			this.attivatoListaPreferiti = true;
			this.fw.getLayoutManager().setLayoutVisible("attivatoListaPreferiti", true);
		}
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "lanciaGuidaPreferiti";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	finally
	{
		return true;
	}		
};

HomeTvApp.prototype.eventKeyFwd = function() 
{
	try
	{
		this.manageSectionActivity('fwd');
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "eventKeyFwd";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	finally
	{
		return true;
	}		
};

HomeTvApp.prototype.eventKeyRwd = function() 
{
	try
	{
		this.manageSectionActivity('rwd');
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "eventKeyRwd";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	finally
	{
		return true;
	}		
};



HomeTvApp.prototype.eventKeyInfo = function() 
{
	try
	{
		this.manageSectionActivity('info');
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "eventKeyInfo";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	finally
	{
		return true;
	}		
};


HomeTvApp.prototype.eventKeyDown = function() 
{
	try
	{
		this.manageSectionActivity('down');
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "eventKeyDown";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	finally
	{
		return true;
	}		
};

HomeTvApp.prototype.eventKeyUp =function() {
	try
	{
		this.manageSectionActivity('up');		
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "eventKeyUp";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
		
	}	
	finally
	{
		return true;
	}			
};

HomeTvApp.prototype.eventKeyLeft = function() 
{
	try
	{
		this.manageSectionActivity('left');
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "eventKeyLeft";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	finally
	{
		return true;
	}				
};

HomeTvApp.prototype.eventKeyEnter = function() 
{
	try
	{
		this.manageSectionActivity('enter');
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "eventKeyLeft";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	finally
	{
		return true;
	}				
};

HomeTvApp.prototype.eventKeyRight=function() { 
	try
	{
		this.manageSectionActivity('right');		
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "eventKeyRight";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	
	finally
	{
		return true;	
	}	
};

/****************************************************************
FUNCTION 		: eventKeyGuide
PARAMETER 	: 
DESCRIPTION : il metodo serve a accendere/spegnere il layout della
							epg grid							
*****************************************************************/
HomeTvApp.prototype.eventKeyGuide=function()
{
 	try
 	{
 		omc.logger.addEntry("@@@@ TASTO eventKeyGuide");
 		this.manageSectionActivity('guida');
 		
 	}catch(ecc){
 		this._objErrorInfo._methodName = "eventKeyGuide";	
 		this._objErrorInfo._obException = ecc;
 		this.handleError();
 	}	
 	finally{
		return true;
 	}		
};

HomeTvApp.prototype.eventKeyOptions=function()
{
 	try
 	{
 		omc.logger.addEntry("@@@@ TASTO eventKeyOptions");
 		this.manageSectionActivity('guida');
 		
 	}catch(ecc){
 		this._objErrorInfo._methodName = "eventKeyGuide";	
 		this._objErrorInfo._obException = ecc;
 		this.handleError();
 	}	
 	finally{
		return true;
 	}		
};
/****************************************************************
FUNCTION 		: eventKeyHot2
PARAMETER 	: 
DESCRIPTION : il metodo serve a accendere/spegnere il layout della
							epg grid							
*****************************************************************/
HomeTvApp.prototype.eventKeyHot2=function()
{
	try
	{
		this.manageSectionActivity('hot2');
		
	}catch(ecc){
		this._objErrorInfo._methodName = "eventKeyHot2";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	
	finally{
		return true;
	}		
};

HomeTvApp.prototype.getSelectedChannel = function ()
{
	try
	{
		return this._mySelectedChannel;
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "getSelectedChannel";	
		this._objErrorInfo._obException = ecc;	
		this.handleError();				
	}
};

HomeTvApp.prototype.activateZapper = function()
{
	try
	{
		omc.logger.addEntry("############# ACTIVATE ZAPPER ###################à");
		this.referImageToIFrame( this._layoutId ,'layout', 'guida' ,'/ovaImages/restyling/buttons/tasto_canali.png') ;
		var bottoneGuida_Label="guida";
		var bottoneGuidaDefault ="/ovaImages/restyling/buttons/tasto_canali.png";
		var bottoneGuidaFav ="/ovaImages/restyling/buttons/tasto_preferiti.png";
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.activateZapper - ShowPreferiti: "+this.fw.ShowPreferiti);
		if(this.fw.ShowPreferiti==0){//zapper default
			this.canali = this.getZapperSaved();
			this.referImageToIFrame( this._layoutId ,'layout', bottoneGuida_Label ,bottoneGuidaFav) ;			
		}else if(this.fw.ShowPreferiti==1){//zapper preferiti
			this.canali = this.getPreferiti();
			this.referImageToIFrame( this._layoutId ,'layout', bottoneGuida_Label ,bottoneGuidaDefault) ;
		}
		

		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.activateZapper - ShowPreferiti -this.fw._currIndexForZapper: "+this.fw._currIndexForZapper);
		this._mySelectedChannel=this.fw._currIndexForZapper;

		var titoloGuidaTV = "";
		var testo_GuidaTV = "";
		if(this.fw.ShowPreferiti==0){//zapper default
			titoloGuidaTV = "/ovaImages/menuRes/guidatv.png";
			testo_GuidaTV="/ovaImages/menu/guidaTV_testo.png";
		}else if(this.fw.ShowPreferiti==1){//zapper preferiti
			titoloGuidaTV = "/ovaImages/menuRes/preferiti.png";
			testo_GuidaTV="/ovaImages/menu/preferiti_testo.png";
		}
		this.referImageToIFrame( this._layoutId ,'layout', 'titoloGuidaTV' ,titoloGuidaTV) ;
		this.referImageToIFrame( this._layoutId ,'layout', 'testo_canali_preferiti' ,testo_GuidaTV) ;
		
		this.fillEpgGridLayers('down',true);
	}
	catch(ecc)
	{
		omc.logger.addEntry(" ECCEZIONE HomeTvApp.activateZapper ecc: "+ecc.message);
		this._objErrorInfo._methodName = "activateZapper";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/******************************************************************
FUNCTION 		: getDate
PARAMETER 	: time (time stamp in millisecondi) , dayPlus (intero)
DESCRIPTION : la funzione ritorna l'indice in formato stringa con la data formattata
							'YYYYMMDD'. la data � restituita in funzione del giorno di sfasamento
							passato come secondo parametro
******************************************************************/
HomeTvApp.prototype.getDate = function(time,dayPlus,format)
{
	try
	{	
		var day = null;
		var daySpan = null;
		daySpan = (dayPlus == null)? 0: dayPlus*(3600*24*1000);
		time = (daySpan != null) ? new Date(this.fw.getOSD().getTime() + daySpan) : new Date(this.fw.getOSD().getTime());
		var dnow = time;
		var giornoS=""+dnow.getUTCDate();
		if (giornoS.length==1)
		{
			var giorno="0"+giornoS;
		}
		else
		{
			var giorno=giornoS;
		}
		var meseS=""+(dnow.getUTCMonth()+1);
		if (meseS.length==1)
		{
			var mese="0"+meseS;
		}
		else
		{
			var mese=meseS;
		}
		var anno=dnow.getUTCFullYear();
		var day ='';
		if (format == null || format == 'YYYYMMDD')
		{
			day = anno+mese+giorno;
		}
		else if(format == 'day DD/MM')
		{
			day = "&nbsp; &nbsp;"+this.getNameDay(dnow)+ ' '+giorno+'/'+mese;
		}
		
	}
	catch(ecc){
		this._objErrorInfo._methodName = 'getDate';
		this._objErrorInfo._obException = ecc;
	}
	return day;
};

HomeTvApp.prototype.drawDetail = function()
{
	try
	{			 
		this.referImageToIFrame( this._layoutId ,'layout', 'dettaglio','/ovaImages/1pixelclear.gif');
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = 'drawDetail'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	
};

/****************************************************************
FUNCTION 		: takeInfoSEPG
DESCRIPTION : metodo che recupera le informazioni necessarie a
							disegnare la sepg
*****************************************************************/
HomeTvApp.prototype.takeInfoSEPG=function(zappingId) {
	try{
		var canaleFav_SPEG = "<img width=\"40\" height=\"30\" src=\"/ovaImages/stellina-ON.png\">";
		var onePixClear = "<img width=\"40\" height=\"30\" src=\"/ovaImages/1pixelclear.gif\">";
		//la prima volta che visualizzo sepg per un canale aggiorno i relativi attributi
		if(zappingId){
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("c'è lo ZappingID*****************");
			this.zapElement=this.getZapperElement(zappingId);
		}
		else{
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("non c'è lo ZappingID*****************");
			this.zapElement=this.getZapperElement();
		}		
		
		if(this.zapElement.ZappingId||this.zapElement.ZappingId==0){
			this.chanId=this.zapElement.ZappingId;
		}
		if(this.zapElement.ChanName){
			this.chanName=this.zapElement.ChanName;
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("this.chanName=this.zapElement.ChanName;: "+this.chanName);
		}
		//identifico il tipo di canale e se � sky
		this.chanType=this.chanTypeZapper(this.zapElement);
		if(this.zapElement.chanrecid){
			this.mychanrecid=this.zapElement.chanrecid;
		}
		var channel = this.fw.getBTVTuner().getEPG().getChannelByChanRecid(this.mychanrecid);	
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("replaceFrameContents: "+this.zappingIdTag+""+this.chanId+""+this.endTag);
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("replaceFrameContents: "+this.startTitoloTag+""+this.chanName+""+this.endTag);
		this.replaceFrameContents(this._layoutId,"zappingId",this.zappingIdTag+'<font size="6" color="#FFFFFF">'+ this.chanId +'</font>'+this.endTag,null);
		
		var nomeCanale = "";
		if(this.mychanrecid == 240 || this.mychanrecid == 241 || this.mychanrecid == 242 || this.mychanrecid == 243 
				|| this.mychanrecid == 244  || this.mychanrecid == 245  || this.mychanrecid == 272  || this.mychanrecid == 273 ){
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("############## SEPG NOME CANALE : "+this.chanName);//.replace(/ù/g,"u'"));
			nomeCanale = this.chanName;			
			
		}else{
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("############## SEPG NOME CANALE : "+channel.callLetters);//.replace(/ù/g,"u'"));
			nomeCanale = channel.callLetters;
			
		}
		this.replaceFrameContents(this._layoutId,"canale",this.startTitoloTag+'<font size="6" color="#FFFFFF">'+nomeCanale+'</font>'+this.endTag,this.cssSrcSepg);
	
		
		
		if (this.fw.ShowPreferiti==0){
			if(this.isCanaleDefaultInPreferiti(nomeCanale)){		
				omc.logger.addEntry("############### STELLINA this.mychanrecid: "+channel.callLetters+" #############################");
				this.replaceFrameContents(this._layoutId,"isCanalePreferitoSEPG",canaleFav_SPEG,null);
										
			}else{
				this.replaceFrameContents(this._layoutId,"isCanalePreferitoSEPG",onePixClear,null);
			}
		}else{
			this.replaceFrameContents(this._layoutId,"isCanalePreferitoSEPG",onePixClear,null);
		}
		
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("### HomeTvApp: serviceInformation ### 1 ###");
		
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("### HomeTvApp: serviceInformation ### 3 ###");
		//riporto sulla sepg le informazioni di canale con replaceFrameContents
		//zapId e titolo
//		this.replaceFrameContents(this._layoutId,"zappingId",this.zappingIdTag+ this.chanId +this.endTag,null);
//		this.replaceFrameContents(this._layoutId,"canale",this.startTitoloTag+this.chanName+this.endTag,this.cssSrcSepg); 
// 		this.replaceFrameContents(this._layoutId,"zappingId2",this.zappingIdTag+ this.chanId +this.endTag,null);
// 		this.replaceFrameContents(this._layoutId,"canale2",this.startTitoloTag+this.chanName+this.endTag,this.cssSrcSepg); 
	
		if(this.getActivity() != this.sepg){
			this.activateLayout(this.sepg);
		}
		
		
		
		this.refreshHourSEPG();
		
	
		
		//this.takeInfoSEPGServiceEvents(channel);
	}catch(ecc){
		omc.logger.addEntry("ECCEZIONE HomeTvApp.takeInfoSEPG: "+ecc.message);
		this._objErrorInfo._methodName = 'takeInfoSEPG';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};


HomeTvApp.prototype.takeInfoSEPGServiceEvents=function(channel) {
	try{
		
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("### HomeTvApp: RECUPERO LA SYSTEM INFORMATION DEL CANALE: "+channel.callLetters+" URL:"+channel.url);
			
		var presentEventList = omc.dvb.getServiceEvents(channel.url, false);		
		var listaEventiPresentAndFuture = new Array();
		
		
		var prefissoHTMLSEPG_Present="<span align=\"left\" class=\"labelCortesia\"><font size=\"4\" color=\"#FFFFFF\">";
		var prefissoHTMLSEPG_Future="<span align=\"left\" class=\"labelCortesia\"><font size=\"4\" color=\"#505050\">";
		var suffissoHTMLSEPG="</font></span>";
		
		listaEventiPresentAndFuture = this.format_service_events(presentEventList);
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("### HomeTvApp: TROVATI PER IL CANALE: "+channel.callLetters+" EVENTI:"+listaEventiPresentAndFuture.length);
			switch(listaEventiPresentAndFuture.length){
				case 0:
				//	for(numeroEventi=1; numeroEventi<3;numeroEventi++){
						this.replaceFrameContents(this._layoutId,"./titoloSchedulazione1_1",prefissoHTMLSEPG_Present+"Programmazione non disponibile"+suffissoHTMLSEPG,null);
						this.replaceFrameContents(this._layoutId,"./elapsedTime1_1",prefissoHTMLSEPG_Present+""+suffissoHTMLSEPG,null);
						
						this.replaceFrameContents(this._layoutId,"./titoloSchedulazione1_2",prefissoHTMLSEPG_Future+"Programmazione non disponibile"+suffissoHTMLSEPG,null);
						this.replaceFrameContents(this._layoutId,"./elapsedTime1_2",prefissoHTMLSEPG_Future+""+suffissoHTMLSEPG,null);
			//		}
					break;
				case 1:
					var eventoPRESENTE = listaEventiPresentAndFuture[0];			
					if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("### EVENTO PRESENTE nome: "+eventoPRESENTE.nome+" durata:"+eventoPRESENTE.durata+" inizio:"+eventoPRESENTE.inizio);
					
					this.replaceFrameContents(this._layoutId,"./titoloSchedulazione1_1",
							prefissoHTMLSEPG_Present+eventoPRESENTE.nome+suffissoHTMLSEPG,null);
					this.replaceFrameContents(this._layoutId,"./elapsedTime1_1",
							prefissoHTMLSEPG_Present+this.convertiMillisecondToOra(eventoPRESENTE.inizio)+suffissoHTMLSEPG,null);
					
					
					this.replaceFrameContents(this._layoutId,"./titoloSchedulazione1_2",
							prefissoHTMLSEPG_Present+""+suffissoHTMLSEPG,null);
					this.replaceFrameContents(this._layoutId,"./elapsedTime1_2",
							prefissoHTMLSEPG_Present+""+suffissoHTMLSEPG,null);
						
					
					break;
				case 2:			
				default:
					listaEventiPresentAndFuture = listaEventiPresentAndFuture.sort(this.ordinaArrayEventSystemInfo);
					var eventoPRESENTE = listaEventiPresentAndFuture[0];
					var eventoFUTURO   = listaEventiPresentAndFuture[1];
					if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("### EVENTO PRESENTE nome: "+eventoPRESENTE.nome+" durata:"+eventoPRESENTE.durata+" inizio:"+eventoPRESENTE.inizio);
					if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("### EVENTO FUTURO nome: "+eventoFUTURO.nome+" durata:"+eventoFUTURO.durata+" inizio:"+eventoFUTURO.inizio);
			
					//for(numeroEventi=0; numeroEventi<listaEventiPresentAndFuture.length;numeroEventi++){
						this.replaceFrameContents(this._layoutId,"./titoloSchedulazione1_1",
								prefissoHTMLSEPG_Present+listaEventiPresentAndFuture[0].nome+suffissoHTMLSEPG,null);
						this.replaceFrameContents(this._layoutId,"./elapsedTime1_1",
								prefissoHTMLSEPG_Present+this.convertiMillisecondToOra(listaEventiPresentAndFuture[0].inizio)+suffissoHTMLSEPG,null);
						
						this.replaceFrameContents(this._layoutId,"./titoloSchedulazione1_2",
								prefissoHTMLSEPG_Future+listaEventiPresentAndFuture[1].nome+suffissoHTMLSEPG,null);
						this.replaceFrameContents(this._layoutId,"./elapsedTime1_2",
								prefissoHTMLSEPG_Future+this.convertiMillisecondToOra(listaEventiPresentAndFuture[1].inizio)+suffissoHTMLSEPG,null);
					//}			
					break;
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'takeInfoSEPGServiceEvents';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};


HomeTvApp.prototype.settaData = function(eventoPRESENTE){
	
	
	return true;
	
};

HomeTvApp.prototype.ordinaArrayEventSystemInfo = function(a,b){
	if(a.inizio>b.inizio)
		return 1;
	if(a.inizio<b.inizio)
		return -1;
	return 0;
	
};

HomeTvApp.prototype.format_service_events=function(service_event_list) {
	 
	 var listaEventi = new Array();
	 
	 try{
		  for(service_event_index=0; service_event_index < service_event_list.length; service_event_index++ ){	
			  	 var evento= new Object();
		         var service_event = service_event_list[service_event_index];     
		         var short_descs = service_event["short_descriptions"];
		         var nomeEvento = short_descs[0]["name"];
		         var durataEvento = service_event["duration"];
		         var inizioEvento = service_event["start_date"];
		         evento.nome = nomeEvento;
		         evento.durata = durataEvento;
		         evento.inizio = inizioEvento;
		         listaEventi.push(evento);
		         
		    }
	}catch(ecc){
		this._objErrorInfo._methodName = 'format_service_events';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	 
	return listaEventi;
};
HomeTvApp.prototype.convertiMillisecondToOra=function(millisecond) {

	millisecond *= 1000;
	var orario="";
	
	var dataInizio = new Date(millisecond);
	
	
	var ore  = ""+(dataInizio.getHours()+1);
	var minuti  = ""+dataInizio.getMinutes();
	
	if(ore.length==1)
		ore="0"+ore;
	if(minuti.length==1)
		minuti="0"+minuti;
	orario=ore+":"+minuti;
	return orario;
}

/****************************************************************
FUNCTION 		: aggiornaInfoSEPG
PARAMETER 	: 1) direction - direzione di scorrimento della
														programmazione del canale: 'dx' o 'sx'
DESCRIPTION : aggiorna il contenuto della sepg scorrendo nella programmazione
							secondo il valore di direction: 'dx' o 'sx'
*****************************************************************/
HomeTvApp.prototype.aggiornaInfoSEPG=function(direction) {
	try{
		this.mychanrecid=this.zapElement.chanrecid;
		
		//mi sposto allo slot successivo o precedente in base a direction
		if(direction=='dx'){
			spostamento=+1;
		}else if(direction=='sx'){
			spostamento=-1;
		}
		
		//cerco di prendere il nuovo slot
		var epgSlot = new Object();
		epgSlot = this.getProgramSlot(this.mychanrecid, this._initIndex+this._offsetIndex+spostamento);
		
		if (epgSlot==null || epgSlot==undefined){
			return true; //non c'� ulteriore programmazione, quindi non faccio nulla
		}else{
			this._offsetIndex+=spostamento; //cambio lo slot attualmente visualizzato
			this.disegnaInternoSEPG(epgSlot);
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'aggiornaInfoSEPG';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};


/****************************************************************
FUNCTION 		: disegnaInternoSEPG
PARAMETER 	: 1) epgSlot - program slot da disegnare sulla sepg
DESCRIPTION : metodo che disegna l'interno della sepg a partire
							dalle informazioni precedentemnte recuperate
*****************************************************************/
HomeTvApp.prototype.disegnaInternoSEPG=function(epgSlot){
	try{
		
		//da slot prendo titolo e parental control dello slot attuale
		var lunghezza_titolo=45;
// 		this.parentalControl='/ovaImages/1pixelclear.gif'; //di default vuota
		rating_contenuto=null;
		
		//Recupero il rating del canale attuale
		this._epg=this.fw.getBTVTuner().getEPG();						  	
		if(this.mychanrecid && this._epg.getChannelByChanRecid(this.mychanrecid)){		  	
  			rating_contenuto=this._epg.getChannelByChanRecid(this.mychanrecid).ratingRecid;   
  			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.disegnaInternoSEPG rating_contenuto = "+rating_contenuto);       
  		}
  		epgSlot = this.getProgramSlot(this.mychanrecid, 0);
		if(epgSlot==null || epgSlot==undefined || epgSlot.program==null || epgSlot.program==undefined){
			this.titolo = " ";  	
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.disegnaInternoSEPG 1 - titolo = "+this.titolo +"  mychanrecid= "+this.mychanrecid+" epgslot="+epgSlot);   
		}else{
			this.titolo=epgSlot.program.title;
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.disegnaInternoSEPG 2 - titolo = "+this.titolo); 
			if (this.titolo==null || this.titolo==undefined){
				this.titolo=" ";
			}
			//per i canali tematici rai aggiungo il tema del giorno
			if(this.isRai && epgSlot.program.shortdescription){
				this.titolo=this.titolo+" - "+epgSlot.program.shortdescription;
				if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.disegnaInternoSEPG 3 - titolo = "+this.titolo); 
			}
			//taglio il titolo eccedente la lunghezza_titolo massima consentita
			this.titolo=this.fw.getUtil().truncateString(this.titolo, lunghezza_titolo, true);
			if(this.titolo==null || this.titolo==undefined){
				this.titolo="";	
				if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.disegnaInternoSEPG 4 - titolo = "+this.titolo); 
			}
			if(epgSlot.program.ratingid && epgSlot.program.ratingid>=1 && epgSlot.program.ratingid<=3){
				rating_contenuto=epgSlot.program.ratingid;
			}
		}
		
		//imposto immagine omino parental control		
// 		if (rating_contenuto!=null){
// 			this.parentalControl='/ovaImages/sepg/bt_parental_'+rating_contenuto+'.gif';
// 		}
		
		//recupero fascia oraria e descrizione dello slot attuale
		if(epgSlot==null || epgSlot==undefined || epgSlot.program==null || epgSlot.program==undefined) {
			this.ora="";
			this.longDesc="";
		}else{
			this.longDesc = epgSlot.program.longdescription;
			if(this.longDesc==null || this.longDesc==undefined){
				this.longDesc="";
			}
			var startTime=this.convertHourSEPG(this.checkOraLegale(epgSlot.program.startdate));
			var endTime=this.convertHourSEPG(this.checkOraLegale(epgSlot.program.enddate));
			this.ora=startTime+" "+endTime;
			if(this.ora==null || this.ora==undefined){
				this.ora="";
			}
		}
		
		//costruisco il testo interno della sepg e lo divido in blocchi
		//nell'array descBlocchi, ciascuno di size_max_box caratteri
		
		this.size_max_box=63; //lunghezza max riga di descrizione
		this.righePerBlocco = 3; //numero di righe per blocco di descrizione
		
		//qui inserisco il messaggio di cortesia per i canali dtt non scannerizzati
		channel = this._epg.getChannelByChanRecid(this.mychanrecid);
		if(this.isDTTEnabled()){	
			if ((channel) && (channel.chanType) && (channel.chanType.toLowerCase() == 'dvbt' ) && (this.fw.getDTT().getChannelByURL(channel.url) == null)){
				this.titDescrizione="";
				this.descrizione=(this.fw.getConfig().DTT_CHAN_DESCRIPTION != null )? this.fw.getConfig().DTT_CHAN_DESCRIPTION : "Il canale al momento non e' disponibile. Ti consigliamo di effettuare una nuova ricerca nella sezione Impostazioni alla voce Digitale Terrestre.";
			}else{
				this.titDescrizione = this.ora+" "+this.titolo
				this.descrizione = this.longDesc;
			}
		}else{
			this.titDescrizione = this.ora+" "+this.titolo
			this.descrizione = this.longDesc;
		}
		
		//riempio l'array delle righe di descrizione
		this.numeroRighe=0; //variabile globale che tiene traccia del numero totale
												//delle righe di descrizione da visualizzare
		this.righeDescrizione = new Array();
		
		if (this.titDescrizione!=null && this.titDescrizione!=""){
			this.numeroRighe++;
			this.righeDescrizione[this.numeroRighe]=this.titDescrizione;
		}
		while (this.descrizione!=null && this.descrizione!=""){
			this.numeroRighe++;
			this.righeDescrizione[this.numeroRighe]=this.ricavaRigaDescrizione();
		}
		
		this.numeroRigaAttuale=1; //variabile globale che tiene traccia della riga dove mi trovo					//parto dalla prima riga
			
		this.disegnaDescrizioneSEPG()
		
		//disegno il cursore sulla barra di scorrimento verticale
		this.paintCursor();
	}catch(ecc){
		this._objErrorInfo._methodName = 'disegnaInternoSEPG';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};



/****************************************************************
FUNCTION 		: getCurrentProgramSlotIndex
PARAMETER 	: 1) chanRecid - recid del canale
DESCRIPTION : metodo che recupera l'indice del program slot attuale
							del canale identificato da chanRecid
RETURN			:	1) idx - indice slot attuale
*****************************************************************/
HomeTvApp.prototype.getCurrentProgramSlotIndex = function(chanRecid) {
	try{		
		
		if(!chanRecid) return null;
		time = this.fw.getOSD().getTime();		  	  
		//timei=time + parseInt(this.fw.getConfig().OFFSET_ORA_LEGALE);		 
		
	
		
			try{ 	 
			   this._epg = this.fw.getBTVTuner().getEPG();
			   var idx=this._epg.findSlotIndexByTime(chanRecid,time);
		  }catch(e){
		  	 idx=null;
		  }
		
		
		return idx;
	}catch(ecc){
		this._objErrorInfo._methodName = 'getCurrentProgramSlotIndex'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}	       	
};

/****************************************************************
FUNCTION 		: disegnaDescrizioneSEPG
PARAMETER 	: 
DESCRIPTION : metodo che disegna la descrizione dentro la sepg a partire
							dalle informazioni precedentemente recuperate
*****************************************************************/
HomeTvApp.prototype.disegnaDescrizioneSEPG=function(){
	try{
		//controlli iniziali di consistenza sui parametri di input
		if (this.numeroRigaAttuale<1){
			this.numeroRigaAttuale==1;
		}
		if (this.numeroRighe<1){
			this.numeroRighe==1;
		}
		if (this.numeroRigaAttuale>this.numeroRighe){
			this.numeroRigaAttuale=this.numeroRighe;
		}
		
		stringaUscita="";
		//visualizzo le varie righe di testo una alla volta
		if (this.numeroRigaAttuale<=this.numeroRighe){
			stringaUscita+=this.righeDescrizione[this.numeroRigaAttuale];
		}
		//seconda riga caso prima pagina
		if (this.numeroRigaAttuale+1<=this.numeroRighe){
			stringaUscita+="<BR>"+this.righeDescrizione[this.numeroRigaAttuale+1];
		}
		//terza riga caso prima pagina
		if (this.numeroRigaAttuale+2<=this.numeroRighe){
			stringaUscita+="<BR>"+this.righeDescrizione[this.numeroRigaAttuale+2];
		}
		//riporto all'interno della sepg le righe di descrizione trovate
		this.replaceFrameContents(this._layoutId,"./desc",this.startStringaUscitaTag+ stringaUscita +this.endTag,this.cssSrcSepg); 
		
	}catch(ecc){
		this._objErrorInfo._methodName = 'disegnaDescrizioneSEPG';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/****************************************************************
FUNCTION 		: paintCursor
PARAMETER 	: 
DESCRIPTION : metodo che disegna il cursore nella barra verticale
							a dx della sepg in maniera coerente con il numero
							totale di righe di testo che compongono la descrizione
							e con quale � la riga attuale
*****************************************************************/
HomeTvApp.prototype.paintCursor=function(){
	try
	{	
		return true;
	}
	catch(ecc){
		this._objErrorInfo._methodName = 'paintCursor'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	       
	return true;	
};

/****************************************************************
FUNCTION 		: ricavaRigaDescrizione
PARAMETER 	: -
OUTPUT			: ritorna la prossima riga di descrizione
DESCRIPTION : metodo che, a partire dalla stringa che contiene
						  la descrizione, ricava la prossima riga di testo,
						  conservando le parole nella loro interezza
*****************************************************************/
HomeTvApp.prototype.ricavaRigaDescrizione=function(){
	try
	{	
		if (this.descrizione.length > this.size_max_box){
			sottoStringa=this.descrizione.substring(0,this.size_max_box);
			lastSpace=sottoStringa.lastIndexOf(' ');
			if (lastSpace!=-1){
				sottoStringa=this.descrizione.substring(0,lastSpace);
				this.descrizione=this.descrizione.substring(lastSpace,this.descrizione.length);
				return sottoStringa;
			}else{
				this.descrizione=this.descrizione.substring(this.size_max_box,this.descrizione.length);
				return sottoStringa;
			}
		}else{
			sottoStringa=this.descrizione;
			this.descrizione="";
			return sottoStringa;
		}
	}
	catch(ecc){
		this._objErrorInfo._methodName = 'ricavaRigaDescrizione'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return new String("");
	}	
};

/****************************************************************
FUNCTION 		: eventKeyHot4
PARAMETER 	: 
DESCRIPTION : il metodo serve a accendere/spegnere il layout della
							short-epg							
*****************************************************************/
HomeTvApp.prototype.eventKeyHot4=function(){
	try{
		this.manageSectionActivity('hot4');
	}catch(ecc){
		this._objErrorInfo._methodName = "eventKeyHot4";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	
};

/****************************************************************
FUNCTION 		: eventKeyHot1
PARAMETER 	: 
DESCRIPTION : il metodo serve a gestire il tasto rosso
*****************************************************************/
HomeTvApp.prototype.eventKeyHot1=function(){
	
	try{

		this.manageSectionActivity('hot1');
		
		omc.logger.addEntry("FATTO ...");
	}catch(ecc){
		this._objErrorInfo._methodName = "eventKeyHot1";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	
	return true;
};


/****************************************************************
FUNCTION 		: eventKeyEsc
PARAMETER 	: 
DESCRIPTION : il metodo serve a gestire il tasto Esc
*****************************************************************/
HomeTvApp.prototype.eventKeyEsc=function(){
	try{
		this.manageSectionActivity('esc');
	}catch(ecc){
		this._objErrorInfo._methodName = "eventKeyEsc";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	
};

/****************************************************************
FUNCTION 		: eventKeyBack
PARAMETER 	: 
DESCRIPTION : il metodo serve a gestire il tasto Back
*****************************************************************/
HomeTvApp.prototype.eventKeyBack=function(){
	try{
		switch(this.fw._myActivity){
			default:	
				this.eventKeyEsc();
				break;
		}
	}catch(ecc){
		this._objErrorInfo._methodName = "eventKeyBack";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	
};

HomeTvApp.prototype.eventKeyMenu  = function(){	
	try{
		this.eventKeyEye();
	}catch(ecc){
		this._objErrorInfo._methodName = "eventKeyEye";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	
	return true;
};

/****************************************************************
FUNCTION 		: eventKeyEye
PARAMETER 	: 
DESCRIPTION : il metodo serve a gestire il tasto occhio
*****************************************************************/
HomeTvApp.prototype.eventKeyEye  = function(){	
	try{
		this.manageSectionActivity('eye');
	}catch(ecc){
		this._objErrorInfo._methodName = "eventKeyEye";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	
	return true;
};

/****************************************************************
FUNCTION 		: eventKeyScrollUp
PARAMETER 	: 
DESCRIPTION : il metodo serve a gestire lo zapping tra i vari canali
							con e senza le due sepg aperte						
*****************************************************************/
HomeTvApp.prototype.eventKeyScrollUp=function(){ 
	try
	{
		this.manageSectionActivity('scrollUp');
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = 'eventKeyScrollUp';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}finally{
		return true;	
	}
};


/****************************************************************
FUNCTION 		: eventKeyScrollDown
PARAMETER 	: 
DESCRIPTION : il metodo serve a gestire lo zapping tra i vari canali
							con e senza le due sepg aperte						
*****************************************************************/
HomeTvApp.prototype.eventKeyScrollDown=function(){ 
	try
	{
		this.manageSectionActivity('scrollDown');
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = 'eventKeyScrollUp';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}finally{
		return true;	
	}
};

/****************************************************************
FUNCTION 		: eventKeyHot3
PARAMETER 	: 
DESCRIPTION : il metodo serve a accendere/spegnere il layout della
							sepg grid sezione setting (solo canali sky)						
*****************************************************************/
HomeTvApp.prototype.eventKeyHot3=function(){
	try{	//omc.logger.addEntry("Tasto hot3 Premuto");
		this.manageSectionActivity('hot3');
	}catch(ecc){
		this._objErrorInfo._methodName = "eventKeyHot3";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}finally{
		return true;
	}		
};

/****************************************************************
FUNCTION 		: eventKeyOptions
PARAMETER 	: 
DESCRIPTION : il metodo serve a accendere/spegnere il layout della
							sepg grid sezione setting (solo canali sky)						
*****************************************************************/
HomeTvApp.prototype.eventKeyOptions=function(){
	try{
		this.manageSectionActivity('options');
	}catch(ecc){
		this._objErrorInfo._methodName = "eventKeyOptions";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}finally{
		return true;
	}		
};

/*****************************************************
FUNCTION: deactivateTimer
DESCRIPTION: 	funzione chiamata per disattivare i timer
						delle attivit�
*****************************************************/
HomeTvApp.prototype.deactivateTimer=function(){
	try
	{
		//se attivo, distruggo il timer dell'orologio per le sepg
		if(this.currentHourSEPG){
			this.fw.getTimer().clearTimeout(this.currentHourSEPG);
		}
		if (this._myIdTimer)
		{
			this.fw.getTimer().clearTimeout(this._myIdTimer);
		}
		if (this.currentHour)
		{
			this.fw.getTimer().clearTimeout(this.currentHour);
		}
		if (this._menuTimer)
		{
			this.fw.getTimer().clearTimeout(this._menuTimer);
		}
		if(this._newsTimer)
		{
			this.fw.getTimer().clearTimeout(this._newsTimer);
		}
		if(this.timerDettaglio)
		{
			this.fw.getTimer().clearTimeout(this.timerDettaglio);
		}
		
		return true;
	}catch(ecc){
		this._objErrorInfo._methodName = "deactivateTimer";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
		
	}	
};

/*****************************************************
FUNCTION: fin
DESCRIPTION: 	funzione chiamata all'atto della chiusura
							dell'applicazione
*****************************************************/
HomeTvApp.prototype.fin=function(){
	try
	{
		this.deactivateTimer();
		
		//this.unload_Video();
		return true;
	}catch(ecc){
		this._objErrorInfo._methodName = "fin";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
		
	}	
};

/****************************************************************
FUNCTION 		: refreshHourSEPG
PARAMETER 	: 
DESCRIPTION : metodo che gestisce la visualizzazione periodica, ogni
							minuto, della data e dell'orario sulle due sepg
*****************************************************************/
HomeTvApp.prototype.refreshHourSEPG = function(){
	try{
		if (this.getActivity()==this.sepg || this.getActivity()==this.setting){		
			var now=this.fw.getOSD().getTime();
			var dnow=new Date();
	//		dnow.setTime(now);
			
			var giornoS=""+dnow.getUTCDate();
			if (giornoS.length==1){
				var giorno="0"+giornoS;
			}else{
				var giorno=giornoS;	      
			}
			
			var meseS=""+(dnow.getUTCMonth()+1);
			if (meseS.length==1){
				var mese="0"+meseS;
			}else{
				var mese=meseS;	      
			}
			var anno=dnow.getUTCFullYear();
			anno=anno.toString().slice(2);
			//mese = this.getMonthName(mese,true);
			
			this.oggi =giorno+"/"+mese+"/"+anno;
			
			//TODO regolare l'ora solare
			//this.hours = parseInt(dnow.getUTCHours()+2);
			this.hours = parseInt(dnow.getHours());
			this.minutes = parseInt(dnow.getUTCMinutes());
			
			if(this.minutes>=0 && this.minutes<=9)
			this.minutes = "0"+this.minutes;
			
			if(this.hours>=0 && this.hours<=9)
			this.hours = "0"+this.hours;
			
			var label_orario = this.oggi+" "+this.hours+":"+this.minutes;
			omc.logger.addEntry("replaceFrameContents: "+this.startOraTag+""+label_orario+""+this.endTag);
			if(this.fw.DATA_ORA_ENABLED)
				this.replaceFrameContents(this._layoutId,"./ora",  this.startOraTag+'<font size="3" color="#FFFFFF">' + label_orario + '</font>'+this.endTag,this.cssSrcSepg);
			else
				this.replaceFrameContents(this._layoutId,"./ora",  "",this.cssSrcSepg);
		//	if(this.fw.DATA_ORA_ENABLED)
		//		this.replaceFrameContents(this._layoutId,"tipoCanale",  this.startOraTag+'<font size="3" color="#FFFFFF">' + this.getChannelTypeString() + '</font>'+this.endTag,this.cssSrcSepg);
		//	else
		//		this.replaceFrameContents(this._layoutId,"tipoCanale",  "",this.cssSrcSepg);
			if(this.currentHourSEPG){
				this.fw.getTimer().clearTimeout(this.currentHourSEPG);
			}
			this.currentHourSEPG = this.fw.getTimer().setTimeout(60000,this.refreshHourSEPG,this);
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'refreshHourSEPG';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/****************************************************************
FUNCTION 		: convertHourSEPG
PARAMETER 	: 1)hourMillis - ora da convertire, in millisecondi dal 1970
DESCRIPTION : metodo che converte la data in millisecondi ricavando
							ora e minuti e formattandoli come serve per la sepg
*****************************************************************/
HomeTvApp.prototype.convertHourSEPG = function(hourMillis){
	try	{
		var dnow=new Date();
		dnow.setTime(hourMillis);
		
		this.hours = parseInt(dnow.getUTCHours());
		this.minutes = parseInt(dnow.getUTCMinutes());

		if(this.minutes>=0 && this.minutes<=9){
			this.minutes = "0"+this.minutes;
		}
		if(this.hours>=0 && this.hours<=9){
			this.hours = "0"+this.hours;
		}
		var label_orario = this.hours+":"+this.minutes;
		return label_orario;
	}catch(ecc){
		this._objErrorInfo._methodName = 'convertHourSEPG';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

/****************************************************************
FUNCTION 		: getProgramSlot
PARAMETER 	: 1) chanRecid - recid del canale di cui prendere lo slot
							2) index - indice dello slot da recuperare
DESCRIPTION : metodo che restituisce il program slot del canale
							identificato da chanRecid per l'indice index
RETURN			:	1) epgSlot - program slot restituito, null se non
													c'� schedulazione o se index � errato
*****************************************************************/
HomeTvApp.prototype.getProgramSlot = function(chanRecid, index) {
	try{
		//recupero il canale attuale
		var chan = this._epg.getChannelByChanRecid(chanRecid);
		
		if(chan!= null){
			if(chan.isLocal!=true){	//caso canale non locale sia dtt che bvt
				//prendo lo slot dal db tramite epg
				var schd = this._epg.getChannelSchedule(chanRecid);
				
				var ret=null;
				if (schd != null && 0 <= index && index < schd.length){
					this.maxIndex = schd.length;
					ret=schd[index];
					
				}	
			}else if (this.isDTTEnabled() == true){ //caso canale locale dtt
				//prendo lo slot direttamente dalla ovaDTT
				var schd = this.fw.getDTT().getSchedule(chan.url,false);
				if (schd != null && schd.length>0){
					this.initIndex = 0;
					ret = schd[0];
					//ret.longdescription = schd[0].program.shortDescription;
					ret.nonUsareOffset = true;
				}else{
					ret = null;
				}	
			}
		}else if (this.isDTTEnabled() == true){
			//caso canali locale non restituito dalla epg
			if (this.fw.getDTT().getChannelByRecid(chanRecid)){
				var schd = this.fw.getDTT().getSchedule(this.fw.getDTT().getChannelByRecid(chanRecid).url,false);
			}
			if (schd != null && schd.length>0){
				this.initIndex = 0;
				ret = schd[0];
				//ret.longdescription = schd[0].program.shortDescription;
				ret.nonUsareOffset = true;
			}else{
				ret = null;
			}
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'getProgramSlot'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return ret;
};


HomeTvApp.prototype.fillOpzioniGridLayers = function(action)
{
	try
	{
		
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "fillOpzioniGridLayers";	
		this._objErrorInfo._obException = ecc;	
		this.handleError();				
	}
};

HomeTvApp.prototype.isCanaleDefaultInPreferiti = function (nomeCanaleDaCercare)
{	
	if(this.fw.OMC_LOGGER_ENABLED)
		omc.logger.addEntry("######### HomeTvApp.isCanaleDefaultInPreferiti ###  1 ### CERCO "+nomeCanaleDaCercare);
	var trovato = false;
	try{
		var chID = null;	
		var channel = null;
		var nomeFav = null;
	
		if (this.fw.ListaFavoriti.length>0){
			for (j=0; j<this.fw.ListaFavoriti.length;j++){
				chID = this.fw.ListaFavoriti[j].chanrecid;
				channel = this.fw.getBTVTuner().getEPG().getChannelByChanRecid(this.fw.ListaFavoriti[j].chanrecid);
				if(chID == 240 || chID == 241 || chID == 242 || chID == 243 
						|| chID == 244  || chID == 245  || chID == 272  || chID == 273 ){
					nomeFav = this.fw.ListaFavoriti[j].ChanName;		
				}else{
					nomeFav =  channel.callLetters;
				}
				omc.logger.addEntry("######### HomeTvApp.isCanaleDefaultInPreferiti Scorro nome canale : "+nomeFav);
				if (nomeCanaleDaCercare == nomeFav){
					if(this.fw.OMC_LOGGER_ENABLED)
						omc.logger.addEntry("######### HomeTvApp.isCanaleDefaultInPreferiti ###  3 ### TROVATO "+nomeCanaleDaCercare);
					trovato = true;					
				}	
			}
		}
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "isCanaleDefaultInPreferiti";	
		this._objErrorInfo._obException = ecc;	
		//this.handleError();
		return false;
	}
	return trovato;
	//return false;
};
HomeTvApp.prototype.fillEpgGridLayers = function(action,forceRedraw)
{
	try
	{	
		if (this._isEpgGridLocked() == true)
		{	
			return;
		}
		var size = (this.getActivity() == this.epgGrid) ? this._epgGrid._rows : this.zapperGridSize;
		var selectedIndex =  this.getSelectedChannel() % size;
		var imgTabLevel = 'zapper_canale';
		var time = new Date(this.fw.getOSD().getTime());
		var date = this.getDate(time,this.daySpan);
		this._myDate = date;	
		var onePixClear = '/ovaImages/1pixelclear.gif';
		var canaleFav_on = '/ovaImages/canale_pref_on.png';
		var canaleFav_off = '/ovaImages/canale_pref_off.png';
		var canaleFav_label = 'Zapper_dx_';
		
		      
		this._epg = this.fw.getBTVTuner().getEPG();
		if ((forceRedraw != true && !(selectedIndex == 0 && action == 'down') && !(selectedIndex == (size-1) && action == 'up')) )
		{
			this.switchFocus(action);
		}
		else
		{
			if (forceRedraw!=true){
				//prima di ridisegnare la nuova pagina spengo l'ultimo elemento visitato
				//per evitare il problema del doppio focus
				var index_prev 	= this._myPrevSelectedChannel % size;
				if (action=='up'){
					// spengo il precedente
					if (this.fw.ShowPreferiti==0){
						if(this.isCanaleDefaultInPreferiti(this.canali[this._myPrevSelectedChannel].ChanName)){					
							this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index_prev+1) , canaleFav_off);						
						}else{
							this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index_prev+1) , onePixClear);
						}
						this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (index_prev+1) , this.fw.ImageLibOffCGI[this.canali[this._myPrevSelectedChannel].chanrecid].src);
					}else if (this.fw.ShowPreferiti==1){
						this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (index_prev+1) , this.fw.ImagePreferitiOff[this.canali[this._myPrevSelectedChannel].chanrecid].src);
						this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index_prev+1) , onePixClear);
					}
				}else{
					// spengo il precedente
						if (this.fw.ShowPreferiti==0){
							if(this.isCanaleDefaultInPreferiti(this.canali[this._myPrevSelectedChannel].ChanName)){					
								this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index_prev+1) , canaleFav_off);								
							}else{
								this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index_prev+1) , onePixClear);
							}
							//else
							this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (index_prev+1) , this.fw.ImageLibOffCGI[this.canali[this._myPrevSelectedChannel].chanrecid].src);
						}else if (this.fw.ShowPreferiti==1){
							this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (index_prev+1) , this.fw.ImagePreferitiOff[this.canali[this._myPrevSelectedChannel].chanrecid].src);
							this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index_prev+1) , onePixClear);
						}
				}
			}

			var initIndex = Math.floor((this.getSelectedChannel() / size)) * size;
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("this.canali.length: "+this.canali.length);
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.fillEpgGridLayers - initIndex:"+initIndex+" size:"+size);
			for (i = initIndex; i < initIndex + size; i++) {
				
				var indxArray = 0;
				var indxTable = 0;
				
				if (action == "down" || forceRedraw)
				{	
					// set dei valori per il caso down
					indxArray = i ;
					indxTable = i - initIndex;	
				} else if (action == "up"|| forceRedraw) {
					// set dei valori per il caso up
					indxArray = 2*initIndex + size - 1 - i ;
					indxTable = size -1 - i + initIndex;
				} else if(action == "left" || forceRedraw){
					// set dei valori per il caso left
					indxArray = i;
					indxTable = i - initIndex;
				} else if (action == "right" || forceRedraw){
					// set dei valori per il caso right
					indxArray = i;
					indxTable = i - initIndex;
				}
				if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.fillEpgGridLayers - indxArray:"+indxArray+" this.canali.length:"+this.canali.length);
				if (indxArray < this.canali.length) {
					
					if(selectedIndex == indxTable ) {//Cambio quello selezionato
						/* se per esempio initIndex + size vale 11, qui entra 1 volta per creare il
						   zapperone, tranne quello selezionato */
						if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.fillEpgGridLayers - this.fw.ShowPreferiti:"+this.fw.ShowPreferiti);							
						if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.fillEpgGridLayers - imgTabLevel+(indxTable+1) :" +(imgTabLevel+(indxTable+1)));
						if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.fillEpgGridLayers - this.canali[indxArray].ChanName :" +this.canali[indxArray].ChanName);

						if (this.fw.ShowPreferiti==0) {
							if(this.fw.OMC_LOGGER_ENABLED)
								omc.logger.addEntry("HomeTvApp.fillEpgGridLayers - this.fw.ImageLibOnCGI[this.canali[indxArray].chanrecid].src :" +this.fw.ImageLibOnCGI[this.canali[indxArray].chanrecid].src);
							if(this.isCanaleDefaultInPreferiti(this.canali[indxArray].ChanName)){					
								this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(indxTable+1) , canaleFav_on);							
							}else{
								this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(indxTable+1) , onePixClear);
							}
							//else
							this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+(indxTable+1) , this.fw.ImageLibOnCGI[this.canali[indxArray].chanrecid].src);
						} else if (this.fw.ShowPreferiti==1) {
							if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.fillEpgGridLayers - this.fw.ImageLibOnCGI[this.canali[indxArray].chanrecid].src :" +this.fw.ImagePreferitiOn[this.canali[indxArray].chanrecid].src);
							this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (indxTable+1) , this.fw.ImagePreferitiOn[this.canali[indxArray].chanrecid].src);
							this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(indxTable+1) , onePixClear);
						}
					} else {
						/* se per esempio initIndex + size vale 10, qui entra 9 volte per creare il
						   zapperone, tranne quello selezionato */
							if (this.fw.ShowPreferiti==0){
								if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("HomeTvApp.fillEpgGridLayers - this.fw.ImageLibOffCGI[this.canali[indxArray].chanrecid].src :" +this.fw.ImageLibOffCGI[this.canali[indxArray].chanrecid].src);
								if(this.isCanaleDefaultInPreferiti(this.canali[indxArray].ChanName)){					
									this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(indxTable+1) , canaleFav_off);							
								}else{
									this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(indxTable+1) , onePixClear);
								}
								//else
								this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+(indxTable+1) , this.fw.ImageLibOffCGI[this.canali[indxArray].chanrecid].src);
							} else if (this.fw.ShowPreferiti==1) {							
								this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (indxTable+1) , this.fw.ImagePreferitiOff[this.canali[indxArray].chanrecid].src);
								this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(indxTable+1) , onePixClear);
							}	
					}					
				} else {
					this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+(indxTable+1) , onePixClear);
					this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(indxTable+1) , onePixClear);
				}
			}
		}	
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "fillEpgGridLayers";	
		this._objErrorInfo._obException = ecc;	
		this.handleError();				
	}
	this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", false);
};

/************************************************************/
HomeTvApp.prototype.switchFocus = function(action)
{
	try {
		if (this._isEpgGridLocked() == true)
		{
			return;
		}
// 		var val = 0;
		var onePixClear = '/ovaImages/1pixelclear.gif';
		var date = this._myDate;
		var rows = (this.getActivity() == this.epgGrid) ? this._epgGrid._rows : this.zapperGridSize;
		var index = this._mySelectedChannel % rows;
		var index_prev 	= (action=='up') ? index + 1 : index - 1 ;
		      

		var imgTabLevel = 'zapper_canale';
		var canaleFav_on = '/ovaImages/canale_pref_on.png';
		var canaleFav_off = '/ovaImages/canale_pref_off.png';
		var canaleFav_label = 'Zapper_dx_';
		if (action=='up')
		{
			// spengo il precedente
	
				if (this.fw.ShowPreferiti==0) {
					if(this.isCanaleDefaultInPreferiti(this.canali[this._myPrevSelectedChannel].ChanName)){					
						this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index_prev+1) , canaleFav_off);					
					}else{
						this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index_prev+1) , onePixClear);
					}
					this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (index_prev+1) , this.fw.ImageLibOffCGI[this.canali[this._myPrevSelectedChannel].chanrecid].src);
				} else if (this.fw.ShowPreferiti==1) {
					this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (index_prev+1) , this.fw.ImagePreferitiOff[this.canali[this._myPrevSelectedChannel].chanrecid].src);
					this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index_prev+1) , onePixClear);
				}	
			// accendo il nuovo	
				if (this.fw.ShowPreferiti==0) {
					if(this.isCanaleDefaultInPreferiti(this.canali[this._mySelectedChannel].ChanName)){					
						this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index+1) , canaleFav_on);					
					}else{
						this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index+1) , onePixClear);
					}
					this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (index+1) , this.fw.ImageLibOnCGI[this.canali[this._mySelectedChannel].chanrecid].src);
				} else if (this.fw.ShowPreferiti==1) {
					this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (index+1) , this.fw.ImagePreferitiOn[this.canali[this._mySelectedChannel].chanrecid].src);
					this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index+1) , onePixClear);
				}			
			} else	{ 
		
				if (this.fw.ShowPreferiti==0){
					if(this.isCanaleDefaultInPreferiti(this.canali[this._myPrevSelectedChannel].ChanName)){					
						this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index_prev+1) , canaleFav_off);					
					}else{
						this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index_prev+1) , onePixClear);
					}
					this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (index_prev+1) , this.fw.ImageLibOffCGI[this.canali[this._myPrevSelectedChannel].chanrecid].src);
				} else if (this.fw.ShowPreferiti==1) {
					this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (index_prev+1) , this.fw.ImagePreferitiOff[this.canali[this._myPrevSelectedChannel].chanrecid].src);
					this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index_prev+1) , onePixClear);
				}	
				
			// accendo il nuovo
				if (this.fw.ShowPreferiti==0){
					if(this.isCanaleDefaultInPreferiti(this.canali[this._mySelectedChannel].ChanName)){					
						this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index+1) , canaleFav_on);						
					}else{
						this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index+1) , onePixClear);
					}
					this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (index+1) , this.fw.ImageLibOnCGI[this.canali[this._mySelectedChannel].chanrecid].src);
				} else if (this.fw.ShowPreferiti==1) {
					this.referImageToIFrame( this._layoutId ,'layout', imgTabLevel+ (index+1) , this.fw.ImagePreferitiOn[this.canali[this._mySelectedChannel].chanrecid].src);
					this.referImageToIFrame( this._layoutId ,'layout', canaleFav_label+(index+1) , onePixClear);
				}	
		}
	} catch(ecc) {
		this._objErrorInfo._methodName = 'switchFocus';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

HomeTvApp.prototype.getNameDay = function(time)
{
	var nomegiorno ="";
	try
	{	
		
		switch(time.getUTCDay())
		{
		case 0:
			nomegiorno = "Domenica";
			break;
			case 1:
			nomegiorno = "Lunedi'";
			break;
			case 2:
			nomegiorno = "Martedi'";
			break;
			case 3:
			nomegiorno = "Mercoledi'";
			break;
			case 4:
			nomegiorno = "Giovedi'";
			break;
			case 5:
			nomegiorno = "Venerdi'";
			break;
			case 6:
			nomegiorno = "Sabato";
			break;
		}
	}
	catch(ecc)
	{
			this._objErrorInfo._methodName = 'getNameDay';
			this._objErrorInfo._obException = ecc;
			this.handleError();
	}
	return nomegiorno;
};

HomeTvApp.prototype.setNewDate=function()
{
	try
	{
		var time = new Date(this.fw.getOSD().getTime());
		this.newDate = this.getDate(time,this.daySpan,'day DD/MM');
		this.formattedTd = '<td width="200" height="30" valign="center" background="/ovaImages/bgkdata.png" >'+this.newDate+'</td>';
		this._ui.setLabelText("data",this.formattedTd);
		this._ui.redraw();
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = 'setNewDate'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();	
  }
	return true;
};

HomeTvApp.prototype.handleErrorCustom=function(message_id){
	try{
	}catch(ecc){
	 
	}
	return true;
};

HomeTvApp.prototype.goTogotData=function(){
try{ 
		this.gotData(this.fw.objNews["novita_menu_news"]);
	}catch(ecc)
	{
		this._objErrorInfo._methodName = 'goTogotData'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();	
  }
	return true;
};

/****************************************************************
FUNCTION 		: ripulisciSEPG
PARAMETER 	: 
DESCRIPTION : svuota la SEPG , sia la grafica che le variabili						
*****************************************************************/
HomeTvApp.prototype.ripulisciSEPG = function() 
{
	try{
		
		this.replaceFrameContents(this._layoutId,"./titolo",  this.startOraTag+'<font size="6" color="#FFFFFF">' + '' + '</font>'+this.endTag);
		this.replaceFrameContents(this._layoutId,"./ora", this.startOraTag+'<font size="3" color="#FFFFFF">' + '' + '</font>'+this.endTag);
		this.replaceFrameContents(this._layoutId,"tipoCanale", this.startOraTag+'<font size="3" color="#FFFFFF">' + '' + '</font>'+this.endTag);
		this.replaceFrameContents(this._layoutId,"./desc", this.startOraTag+'<font size="6" color="#FFFFFF">' + '' + '</font>'+this.endTag);
	}catch(ecc){
		this._objErrorInfo._methodName = "ripulisciSEPG";
		this._objErrorInfo._obException = ecc;
		this.handleError();		
	}
	return true;
};


HomeTvApp.prototype.creaInfoSlot=function() {
	try{
	//identifico i canali tematici rai 
// 	this.isRai=this.isTematicoRai(this.zapElement);
	//attributo con l'index dello slot iniziale
	var channel = this.fw.getBTVTuner().getEPG().getChannelByChanRecid(this.mychanrecid);		
	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("###############   HomeTvApp.creaInfoSlot canale: "+channel.callLetters);		
	this._initIndex=this.getCurrentProgramSlotIndex(this.mychanrecid); //prendo lo slot attuale
	this.epgSlot = new Object();
	this.epgSlot = this.getProgramSlot(this.mychanrecid, this._initIndex);
	//attributo con l'offset rispetto allo slot index iniziale
	this._offsetIndex=0; 
	
	//disegno all'interno della sepg le info della system information
	this.takeInfoSEPGServiceEvents(channel);
	
	//disegno l'interno della sepg con le info presenti nello slot
	this.disegnaInternoSEPG(this.epgSlot);	
}catch(ecc){
		this._objErrorInfo._methodName = 'creaInfoSlot';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

HomeTvApp.prototype.setSEPGIndex=function(index) {
try{
	this.sepgIndex = index;
}catch(ecc){
		this._objErrorInfo._methodName = 'setSEPGIndex';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/****************************************************************
FUNCTION 		: _unlockEpgGrid, _isEpgGridLocked, _lockEpgGrid
DESCRIPTION : funzioni di lock sulla griglia
*****************************************************************/

HomeTvApp.prototype._unlockEpgGrid = function()
{
	if (this._myTimerLock)
	{
		this.fw.getTimer().clearTimeout(this._myTimerLock);
	}
	this._myLock = false;
};

HomeTvApp.prototype._isEpgGridLocked = function()
{
	//this.getPlogger("_isEpgGridLocked:"+this._myLock);
	return this._myLock;
};

HomeTvApp.prototype._lockEpgGrid = function()
{
	try
	{
		 var platformType=this.fw.getAppManager()._path;
		if(platformType=="pirelli_dtt" && this.fw.currentFwVersion=="1.5.12"){

			if (this._myTimerLock)
			{
				this.fw.getTimer().clearTimeout(this._myTimerLock);
			}
			this._myLock = true;
			this._myTimerLock = this.fw.getTimer().setTimeout(4000,this._unlockEpgGrid,this);
	}
}
	catch(ecc){
		this._objErrorInfo._methodName = "_lockEpgGrid";	
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// Nuove modifiche

/*****************************************************
FUNCTION: drawLeftPanelItemsList
PARAMETRI: direction (stringa)
DESCRIPTION: 	Metodo che disegna i bottoni del men� in base allo status passato come parametro
*****************************************************/
HomeTvApp.prototype.drawRightPanelItemsList = function (direction,setFocusOn,statusPanel,reloadLeftPanel) {
	try	{
		
		if(this.reloadRightPanel){
			this.fw.getTimer().clearTimeout(this.reloadRightPanel);
		}
		var imgName = '';
		var imgUrl = '';
		var position = 0;
		var actualVerticalPosition = 0;
		var idx = 0;

		if( this.fw.myRightPanelIndex >= 0 && this.fw.myRightPanelIndex < this.fw.menuArray.length && this.fw.menuArray[this.fw.myRightPanelIndex] && this.fw.menuArray[this.fw.myRightPanelIndex].menuChilds && this.fw.menuArray[this.fw.myRightPanelIndex].lastChildIndexSelected ){
			idx = this.fw.myRightPanelIndex;
			//sono appena entrato vado al menu root specificato
			if( this.fw.myRightPanelIndex == 0 ) 
				idx = 0;
		}else{
			if( this.fw.myRightPanelIndex == undefined || this.fw.myRightPanelIndex == null || this.fw.myRightPanelIndex < 0 || this.fw.myRightPanelIndex > this.fw.menuArray.length ){
				this.fw.myRightPanelIndex = 0;
				this.fw.verticalMenuRightPanelIndexIndex = 0;
			}else if( !this.fw.menuArray[this.fw.myRightPanelIndex] && !this.fw.menuArray[this.fw.myRightPanelIndex].menuChilds && !this.fw.menuArray[this.fw.myRightPanelIndex].lastChildIndexSelected ){
				this.fw.myRightPanelIndex = this.getPreviousMenuLevel();
			}
			idx = this.fw.myRightPanelIndex;
		}		
		
		if( direction && direction == 'up' ){
			
			if( this.fw.menuArray[ idx ].menuChilds.length > this.firstLevelSize ){
				
				if( this.fw.verticalMenuRightPanelIndex == ( this.fw.menuArray[ idx ].menuChilds.length-1 ) && (this.fw.menuArray[idx].menuChilds.length%this.firstLevelSize) != 0 ){
					
					actualVerticalPosition = (this.fw.verticalMenuRightPanelIndex - (this.fw.menuArray[idx].menuChilds.length%this.firstLevelSize))+1;
				} else {
					
					actualVerticalPosition = this.fw.verticalMenuRightPanelIndex - (this.firstLevelSize - 1);
				}
			}
		} else {
			var page = this.fw.menuArray[idx].lastChildIndexSelected-(this.fw.menuArray[idx].lastChildIndexSelected%this.firstLevelSize);
			actualVerticalPosition = page;
			page = null;
		}		
		
		for( i = 0; i < this.firstLevelSize ; i++){
			imgName = 'Tab_dx_'+parseInt(i+1);
			position = i+actualVerticalPosition;
			if( position < this.fw.menuArray[ idx ].menuChilds.length ){
				if(setFocusOn){
					if( i == this.fw.menuArray[idx].lastChildIndexSelected%this.firstLevelSize ){
						imgUrl = this.headerNavigationMenuImagesPath+this.listImageString+this.fw.menuArray[ this.fw.menuArray[ idx ].menuChilds[ position ] ].myIndex+'_v0_on_'+this.rightPanel+'.png';
					} else {
						imgUrl = this.headerNavigationMenuImagesPath+this.listImageString+this.fw.menuArray[ this.fw.menuArray[ idx ].menuChilds[ position ] ].myIndex+'_v0_off_'+this.rightPanel+'.png';
					}
				}else{
					if(statusPanel){
								imgUrl = this.headerNavigationMenuImagesPath+this.listImageString+this.fw.menuArray[ this.fw.menuArray[ idx ].menuChilds[ position ] ].myIndex+'_v0_off_'+this.rightPanel+'.png';
					}else{
								imgUrl = this.headerNavigationMenuImagesPath+this.listImageString+this.fw.menuArray[ this.fw.menuArray[ idx ].menuChilds[ position ] ].myIndex+'_v0_off_gray_'+this.rightPanel+'.png';
					}
				}
				this.referImageToIFrame(this._layoutId,"layout", imgName, imgUrl );
				//this.referImageToIFrame('', this._frame, 'x'+imgName, imgUrl );
			} else {
				this.referImageToIFrame(this._layoutId,"layout", imgName, "/ovaImages/1pixelclear.gif");
				//this.referImageToIFrame('', this._frame, 'x'+imgName, this.clearImage);
			}
			this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.rightPanel+"_"+parseInt(i+1),"/ovaImages/1pixelclear.gif");
			
		}
	//this.fw.verticalMenuRightPanelIndex = this.fw.menuArray[idx].lastChildIndexSelected;
		if(reloadLeftPanel){
			this.drawLeftPanelItemsList('down',false);
			this.setNavigationPositionPanel(this.leftPanel);
		}
		
		//this.setNavigationPositionPanel(this.rightPanel);
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "drawRightPanelItemsList";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*****************************************************
FUNCTION: setNavigationPositionPanel
PARAMETRI: directionPanel (intero)
DESCRIPTION: 	Metodo che disegna i bottoni del men� in base allo status passato come parametro
*****************************************************/
HomeTvApp.prototype.setNavigationPositionPanel = function (directionPanel) {
	try	
	{
		this.navigationMenuPanel = directionPanel.toLowerCase();
		this.setPanelArrows();
		return true;
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "setNavigationPositionPanel";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

HomeTvApp.prototype.setPanelArrows = function(  ){
	try{
		if(this.getNavigationPositionPanel()===this.leftPanel){
			this.referImageToIFrame(this._layoutId,"layout",this.leftPanelUpperArrow,"/ovaImages/restyling/arrows/active_up.png");
			this.referImageToIFrame(this._layoutId,"layout",this.leftPanelLowerArrow,"/ovaImages/restyling/arrows/active_down.png");
			this.referImageToIFrame(this._layoutId,"layout",this.rightPanelUpperArrow,"/ovaImages/restyling/arrows/inactive_up.png");
			this.referImageToIFrame(this._layoutId,"layout",this.rightPanelLowerArrow,"/ovaImages/restyling/arrows/inactive_down.png");
		}else{
			this.referImageToIFrame(this._layoutId,"layout",this.leftPanelUpperArrow,"/ovaImages/restyling/arrows/inactive_up.png");
			this.referImageToIFrame(this._layoutId,"layout",this.leftPanelLowerArrow,"/ovaImages/restyling/arrows/inactive_down.png");
			this.referImageToIFrame(this._layoutId,"layout",this.rightPanelUpperArrow,"/ovaImages/restyling/arrows/active_up.png");
			this.referImageToIFrame(this._layoutId,"layout",this.rightPanelLowerArrow,"/ovaImages/restyling/arrows/active_down.png");
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'setPanelArrows'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*****************************************************
FUNCTION: drawLeftPanelItemsList
PARAMETRI: direction (stringa)
DESCRIPTION: 	Metodo che disegna i bottoni del men� in base allo status passato come parametro
*****************************************************/
HomeTvApp.prototype.drawLeftPanelItemsList = function (direction,activateTimer) {
	try	
	{
		var imgName = '';
		var imgUrl = '';
		var position = 0;
		var actualVerticalPosition = 0;
		var idx = 0;


		if( this.fw.myIndex >= 0 && this.fw.myIndex < this.fw.menuArray.length && this.fw.menuArray[this.fw.myIndex] && this.fw.menuArray[this.fw.myIndex].menuChilds && this.fw.menuArray[this.fw.myIndex].lastChildIndexSelected ){
			idx = this.fw.myIndex;
			//sono appena entrato vado al menu root specificato
			if( this.fw.myIndex == 0 ) 
				idx = 0;
		}else{
			if( this.fw.myIndex == undefined || this.fw.myIndex == null || this.fw.myIndex < 0 || this.fw.myIndex > this.fw.menuArray.length ){
				this.fw.myIndex = 0;
				this.fw.verticalMenuIndex = 0;
			}else if( !this.fw.menuArray[this.fw.myIndex] && !this.fw.menuArray[this.fw.myIndex].menuChilds && !this.fw.menuArray[this.fw.myIndex].lastChildIndexSelected ){
				this.fw.myIndex = this.getPreviousMenuLevel();
			}
			idx = this.fw.myIndex;
		}		
		
		if( direction && direction == 'up' ){
			if( this.fw.menuArray[ idx ].menuChilds.length > this.firstLevelSize ){
				if( this.fw.verticalMenuIndex == ( this.fw.menuArray[ idx ].menuChilds.length-1 ) && (this.fw.menuArray[idx].menuChilds.length%this.firstLevelSize) != 0 ){
					actualVerticalPosition = (this.fw.verticalMenuIndex - (this.fw.menuArray[idx].menuChilds.length%this.firstLevelSize))+1;
				} else {
					actualVerticalPosition = this.fw.verticalMenuIndex - (this.firstLevelSize - 1);
				}
			}
		} else {
			
			var page = this.fw.menuArray[idx].lastChildIndexSelected-(this.fw.menuArray[idx].lastChildIndexSelected%this.firstLevelSize);
			actualVerticalPosition = page;
			
			page = null;
		}		
		
		for( i = 0; i < this.firstLevelSize ; i++){
			
			imgName = 'Tab_sx_'+parseInt(i+1);
			position = i+actualVerticalPosition;
//			var now=new Date(this.fw.getOSD().getTime());
//			var month=now.getUTCMonth()+1;			
			
			if( position < this.fw.menuArray[ idx ].menuChilds.length ){
				if( i == this.fw.menuArray[idx].lastChildIndexSelected%this.firstLevelSize ){
					
						imgUrl = this.headerNavigationMenuImagesPath+'list_'+this.fw.menuArray[ this.fw.menuArray[ idx ].menuChilds[ position ] ].myIndex+'_v0_on.png';
						this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.leftPanel+"_"+parseInt(i+1),"/ovaImages/restyling/arrows/red.png");
				} else {
					
					imgUrl = this.headerNavigationMenuImagesPath+'list_'+this.fw.menuArray[ this.fw.menuArray[ idx ].menuChilds[ position ] ].myIndex+'_v0_off.png';
				}
				this.referImageToIFrame(this._layoutId ,'layout', imgName, imgUrl );
				//this.referImageToIFrame('', this._frame, 'x'+imgName, imgUrl );
			} else {
				this.referImageToIFrame(this._layoutId ,'layout', imgName, "/ovaImages/1pixelclear.gif");
				//this.referImageToIFrame('', this._frame, 'x'+imgName, this.clearImage);
			}
			this.referImageToIFrame(this._layoutId,"layout","Arrow_"+this.leftPanel+"_"+parseInt(i+1),"/ovaImages/1pixelclear.gif");
			this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.leftPanel+"_"+parseInt(i+1),"/ovaImages/1pixelclear.gif");						
		}
		
//		this.referImageToIFrame(this._layoutId,"layout","nodeName",this.headerNavigationMenuImagesPath+this.horizontalImageString+this.fw.menuArray[this.fw.myIndex].myIndex+"_v0.png");
		//this.referImageToIFrame('',this._frame,"nodeName","/ovaImages/restyling/"+this.fw.menuArray[this.fw.myIndex].menuName+".png");
		if(this.fw.menuArray[this.fw.myIndex].menuParent > 0){
			this.referImageToIFrame(this._layoutId,"layout","parentNodePath",'/ovaImages/menuRes/'+this.absoluteImageString+this.fw.menuArray[this.fw.menuArray[this.fw.myIndex].menuParent].myIndex+"_v0.png");
		}else{
			this.referImageToIFrame(this._layoutId,"layout","parentNodePath","/ovaImages/1pixelclear.gif");
		}
		
		if(activateTimer){
			
			this.fw.verticalMenuIndex = this.fw.menuArray[idx].lastChildIndexSelected;
			var myRightPanelIndex = this.fw.menuArray[this.fw.myIndex].myIndex;
			
			//.menuChilds[this.fw.verticalMenuIndex]; 
			if(this.fw.menuArray[this.fw.menuArray[this.fw.myIndex].menuChilds[this.fw.verticalMenuIndex]].menuChilds.length > 0){
				this.fw.myRightPanelIndex = this.fw.menuArray[myRightPanelIndex].menuChilds[this.fw.verticalMenuIndex];
			
				this.fw.verticalMenuRightPanelIndex = 0;
				if(this.reloadRightPanel){
					this.fw.getTimer().clearTimeout(this.reloadRightPanel);
				}
			
				this.reloadRightPanel = this.fw.getTimer().setTimeout(this.reloadRightPanelTimer,this.drawRightPanelItemsList,this);
			}else{
				
				this.drawEmptyRightPanelItemsList();
			}
		}else{
			
				//this.drawEmptyRightPanelItemsList();
		}
		//this.fw.verticalMenuIndex = this.fw.menuArray[idx].lastChildIndexSelected;
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "drawLeftPanelItemsList";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*****************************************************
FUNCTION: drawBackLeftPanelItemsList
PARAMETRI: direction (stringa)
DESCRIPTION: 	Metodo che disegna i bottoni del men� in base allo status passato come parametro
*****************************************************/
HomeTvApp.prototype.drawSelectedLeftPanelItemsList = function (direction) {
	try	
	{
		var imgName = '';
		var imgUrl = '';
		var position = 0;
		var actualVerticalPosition = 0;
		var idx = 0;
		
		if( direction && direction == 'up' ){
			if( this.fw.menuArray[ idx ].menuChilds.length > this.firstLevelSize ){
				if( this.fw.verticalMenuIndex == ( this.fw.menuArray[ idx ].menuChilds.length-1 ) && (this.fw.menuArray[idx].menuChilds.length%this.firstLevelSize) != 0 ){
					actualVerticalPosition = (this.fw.verticalMenuIndex - (this.fw.menuArray[idx].menuChilds.length%this.firstLevelSize))+1;
				} else {
					actualVerticalPosition = this.fw.verticalMenuIndex - (this.firstLevelSize - 1);
				}
			}
		} else {
			var page = this.fw.menuArray[idx].lastChildIndexSelected-(this.fw.menuArray[idx].lastChildIndexSelected%this.firstLevelSize);
			actualVerticalPosition = page;
			page = null;
		}
		for( i = 0; i < this.firstLevelSize ; i++){
			imgName = 'Tab_sx_'+parseInt(i+1);
			position = i+actualVerticalPosition;		
			var now=new Date(this.fw.getOSD().getTime());
			var month=now.getUTCMonth()+1;
			if( position < this.fw.menuArray[ idx ].menuChilds.length ){
				if( i == this.fw.menuArray[idx].lastChildIndexSelected%this.firstLevelSize ){
					imgUrl = this.headerNavigationMenuImagesPath+this.listImageString+this.fw.menuArray[ this.fw.menuArray[ idx ].menuChilds[ position ] ].myIndex+'_v0_off_selected.png';
				} else {
					imgUrl = this.headerNavigationMenuImagesPath+this.listImageString+this.fw.menuArray[ this.fw.menuArray[ idx ].menuChilds[ position ] ].myIndex+'_v0_off_gray.png';
				}
				this.referImageToIFrame(this._layoutId,"layout", imgName, imgUrl );
				//this.referImageToIFrame('', this._frame, 'x'+imgName, imgUrl );
			} else {
				this.referImageToIFrame(this._layoutId,"layout", imgName, "/ovaImages/1pixelclear.gif");
				//this.referImageToIFrame('', this._frame, 'x'+imgName, this.clearImage);
			}
			this.referImageToIFrame(this._layoutId,"layout","Arrow_"+this.leftPanel+"_"+parseInt(i+1),"/ovaImages/1pixelclear.gif");
			this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.leftPanel+"_"+parseInt(i+1),"/ovaImages/1pixelclear.gif");						
		}
	  this.drawRightPanelItemsList('down',true,true);
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "drawBackLeftPanelItemsList";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};


/*****************************************************
FUNCTION: drawEmptyRightPanelItemsList
PARAMETRI: direction (stringa)
DESCRIPTION: 	Metodo che disegna i bottoni del men� in base allo status passato come parametro
*****************************************************/
HomeTvApp.prototype.drawEmptyRightPanelItemsList = function (direction,activateTimer) {
	try	
	{
		for( i = 0; i < this.firstLevelSize ; i++){
			imgName = 'Tab_dx_'+parseInt(i+1);			
				this.referImageToIFrame(this._layoutId,"layout", imgName, "/ovaImages/1pixelclear.gif");
		}
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "drawEmptyRightPanelItemsList";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*****************************************************
FUNCTION: getNavigationPositionPanel
PARAMETRI: 
DESCRIPTION: 	ritorna il pannello attivo
*****************************************************/
HomeTvApp.prototype.getNavigationPositionPanel = function () {
	try	
	{
		return this.navigationMenuPanel;
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = "getNavigationPositionPanel";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};


HomeTvApp.prototype.checkItem = function(  ){
	try{
		if(this.checkItemTimer){
			this.fw.getTimer().clearTimeout(this.checkItemTimer);
		}
		if(this.getNavigationPositionPanel()==this.leftPanel){
			
			if (this.fw.menuArray && this.fw.menuArray[this.fw.menuArray[this.fw.myIndex].menuChilds[this.fw.verticalMenuIndex]]) {
			
				if(this.fw.menuArray[this.fw.menuArray[this.fw.myIndex].menuChilds[this.fw.verticalMenuIndex]].menuChilds.length > 0){
			
					this.referImageToIFrame(this._layoutId,"layout","ok","/ovaImages/1pixelclear.gif");
					//this.fw.verticalMenuIndex = this.fw.menuArray[idx].lastChildIndexSelected;
					this.referImageToIFrame(this._layoutId,"layout",this.rightPanelUpperArrow,"/ovaImages/restyling/arrows/inactive_up.png");
					this.referImageToIFrame(this._layoutId,"layout",this.rightPanelLowerArrow,"/ovaImages/restyling/arrows/inactive_down.png");
					this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.leftPanel+"_"+parseInt((this.fw.verticalMenuIndex%this.firstLevelSize)+1),"/ovaImages/restyling/arrows/red.png");
					this.referImageToIFrame(this._layoutId,"layout","Arrow_"+this.leftPanel+"_"+parseInt((this.fw.verticalMenuIndex%this.firstLevelSize)+1),"/ovaImages/restyling/arrows/left_item_arrow.png");
			
				}else{
			
					this.referImageToIFrame(this._layoutId,"layout",this.rightPanelUpperArrow,"/ovaImages/1pixelclear.gif");
					this.referImageToIFrame(this._layoutId,"layout",this.rightPanelLowerArrow,"/ovaImages/1pixelclear.gif");
					this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.leftPanel+"_"+parseInt((this.fw.verticalMenuIndex%this.firstLevelSize)+1),"/ovaImages/restyling/arrows/red.png");
					this.referImageToIFrame(this._layoutId,"layout","Arrow_"+this.leftPanel+"_"+parseInt((this.fw.verticalMenuIndex%this.firstLevelSize)+1),"/ovaImages/restyling/arrows/red.png");
					
					this.drawEmptyRightPanelItemsList();
				}
			}
			
			var myRightPanelIndex = this.fw.menuArray[this.fw.myIndex].myIndex;
			this.fw.myRightPanelIndex = this.fw.menuArray[myRightPanelIndex].menuChilds[this.fw.verticalMenuIndex];
			this.fw.verticalMenuRightPanelIndex = 0;
			if (this.fw.myRightPanelIndex)
			      this.fw.menuArray[this.fw.myRightPanelIndex].lastChildIndexSelected = 0;
			if(this.reloadRightPanel){
				this.fw.getTimer().clearTimeout(this.reloadRightPanel);
			}
			this.reloadRightPanel = this.fw.getTimer().setTimeout(this.reloadRightPanelTimer,this.drawRightPanelItemsList,this);
		}
		this.checkVodCounterArray();
	}catch(ecc){
		this._objErrorInfo._methodName = 'checkItem'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

HomeTvApp.prototype.switchFocusImageOff = function( newIdxOff ){
	try{
		var imgName = 'Tab_'+this.getNavigationPositionPanel()+"_"+parseInt((newIdxOff%this.firstLevelSize)+1);
		var imgCounterName = 'Counter_'+this.getNavigationPositionPanel()+"_"+parseInt((newIdxOff%this.firstLevelSize)+1);
		var imgArrowName = 'Arrow_'+this.getNavigationPositionPanel()+"_"+parseInt((newIdxOff%this.firstLevelSize)+1);
//		var now=new Date(this.fw.getOSD().getTime());
//		var month=now.getUTCMonth()+1;
		var imgUrl = '';
		if(this.getNavigationPositionPanel()===this.leftPanel){
			if( this.fw.menuArray[ this.fw.menuArray[ this.fw.myIndex ].menuChilds[ newIdxOff ] ] ){
					imgUrl = this.headerNavigationMenuImagesPath+this.listImageString+this.fw.menuArray[ this.fw.menuArray[ this.fw.myIndex ].menuChilds[ newIdxOff ] ].myIndex+'_v0_off.png';
				this.referImageToIFrame(this._layoutId,"layout",imgArrowName,"/ovaImages/1pixelclear.gif");
				this.referImageToIFrame(this._layoutId,"layout",imgCounterName,"/ovaImages/1pixelclear.gif");				
				this.referImageToIFrame(this._layoutId,"layout", imgName, imgUrl );
			}
		}else{
			if( this.fw.menuArray[ this.fw.menuArray[ this.fw.myRightPanelIndex ].menuChilds[ newIdxOff ] ] ){
				imgUrl = this.headerNavigationMenuImagesPath+this.listImageString+this.fw.menuArray[ this.fw.menuArray[ this.fw.myRightPanelIndex ].menuChilds[ newIdxOff ] ].myIndex+'_v0_off_'+this.rightPanel+'.png';
				this.referImageToIFrame(this._layoutId,"layout",imgCounterName,"/ovaImages/1pixelclear.gif");	
				this.referImageToIFrame(this._layoutId,"layout", imgName, imgUrl );
			}
		}
	} catch ( ecc ){
		this._objErrorInfo._methodName = 'switchFocusImageOff';
		this._objErrorInfo._obException = ecc;
		this.handleError();	
	}
};


HomeTvApp.prototype.switchFocusImageOn = function( newIdxOn ){
	try{
		var imgName = '';
		if(parseInt(newIdxOn+1)%this.firstLevelSize > 0){
			imgName = 'Tab_'+this.getNavigationPositionPanel()+"_"+parseInt((newIdxOn+1)%this.firstLevelSize);
		}else{
			imgName = 'Tab_'+this.getNavigationPositionPanel()+"_"+this.firstLevelSize;
		}
//		var now=new Date(this.fw.getOSD().getTime());
//		var month=now.getUTCMonth()+1;
		var imgUrl = '';
		if(this.getNavigationPositionPanel()===this.leftPanel){
			if( this.fw.menuArray[ this.fw.menuArray[ this.fw.myIndex ].menuChilds[ newIdxOn ] ] ){
				imgUrl = this.headerNavigationMenuImagesPath+this.listImageString+this.fw.menuArray[ this.fw.menuArray[ this.fw.myIndex ].menuChilds[ newIdxOn ] ].myIndex+'_v0_on.png';
				this.referImageToIFrame(this._layoutId,"layout", imgName, imgUrl );	
			}
		}else{
			if( this.fw.menuArray[ this.fw.menuArray[ this.fw.myRightPanelIndex ].menuChilds[ newIdxOn ] ] ){
				imgUrl = this.headerNavigationMenuImagesPath+this.listImageString+this.fw.menuArray[ this.fw.menuArray[ this.fw.myRightPanelIndex ].menuChilds[ newIdxOn ] ].myIndex+'_v0_on_'+this.rightPanel+'.png';
				this.referImageToIFrame(this._layoutId,"layout", imgName, imgUrl );	
			}
		}
		imgName = null;
		
	} catch ( ecc ){
		this._objErrorInfo._methodName = 'switchFocusImageOn';
		this._objErrorInfo._obException = ecc;
		this.handleError();	
	}
};


HomeTvApp.prototype.checkVodCounterArray = function(  ){
	try{
		if(this.getNavigationPositionPanel()===this.leftPanel){
				this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.leftPanel+"_"+parseInt((this.fw.verticalMenuIndex%this.firstLevelSize)+1),"/ovaImages/restyling/arrows/red.png");
		}else{
				this.referImageToIFrame(this._layoutId,"layout","Counter_"+this.rightPanel+"_"+parseInt((this.fw.verticalMenuRightPanelIndex%this.firstLevelSize)+1),"/ovaImages/restyling/arrows/red.png");
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'checkVodCounterArray'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

HomeTvApp.prototype.getNextMenuDownRightPanel = function(  ){
	try{
		
		//Aggiorno l'indice del men� verticale
		this.fw.verticalMenuRightPanelIndex++;
		//ricavo il parentId corretto il problema si pone al primo accesso
	
		var parentId = this.fw.myRightPanelIndex;
		
		if( this.fw.menuArray[this.fw.myRightPanelIndex] && this.fw.menuArray[this.fw.myRightPanelIndex].menuParent == -1 )parentId = this.fw.menuArray[this.fw.myRightPanelIndex].menuChilds[0];
		//controlla la consistenza dell'indice ricavato
		if( this.fw.menuArray[parentId] && this.fw.verticalMenuRightPanelIndex >= this.fw.menuArray[parentId].menuChilds.length ) this.fw.verticalMenuRightPanelIndex = 0;
	}catch(ecc){
		this._objErrorInfo._methodName = 'getNextMenuDownRightPanel'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	       
};

HomeTvApp.prototype.getNextMenuUpRightPanel = function(  ){
	try{
		//Aggiorno l'indice del men� verticale
		this.fw.verticalMenuRightPanelIndex--;
		//ricavo il parentId corretto il problema si pone al primo accesso
		var nodeId = this.fw.myRightPanelIndex;
		if( this.fw.menuArray[this.fw.myRightPanelIndex] && this.fw.menuArray[this.fw.myRightPanelIndex].menuParent == -1 ) nodeId = this.fw.menuArray[this.fw.myRightPanelIndex].menuChilds[0];
		//controlla la consistenza dell'indice ricavato
		if( this.fw.menuArray[nodeId] && this.fw.verticalMenuRightPanelIndex < 0 ) this.fw.verticalMenuRightPanelIndex = this.fw.menuArray[nodeId].menuChilds.length-1;
	}catch(ecc){
		this._objErrorInfo._methodName = 'getNextMenuUpRightPanel'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

HomeTvApp.prototype.aggiornaSEPG = function(  ){
	
	try{
		/*
		if(this.timerINFOSEPG!=null){
			this.fw.getTimer().clearTimeout(this.timerINFOSEPG);
			this.timerINFOSEPG=null;
		}
		*/
		if(this.getActivity()!=this.sepg)
			return true;
		var channel = this.fw.getBTVTuner().getEPG().getChannelByChanRecid(this.mychanrecid);		
		this.takeInfoSEPGServiceEvents(channel);
		//this.takeInfoSEPG();
		//this.creaInfoSlot();
	}catch(ecc){
		this._objErrorInfo._methodName = 'aggiornaSEPG'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};



