
ScanDTTSettingsApp.prototype = top.getFramework().createBaseApp();

function ScanDTTSettingsApp() {}

ScanDTTSettingsApp.prototype.create = function() {  
	try{
		this._objErrorInfo = new Object();
		this._objErrorInfo._applicationName = 'ScanDTTSettingsApp';
		this._ui = this.fw.createSimpleFormUI("ScanDTTSettingsLayout");
		this.pageLayout = this.fw.getLayoutManager().getLayout("ScanDTTSettingsLayout");
		this._ui.setForm(this.createForm());
		
		/* In questo modo in HomeTvApp carica la cache con le immagini per lo zapperone */
		this.fw.refreshImmagZapper=1;
		
	}
	catch(ecc){
		this._objErrorInfo._methodName = 'create';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	finally{
		return true;
	}
};



ScanDTTSettingsApp.prototype.createForm=function() {
	try{
		this._form = this.fw.createForm("helpForm");
		this._form.addField({ name: 'hiddenField', type: this._form.TYPE_HIDDEN, value:'' });
		this._form.setHandler(this);
		return this._form;
	}
	catch(ecc){
		this._objErrorInfo._methodName ='createForm';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*
 * la seguente funzione testa se l'utente � al primo accesso. Nel caso del primo accesso l'applicazione 
 * mostra delle pagine per confermare la linea telefonica sulla quale si sta accedendo all'applicazione
 * nel secondo caso invece viene invocato un fetcher che controlla se il MAC address fisico � uguale 
 * al MAC address provisionato e se la linea su cui il STB � connesso � uguale alla linea su cui l'utente 
 * � provisionato 
 */
ScanDTTSettingsApp.prototype.init = function() { 
	this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", false);	
	try{
		if(this.fw.getDTT().scanInProgress()==true){
			
		   this.fw.getDTT().stopScan();
		}
		try{
			omc.stream.unload();
		} catch(err){
				omc.logger.addEntry("Error: "+err.message);
		}
		this.sendLoadAppTrap("ScanDTTSettingsApp");
//		if(this.fw.UserEnableDTT == 'N'){
//			this.fw.getFetcher().fetchNow("/ovaServices/dtt/SetEnableDTTFetcher.jsp?usrRecid="+this.fw.getUserInfo().getAccountID()+"&flagDTT='Y'", this, this.checkSetEnable);
//		}
		this.foundChannel=false;
		this.fw._bScanAvviato = true;
		this.stato_dtt=0;
		this.descriptionText = new Array();
		this.strinStartLeft = "<table border='0' width='620' height='65' cellspacing='0' cellpadding='0'>"
			+"<tr width='620' height='65'><td width='620' height='65'>"
			+"<span style='color:white' align='left'>";
		this.strinStartCenter = "<table border='0' width='620' height='65' cellspacing='0' cellpadding='0'>"
			+"<tr width='620' height='65'><td width='620' height='65'>"
			+"<span style='color:white' align='center'>";
		this.strinEnd = "</span>"+"</td></tr></table>";
		this.descriptionText[0]=this.strinStartLeft+"Premi il tasto 'Avvia la ricerca' per memorizzare i canali del Digitale Terrestre.<br>Puoi "
							+"verificare la copertura del Digitale Terrestre sul sito www.dgtvi.it.<br><br>"+this.strinEnd;
		this.descriptionText[1]=this.strinStartLeft+"Per la digitazione dei canali del Digitale Terrestre e' necessario che il decoder sia collegato "
							+"direttamente al cavo d'antenna."+this.strinEnd;
		this.descriptionText[2]=this.strinStartCenter+"Ricerca canali Digitale Terrestre in corso. <br>L'operazione richieder&agrave; qualche minuto"+this.strinEnd;
		this.descriptionText[3]="<table border='0' width='640' height='65' cellspacing='0' cellpadding='0'>"
									+"<tr width='640' height='65'><td width='640' height='65'>"
									+"<span style='color:white' align='center'>Ricerca completata<br>#X# canali trovati</span>"
									+"</td></tr></table>";
		this.modalita=1;
		this.searchStart=false;
		this.referImageToLayout("RicercaDTTLayout","btnSearch","/ovaImages/layout/impostazioni/bott_avricerca_on.png");
		this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progressBarOff.png");
		this._ui.setLabelText("./descriptionLine1",this.descriptionText[0]);
		this._ui.setLabelText("./descriptionLine2",this.descriptionText[1]);		
		this._ui.redraw();
	}
	catch(ecc){
		this._objErrorInfo._methodName = 'init';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

ScanDTTSettingsApp.prototype.checkSetEnable = function(obj) {  
	try
	{
		if(obj == null || (obj && obj.content[0].esito=='OK')){
				this.fw.UserEnableDTT = 'Y'; 
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'checkSetEnable';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

ScanDTTSettingsApp.prototype.eventKeyEye  = function(){	
	try{		
//		if(this.fw.getDTT().scanInProgress()==true){
//		   this.fw.getDTT().stopScan();
//		}
//		if (this.goToHomePageTimer){
//			this.fw.getTimer().clearTimeout(this.goToHomePageTimer);
//		}
//		var diretteIndex = (this.fw.menuObj && this.fw.menuObj.menuDiretteIndex) ? this.fw.menuObj.menuDiretteIndex : 2;			   
//		if (this.fw.menuArray && this.fw.menuArray[diretteIndex]){
//			this.fw.menuArray[diretteIndex].lastChildIndexSelected=0;
//		}
//		this.goToHomePageTimer=this.fw.getTimer().setTimeout(1000, this.goToHomePage, this);
//		this.eventKeyEsc();
	}
	catch(ecc){
		this._objErrorInfo._methodName="eventKeyEye";
		this._objErrorInfo._obException = ecc;
		this.handleError();
  }
  finally{
	  return true;
	}
};



ScanDTTSettingsApp.prototype.eventKeyNumeric=function(digit){ 
//
//	try{		
//
//		
//
//		if(this.fw.getDTT().scanInProgress()==true)
//
//		{
//
//		   this.fw.getDTT().stopScan();
//
//		}
//
//		
//
//		this.changeAppTimer=this.fw.getTimer().setTimeout(1000, this.callDigit, this ,digit);
//
//						
//
//	}catch(ecc){
//
//		objErrorInfo._methodName="eventKeyNumeric";
//
//		this._objErrorInfo._obException = ecc;
//
//		this.handleError();
//
//	}finally{

		return true;

//	}

};





ScanDTTSettingsApp.prototype.fin = function() {
	try{		
		if(this.fw.getDTT().scanInProgress()==true)
		   this.fw.getDTT().stopScan();

		this.foundChannel=null;
		this.descriptionText = null;
		this.searchStart=null;
/*
		if (this.goToHomePageTimer){
			this.fw.getTimer().clearTimeout(this.goToHomePageTimer);
		}
		
		if ( !this.changeAppTimer ){
			this.fw.getTimer().clearTimeout(this.changeAppTimer);
			this.changeAppTimer = null;
		}
		*/
		this.loadApp(this.getHomeUrl(),null,null,null,null); 
	}
	catch(ecc){
		this._objErrorInfo._methodName = 'fin';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

ScanDTTSettingsApp.prototype.eventKeyEnter = function() {
	try{
///////////////////////////////CONTROLLO DEL TASTIERINO NUMERICO//////////////////
	if(this.BoxChangeChannel == true){
			 this.EnterNumericDigit();
//////////////////////////////////////////////////////////////////////////////////
  }else{
			if(this.fw.getDTT().scanInProgress()==true)
				 return true;
			if ( this.searchStart==false ){
				this.startChannelSearch();
				this.searchStart = true;
			}
	 }
	}
	catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyEnter';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;	
};

ScanDTTSettingsApp.prototype.eventKeyScrollUp=function(){
	return true;
};

ScanDTTSettingsApp.prototype.eventKeyScrollDown = function() {
	return true;
};

ScanDTTSettingsApp.prototype.eventKeyHot1 = function() {
	return true;
};
ScanDTTSettingsApp.prototype.eventKeyHot2 = function() {
	return true;
};
ScanDTTSettingsApp.prototype.eventKeyHot3 = function() {
	return true;
};
ScanDTTSettingsApp.prototype.eventKeyHot4 = function() {
	return true;
};

ScanDTTSettingsApp.prototype.eventKeyBack= function(){ 
	var urlVideo = this.fw.getLastUrlVideo();
	omc.stream.load(urlVideo, true, 0, 0);
	this.eventKeyEsc();
};

ScanDTTSettingsApp.prototype.eventKeyEsc= function(){
	try{
		if(this.fw.getDTT().scanInProgress()==true){
				this.fw.getDTT().stopScan();
			}
		this.searchStart = false;
///////////////////////////////CONTROLLO DEL TASTIERINO NUMERICO//////////////////
		if(this.BoxChangeChannel == true){
			 this.DeleteNumericDigit();
//////////////////////////////////////////////////////////////////////////////////
		}else{			
			/*
			if (this.goToHomePageTimer){
				this.fw.getTimer().clearTimeout(this.goToHomePageTimer);
			}
			this.goToHomePageTimer=this.fw.getTimer().setTimeout(1000, this.getHomeUrl, this);
			this.loadApp(this.getHomeUrl(),null,null,null,null); 
			*/
			this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", true);
			this.writeOnPopUp( "caricamentoInCorso",null , "/ovaImages/caricamentoInCorso.gif",0 );
			this.fw.backFromExApp = true;
			this.loadApp(this.getHomeUrl(),null,null,null,null); 
			return true;
		}
	}
	catch(ecc){
		this._objErrorInfo._methodName="eventKeyEsc";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};


ScanDTTSettingsApp.prototype.eventKeyUp = function() {
	return true;
};

ScanDTTSettingsApp.prototype.eventKeyDown = function() {
	return true;
};

ScanDTTSettingsApp.prototype.eventKeyLeft = function() {
	return true;
};

ScanDTTSettingsApp.prototype.eventKeyRight = function() {
	return true;
};

ScanDTTSettingsApp.prototype.eventDTTScanProgress=function(par){
	try{
		omc.logger.addEntry("eventDTTScanProgress par: "+par+" this.stato_dtt: "+this.stato_dtt);
		var progress;
		if(this.stato_dtt==0){
			if(par < 12){
				this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress01.png");
			}else if(par < 24){
				this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress02.png");
			}else if(par < 36){
				this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress03.png");
			}else if(par < 48){
				this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress04.png");
			}else if(par < 60){
				this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress05.png");
			}else if(par < 72){
				this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress06.png");
			}else if(par < 84){
				this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress07.png");
			}
			
			/*
		progress= par / 10 ;
		
		if ( par > 10 ) this.foundChannel=true;
	  
	  
		switch (progress){
			case 1:
						this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress01.png");
						break;
			case 2:
						this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress02.png");
			      break;
			case 3:
			      this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress03.png");
			      break;
			case 4:
			      this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress04.png");
			      break;
			case 5:
			      this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress05.png");            
			      break;
			case 6 :
			      this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress06.png");      
			      break;
			case 7:
			      this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress07.png");    
			      break;
			case 8:
			      this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress07.png");
			      break;
			case 9:
			      this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress08.png");
			      break;
			case 10:
			      this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress08.png");                
			  		break;		
			}
		*/
		}	
	}
	catch(ecc){
		this._objErrorInfo._methodName = 'eventDTTScanProgress';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;	
};      

ScanDTTSettingsApp.prototype.eventDTTScanComplete=function(par){
	try{



			this.fw.BOOT = true;
			this.fw.preferiti =false;
		
			this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress08.png");
			this.fw.lastScanSession=this.fw.getOSD().getTime();
			//aggiorna la struttura dello Zapper/Zapping adeguandola ai nuovi canali locali trovati;
			//this.caricaZapperInfoDefault();
			
			this.fw.getTimer().setTimeout(20, this.caricaZapperInfoDefault, this);
		//	this.fw.getTimer().setTimeout(20, this.caricaZapperInfoPreferiti, this);
			
			
			this.fw.getTimer().setTimeout(4000, this.creaImmaginiZapperDefault, this);
			
			
			
		
			
		
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventDTTScanComplete';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}

	return true;

};   
ScanDTTSettingsApp.prototype.creaImmaginiZapperDefault = function() {
	this.fw.cgiHasFinished = false;
	this.salvaFileBootHTML();
	this.canali = this.getZapper();
	var stringaskygrid = 'skygrid_';
	var stringa = '';
	for (i = 0; i < this.canali.length; i++) {
		stringa += this.canali[i].ZappingId + '%20'
				+ this.spaceBlank(this.canali[i].ChanName) + ':'
				+ stringaskygrid + this.canali[i].ZappingId + '_'
				+ this.canali[i].chanrecid + ';';
	}
	
	if(this.fw.OMC_LOGGER_ENABLED)
		omc.logger.addEntry("################     ScanDTTSettingsApp.creaImmaginiZapperDefault stringa: "+stringa);
	this.fw.getFetcher().fetchNow(
			'/cgi-bin/cancEcreaImg.cgi?dest='+this.fw.TILAB_ROOT+this.fw.URL_IMG_ZAPP_DEFAULT+'&lista=' + stringa, this,
			this.caricaImmaginiReturn);
}

ScanDTTSettingsApp.prototype.caricaImmaginiReturn = function(obj) {
	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("################     ScanDTTSettingsApp.creaImmaginiZapperDefault CALLBACK ###################################### codice: "+obj.codice);
	this.fw.getTimer().setTimeout(10, this.caricaImmaginiCGIScan, this);
	this.fw.getTimer().setTimeout(200, this.cgiHasFinished, this);
	return true;

}

ScanDTTSettingsApp.prototype.caricaImmaginiCGIScan = function(){
	try{
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("################     ScanDTTSettingApp.caricaImmaginiCGI CALLBACK ");
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("Caricamento Immagini CGI on / off ....  ");
	
	
	
	this.caricaImmaginiZapperDefault();
	//this.creaImmaginiZapperDefault();
	
	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("Caricamento Immagini CGI on / off .... Eseguito!!! ");


	var chan_num = this.fw.getDTT().getChannels().length;
	if ( chan_num==0 ){
		this.descriptionText[3]="<table border='0' width='640' height='65' cellspacing='0' cellpadding='0'>"
								+"<tr width='640' height='65'><td width='640' height='65'>"
								+"<span style='color:white' align='center'>Ricerca completata<br>Nessun canale trovato</span>"
								+"</td></tr></table>";
	}
	else{
		this.descriptionText[3] = this.descriptionText[3].replace("#X#",chan_num);
		this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress08.png");
	}
	this._ui.setLabelText("./descriptionLine1","");
	this._ui.setLabelText("./descriptionLine2", this.descriptionText[3]);
	this._ui.redraw();	
	
	
	this.fw.BOOT = false;
//	if(this.isAggiornaPrefDopoScansione())
	this.aggiornaPrefDopoScansione();
	if(this.fw.preferiti){
		this.fw.ShowPreferiti=1;
		this.fw.zapper = this.fw.ListaFavoriti;						
		this.createZapper();
		this.canali = this.getPreferiti();
	}
	
	
	this.goToHomePageTimer=this.fw.getTimer().setTimeout(3000, this.tornaIndietro, this);
	} catch (e){
		omc.logger.addEntry("error: "+e.message);
	}

};

//ScanDTTSettingsApp.prototype.caricaImmaginiCGIScan = function(obj){
//	try{
//		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("################     ScanDTTSettingApp.caricaImmaginiCGI CALLBACK errorcode: "+obj.errorCode);
//		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("Caricamento Immagini CGI on / off ....  ");
//	
//	if (obj.codice !=null)
//		omc.logger.addEntry("obj.data.codice: "+obj.codice);
//	
//	this.caricaImmaginiZapperDefault();
//	//this.creaImmaginiZapperDefault();
//	
//	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("Caricamento Immagini CGI on / off .... Eseguito!!! ");
//
//
//	var chan_num = this.fw.getDTT().getChannels().length;
//	if ( chan_num==0 ){
//		this.descriptionText[3]="<table border='0' width='640' height='65' cellspacing='0' cellpadding='0'>"
//								+"<tr width='640' height='65'><td width='640' height='65'>"
//								+"<span style='color:white' align='center'>Ricerca completata<br>Nessun canale trovato</span>"
//								+"</td></tr></table>";
//	}
//	else{
//		this.descriptionText[3] = this.descriptionText[3].replace("#X#",chan_num);
//		this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress08.png");
//	}
//	this._ui.setLabelText("./descriptionLine1","");
//	this._ui.setLabelText("./descriptionLine2", this.descriptionText[3]);
//	this._ui.redraw();	
//	
//	
//	this.fw.BOOT = false;
//	if(this.fw.preferiti){
//		this.fw.ShowPreferiti=1;
//		this.fw.zapper = this.fw.ListaFavoriti;						
//		this.createZapper();
//		this.canali = this.getPreferiti();
//	}
//	
//	 
//	this.goToHomePageTimer=this.fw.getTimer().setTimeout(3000, this.tornaIndietro, this);
//	} catch (e){
//		omc.logger.addEntry("error: "+e.message);
//	}
//
//};

ScanDTTSettingsApp.prototype.tornaIndietro=function(){
	this.loadApp(this.getHomeUrl(),null,null,null,null);
};

ScanDTTSettingsApp.prototype.eventDTTScanStarted=function(par){

	try{
		this.stato_dtt=0;
		this.referImageToLayout("ScanDTTSettingsLayout","./popupStartedNew","/ovaImages/1pixelclear.gif");
	}catch(ecc){

		this._objErrorInfo._methodName = 'eventDTTScanStarted';

		this._objErrorInfo._obException = ecc;

		this.handleError();

	}

	return true;	

};   

   

ScanDTTSettingsApp.prototype.eventDTTScanStopped=function(par){

	try

	{
		if(this.stato_dtt==0){

			this.referImageToLayout("ScanDTTSettingsLayout","./popupStartedNew","/ovaImages/1pixelclear.gif");

			this.stato_dtt=1;

		}
		//this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=HomeImpostazioniApp");
		//this.stato_dtt=0;
		this.yPos=2;
		this._ui.setLabelHtml('./rolloverRossoAlice','<img src="/ovaImages/1pixelclear.gif">');
		this.referImageToLayout("ScanDTTSettingsLayout","./rolloverRicerca","/ovaImages/ricercabutton.gif");

		this.referImageToLayout("ScanDTTSettingsLayout","./rolloverAbilitazione","/ovaImages/abilitazionebutton.gif");

		this.modalita=1;

		this.referImageToLayout("ScanDTTSettingsLayout","./dtt_up","/ovaImages/elementi_sfondo/scan_dtt_up1.gif");

		this.referImageToLayout("ScanDTTSettingsLayout","./dtt_down","/ovaImages/elementi_sfondo/scan_dtt_down1.gif");

		//this.setInitHoriz();

		//this.setHorizOnFocus(this.catList[0].catId);

		

		this._ui.redraw();		

		

	}catch(ecc){

		this._objErrorInfo._methodName = 'eventDTTScanStopped';

		this._objErrorInfo._obException = ecc;

		this.handleError();

	}

	return true;	

};  

    

ScanDTTSettingsApp.prototype.eventDTTScanFailed=function(par){

	try{
		if(this.stato_dtt==0){

			this.referImageToLayout("ScanDTTSettingsLayout","./popupStartedNew","/ovaImages/avanzamento_digitale_Terrestre.gif");

			this.stato_dtt=1;

		}

		//this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=startup&app1=StartupApp&app2=Logger&app3=Sender&app4=AutoUpdate");
	}
	catch(ecc){
		this._objErrorInfo._methodName = 'eventDTTScanFailed';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;	
};

ScanDTTSettingsApp.prototype.startChannelSearch=function(){
	try{
		this._ui.setLabelText("./descriptionLine1",this.descriptionText[2]);
		this._ui.setLabelText("./descriptionLine2","&nbsp;");
		this.referImageToLayout("RicercaDTTLayout","progressBar","/ovaImages/layout/impostazioni/progress00.png");
		this.referImageToLayout("RicercaDTTLayout","btnSearch","/ovaImages/layout/impostazioni/riqua_trasp.png");
		this._ui.redraw();
		omc.logger.addEntry("Occhiooooo ...");
		if (this.modalita==1){
			this.modalita=2;
			this.flagDTTEnable = true;
			omc.logger.addEntry("Occhiooooo, che ...");
			if(this.fw.getDTT().scanInProgress()==true){
				omc.logger.addEntry("Occhiooooo, che non parte ...");
			}
			//this.fw.getFetcher().fetchNow("/ovaServices/dtt/SetEnableDTTFetcher.jsp?usrRecid="+this.fw.getUserInfo().getAccountID()+"&flagDTT=Y", this, this.checkSetEnable);
			
			omc.logger.addEntry("Occhiooooo, che forse ci siamo ...");
			this.fw.getDTT().startScan();
			omc.logger.addEntry("Occhiooooo, scansione partita ...");
		}
		else{
			this.fw.getDTT().startScan();
		}
		return true;
	}
	catch(ecc){
		this._objErrorInfo._methodName = "startChannelSearch";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/************************************************************************************************************************

eventDataFetchComplete � sollevato da ovaDataFecther quando la richiesta di un fetcher � stata completata.

Overriding introdotto per evitare il refresh degli array di zapping/zapper durante la scansione DTT

*******************************************************/

ScanDTTSettingsApp.prototype.eventDataFetchComplete=function(resultData,objUrl, callerObj){
	try{	
		var ob= new Object();	
		ob= this._urlFetchArray.shift();			
	}
	catch(ecc){
	  this._objErrorInfo._methodName = 'eventDataFetchComplete'; 
	  this._objErrorInfo._obException = ecc;
  	this.handleError();
	}finally{
	  return true;
	}
};