var _keyHandlerNames = null;
var api = top.createPortal();


//
// Here are the simple video API functions
//
//
function videoOn() {
  api.loadVideoURL('vsb:239.1.1.100:10000?data_format=m2t', 376, 55, 279, 186);
}

function videoOff() {
  api.unloadVideo();
}



//
// This is the entry point for user key-presses
//
//
function processKey(keyEvent) 
{
	

  // Do we have a key-map?
  if (!_keyHandlerNames)
  {
     createKeyMap();
  }

  // Look up the function name of the key handler
  var handlerName = _keyHandlerNames[keyEvent.which];
  if (handlerName == null)
    return true;
    
  // Convert the name into a function
  var handler = window[handlerName];
  if (handler == null)
    return true;
    
  // alert(keyEvent.which+" "+handlerName); 
   // alert(keyEvent.toSource());
  // Execute
  return handler();
}


//
// Determine if we are running on a PC or a STB
//
function isPC() {
    return (navigator.userAgent.indexOf("x86") != -1);
};


//
// Create a key-map of function names
//
function createKeyMap()
{
 if (isPC()){
    // ========================
    // Telsey's PC Client Key Map
    // ========================
    _keyHandlerNames = {
            32:         "onKeySpace",
            46:         "onKeyDot",
            48:         "onKey0",
            49:         "onKey1",
            50:         "onKey2",
            51:         "onKey3",
            52:         "onKey4",
            53:         "onKey5",
            54:         "onKey6",
            55:         "onKey7",
            56:         "onKey8",
            57:         "onKey9",
            97:         "onKeya",
            98:         "onKeyb",
            99:         "onKeyc",
            100:        "onKeyd",
            101:        "onKeye",
            102:        "onKeyf",
            103:        "onKeyg",
            104:        "onKeyh",
            105:        "onKeyi",
            106:        "onKeyj",
            107:        "onKeyk",
            108:        "onKeyl",
            109:        "onKeym",
            110:        "onKeyn",
            111:        "onKeyo",
            112:        "onKeyp",
            113:        "onKeyq",
            114:        "onKeyr",
            115:        "onKeys",
            116:        "onKeyt",
            117:        "onKeyu",
            118:        "onKeyv",
            119:        "onKeyw",
            120:        "onKeyx",
            121:        "onKeyy",
            122:        "onKeyz",
            1073741825: "onKeyBack",
            1073741828: "onKeyEnter",
            1073741836: "onKeyScrollUp",
            1073741837: "onKeyScrollDown",
            1073741838: "onKeyUp",
            1073741839: "onKeyDown",
            1073741840: "onKeyLeft",
            1073741841: "onKeyRight",
            1073741853: "onKeyUp",
            1073741854: "onKeyScrollUp",
            1073741855: "onKeyLeft",
            1073741857: "onKeyRight",
            1073741859: "onKeyDown",
            1073741860: "onKeyScrollDown",
            1073741861: "onKeyEnter",
            1073741921: "onKeyMenu",
            1073741922: "onKeyTV",
            1073741923: "onKeyWeb",
            1073741924: "onKeyPortal",
            1073741925: "onKeyStop",
            1073741926: "onKeyPlay",
            1073741927: "onKeyRwd",
            1073741928: "onKeyFwd",
            1140850785: "onKeyHot1",
            1140850786: "onKeyHot2",
            1140850787: "onKeyHot3",
            1140850788: "onKeyHot4",
            1140850789: "onKeyMute",
            1140850790: "onKeyPause",
            1140850791: "onKeyVolUp",
            1140850792: "onKeyVolDown"
    };
  }else{
    // ========================
    // Telsey Key Map
    // ========================
    _keyHandlerNames = {
            32:         "onKeySpace",
            46:         "onKeyDot",
            48:         "onKey0",
            49:         "onKey1",
            50:         "onKey2",
            51:         "onKey3",
            52:         "onKey4",
            53:         "onKey5",
            54:         "onKey6",
            55:         "onKey7",
            56:         "onKey8",
            57:         "onKey9",
            97:         "onKeya",
            98:         "onKeyb",
            99:         "onKeyc",
            100:        "onKeyd",
            101:        "onKeye",
            102:        "onKeyf",
            103:        "onKeyg",
            104:        "onKeyh",
            105:        "onKeyi",
            106:        "onKeyj",
            107:        "onKeyk",
            108:        "onKeyl",
            109:        "onKeym",
            110:        "onKeyn",
            111:        "onKeyo",
            112:        "onKeyp",
            113:        "onKeyq",
            114:        "onKeyr",
            115:        "onKeys",
            116:        "onKeyt",
            117:        "onKeyu",
            118:        "onKeyv",
            119:        "onKeyw",
            120:        "onKeyx",
            121:        "onKeyy",
            122:        "onKeyz",
            0x40000004: "onKeyEnter",
            0x4000000E: "onKeyUp",
            0x4000000F: "onKeyDown",
            0x40000010: "onKeyLeft",
            0x40000011: "onKeyRight",
            0x4000000C: "onKeyScrollUp",
            0x4000000D: "onKeyScrollDown",
            0x40000101: "onKeyPause",
            0x40000102: "onKeyStop",
            0x40000100: "onKeyPlay",
            0x40000105: "onKeyRwd",
            0x40000104: "onKeyFwd",
            0x40000097: "onKeyVolUp",
            0x40000098: "onKeyVolDown",
            0x40000099: "onKeyMute",
            0x40000088: "onKeyMenu",
            0x40000084: "onKeyHot1",
            0x40000085: "onKeyHot2",
            0x40000086: "onKeyHot3",
            0x40000087: "onKeyHot4",
            0x40000001: "onKeyBack",
            0x400000A4: "onKeyPower",
            0x4000009E: "onKeyInternet",
            70:         "onKeyFilm",
            1073741827: "onKeyDel",
            0x40000089: "onKeyInfo",
            0x4000000A: "onKeyEye",
            0x40000081: "onKeyEsc"
    };
  }
}




// ---------------------------------------------------------------------------
//
// HERE ARE THE DEFAULT HANDLERS - THESE MAY BE OVERRIDDEN IN THE MAIN PAGE...
//
// The handler should return true if we do not wish to handle the key
//
// Note: The key-handlers only need to be defined for those keys we require
// actions for.  If the key-handler is missing then the default action will
// be to return true from the processKey function.
//


/*
   On/off key
*/

function onKeyPower() {
  api.gotoStandBy();
  return false;
}

/*
  Channel change keys
*/

function onKeyScrollUp() {
  api.gotoNextChannel();
  return false;
}

function onKeyScrollDown() {
  api.gotoPrevChannel();
  return false;
}

/* 
   The short-cut to menu keys 
*/

function onKeyTV() { 
  videoOff();
  api.loadService('TV');
  return false;
} 
    
function onKeyWeb() {
  // videoOff(); 
  //??  api.loadService('Web');
  return false;
}

function onKeyBack() {
  //videoOff();  
  api.loadService('MainMenu');
  return true;
}

function onKeyEsc() {
  //videoOff();  
  api.loadService('MainMenu');
  return true;
}


function onKeyMenu() {
  //videoOff();
  api.loadService('MainMenu');
  return true;
}

function onKeyEye() {
  //videoOff();
  api.loadService('Eye');
  return true;
}

function onKeyPortal() {
  videoOff();
  api.gotoPromotions();
  return false;
}
function onKeyEnter() {
 
  return true;
}


/*
   Move the cursor around the screen. 
   
   By default, we block the action of these keys
*/

function onKeyLeft() { 
    return true;
}       

function onKeyUp() { 
    return true;
}

function onKeyRight() { 
    return true;
}  

function onKeyDown() {
	
    return true;
}


/*
    The hot-keys (FLOF keys)
    
    By default, we block the action of these keys
*/
function onKeyHot1() { 
    return false;
}

function onKeyHot2() { 
    return false;
}

function onKeyHot3() { 
    return false;
}           

function onKeyHot4() { 
    return false;
}       



/*
  The trick-play keys
  
  By default, we block the action of these keys
*/
function onKeyPause() { 
    return false;
}

function onKeyPlay() { 
    return false;
}

function onKeyFwd() { 
    return false;
}

function onKeyRwd() { 
    return false;
}

function onKeyStop() { 
    return false;
}
      
