 function OvaDataCache(){ }
 
 /* Di default CACHE_SIZE vale 20, questo valore indica il numero massimo per quanto riguarda i cache object */
 OvaDataCache.prototype.create=function(size){ this._size=size;
 this._numObj=0;
 this._data={};
 };

 OvaDataCache.prototype.putData=function(id, data, expiration){ 
 	if(this._size==0){ 
		return;
 	}
	/* Nel caso _numObj supera CACHE_SIZE si esegue expunge */
	if(this._numObj>=this._size)this.expunge();
 	this._data[id]={ data: data, expiration: expiration, lastUsed:this.fw.getOSD().getTime() };
 	this._numObj++;
 };

 OvaDataCache.prototype.getData=function(id){
 var obj=this._data[id];
 if(!obj){ 
	 return null;
 } else if(obj.expiration==-1){ 
 	obj.lastUsed=this.fw.getOSD().getTime();
 	return obj.data;
 } 
 var now=this.fw.getOSD().getTime();
 if(now > obj.expiration){  
	delete(this._data[id]);
 	this._numObj--;
 	return null;
 } 
 obj.lastUsed=this.fw.getOSD().getTime();
 return obj.data;
 };

 OvaDataCache.prototype.expunge=function(){ 
 var debug=this.fw.getDebug();
 debug.logDebug("Cache: Expunging");
 var curTime=this.fw.getOSD().getTime();
 var sortedData=new Array();
 var expiredData=new Array();
 for(id in this._data){ 
	/* Si può notare il legame tra expiration e curTime, da definire ... */
 	if((this._data[id].expiration>=0) && ( this._data[id].expiration < curTime)){
 		expiredData.push(id);
 	}
 	else {
 		sortedData.push([this._data[id].lastUsed, id]);
 	}
 }
 debug.logDebug("Cache: Expiring " + expiredData);
 /* Eliminazione da _data[] */
 for(i=0; i < expiredData.length; i++){
 	delete(this._data[expiredData[i]]);
 	this._numObj--;
 }
 var compare=function(a,b){ if(a[0] > b[0])return 1;
 	if(b[0] > a[0])return -1;
 	return 0;
 };
 sortedData.sort(compare);
 numToDelete=(this._numObj / 5);
 for(i=0; i < numToDelete; i++){
 	delete(this._data[sortedData[i][1]]);
 	this._numObj--;
 }
 };

  OvaDataCache.prototype.clearCache=function(){ this._data={};
 this._numObj=0;
 };
 
