function OvaDebug() {
}

OvaDebug.prototype.create = function() {
	this._config = this.fw.getConfig();
	/*
	 * Ricerca un <iframe name= ...> "debugLayout" nel caso non lo trovasse
	 * viene messo a null
	 */
	this._debugLayout = this.fw.getLayoutManager().getLayout("debugLayout");
	this._log = "";
	this._modeVideo = false;
	this._scrolling = false;
	this._videoAlpha = 0;
	this._times = new Object();
	this._allowLogging = true;
	this._loglevel = this._config.LOG_INFO;
	this._allowDebugKeys = false;
	this._alertErrors = false;
	this._alertDebug = false;
	this._consoleVisible = false;
	this._consumeKeys = false;
	this.DEBUG_ENABLED = eval(this._config.DEBUG_ENABLED);
};

OvaDebug.prototype.log = function() {
	if (!this.DEBUG_ENABLED || !this._allowLogging || this._scrolling)
		return;
	var level = arguments[arguments.length - 1];
	var msg = '', arg = null;
	for ( var i = 0; i < arguments.length - 1; i++) {
		arg = arguments[i];
		if (typeof (arg) != 'string') {
			arg = this.fw.getUtil().niceText(arg);
		}
		msg += arg;
	}
	if (parent && parent.isTestHarness) {
		parent.log(msg, level);
	} else if (this.fw.opener) {
		this.fw.opener.log(msg, level);
	} else if (this._debugLayout) {
		if (level <= this._loglevel)
			this._logInternal(msg, level);
	}
	if (level > this._config.LOG_LEVEL)
		return;
	this.fw.getOSD().log(msg, level);
	if ((level <= this._config.LOG_DEBUG) && this._alertDebug)
		alert(msg);
	else if ((level <= this._config.LOG_ERROR) && this._alertErrors)
		alert(msg);
};
OvaDebug.prototype.handleDebugKey = function(ovaEvent) {
	if (!this.DEBUG_ENABLED || !this._allowDebugKeys)
		return false;
	var consumed = false;
	if (this.fw.opener)
		consumed = this.fw.opener.handleDebugKey(ovaEvent);
	else if (parent && parent.isTestHarness)
		consumed = parent.handleDebugKey(ovaEvent);
	if (consumed)
		return true;
	this._scrolling = ("AZXQ".indexOf(ovaEvent)) != -1;
	switch (ovaEvent) {
	case 'h':
		var usage = ("h = display this help message\n"
				+ "a = toggle alert errors\n" + "d = toggle alert debug\n"
				+ "l = toggle logging\n" + "L = list all components loaded\n"
				+ "f = flush debug log\n" + "c = clear debug log\n"
				+ "C = toggle consume unrecognized keys\n"
				+ "e = eval javascript string\n" + "E = throw error\n"
				+ "r = reload framework\n" + "i = go to /ova/index.html\n"
				+ "t = display the time\n" + "u = go to a URL\n"
				+ "I = dump system info\n"
				+ "U = display user agent and platform\n" + "m = toggle mute\n"
				+ "k = disable debug keys\n"
				+ "vv = toggle video on/off (BTV)\n"
				+ "VV = video on/off (VOD)\n" + "va = video toggle alpha\n"
				+ "vf = video full screen\n" + "vF = video fade in/out\n"
				+ "vb = video toggle background\n" + "vw = video window\n"
				+ "vm = video toggle macrovision\n" + "vo = video open url\n"
				+ "vs = video status\n" + "vj = video jump to position\n"
				+ "v> = video fast forward\n" + "v< = video rewind\n"
				+ "vp = video play/pause\n" + "vr = video version\n"
				+ "vk = video key color\n" + "A = scroll up\n"
				+ "Z = scroll down\n" + "X = scroll to bottom\n"
				+ "Q = scroll to top\n");
		this.logInfo(usage);
		break;
	case 'd':
		this._alertDebug = !this._alertDebug;
		this.logInfo("alert debug = " + this._alertDebug);
		break;
	case 'D':
		this._loglevel = this._config.LOG_DEBUG;
		this.logDebug("log debug on");
		break;
	case 'c':
		this._log = "";
		this.flushLog();
		break;
	case 'I':
		this._dumpSystemInfo();
		break;
	case 'k':
		if (this._modeVideo) {
			this.logInfo("vc.background(0x00003A, 0xF0F0F0)");
			this.fw.getVideoControl().background(0x00003A, 0xF0F0F0);
			break;
		} else {
			this._allowDebugKeys = false;
			if (!this._allowDebugKeys && this._consoleVisible) {
				this.fw.getEventManager().enableNav();
				this.fw.getLayoutManager().lastLayout();
			} else {
				this.logInfo("allow debug keys = " + this._allowDebugKeys);
			}
			break;
		}
	case 'l':
		this._allowLogging = !this._allowLogging;
		this.logInfo("logging on");
		break;
	case 'L':
		var info = "";
		for ( var i = 0; i < _osdComps.length; i++)
			info += (_osdComps[i] + "\n");
		for ( var i = 0; i < _comps.length; i++)
			info += (_comps[i] + "\n");
		for ( var i = 0; i < _uiComps.length; i++)
			info += (_uiComps[i] + "\n");
		this.logInfo(info);
		break;
	case 'C':
		this._consumeKeys = !this._consumeKeys;
		this.logInfo("consume keys = " + this._consumeKeys);
		break;
	case 'v':
	case 'V':
		if (!this._modeVideo) {
			this.logInfo("video mode...");
			this._modeVideo = true;
			return true;
		}
		this.logInfo("toggle video, cur mode = "
				+ this.fw.getVideoControl().getMode() + ", cur status = "
				+ this.fw.getVideoControl().getState());
		this._videoAlpha = 0;
		if (this.fw.getVideoControl().getMode() != this.fw.getVideoControl().VIDEO_OFF) {
			this.fw.getVideoControl().videoOff();
		} else {
			this.fw.getVideoControl().setWindow(480, 53, 120, 80);
		}
		if (this.fw.getVideoControl().getState() == 0) {
			if (ovaEvent == "V")
				this.fw.getVideoControl().load('172.19.1.10:5004', 'rtsp',
						'ovs', 'Atomic_Kitten');
			else
				this.fw.getVideoControl().load('239.1.1.100:10000');
		} else {
			this.fw.getVideoControl().unload();
		}
		break;
	case 'w':
		if (this._modeVideo) {
			this.logInfo("video window");
			this.fw.getVideoControl().setWindow(480, 53, 120, 80);
			this._videoAlpha = 0;
		}
		break;
	case '>':
		if (this._modeVideo) {
			this.logInfo("video ff");
			this.fw.getVideoControl().setPlayRate(2);
		}
		break;
	case '<':
		if (this._modeVideo) {
			this.logInfo("video rew");
			this.fw.getVideoControl().setPlayRate(-2);
		}
		break;
	case 'p':
		if (this._modeVideo) {
			this.logInfo("video play/pause");
			this.fw.getEventManager().handleKey("eventKeyPause");
		}
		break;
	case 'j':
		if (this._modeVideo) {
			this.logInfo("video jump");
			this.fw.getVideoControl().setPosition(10);
		}
		break;
	case 's':
		if (this._modeVideo) {
			this.logInfo("video status = "
					+ this.fw.getVideoControl().getState());
		}
		break;
	case 'r':
		if (this._modeVideo) {
			this.logInfo("video version = "
					+ this.fw.getVideoControl().getVersion());
		}
		break;
	case 'o':
		if (this._modeVideo) {
			var url = prompt('Enter Video URL:');
			if (url != "") {
				this.logInfo("open url " + url);
				this.fw.getVideoControl().load(url);
				this.fw.getVideoControl().setWindow(480, 53, 120, 80);
			}
		}
		break;
	case 'f':
		if (this._modeVideo) {
			this.logInfo("video fullscreen");
			this.fw.getVideoControl().fullScreen();
			this._videoAlpha = 0;
		} else {
			this.flushLog();
		}
		break;
	case 'F':
		if (this._modeVideo) {
			if (this._videoAlpha == 255) {
				this.logInfo("video fade in");
				this.fw.getVideoControl()
						.setAlpha("", "", this._videoAlpha, -1);
				this._videoAlpha = 0;
			} else {
				this.logInfo("video fade out");
				this.fw.getVideoControl().setAlpha("", "", this._videoAlpha, 1);
				this._videoAlpha = 255;
			}
		}
		break;
	case 'a':
		if (this._modeVideo) {
			if (this._videoAlpha == 0) {
				this.logInfo("alpha on");
				this.fw.getVideoControl().setAlpha("", "", "", 128);
				this._videoAlpha = 128;
			} else {
				this.logInfo("alpha off");
				this.fw.getVideoControl().setAlpha("", "", "", 0);
				this._videoAlpha = 0;
			}
		} else {
			this._alertErrors = !this._alertErrors;
			this.logInfo("alert errors = " + this._alertErrors);
		}
		break;
	case 'b':
		if (this._modeVideo) {
			this.logInfo("video background");
			this.fw.getVideoControl().background();
			if (this.fw.getVideoControl().getMode() == this.fw
					.getVideoControl().VIDEO_BACKGROUND)
				this._videoAlpha = 255;
			else
				this._videoAlpha = 0;
		}
		break;
	case 'm':
		if (this._modeVideo) {
			this.logInfo("video macrovision");
			this.fw.getVideoControl().setMacrovision(
					!this.fw.getVideoControl().getMacrovision());
		} else {
			this.logInfo("toggle mute");
			this.fw.getOSD().setMute(!this.fw.getOSD().getMute());
		}
		break;
	case 'r':
		this.logInfo("reloading...");
		top.location.reload();
		break;
	case 'e':
		var str = prompt('Enter Eval String:');
		if (str != "") {
			var result = eval(str);
			this.logInfo("Eval Result: " + result);
		}
		break;
	case 'E':
		var code = prompt('Enter Error Code:');
		if (code == "")
			code = "OVA-404";
		this.fw.getEventManager().handleError(code);
		break;
	case 'i':
		this.logInfo("go to /ova/index.html");
		top.location.href = '/ova/index.html';
		break;
	case 'u':
		var url = prompt('Enter URL:');
		if (url != "")
			top.location.href = url;
		break;
	case 'U':
		this.logInfo("UserAgent: " + navigator.userAgent + "\n" + "Platform: "
				+ this.getPlatform());
		break;
	case '/':
		if (!this._consoleVisible) {
			this._consoleVisible = true;
			this.fw.getLayoutManager().setLayout("debugLayout");
			this.flushLog();
		} else {
			this._consoleVisible = false;
			this.fw.getLayoutManager().lastLayout();
		}
		break;
	case 'A':
		if (this._debugLayout)
			this._debugLayout.log.scrollBy(0, -20);
		break;
	case 'Z':
		if (this._debugLayout)
			this._debugLayout.log.scrollBy(0, 20);
		break;
	case 'Q':
		if (this._debugLayout)
			this._debugLayout.log.scroll(0, 0);
		break;
	case 'X':
		if (this._debugLayout)
			this._debugLayout.log.scroll(0, 100000);
		break;
	default:
		this._modeVideo = false;
		return this._consumeKeys;
	}
	this._modeVideo = false;
	return true;
};
OvaDebug.prototype.setAllowDebugKeys = function(val) {
	this._allowDebugKeys = val;
};
OvaDebug.prototype.argsToArr = function(args) {
	if (!this.DEBUG_ENABLED)
		return;
	var arr = [];
	for ( var i = 0; i < args.length; i++) {
		arr.push(args[i]);
	}
	return arr;
};
OvaDebug.prototype.flushLog = function() {
	if (!this.DEBUG_ENABLED)
		return;
	var logui = this._debugLayout.log;
	logui.document.open();
	logui.document.write("<html><head></head><body>" + this._log
			+ "</body></html>");
	logui.document.close();
	logui.scroll(0, 100000);
};
OvaDebug.prototype._logInternal = function(msg, level) {
	if (!this.DEBUG_ENABLED)
		return;
	switch (level) {
	case this._config.LOG_INFO:
		msg = "<span style='color: black'>" + msg + "</span><br>";
		break;
	case this._config.LOG_DEBUG:
		msg = "<span style='color: blue'>" + msg + "</span><br>";
		break;
	case this._config.LOG_WARNING:
		msg = "<span style='color: green'>" + msg + "</span><br>";
		break;
	case this._config.LOG_ERROR:
		msg = "<span style='color: red;font-weight: bold;'>" + msg
				+ "</span><br>";
		break;
	default:
		break;
	}
	;
	this._log += this.fw.getUtil().niceHTML(msg);
	if (this._consoleVisible)
		this.flushLog();
	if (this._log.length > 100000)
		this._log = "";
};
OvaDebug.prototype.logDebug = function() {
	if (!this.DEBUG_ENABLED)
		return;
	var args = this.argsToArr(arguments);
	args.push(this._config.LOG_DEBUG);
	this.log.apply(this, args);
};
OvaDebug.prototype.logInfo = function() {
	if (!this.DEBUG_ENABLED)
		return;
	var args = this.argsToArr(arguments);
	args.push(this._config.LOG_INFO);
	this.log.apply(this, args);
};
OvaDebug.prototype.logError = function() {
	if (!this.DEBUG_ENABLED)
		return;
	var args = this.argsToArr(arguments);
	args.push(this._config.LOG_ERROR);
	this.log.apply(this, args);
};
OvaDebug.prototype.logWarning = function() {
	if (!this.DEBUG_ENABLED)
		return;
	var args = this.argsToArr(arguments);
	args.push(this._config.LOG_WARNING);
	this.log.apply(this, args);
};
OvaDebug.prototype.getPlatform = function() {
	if (!this.DEBUG_ENABLED)
		return;
	if (navigator.userAgent.indexOf("0.9.2") != -1)
		return "kreatel";
	else if (navigator.userAgent.indexOf("Mozilla/5.0") != -1)
		return "samsung";
	else
		return "thomson";
};
OvaDebug.prototype._dumpSystemInfo = function() {
	if (!this.DEBUG_ENABLED)
		return;
	var platform = this._getPlatform();
	var info = "System Info For " + platform + "\n";
	if (platform == "kreatel" && !this.fw.getOSD().isPC()) {
		var sys = appContext.systemInfo;
		for (i in sys) {
			info += i + ": " + sys[i] + "\n";
		}
	} else {
		info += "not supported";
	}
	this.logInfo(info);
};
OvaDebug.prototype.startTimer = function(i) {
	if (!this._times[i])
		this._times[i] = new Object();
	this._times[i].start = new Date();
};
OvaDebug.prototype.endTimer = function(i) {
	if (!this._times[i])
		this._times[i] = new Object();
	this._times[i].end = new Date();
};
OvaDebug.prototype.showElapsed = function(i) {
	if (i != null) {
		var start = this._times[i].start.getTime();
		var end = this._times[i].end.getTime();
		var elapsed = this._times[i].end - this._times[i].start;
		alert("Timer: " + i + "\n\tStart: " + start + "\n\tEnd: " + end
				+ "\nElapsed: " + elapsed + "\n\n");
	} else {
		for (key in this._times) {
			var start = this._times[key].start.getTime();
			var end = this._times[key].end.getTime();
			var elapsed = this._times[key].end - this._times[key].start;
			alert("Timer: " + key + "\n\tStart: " + start + "\n\tEnd: " + end
					+ "\nElapsed: " + elapsed + "\n\n");
		}
	}
};
OvaDebug.prototype.clearTimers = function() {
	this._times = new Object();
};