 function OvaEPGManager(){ } 

 OvaEPGManager.prototype.create=function(){
 this._callBackObj=null;
 this._callBackFunc=null;
 this._schedule=null;
 this._channels=null;
 this._reloadInterval=eval(this.fw.getConfig().RELOAD_INTERVAL_SCHEDULE);
 this.FILTER_CHANNELS_BY_RATING=eval(this.fw.getConfig().FILTER_CHANNELS_BY_RATING);
 };

/* Salvo in _callBackObj e _callBackFunc rispettivamente callBackObj e callBackFunc */
 OvaEPGManager.prototype.init=function(callBackObj, callBackFunc){ 
 	this._callBackObj=callBackObj;
 	this._callBackFunc=callBackFunc;
 	this.reload();
 };

/* Imposto la priorità */
 OvaEPGManager.prototype.reload=function(){ 
	this._highPriority=true;
 	this._reload();
 };

/* Chiamata a _loadSchedule(), bisogna tener presente che questo oggetto possiede già le informazioni memorizzate in:
   this._callBackObj, this._callBackFunc e this._highPriority */
 OvaEPGManager.prototype._reload=function(){
 	if(this._scheduleReloadTimer){ 
		this.fw.getDebug().logInfo("clearing current schedule reload timer...");
 		this.fw.getTimer().clearTimeout(this._scheduleReloadTimer);
 		this._scheduleReloadTimer=null;
 	} 
	this._loadSchedule();
 	if(this._reloadInterval > 0){
		this.fw.getDebug().logInfo("schedule info reload in " + this._reloadInterval + " seconds");
 		this._scheduleReloadTimer=this.fw.getTimer().setTimeout(this._reloadInterval*1000, this._reload, this);
 	}
 };

 OvaEPGManager.prototype.suspendUpdates=function(){ if(this._scheduleReloadTimer){ this.fw.getDebug().logInfo("clearing current schedule reload timer...");
 this.fw.getTimer().clearTimeout(this._scheduleReloadTimer);
 this._scheduleReloadTimer=null;
 } };
 OvaEPGManager.prototype.resumeUpdates=function(){ if(this._reloadInterval > 0){ this.fw.getDebug().logInfo("schedule info reload in " + this._reloadInterval + " seconds");
 this._scheduleReloadTimer=this.fw.getTimer().setTimeout(this._reloadInterval*1000, this._reload, this);
 } };

 OvaEPGManager.prototype._loadSchedule=function(){
 if(this._highPriority==true) {
	/* Esecuzione di fetchNow per l'inserimento di una nuova fetchRequestObject in modalità HighPriority, dove 
           this._getChannelsURL() --> url, this --> callerObj, this._gotChannels -->callback */
 	this.fw.getFetcher().fetchNow(this._getChannelsURL(), this, this._gotChannels);
	/* Esecuzione di fetchNow per l'inserimento di una nuova fetchRequestObject in modalità HighPriority, dove 
	   this._getScheduleURL() --> url, this --> callerObj, this._gotSchedule --> callback che richiamerà _start()
	   che a sua volta richiama la callback epgDone definita in Bootstrap.js */
	/* lancio fetchNow con la callback _gotSchedule che mi chiamerà _start(), osservando in OvaDataFetcher(), in
	   eventFetchCompleted(), lancio l'apply per eseguire la callback (in questo caso _gotSchedule e prima _gotChannels)
	   passando fetchRequestObject.callback.apply( fetchRequestObject.callerObj, [ fetchResultObject.data ] ); cioè anche
	   data definito nelle rispettive pagine html, però solo schedule richiama a bootstrap.js tramite _start() */
 	this.fw.getFetcher().fetchNow(this._getScheduleURL(), this, this._gotSchedule);
 } else {
 	this.fw.getFetcher().fetchLater(this._getChannelsURL(), this, this._gotChannels);
 	this.fw.getFetcher().fetchLater(this._getScheduleURL(), this, this._gotSchedule);
 } return true;
 };

 OvaEPGManager.prototype._gotSchedule=function(obj){ 
 this._schedule=obj;
 this._start();
 return true;
 };

 OvaEPGManager.prototype._gotChannels=function(obj){ 
	this._channels=obj.channels;
 	return true;
 };

 OvaEPGManager.prototype._getChannelsURL=function(){
 	var pkgs=this.fw.getUserInfo().getPackages();
 	pkgs=pkgs.join(',');
	/*Per esempio in index.html --> CHANNEL_INFO_URL: '/ovaServices/tvspace/GetChannelData.html'*/
 	var chan_url=this.fw.getConfig().CHANNEL_INFO_URL;
 	/* Questa la si può notare su console in formato per Channel*/
	return chan_url+'?packages='+pkgs;
 };

 OvaEPGManager.prototype._getScheduleURL=function(){
 	var usr=this.fw.getUserInfo();
	/*Per esempio in index.html --> PROGRAM_INFO_URL: '/ovaServices/tvspace/GetProgramData.html'*/
 	var prog_url=this.fw.getConfig().PROGRAM_INFO_URL;
 	var packages=usr.getPackages().join(',');
 	var timezone=escape(usr.getTimeZone());
 	var startOffset=this.fw.getUtil().parseInteger( this.fw.getConfig().SCHEDULE_WINDOW_START, -5);
 	var endOffset=this.fw.getUtil().parseInteger( this.fw.getConfig().SCHEDULE_WINDOW_END, 6);
 	var numhourstop=0-startOffset;
 	var numhoursbottom=endOffset;
 	var createGaps=this.fw.getUtil().parseBoolean( this.fw.getConfig().SCHEDULE_CREATE_EMPTY_SLOTS, false);
	/* Questa la si può notare su console in formato per Schedule*/
 	var url= prog_url + '?type=sepg' + '&timezone='+timezone + '&packages='+packages + '&numhourstop='+numhourstop + '&numhoursbottom='+numhoursbottom + '&createGaps='+createGaps;
 	return url;
 };

 OvaEPGManager.prototype._start=function(){
 	this._highPriority=false;
 	var epg=this.fw.getBTVTuner().getEPG();
	/* Al primo accesso è null */
 	if(epg==null){ 
		epg=this.fw.createEPG();
 		this.fw.getBTVTuner().setEPG(epg);
 	} 
	this.refresh();
 	if(this._callBackObj!=null&&this._callBackFunc!=null){
		/* Nel caso GetProgramData chiamata a epgDone in Bootstrap.js */
		this._callBackFunc.call(this._callBackObj);
 		this._callBackFunc=null;
 		this._callBackObj=null;
 	}
 };

 OvaEPGManager.prototype.refresh=function(){
 if(this._channels === undefined||this._channels === null) return;
 var epg=this.fw.getBTVTuner().getEPG();
 /* epg è un oggetto OvaEPG salvato in OvaBTVTuner INTERESSANTE */
 epg.setData(this._schedule, this._channels);
 var createGaps=this.fw.getUtil().parseBoolean( this.fw.getConfig().SCHEDULE_CREATE_EMPTY_SLOTS, false);
 epg.setBrowseEmptySlots(createGaps);
 /* Di default è false */
 if(this.FILTER_CHANNELS_BY_RATING){
 	epg.filterChannelsByUserRating();
 }
 if(!this.fw.getUserInfo().showBlockedChannels()){
 	epg.filterBlockedChannels();
 }
 this.fw.getBTVTuner().eventEPGUpdated();
 /* In linea di princio ritorna false, infatti commentandoli non cambia niente (per il caso boot!!!) */
 this.fw.getEventManager().handleEvent("eventEPGUpdated");
 };

 OvaEPGManager.prototype.createEPG=function(){
 var epg=this.fw.createEPG();
 epg.setData(this._schedule, this._channels);
 return epg;
 };
 
