function OvaErrors ()
{
  return this;
}

OvaErrors.prototype.create = function ()
{
};

OvaErrors.prototype.setData = function (obj)
{
  this._data = obj;
};

OvaErrors.prototype.getError = function (ovaErrorCode)
{
  var defaultErrorObj = this._getDefaults ();
  var i = ovaErrorCode.indexOf ("-");
  var type = ovaErrorCode.substring (0, i);
  var number = ovaErrorCode.substring (i + 1);
  if (i < 0 || !type || !number)
    {
      this.fw.getDebug ().logError ("OvaErrors.getError() Bad error code = " +
				    ovaErrorCode);
    }
  var appErrorObj = this._data[type];
  var domainErrorObj = defaultErrorObj[type];
  var message;
  var mappedNumber;
  var baseCode;
  if (appErrorObj)
    {
      message = appErrorObj[number];
      baseCode = domainErrorObj.baseCode;
      mappedNumber = parseInt (baseCode) + parseInt (number);
      if (!message)
	{
	  if (domainErrorObj)
	    {
	      message = domainErrorObj[number];
	    }
	  if (!message)
	    {
	      message = appErrorObj.defaultError;
	      mappedNumber = baseCode;
	    }
	  if (!message)
	    {
	      if (domainErrorObj)
		{
		  message = domainErrorObj.defaultError;
		  mappedNumber = baseCode;
		}
	    }
	}
    }
  else
    {
      this.fw.getDebug ().
	logWarning ("OvaErrors.getError() Undefined error domain requested: "
		    + "domain = " + type);
    }
  if (!message)
    message = defaultErrorObj['DEFAULT'].defaultError;
  if (!mappedNumber)
    mappedNumber = defaultErrorObj['DEFAULT'].baseCode;
  if (!message)
    message =
      this.fw.getUtil ().sprintf (this.fw.getConfig ().
				  NO_ERROR_MESSAGE_FOUND_STRING,
				  ovaErrorCode);
  if (!mappedNumber)
    mappedNumber =
      this.fw.getUtil ().sprintf (this.fw.getConfig ().
				  NO_ERROR_NUMBER_FOUND_STRING, ovaErrorCode);
  var ovaError = new Object ();
  ovaError.original = new Object ();
  ovaError.original.errorString = ovaErrorCode;
  ovaError.original.type = type;
  ovaError.original.number = number;
  ovaError.number = mappedNumber;
  ovaError.message = message;
  return ovaError;
};

OvaErrors.prototype._getDefaults = function ()
{
  return this.fw.getBootstrap ().getErrors ();
};
