 function OvaEventManager(){ }
 OvaEventManager.prototype.PRIORITY_POPUP=10;
 OvaEventManager.prototype.PRIORITY_BASEAPP=0;
 OvaEventManager.prototype.PRIORITY_DEFAULT=-10;

 OvaEventManager.prototype.create=function(){
 this._keysEnabled=true;
 this._handlers=new Array();
 this._idSequence=0;

 /*Registrazione di default fatta in fase di init framework dell' handler (this) e handler name ("OvaEventManager") 
   OvaEventManager (handler generale) */
 this.registerDefaultEventHandler(this, "OvaEventManager");

 /*Registrazione di OvaEventManager handler fatta in fase di init in OvaOSD */
 this.fw.getOSD().registerEventHandler(this);

 /* Di default USER_INACTIVITY_TIMEOUT_MS vale '600000' */
 this._inactivityTimeout=eval(this.fw.getConfig().USER_INACTIVITY_TIMEOUT_MS);
 this._userInactive=false;
 this.resetInactivityTimer();
 };
 
 OvaEventManager.prototype.registerEventHandler=function(handler, handlerName, priority ){
 	var id=this._nextHandlerId();
 	if(priority==undefined)priority=this.PRIORITY_BASEAPP;
 	var entry={id:id, name:handlerName, handler:handler, priority:priority};
 	var insertIndex=0;
 	while ((insertIndex < this._handlers.length)&& (priority < this._handlers[insertIndex].priority)) insertIndex++;
 	this._handlers.splice(insertIndex, 0, entry);
 	return id;
 };

  OvaEventManager.prototype.registerDefaultEventHandler=function(handler, handlerName){
  	return this.registerEventHandler(handler, handlerName, this.PRIORITY_DEFAULT);
 };

  OvaEventManager.prototype.unregisterEventHandler=function(id){ 
 for(var i=0; i<this._handlers.length; i++){ 
	if(this._handlers[i].id==id){
// 		top.getFetcher().sendDebugTrap("Ci sono1: "+this._handlers[i].name);
		this._handlers.splice(i, 1);
 		return true;
 	}
 } 
 return false;
 };

 OvaEventManager.prototype._nextHandlerId=function(){
 	return "eventHandler" + (++this._idSequence);
 };

 OvaEventManager.prototype.handleKeyEvent=function(ovaEvent){
 if(!this._keysEnabled)
 	return true;
 this.resetInactivityTimer();
 /* Esempio di ovaEvent --> "eventKeyInfo" definito in OvaKeyMap.js */
 if(this._handleActivity(ovaEvent)){ 
	return true;
 }
 /* Inizialmente non entra nei vari if, ma esegue quello di seguito */
 return this.handleEvent(ovaEvent);
 };

 OvaEventManager.prototype.handleVideoEvent=function(ovaEvent){ return this.handleEvent(ovaEvent);
 };

/* Esempio chiamata da OvaDataFetcher
   handleEvent("eventDataFetchStart", fetchRequestObject.url, fetchRequestObject.callerObj); */
  OvaEventManager.prototype.handleEvent=function(ovaEvent){ 

 	/*argsToArr --> permette di creare un array composto dagli argomenti passati */
	var args=this.fw.getUtil().argsToArr(arguments);
 	
	/* The shift() method is used to remove and return the first element of an array*/
	args.shift();
 	var numberKey="";
	/* Verifico che si tratti di tasto schiacciato ... */
	/* nel caso EventKeyEye non dovrebbe entrare ma va oltre ed esegue la funzione eventKeyEye definita come
	   funzione */
 	if(((ovaEvent.length == 9) && (ovaEvent.indexOf("eventKey") == 0)) || (ovaEvent == "eventKeyDot")|| (ovaEvent == "eventKeySpace")){
 		numberKey=ovaEvent.substring(8)-0;
 		if(!isNaN(numberKey)){
			ovaEvent = "eventKeyNumeric";
 			args.unshift(numberKey);
 		} else if (ovaEvent == "eventKeyDot"){
				numberKey=".";
 				ovaEvent = "eventKeyChar";
 				args.unshift(numberKey);
 			} else if (ovaEvent == "eventKeySpace"){ 
					numberKey=" ";
					ovaEvent = "eventKeyChar";
 					args.unshift(numberKey);
 				} else { 
					numberKey=ovaEvent.substring(8);
 					ovaEvent = "eventKeyChar";
 					args.unshift(numberKey);
 				} if(this._handleActivity(ovaEvent)){ 
					return true;
 				} 
	} 
 	var allArgs=args.slice(0);
 	allArgs.unshift(ovaEvent);
	/* In fase di default avevamo inizializzato quello di default --> OvaEventManager */
 	for(var i=0; i < this._handlers.length; i++){
 		/* per ogni handler_entry contenuto in _handlers[i] prelevo l'handler e ne ricavo il nome */
		var obj=this._handlers[i];
		/* la func dipende dal chiamante, può non esistere, come nel caso del percorso iniziale di bootstrap dove 
		   si cerca un handlername pari a "eventDataFetchStart", quindi func risulta null */
		/* OCCHIO: in BaseApp sono definite le funzioni tipo eventDataFetchStart che vengono effettivamente chiamata
		   Con "OvaEventManager" non ci sono funzioni definite, mentre in "app" si
		   Quando faccio la fetchNow entra in OvaDataFetcher e lancia la handle event, se siamo nel caso 
		   _handlet[i]="app" si vede che esiste una funzione definita */
 		/* Quando la handler è app e si lancia come name eventDataFetchStart viene salvato in BaseApp.js, in
		   _urlFetchArray i vari fetcherObject (sia l'url che la callback) però con lo eventDataFetchStart 
		   non avviene la chiamata al callback. Questo avverrà con la chiamata a eventFetchCompleted 
		   all'interno del file html. A questo punto dentro eventFetchCompleted ci sarà una chiamata ad
		   handleEvent con name eventDataFetchComplete */
		/* Le funzioni che gestisce con handleEvent son viste grazie al fatto che sono include quando 
		   carico il file JS, per esempio in StartupApp, all'inizio, c'è la dichiarazione di BaseApp.js */
		/* La registrazione di "app" infatti la faccio in OvaAppManager.js */
		var func=obj.handler[ovaEvent];
 		var handlerName=obj.name;
// 		top.getFetcher().sendDebugTrap("Ci sono: "+obj.name+" -- OvaEvent: "+ovaEvent+" func: "+func);
		/* esegue anche la eventKeyEye sull'immagine iniziale, arriva da OvaKeyMap, in questo
		   caso l'handler è definito in StartupApp.js sotto eventKeyEye */
 		if(func&&func.apply(obj.handler, args)){ 
		 	//top.getFetcher().sendDebugTrap("-- Apply --");
			return true;
 		}
		/* Accade nel caso in cui siamo in quello di default iniziale, ritornerà false */
		if(obj.handler==this) continue;
 		func = obj.handler["handleEvent"];
 		if(func&&func.apply(obj.handler, allArgs)){ 
			return true;
 		}
 	}
  	return false;
 };
 
 OvaEventManager.prototype.handleError=function(ovaErrorCode){
 var app=this.fw.getAppManager().getCurrentApp();
 if(app&&app.handleError){
	/* è riferito all'applicazione corrente, per esempio in BaseApp.js è definito
	   prorotype.handleError */
 	if(app.handleError(ovaErrorCode)){
 		return true;
 	}
 } if(this._handleError(ovaErrorCode)){ 
	return true;
 }  return false;
 };

 OvaEventManager.prototype.disableNav=function(){
 	this._keysEnabled=false;
 };

 OvaEventManager.prototype.enableNav=function(){
 	this._keysEnabled=true;
 };

 OvaEventManager.prototype._handleError=function(errorCode){ 
 var errors=this.fw.createErrors();
 errors.setData({});
 var errorObj=errors.getError(errorCode);
 var dlg=this.fw.createDialog();
 dlg.setTitle(errorObj.number);
 dlg.setContent(errorObj.message);
 dlg.start();
 return true;
 };

 OvaEventManager.prototype.eventDialogStart=function(dlg){
 var dlgui = this.fw.createDialogUI("dialogLayout");
 dlgui.setDialog(dlg);
 dlgui.redraw();
 return true;
 };

 OvaEventManager.prototype.eventDialogDismiss=function(dlg){ this.fw.getLayoutManager().lastLayout();
 return true;
 };
 OvaEventManager.prototype.resetInactivityTimer=function(){ if(this._inactivityTimeout > 0) { if(this._inactivityTimer!=null){ this.fw.getTimer().clearTimeout(this._inactivityTimer);
 } this._inactivityTimer=this.fw.getTimer().setTimeout( this._inactivityTimeout, this._handleInactivity, this );
 } };
 OvaEventManager.prototype._handleInactivity=function(){ this.resetInactivityTimer();
 this._userInactive=true;
 this.handleEvent("eventUserInactive");
 return true;
 };

 OvaEventManager.prototype._handleActivity=function(ovaEvent){
 	if(this._userInactive) {
		this._userInactive=false;
  		eventUserActiveFlag=this.handleEvent("eventUserActive", ovaEvent);
  		return this.handleEvent(ovaEvent);
 	} return false;
 };

 OvaEventManager.prototype.setInactivityTimeout=function(timeout){ this._inactivityTimeout=timeout;
 this.resetInactivityTimer();
 return true;
 };
 OvaEventManager.prototype.getInactivityTimeout=function(){ return this._inactivityTimeout;
 };
 
