function
OvaForm (){ }

OvaForm.prototype.TYPE_BUTTON = 'button';
OvaForm.prototype.TYPE_SUBMIT = 'submit';
OvaForm.prototype.TYPE_CHECKBOX = 'checkbox';
OvaForm.prototype.TYPE_PASSWORD = 'password';
OvaForm.prototype.TYPE_RADIO = 'radio';
OvaForm.prototype.TYPE_SELECT_MULTIPLE = 'select-multiple';
OvaForm.prototype.TYPE_SELECT_ONE = 'select-one';
OvaForm.prototype.TYPE_TEXT = 'text';
OvaForm.prototype.TYPE_HIDDEN = 'hidden';
OvaForm.prototype.TYPE_TEXTAREA = 'textarea';
OvaForm.prototype.TYPE_IMAGE = 'image';

OvaForm.prototype.create = function (formName)
{
  this._fields =[];
  this._fieldsByName =
  {
  };
  this._handler = null;
  this._name = formName;
};

OvaForm.prototype.getName = function ()
{
  return this._name;
};

OvaForm.prototype.setName = function (val)
{
  this._name = val;
  ;
};

OvaForm.prototype.addField = function (newField)
{
  this._fields.push (newField);
  this._fieldsByName[newField.name] = newField;
};

OvaForm.prototype.getFieldByName = function (fieldName)
{
  return this._fieldsByName[fieldName];
};

OvaForm.prototype.getField = function (i)
{
  return this._fields[i];
};

OvaForm.prototype.getLength = function ()
{
  return this._fields.length;
};

OvaForm.prototype.setHandler = function (val)
{
  this._handler = val;
};

OvaForm.prototype.getHandler = function ()
{
  return this._handler;
};

OvaForm.prototype.submit = function ()
{
  if (this._handler != null)
    this._handler.eventFormSubmit (this);
};

OvaForm.prototype.enterField = function (field)
{
  if (this._handler != null && this._handler.eventFormEnterField != null)
    return this._handler.eventFormEnterField (this, field);
};

OvaForm.prototype.exitField = function (field, oldValue)
{
  if (this._handler != null && this._handler.eventFormExitField != null)
    return this._handler.eventFormExitField (this, field, oldValue);
};

OvaForm.prototype.selectField = function (field, oldValue)
{
  if (this._handler != null && this._handler.eventFormSelectField != null)
    return this._handler.eventFormSelectField (this, field, oldValue);
};
