 function OvaNotifications(){ } 

 OvaNotifications.prototype.create=function(){
 this._display=new Array();
 this._FavTimeouts={};
 this._PpvTimeouts={};
 this._NvodTimeouts={};
 this._displayMode=false;
 this._notificationUI=null;
 this._bootResources=this.fw.createResourceStrings();
 /* Di default PROGRAM_NOTIFICATION_TITLE_MAXLENGTH vale 60 */
 this._titleMaxLength=this.fw.getConfig().PROGRAM_NOTIFICATION_TITLE_MAXLENGTH;
 };

 OvaNotifications.prototype.setProgramNotification=function(schdRecid, type){ var slot=this.fw.getBTVTuner().getEPG().findSlotByScheduleId(schdRecid);
 if(!slot||!slot.program||slot.program.isEmpty )return;
 var now=this.fw.getOSD().getTime();
 var offset=this.fw.getConfig().PROGRAM_NOTIFICATION_OFFSET;
 var sDate=slot.program.startdate;
 var interval=sDate-now-offset;
 if(interval > 0){ switch(type){ case "FAV" : this._FavTimeouts[schdRecid]=( this.fw.getTimer().setTimeout(interval, this._doProgramNotification, this, slot));
 break;
 case "PPV" : this._PpvTimeouts[schdRecid]=( this.fw.getTimer().setTimeout(interval, this._doProgramNotification, this, slot));
 break;
 case "NVOD" : this._NvodTimeouts[schdRecid]=( this.fw.getTimer().setTimeout(interval, this._doProgramNotification, this, slot));
 break;
 } } };
 OvaNotifications.prototype.setProgramNotifications=function(schdRecids, type){ if(schdRecids!=null){ this.clearAllProgramNotifications(type);
 for(recid in schdRecids){ this.setProgramNotification(recid, type);
 } } };
  OvaNotifications.prototype.setNotificationsByProgramIds=function(programIds, type){ if(programIds!=null){ this.clearAllProgramNotifications(type);
 for(recid in programIds){ var slot=this.fw.getBTVTuner().getEPG().findSlotByProgramId( recid, type );
 this.setNotificationOfCurrentProgram(slot, type);
 } } };

OvaNotifications.prototype.setNotificationsByScheduleIds=function(schdIds, type){ 
 if(schdIds!=null){
 	this.clearAllProgramNotifications(type);
 	var slots=this.fw.getBTVTuner().getEPG().findSlotByScheduleIds( schdIds, type );
 	for(i=0; i<slots.length; i++){
		this.setNotificationOfCurrentProgram(slots[i], type);
 	}
}
};

  OvaNotifications.prototype.setNotificationOfCurrentProgram=function(slot, type){ if( slot ){ if( slot.program!=null ){ var now=this.fw.getOSD().getTime();
 var offset=this.fw.getConfig().PROGRAM_NOTIFICATION_OFFSET;
 var sDate=slot.program.startdate;
 var interval=sDate-now-offset;
 if(interval > 0){ switch(type){ case "PPV" : this._PpvTimeouts[slot.program.schdid]=( this.fw.getTimer().setTimeout(interval, this._doProgramNotification, this, slot));
 break;
 case "NVOD" : this._NvodTimeouts[slot.program.schdid]=( this.fw.getTimer().setTimeout(interval, this._doProgramNotification, this, slot));
 break;
 } } } } };
 OvaNotifications.prototype._doProgramNotification=function(slot){ this.fw.getDebug().logInfo("Queuing program notification display, schdRecid=" + slot.program.schdid);
 this._display.unshift(slot);
 if(this._displayMode==false)this._displayNextNotification();
 };
 OvaNotifications.prototype.dismissNotification=function(){ if(this._displayMode==true){ this.hideNotificationDialog();
 if(this._display.length > 0){ this._displayNextNotification();
 } else { this._displayMode=false;
 this.fw.getEventManager().unregisterEventHandler(this._eventHandlerId);
 } } };
 OvaNotifications.prototype.handleEvent=function(ovaEvent, args){ if(this._displayMode==true){ this.dismissNotification();
 } return false;
 };
 OvaNotifications.prototype._displayNextNotification=function(){ this._displayMode=true;
 this._eventHandlerId = this.fw.getEventManager().registerEventHandler(this, "OvaNotifications");
 var slot=this._display.pop();
 var notif=this.fw.createNotification();
 notif.setHeading(this._bootResources.getLabel("OVA/COMMON/NOTIFICATION","ALERT_HEADING"));
 var fitTitle=this.fw.getUtil().truncateString(slot.program.title+'-'+slot.channel.callLetters, this._titleMaxLength, true);
 notif.setContent(fitTitle);
 notif.setMessage(this._bootResources.getLabel("OVA/COMMON/NOTIFICATION","ALERT_MESSAGE"));
 this.showNotificationDialog(notif);
 };
 OvaNotifications.prototype.clearProgramNotification=function(schdRecid, type){ switch (type){ case "FAV" : var to=this._FavTimeouts[schdRecid];
 if(!to)return;
 this.fw.getTimer().clearTimeout(to);
 this._FavTimeouts[schdRecid]=null;
 break;
 case "PPV" : var to=this._PpvTimeouts[schdRecid];
 if(!to)return;
 this.fw.getTimer().clearTimeout(to);
 this._PpvTimeouts[schdRecid]=null;
 break;
 case "NVOD" : var to=this._NvodTimeouts[schdRecid];
 if(!to)return;
 this.fw.getTimer().clearTimeout(to);
 this._NvodTimeouts[schdRecid]=null;
 break;
 } };
 OvaNotifications.prototype.clearAllProgramNotifications=function(type){ switch (type){ case "FAV" : for(var i in this._FavTimeouts){ var to=this._FavTimeouts[i];
 if(!to)continue;
 this.fw.getTimer().clearTimeout(to);
 this._FavTimeouts[i]=null;
 } this._FavTimeouts={};
 break;
 case "PPV" : for(var i in this._PpvTimeouts){ var to=this._PpvTimeouts[i];
 if(!to)continue;
 this.fw.getTimer().clearTimeout(to);
 this._PpvTimeouts[i]=null;
 } this._PpvTimeouts={};
 break;
 case "NVOD" : for(var i in this._NvodTimeouts){ var to=this._NvodTimeouts[i];
 if(!to)continue;
 this.fw.getTimer().clearTimeout(to);
 this._NvodTimeouts[i]=null;
 } this._NvodTimeouts={};
 break;
 } };
 OvaNotifications.prototype.showNotificationDialog=function(notif){ if(!this._notificationUI) this._notificationUI = this.fw.createNotificationUI("notificationLayout");
 this._notificationUI.setVisible(true);
 this._notificationUI.setNotification(notif);
 this._notificationUI.redraw();
 };
 OvaNotifications.prototype.hideNotificationDialog=function(){ if(!this._notificationUI) this._notificationUI = this.fw.createNotificationUI("notificationLayout");
 this._notificationUI.setNotification(null);
 this._notificationUI.setVisible(false);
 this._notificationUI.redraw();
 };
 OvaNotifications.prototype.isNotificationDialogVisible=function(){ if(!this._notificationUI) this._notificationUI = this.fw.createNotificationUI("notificationLayout");
 return this._notificationUI.getVisible();
 };
 
