function OvaTimer(){
}

OvaTimer.prototype.create = function(){
    this._funcs = {};
    this._funcObjs = {};
    this._funcArgs = {};
    this._idToTimeoutId = {};
    this._numOfTimers = 0;
    this._idSequence = 0;
};

OvaTimer.prototype.setTimeout = function(interval, func, funcObj){
    if (interval <= 0) 
        throw new Error('OvaTimer.setTimeout() Negative interval: ' + interval);
    var id = this._createId();
    this._funcs[id] = func;
    this._funcObjs[id] = funcObj;
    if (arguments.length > 3) {
        var args = [];
        for (var i = 3; i < arguments.length; i++) 
            args.push(arguments[i]);
        this._funcArgs[id] = args;
    }
    else {
        this._funcArgs[id] = null;
    }
    this._idToTimeoutId[id] = setTimeout('getFramework().getTimer()._trigger(' + id + ');', interval);
    this._numOfTimers++;
    return id;
};
OvaTimer.prototype.clearTimeout = function(id){
    var timeoutId = this._idToTimeoutId[id];
    if (timeoutId) {
        clearTimeout(timeoutId);
        delete (this._funcs[id]);
        delete (this._funcObjs[id]);
        delete (this._funcArgs[id]);
        delete (this._idToTimeoutId[id]);
        this._numOfTimers--;
    }
};
OvaTimer.prototype._trigger = function(id){
    var func = this._funcs[id];
    var funcObj = this._funcObjs[id];
    var funcArgs = this._funcArgs[id];
    this.clearTimeout(id);
    if (func == null) 
        return;
    if (funcArgs == null) {
        func.apply(funcObj);
    }
    else {
        func.apply(funcObj, funcArgs);
    }
};
OvaTimer.prototype._createId = function(){
    this._idSequence++;
    return this._idSequence;
};
OvaTimer.prototype.clearAllTimers = function(){
    for (id in this._idToTimeoutId) {
        this.clearTimeout(id);
    }
};
