var CSS_include = '<link rel="stylesheet" type="text/css" href="/ovaUI/pirelli_dtt/OvaPirelli.css">';
function OvaBaseUI(){
}

OvaBaseUI.prototype.create = function(layoutId){
    this._create(layoutId);
};

OvaBaseUI.prototype._create = function(layoutId){
    this._layoutId = layoutId;
    this._hotkeys = new Array();
    this._textLabels = {};
    this._htmlLabels = {};
    this._textImages = {};
    this._showChangeUser = true;
    this._hotkeyImages = ["/ovaImages/NavOption1Red.gif", "/ovaImages/NavOption2Green.gif", "/ovaImages/NavOption3Yellow.gif", "/ovaImages/NavOption3Yellow.gif", ];
};

OvaBaseUI.prototype.setLayout = function(layoutId){
    this._layoutId = layoutId;
};
OvaBaseUI.prototype.setElementUI = function(elementUI){
    this._elementUI = elementUI;
};
OvaBaseUI.prototype.getElementUI = function(){
    return this._elementUI;
};
OvaBaseUI.prototype._getHotKeyByNumber = function(num){
    return this._hotkeys[num - 1];
};
OvaBaseUI.prototype._initHotKeys = function(num){
    for (var i = 0; i < num; i++) {
        var hotkey = new Object();
        hotkey.visible = false;
        hotkey.label = "";
        hotkey.labelVisible = false;
        hotkey.image = null;
        this._hotkeys[i] = hotkey;
    }
};
OvaBaseUI.prototype.setHotKeys = function(hotkeys){
    this._hotkeys = hotkeys;
};
OvaBaseUI.prototype.getHotKeys = function(clone){
    if (clone == true) {
        var hotkeys = new Array();
        for (var i = 0; i < this._hotkeys.length; i++) {
            hotkeys[i] = new Object();
            hotkeys[i].label = this._hotkeys[i].label;
            hotkeys[i].visible = this._hotkeys[i].visible;
            hotkeys[i].labelVisible = this._hotkeys[i].labelVisible;
            hotkeys[i].image = this._hotkeys[i].image;
            hotkeys[i].imageWidth = this._hotkeys[i].imageWidth;
            hotkeys[i].imageHeight = this._hotkeys[i].imageHeight;
        }
        return hotkeys;
    }
    return this._hotkeys;
};
OvaBaseUI.prototype.setHotKeyVisible = function(num, val){
    this._getHotKeyByNumber(num).visible = val;
};
OvaBaseUI.prototype.setHotKeyLabel = function(num, val){
    this._getHotKeyByNumber(num).label = val;
    this._getHotKeyByNumber(num).image = null;
    this._getHotKeyByNumber(num).imageWidth = null;
    this._getHotKeyByNumber(num).imageHeight = null;
};
OvaBaseUI.prototype.setHotKeyLabelAsImage = function(num, val, w, h){
    this._getHotKeyByNumber(num).image = val;
    this._getHotKeyByNumber(num).imageWidth = w;
    this._getHotKeyByNumber(num).imageHeight = h;
    this._getHotKeyByNumber(num).label = null;
};
OvaBaseUI.prototype.setHotKeyLabelVisible = function(num, val){
    this._getHotKeyByNumber(num).labelVisible = val;
};
OvaBaseUI.prototype._redrawHotKeys = function(){
    var layoutManager = this.fw.getLayoutManager();
    var hotkey_label, hotkey_image;
    for (var i = 0; i < this._hotkeys.length; i++) {
        var hotkey = this._hotkeys[i];
        hotkey_label = "hotkey".concat((i + 1), "Label");
        hotkey_image = "hotkey".concat((i + 1), "Image");
        if (hotkey) {
            if (hotkey.image) {
                layoutManager.writeBlock(this._layoutId, hotkey_label, hotkey.image, "image", {
                    width: hotkey.imageWidth,
                    height: hotkey.imageHeight
                });
            }
            else 
                if (hotkey.label) {
                    layoutManager.writeBlock(this._layoutId, hotkey_label, '<div><div class="hotkeyLabel"><font color="#FFFFFF">' + hotkey.label + '</font></div></div>', "text");
                }
            layoutManager.setElementVisible(this._layoutId, hotkey_image, hotkey.visible);
            layoutManager.setElementVisible(this._layoutId, hotkey_label, hotkey.labelVisible);
        }
        else {
            layoutManager.writeBlock(this._layoutId, hotkey_label, "", "text");
            layoutManager.setElementVisible(this._layoutId, hotkey_image, false);
            layoutManager.setElementVisible(this._layoutId, hotkey_label, false);
        }
        layoutManager.writeBlock(this._layoutId, hotkey_image, this._hotkeyImages[i], "image");
    }
};
OvaBaseUI.prototype.setPinDialog = function(obj){
    this._pinDialog = obj;
};
OvaBaseUI.prototype.setChangeUser = function(obj){
    this._changeUser = obj;
};
OvaBaseUI.prototype.setChangeUserMode = function(val){
    this._changeUserMode = val;
};
OvaBaseUI.prototype.getChangeUserMode = function(){
    return this._changeUserMode == true;
};
OvaBaseUI.prototype.setPinDialogMode = function(val){
    this._pinDialogMode = val;
};
OvaBaseUI.prototype.getPinDialogMode = function(){
    return this._pinDialogMode == true;
};
/* Chiamata da OvaSimpleFormUI in redraw "ova:label", null, this._getLabel, this */
OvaBaseUI.prototype._redrawByTagName = function(tagName, model, func, funcObj, leadin, leadout){
    if (!funcObj) 
        funcObj = this._elementUI;
    var layoutManager = this.fw.getLayoutManager();
	/* this._layoutId = homeTvLayout */
    var tags = layoutManager.getElements(this._layoutId);
//     top.getFetcher().sendDebugTrap("element: "+this._layoutId);
    var element, data, write_data;
    var layout = layoutManager.getLayout(this._layoutId);
    for (id in tags) {
        element = tags[id];
	/* scorro su tutti gli elementi presenti nel frame e sotto-frame */
// 	top.getFetcher().sendDebugTrap("element: "+element.name);
	/* in particolare la chiamata la effettuavamo con tagName=ova:label, quindi ricerchiamo proprio
	   questo elemento */
        if (tags[id].ovaType == tagName) {
            data = func.apply(funcObj, [model, element.name]);
            if (data) {
                write_data = !element.hidden && (!element.block || element.block != data.content);
                if (data.content != null) {
                    element.block = data.content;
                    element.type = "html";
                    element.params = null;
                }
                if (write_data) {
                    var new_data;
                    var start_css = "";
                    var end_css = "";
                    var CSS_include = element.cssinclude;
                    if (CSS_include != null) {
                        CSS_include = '<link rel="stylesheet" type="text/css" href="'.concat(CSS_include, '">');
                    }
                    else {
                        CSS_include = '<link rel="stylesheet" type="text/css" href="/ovaUI/amino/OvaAmino.css">';
                    }
                    if (element.innerstyle != null && element.innerstyle != "") {
                        start_css = '<span><TABLE border="0" cellpadding="0" cellspacing="0" class="'.concat(element.innerstyle, '"><tr><td>');
                        end_css = '</td></tr></TABLE></span>';
                    }
                    new_data = "literal:<base href='".concat(layoutManager.hostname, "'>", CSS_include, start_css, data.content, end_css);
                    layout.window.replaceFrameContents(new_data, element.name);
                }
            }
        }
    }
};

OvaBaseUI.prototype._makeStyleString = function(styles, content){
    var styleStr = "";
    for (var istyle = 0; istyle < styles.length; istyle++) 
        styleStr = styleStr.concat('<div class="', styles[istyle], '">');
    styleStr += content;
    for (var istyle = 0; istyle < styles.length; istyle++) 
        styleStr += '</div>';
    return styleStr;
};

OvaBaseUI.prototype._extractInputsByName = function(form){
    var layoutManager = this.fw.getLayoutManager();
    var inputsByName = this.fw.getUtil().arrayToAssocArray(layoutManager.getInputElementsByTagName(form), "name");
    return inputsByName;
};

OvaBaseUI.prototype._extractInputs = function(form){
    var layoutManager = this.fw.getLayoutManager();
    var inputs = layoutManager.getInputElementsByTagName(form);
    return inputs;
};
/* chiamata da OvaSimpleFormUI con this._form (OvaForm), win (homeTvLayout.html) */
OvaBaseUI.prototype._bindForm = function(formData, targetWindow){
    var formName = formData.getName();
    /* formName, vale "helpForm". Lo avevamo impostato in fase di inizializzazione */
//     top.getFetcher().sendDebugTrap("Ci sono: "+formName);
    /* cerca formName nel file html e nei suoi iframe e frame */
    /* dentro findForm stampa la ricerca su console */
    var inputForm = this._findForm(formName, targetWindow);
    if (inputForm == null) 
        throw new Error('OvaBaseUI._bindForm() no form found with name: ' + formName);
    var inputsByName = this._extractInputsByName(inputForm);
    inputForm.__data = formData;
    inputForm.__ui = this;
    inputForm.__inputsByName = inputsByName;
    var n = formData.getLength();
    /* n sarà 1 nel caso homeTvApp */
    for (var i = 0; i < n; i++) {
// 	top.getFetcher().sendDebugTrap("Ci sono: "+n);
	/* In ovaForm "helpForm" dovrebbe esssere presente solo un campo definito:
	   { name: 'hidd', type: this._form.TYPE_HIDDEN } */
        var field = formData.getField(i);
        var input = inputsByName[field.name];
        if (input == null) 
            continue;
        var inputName = input.name;
        if (field.type != input.type) {
            throw new Error('OvaBaseUI._bindForm() input "' + inputName + '" type of "' + input.type + '" does not match field type of "' + field.type + '"');
        }
        input.onfocus = this.__formInputOnFocus;
        input.onblur = this.__formInputOnBlur;
        switch (field.type) {
            case formData.TYPE_SUBMIT:
            case formData.TYPE_BUTTON:
            case formData.TYPE_IMAGE:
                input.__clicked = false;
                input.onclick = function(){
                    this.__clicked = true;
                };
                break;
            case formData.TYPE_CHECKBOX:
                if (field.value) {
                    input.checked = true;
                }
                else {
                    input.checked = false;
                }
                break;
            case formData.TYPE_RADIO:
                var foundChecked = false;
                for (var k = 0; k < inputForm.elements.length; k++) {
                    if (inputForm.elements[k].name == input.name) {
                        if (field.value == inputForm.elements[k].value) {
                            inputForm.elements[k].checked = true;
                            foundChecked = true;
                        }
                    }
                }
                if (!foundChecked) {
                    throw new Error('OvaBaseUI._bindForm() selected radio value of "' + field.value + '" not found: ' + inputName);
                }
                break;
            case formData.TYPE_SELECT_MULTIPLE:
                input.options.length = 0;
                for (var j = 0; j < field.opts.length; j++) {
                    var fieldOptionValue = field.opts[j].value;
                    var fieldOptionText = field.opts[j].text;
                    var fieldOptionSelected = field.value[fieldOptionValue];
                    if (fieldOptionSelected == null) {
                        fieldOptionSelected = false;
                    }
                    input.options[input.options.length] = new Option(fieldOptionText, fieldOptionValue, false, fieldOptionSelected);
                }
                input.onchange = this.__formInputOnChange;
                break;
            case formData.TYPE_SELECT_ONE:
                input.options.length = 0;
                for (var j = 0; j < field.opts.length; j++) {
                    var fieldOptionValue = field.opts[j].value;
                    var fieldOptionText = field.opts[j].text;
                    var fieldOptionSelected = field.value[fieldOptionValue];
                    var fieldOptionReadOnly = field.readOnly;
                    if (fieldOptionSelected == null) {
                        fieldOptionSelected = false;
                    }
                    var opt = new Option(fieldOptionText, fieldOptionValue, false, fieldOptionSelected);
                    opt.disabled = fieldOptionReadOnly ? true : false;
                    input.options[input.options.length] = opt;
                }
                input.onchange = this.__formInputOnChange;
                break;
            case formData.TYPE_PASSWORD:
            case formData.TYPE_HIDDEN:
            case formData.TYPE_TEXT:
            case formData.TYPE_TEXTAREA:
                input.value = field.value;
                input.readOnly = (field.readOnly == true);
                break;
        }
    }
    inputForm.onsubmit = this.__formOnSubmit;
};

OvaBaseUI.prototype._unbindForm = function(formData, targetWindow){
    if (formData == null) 
        return;
    var formName = formData.getName();
    var layoutManager = this.fw.getLayoutManager();
    var inputForm = this._findForm(formName, layoutManager.getLayout(this._layoutId));
    if (inputForm == null) {
        return;
    }
    inputForm.__data = null;
    inputForm.__ui = null;
    var elts = inputForm.__inputsByName;
    var input;
    for (var inputName in elts) {
        input = elts[inputName];
        switch (input.type) {
            case formData.TYPE_SUBMIT:
            case formData.TYPE_BUTTON:
            case formData.TYPE_IMAGE:
                input.__clicked = null;
                break;
            case formData.TYPE_PASSWORD:
            case formData.TYPE_HIDDEN:
            case formData.TYPE_TEXT:
            case formData.TYPE_TEXTAREA:
                input.readOnly = false;
                break;
            case formData.TYPE_SELECT_MULTIPLE:
            case formData.TYPE_SELECT_ONE:
                input.onchange = null;
                input.disabled = false;
                break;
        }
    }
    inputForm.__inputsByName = null;
};
OvaBaseUI.prototype._getInputValue = function(input){
    if (input.form == null) 
        throw new Error('OvaBaseUI._getInputValue() input "' + input.name + '" has no form');
    if (input.form.__data == null) 
        throw new Error('OvaBaseUI._getInputValue() input "' + input.name + '" has no form data');
    var formData = input.form.__data;
    switch (input.type) {
        case formData.TYPE_SUBMIT:
        case formData.TYPE_BUTTON:
        case formData.TYPE_IMAGE:
            return input.__clicked;
            break;
        case formData.TYPE_CHECKBOX:
            return input.checked;
            break;
        case formData.TYPE_RADIO:
            var elts = input.form.elements;
            var elt;
            for (var i = 0; i < elts.length; i++) {
                elt = elts[i];
                if (elt.name == input.name && elt.type == formData.TYPE_RADIO && elt.checked) {
                    return elt.value;
                }
            }
            return null;
            break;
        case formData.TYPE_SELECT_MULTIPLE:
            var picked = {};
            for (var j = 0; j < input.options.length; j++) {
                if (input.options[j].selected) {
                    picked[input.options[j].innerHTML] = input.options[j].value;
                }
            }
            return picked;
            break;
        case formData.TYPE_SELECT_ONE:
            var picked = {};
            for (var j = 0; j < input.options.length; j++) {
                if (input.options[j].selected) {
                    picked[input.options[j].innerHTML] = input.options[j].value;
                    break;
                }
            }
            return picked;
            break;
        case formData.TYPE_PASSWORD:
        case formData.TYPE_HIDDEN:
        case formData.TYPE_TEXT:
        case formData.TYPE_TEXTAREA:
            return input.value;
            break;
    }
};

OvaBaseUI.prototype._findForm = function(formName, targetWindow){
    this.fw.LoggerApp.debugLog("formName="+formName+" window="+targetWindow.document.name);
    var fs = targetWindow.document.forms;
    var f;
    for (var i = 0; i < fs.length; i++) {
        f = fs[i];
        if (f.name == formName) 
            return f;
    }
    for (i = 0; i < targetWindow.frames.length; i++) {
        f = this._findForm(formName, targetWindow.frames[i]);
        if (f != null) {
            return f;
        }
    }
    return null;
};

OvaBaseUI.prototype._findInput = function(formName, inputName, targetWindow){
    var f = this._findForm(formName, targetWindow);
    if (f == null) 
        return null;
    if (f.__inputsByName != null) {
        return f.__inputsByName[inputName];
    }
    var elts = this._extractInputs(f);
    var elt;
    for (var j = 0; j < elts.length; j++) {
        elt = elts[j];
        if (elt.name == inputName) 
            return elt;
    }
    return null;
};
OvaBaseUI.prototype._setLockedField = function(formName, fieldName){
    this._lockedFormName = formName;
    this._lockedFieldName = fieldName;
};
OvaBaseUI.prototype._focusOnLockedField = function(){
    if (this._lockedFormName == null || this._lockedFieldName == null) 
        return;
    var layoutManager = this.fw.getLayoutManager();
    var win = layoutManager.getLayout(this._layoutId);
    var input = this._findInput(this._lockedFormName, this._lockedFieldName, win);
    if (input == null) {
        throw new Error('OvaBaseUI._focusOnLockedField() input ' + this._lockedFormName + '.' + this._lockedFieldName + ' not found');
    }
    layoutManager.focusOn(this._layoutId, this._lockedFieldName);
};
OvaBaseUI.prototype._checkLockedField = function(formName, fieldName){
    if (this._lockedFormName == null || this._lockedFieldName == null) 
        return true;
    return (this._lockedFormName == formName && this._lockedFieldName == fieldName);
};

OvaBaseUI.prototype._hasLockedField = function(formName, fieldName){
    return (this._lockedFormName != null && this._lockedFieldName != null);
};

OvaBaseUI.prototype.__formInputOnFocus = function(){
    if (this.form == null || this.form.__data == null) 
        return;
    if (this.form.__ui == null) 
        return;
    if (this.__formInputOnFocus) 
        return;
    this.__inFormInputOnFocus = true;
    var formData = this.form.__data;
    var ui = this.form.__ui;
    var formName = this.form.name;
    var fieldName = this.name;
    if (!ui._checkLockedField(formName, fieldName)) {
        ui._focusOnLockedField();
        this.__inFormInputOnFocus = false;
        return;
    }
    var field = formData.getFieldByName(fieldName);
    field.value = ui._getInputValue(this);
    formData.enterField(field);
    this.__inFormInputOnFocus = false;
};
OvaBaseUI.prototype.__formInputOnBlur = function(){
    var fw = getFramework();
    if (this.form == null || this.form.__data == null) 
        return;
    if (this.form.__ui == null) 
        return;
    var formData = this.form.__data;
    var ui = this.form.__ui;
    var fieldName = this.name;
    var formName = this.form.name;
    if (!ui._checkLockedField(formName, fieldName)) {
        return;
    }
    var field = formData.getFieldByName(fieldName);
    var oldValue = field.value;
    field.value = ui._getInputValue(this);
    formData.exitField(field, oldValue);
};
OvaBaseUI.prototype.__formInputOnChange = function(){
    if (this.form == null || this.form.__data == null) 
        return;
    if (this.form.__ui == null) 
        return;
    var formData = this.form.__data;
    var ui = this.form.__ui;
    var fieldName = this.name;
    var formName = this.form.name;
    var field = formData.getFieldByName(fieldName);
    var oldValue = field.value;
    field.value = ui._getInputValue(this);
    formData.selectField(field, oldValue);
};

OvaBaseUI.prototype.__formOnSubmit = function(){
    if (this.__data == null) 
        return;
    var formData = this.__data;
    var ui = this.__ui;
    ui._populateForm(formData, this);
    formData.submit();
    ui._clearFormButtonState(formData, this);
    return false;
};

OvaBaseUI.prototype._populateForm = function(formData, form){
    var inputs = form.__inputsByName;
    if (inputs != null) {
        for (var inputName in inputs) {
            var input = inputs[inputName];
            var field = formData.getFieldByName(inputName);
            if (field == null) 
                continue;
            field.value = this._getInputValue(input);
        }
    }
};
OvaBaseUI.prototype._clearFormButtonState = function(formData, form){
    var inputs = form.__inputsByName;
    for (var inputName in inputs) {
        var input = inputs[inputName];
        if (input.__clicked == true) 
            input.__clicked = false;
    }
};
OvaBaseUI.prototype.setResources = function(resources, appDomain){
    this._resources = resources;
    this._appDomain = appDomain;
};
OvaBaseUI.prototype.setErrors = function(appErrors){
    this._appErrors = appErrors;
};
OvaBaseUI.prototype.setLabelHtml = function(labelId, html){
    this._htmlLabels[labelId] = html;
    this._textImages[labelId] = null;
    this._textLabels[labelId] = null;
};
OvaBaseUI.prototype.setLabelText = function(labelId, text){
    this._textLabels[labelId] = text;
    this._textImages[labelId] = null;
    this._htmlLabels[labelId] = null;
};
OvaBaseUI.prototype.setLabelImage = function(labelId, img){
    this._textImages[labelId] = img;
    this._textLabels[labelId] = null;
    this._htmlLabels[labelId] = null;
};

OvaBaseUI.prototype._getLabel = function(carousel, tagId){
    if (this._textLabels != null) {
        if (this._textLabels[tagId] != null) 
            return ({
                content: this._textLabels[tagId],
                type: "text",
                styles: null
            });
    }
    if (this._htmlLabels != null) {
        if (this._htmlLabels[tagId] != null) 
            return ({
                content: this._htmlLabels[tagId],
                type: "html",
                styles: null
            });
    }
    if (this._textImages != null) {
        if (this._textImages[tagId] != null) {
            return ({
                content: this._textImages[tagId],
                type: "image",
                styles: null
            });
        }
    }
    if (tagId.indexOf(".") == 0) 
        tagId = this._appDomain + (tagId.substring(1));
    if (this._resources == null) {
        this.fw.getDebug().logWarning('OvaBaseUI._getLabel() No resoureces, return empty string');
        return '';
    }
    var i = tagId.lastIndexOf("/");
    var domainName = tagId.substring(0, i);
    var labelName = tagId.substring(i + 1);
    var label = this._resources.getLabel(domainName, labelName);
    return ({
        content: label,
        type: "text",
        styles: null
    });
};

OvaBaseUI.prototype._getError = function(carousel, tagId){
    if (this._appErrors == null) {
        this.fw.getDebug().logWarning('OvaBaseUI._getError() No app errors, return empty string');
        return '';
    }
    var e = this._appErrors.getError(tagId);
    return ({
        content: e.message,
        type: "text",
        styles: null
    });
};
OvaBaseUI.prototype.setStatusBar = function(val){
    this._statusBarVisible = val;
};
OvaBaseUI.prototype._drawStatusBar = function(){
    var statusBarUI = this.fw.getStatusBarUI();
    statusBarUI.setVisible(this._statusBarVisible);
    statusBarUI.redraw();
};
OvaBaseUI.prototype._drawPinForm = function(pinForm){
    var layoutManager = this.fw.getLayoutManager();
    layoutManager.setLayoutVisible(this._layoutId + "Z3", true);
    layoutManager.getLayout(this._layoutId + "Z3").scroll(0, 0);
    this._pinForm.getFieldByName("pinInput").value = "";
    this._bindForm(this._pinForm, layoutManager.getLayout(this._layoutId + "Z3"));
    layoutManager.focusOn(this._layoutId + "Z3", "pinInput");
};
OvaBaseUI.prototype._drawPinDialog = function(pd){
    var layoutManager = this.fw.getLayoutManager();
    layoutManager.setLayout(this._layoutId);
    if (pd.getMode() != pd.MODE_INACTIVE) {
        this.setHotKeyLabel(1, this._resources.getLabel("OVA/COMMON/PIN", "accept"));
        this.setHotKeyLabel(2, this._resources.getLabel("OVA/COMMON/PIN", "cancel"));
        this.setHotKeyVisible(1, true);
        this.setHotKeyLabelVisible(1, true);
        this.setHotKeyVisible(2, true);
        this.setHotKeyLabelVisible(2, true);
        this.setHotKeyVisible(3, false);
        this.setHotKeyLabelVisible(3, false);
        this._drawPinForm(pd.getPinForm());
        if (pd.getMode() == pd.MODE_ERROR) {
            layoutManager.setElementVisible(this._layoutId + "Z3", "OVA-510", true);
            layoutManager.focusOn(this._layoutId + "Z3", "pinInput");
        }
        else {
            layoutManager.setElementVisible(this._layoutId + "Z3", "OVA-510", false);
        }
    }
};
OvaBaseUI.prototype.setPinForm = function(pinForm){
    if (this._pinForm != null) {
        var layoutManager = this.fw.getLayoutManager();
        this._unbindForm(this._pinForm, layoutManager.getLayout(this._layoutId + "Z3"));
        layoutManager.getLayout(this._layoutId).focus();
    }
    this._pinForm = pinForm;
};
OvaBaseUI.prototype.getPinForm = function(){
    return this._pinForm;
};
OvaBaseUI.prototype.populatePinForm = function(){
    if (this._pinForm == null) 
        return;
    var layoutManager = this.fw.getLayoutManager();
    var win = layoutManager.getLayout(this._layoutId + "Z3");
    var form = this._findForm(this._pinForm.getName(), win);
    this._populateForm(this._pinForm, form);
};
OvaBaseUI.prototype.setShowChangeUser = function(val){
    this._showChangeUser = val;
};
OvaBaseUI.prototype.getShowChangeUser = function(){
    return this._showChangeUser;
};
OvaBaseUI.prototype._drawChangeUser = function(){
    var layoutManager = this.fw.getLayoutManager();
    layoutManager.setLayout(this._layoutId);
    var cu = this.fw.getChangeUser();
    if (cu.getMode() == cu.MODE_INACTIVE) {
        if (this._showChangeUser) {
            this.setHotKeyVisible(1, true);
            this.setHotKeyLabelVisible(1, true);
            this.setHotKeyLabelAsImage(1, "/ovaImages/NavChangeUser.gif");
        }
    }
    else 
        if (cu.getMode() == cu.MODE_SELECT) {
            var usr = cu.getUser();
            var usrname = !usr ? "" : usr.username;
            layoutManager.writeBlock(this._layoutId, "R3", usrname, "text");
            this.setHotKeyVisible(1, true);
            this.setHotKeyLabelVisible(1, true);
            this.setHotKeyLabel(1, this._resources.getLabel("OVA/COMMON/CHANGEUSER", "nextUser"));
            this.setHotKeyVisible(2, true);
            this.setHotKeyLabelVisible(2, true);
            this.setHotKeyLabel(2, this._resources.getLabel("OVA/COMMON/CHANGEUSER", "cancel"));
            this.setHotKeyVisible(3, true);
            this.setHotKeyLabelVisible(3, true);
            this.setHotKeyLabel(3, this._resources.getLabel("OVA/COMMON/CHANGEUSER", "familyUser"));
        }
        else 
            if (cu.getMode() == cu.MODE_NO_USERS) {
                layoutManager.writeBlock(this._layoutId, "R3", this._resources.getLabel("OVA/COMMON/CHANGEUSER", "noUsers"), "text");
                this.setHotKeyVisible(1, false);
                this.setHotKeyLabelVisible(1, false);
                this.setHotKeyVisible(2, true);
                this.setHotKeyLabelVisible(2, true);
                this.setHotKeyLabel(2, this._resources.getLabel("OVA/COMMON/CHANGEUSER", "cancel"));
                this.setHotKeyVisible(3, true);
                this.setHotKeyLabelVisible(3, true);
                this.setHotKeyLabel(3, this._resources.getLabel("OVA/COMMON/CHANGEUSER", "familyUser"));
            }
            else 
                if ((cu.getMode() == cu.MODE_PIN) || (cu.getMode() == cu.MODE_ERROR)) {
                    this.setHotKeyLabel(1, this._resources.getLabel("OVA/COMMON/PIN", "accept"));
                    this.setHotKeyLabel(2, this._resources.getLabel("OVA/COMMON/PIN", "cancel"));
                    this.setHotKeyVisible(3, false);
                    this.setHotKeyLabelVisible(3, false);
                    if (cu.getMode() == cu.MODE_ERROR) {
                        layoutManager.setElementVisible(this._layoutId + "Z3", "slotSelectedPinError", true);
                        layoutManager.focusOn(this._layoutId, "pinInput");
                    }
                    else {
                        layoutManager.setElementVisible(this._layoutId + "Z3", "slotSelectedPinError", false);
                    }
                }
};
OvaBaseUI.prototype.setIgnoreCursorKeys = function(blnIgnore){
};
