OvaDRM.prototype.INVALIDCAPACKET = 0x01;
OvaDRM.prototype.CARDNOTAUTHORIZED = 0x02;
OvaDRM.prototype.BLACKOUTACITVE = 0x01;
OvaDRM.prototype.CARDNOTPAIRED = 0x10;
OvaDRM.prototype.SERVICENOTAUTHORISED = 0x20;
OvaDRM.prototype.DRMTYPE_UNICAST = "unicast";
OvaDRM.prototype.DRMTYPE_MULTICAST = "multicast";
OvaDRM.prototype._NULL_ECM_CHANNEL = "";
OvaDRM.prototype.STATUS_CARD_REMOVED = 0;
OvaDRM.prototype.STATUS_CARD_READY = 1;
OvaDRM.prototype.STATUS_CARD_FAILED = 2;
OvaDRM.prototype.STATUS_CARD_INVALID = 3;
OvaDRM.prototype.STATUS_CARD_CLOSED = 4;
OvaDRM.prototype.STATUS_CARD_TRANSITION = 5;
OvaDRM.prototype.STATUS_CARD_INSERTED = 6;
function OvaDRM(){
}

_onCARD_STATUS = function(CardStatus, CardType){
    getFramework().getDRM()._onCARD_STATUS.apply(getFramework().getDRM(), [CardStatus, CardType]);
};

OvaDRM.prototype.create = function(){
    this._isPC = this.fw.getOSD().isPC();
    this._serviceId = 1;
    this._eCMPort = null;
    this._eMMSocket = null;
    this._eMMValue = null;
    this._pECMValue = null;
    this.DRM_ENABLED = this.fw.getConfig().ENABLE_DRM;
    this._NULL_ECM_CHANNEL = this.fw.getConfig().CASID_HEX_NULL_ECM_CHANNEL;
    this._NULL_ECM_CHANNEL = this._NULL_ECM_CHANNEL + "-0.0.0.0-0000";
    if (!this._isPC && this.DRM_ENABLED) {
        try {
            var evobj = new Object();
            evobj.onCARD_STATUS = _onCARD_STATUS;
            omc.event.setEventObject(evobj);
        } 
        catch (e) {
            this.fw.getEventManager().handleEvent("eventDRMInitFailed", e);
        }
    }
};

OvaDRM.prototype.init = function(){
    var DRMType = this.fw.getConfig().DRM_TYPE;
    var usr = this.fw.getUserInfo();
    switch (DRMType) {
        case this.DRMTYPE_UNICAST:
            this._processEMM(usr.getInventoryAuthInfo());
            usr.clearInventoryAuthInfo();
            break;
        case this.DRMTYPE_MULTICAST:
            this._setEMMSocket(usr.getAccountauthInfo());
            usr.clearAccountAuthInfo();
            break;
    }
};
OvaDRM.prototype._refresh = function(usr){
    var authRefreshDate = usr.getAuthRefreshDate();
    var lastDate = usr.getAuthLastUpdate();
    if (authRefreshDate == null || authRefreshDate < lastDate) {
        return true;
    }
    else {
        return false;
    }
};
OvaDRM.prototype._onCARD_STATUS = function(CardStatus, CardType){
    switch (CardStatus) {
        case this.STATUS_CARD_REMOVED:
            this._handleError('DRM-0001');
            break;
        case this.STATUS_CARD_READY:
            break;
        case this.STATUS_CARD_FAILED:
            this._handleError('DRM-0002');
            break;
        case this.STATUS_CARD_INVALID:
            this._handleError('DRM-0003');
            break;
        case this.STATUS_CARD_CLOSED:
            this._handleError('DRM-0004');
            break;
        case this.STATUS_CARD_TRANSITION:
            this._handleError('DRM-0004');
            break;
        case this.STATUS_CARD_INSERTED:
            break;
        default:
            this._handleError('DRM-0011');
            break;
    }
};
OvaDRM.prototype.onCARD_CONFIG = function(CardID, CASID, CAAPIVersion){
};
OvaDRM.prototype.onUSER_LIMIT = function(user_id){
};
OvaDRM.prototype._onCA_MODULE_CONFIG = function(CardID, CASID, CAAPIVersion){
};
OvaDRM.prototype._onUSER_PARAMETER_UPDATE = function(event_handle_value, user_id){
};
OvaDRM.prototype._onCA_EVENT_STATUS = function(ServiceIdentifier, CWStatus, VP1, VP2, VP3, VP4){
    if (CWStatus == 1) {
    }
    else {
        if (VP1 != 0) {
            switch (VP1) {
                case this.INVALIDCAPACKET:
                    this._handleError('DRM-0009');
                    break;
                case this.CARDNOTAUTHORIZED:
                    this._handleError('DRM-0007');
                    break;
                default:
                    this._handleError('DRM-0012');
                    break;
            }
        }
        if (VP2 != 0) {
            switch (VP2) {
                case this.BLACKOUTACITVE:
                    this._handleError('DRM-0008');
                    break;
                case this.CARDNOTPAIRED:
                    this._handleError('DRM-0010');
                    break;
                default:
                    this._handleError('DRM-0012');
                    break;
            }
        }
        if (VP3 != 0) {
            switch (VP3) {
                case (SERVICENOTAUTHORISED):
                    this._handleError('DRM-0006');
                    break;
                default:
                    this._handleError('DRM-0012');
                    break;
            }
        }
    }
};
OvaDRM.prototype._onSEND_EMM_ACK = function(EMMAckStr){
};
OvaDRM.prototype._onPECM_PROCESSING = function(status){
};
OvaDRM.prototype._onSEND_CW_STATUS = function(service_identifier, cw_status){
};
OvaDRM.prototype._Authenticate = function(conce, usrnm, rspe){
    try {
        var outobj1 = new Object();
        var outobj2 = new Object();
        usrnm.value = outobj1.value;
        rspe.value = outobj2.value;
    } 
    catch (e) {
    }
};
OvaDRM.prototype._loadVideo = function(asset){
    if (asset.protocol == 'rtsp' || asset.protocol == 'vsi') {
        this._processPECM(asset.pecmList);
        this.fw.getVideoControl()._loadVideo();
    }
    else {
        this._unloadChannel();
        this.fw.getVideoControl()._loadVideo();
        this._channelChange(asset.ecmPort);
    }
};
OvaDRM.prototype._unloadChannel = function(){
    this._channelChange(this._NULL_ECM_CHANNEL);
};
OvaDRM.prototype._channelChange = function(eCMPort){
    if (!this._isPC) {
        this._serviceId++;
        this._eCMPort = eCMPort;
    }
};
OvaDRM.prototype._setEMMSocket = function(eMMSocket){
    if (!this._isPC && eMMSocket) {
        this._eMMSocket = eMMSocket;
        omc.ca.nds.setEMMSocket(this._eMMSocket);
    }
};
OvaDRM.prototype._processEMM = function(emm_value){
    if (!this._isPC && emm_value) {
        this._serviceId++;
        this._eMMValue = emm_value;
        omc.ca.nds.processEMM(this._serviceId, this._eMMValue);
    }
};
OvaDRM.prototype._processPECM = function(pecm_value){
    if (!this._isPC && pecm_value) {
        this._serviceId++;
        this._pECMValue = pecm_value;
        omc.ca.nds.processPECM(this._serviceId, this._pECMValue);
    }
};
OvaDRM.prototype._handleError = function(msg){
    if (!this._isPC) {
    	omc.logger.addEntry("######## REBOOT ## 10 ## : "+msg);
        //omc.stb.reboot();
    }
};
