OvaGameControl.prototype.STATE_STOPPED = 0;
OvaGameControl.prototype.STATE_PLAYING = 1;
function OvaGameControl (){ }

OvaGameControl.prototype.create = function ()
{
};

OvaGameControl.prototype._handleStreamEvent = function (videoEvent)
{
  if (!videoEvent.status)
    {
      var consumed =
	this.fw.getEventManager ().handleVideoEvent ("eventStreamLost");
      if (consumed)
	return true;
    }
  else
    {
      var consumed =
	this.fw.getEventManager ().handleVideoEvent ("eventStreamAcquired");
      if (consumed)
	return true;
    }
};

OvaGameControl.prototype._handleVideoEvent = function (videoEvent)
{
  switch (videoEvent.reason)
    {
    case appContext.videoPlayer.POS_AT_END:
      break;
    case appContext.videoPlayer.POS_AT_START:
      break;
    case appContext.videoPlayer.ERR_COULD_NOT_CONNECT:
      this.fw.getDebug ().logError ("video: couldn't connect");
      return this.fw.getEventManager ().handleError ("OVA-999");
    case appContext.videoPlayer.ERR_NOT_FOUND:
      this.fw.getDebug ().logError ("video: not found");
      return this.fw.getEventManager ().handleError ("OVA-999");
    case appContext.videoPlayer.ERR_NO_DATA:
      this.fw.getDebug ().logError ("video: no data");
      return this.fw.getEventManager ().handleError ("OVA-999");
    case appContext.videoPlayer.ERR_NETWORK_ERROR:
      this.fw.getDebug ().logError ("video: network error");
      return this.fw.getEventManager ().handleError ("OVA-999");
    default:
      return true;
    };
};

OvaGameControl.prototype.getURL = function ()
{
  return this._gameURL;
};

OvaGameControl.prototype.load = function (hostname, port)
{
  if (!hostname)
    {
      return false;
    }
  this._hostname = hostname;
  this._port = port;
  if (this._videoStatus != 0)
    {
      this.unload ();
    }
  this._gameURL = this._constructURL (hostname, port);
  this._loadGame ();
  return 0;
};

OvaGameControl.prototype._loadGame = function ()
{
  if (!this._isPC)
    {
      appContext.videoPlayer.start (this._gameURL);
      this._videoWindow.setFullScreenVideo ();
      this._videoWindow.setVideoVisibility (this._videoWindow.VIDEO_VISIBLE);
    }
  this._gameStatus = this.STATE_PLAYING;
};

OvaGameControl.prototype._constructURL = function (hostname, port)
{
  return "gclust://" + hostname + ":" + port;
};

OvaGameControl.prototype.unload = function ()
{
  if (!this._gameURL)
    {
      return;
    }
  if (!this._isPC)
    {
      this._videoWindow.setVideoVisibility (this._videoWindow.
					    VIDEO_INVISIBLE);
      appContext.videoPlayer.stop ();
    }
};

OvaGameControl.prototype.getState = function ()
{
  return this._gameStatus;
};
