OvaSimpleFormUI.prototype=new OvaBaseUI();
 function OvaSimpleFormUI(){ } 

 OvaSimpleFormUI.prototype.create=function(layoutId){
 this._create(layoutId);
 this._layoutId=layoutId;
 this._form=null;
 this._message='';
 this._firstRedraw=true;
 this._inputPos=-1;
 this._focusFieldName=null;
 };

 OvaSimpleFormUI.prototype.getSelectedItem=function(optionArray, choice){
 if((optionArray.length<=0)|| (choice==null) ){
	 return;
 }
 var selectedItems={};
 var key, value;
 for(var i=0; i < optionArray.length; i++){
 	key=optionArray[i];
 	value=optionArray[i]==choice ? true:false;
 	selectedItems[key]=value;
 }
 return selectedItems;
 };

 OvaSimpleFormUI.prototype._getInputForm=function(){
 	if(this._form==null)
		 return null;
 	var win=this.fw.getLayoutManager().getLayout(this._layoutId);
 	return this._findForm(this._form.getName(), win);
 };

 OvaSimpleFormUI.prototype._moveInput=function(offset){
 var form=this._getInputForm();
 if(form==null)
 	return;
 var eltNum=form.elements.length;
 if(eltNum==0)
	 return;
 this._inputPos=this._inputPos+offset;
 this._inputPos=this._inputPos % eltNum;
 if(this._inputPos < 0)
 	this._inputPos=this._inputPos+eltNum;
 	this.fw.getLayoutManager().focusOn(this._layoutId, form.elements[this._inputPos].name);
 };

 OvaSimpleFormUI.prototype.setFocusFieldName=function(val){
 	this._focusFieldName=val;
 };

 OvaSimpleFormUI.prototype.getFocusFieldName=function(){
 	return this._focusFieldName;
 };

 OvaSimpleFormUI.prototype.prevInput=function(){
	 this._moveInput(-1);
 };

 OvaSimpleFormUI.prototype.nextInput=function(){
	 this._moveInput(1);
 };

 OvaSimpleFormUI.prototype._focusOnInput=function(){
 var form=this._getInputForm();
 if(form==null)
	 return;
 if(this._focusFieldName){
	 var formData=form.__data;
 var formField=formData.getFieldByName(this._focusFieldName);
 if(formField==null)
	 return;
 var selectedId=null;
 if(formField.type==formData.TYPE_RADIO){
 	var opts=formField.opts;
 	var fieldValue=formField.value;
 for(var optId in opts){
 	var opt=opts[optId]; 
	if(opt.value==fieldValue){ 
		selectedId=optId;
 		break;
 	}
 }
 if(selectedId==null)
	 return;
 var elts=form.elements;
 for(var i=0; i < elts.length; i++){
 	if(elts[i].id==selectedId){
		this._inputPos=i;
 		break;
 	}
 }
 } else {
	var fieldName=formField.name;
 	var elts=form.elements;
 	for(var i=0; i < elts.length; i++){
 		if(elts[i].name==fieldName){
 			this._inputPos=i;
 			selectedId=elts[i].id;
 			break;
 		}
	}
 }
 this.fw.getLayoutManager().focusOn( this._layoutId, selectedId);
 } else {
 	this.fw.getLayoutManager().focusOn( this._layoutId, form.elements[this._inputPos].name);
 }
 };
 
 OvaSimpleFormUI.prototype.setForm=function(val){
 this._form=val;
 this._inputPos=0;
 };

 OvaSimpleFormUI.prototype.getForm=function(){
 return this._form;
 };
 
 OvaSimpleFormUI.prototype.populateForm=function(){
 if(this._form==null)
 	return;
 var layoutManager=this.fw.getLayoutManager();
 var win=layoutManager.getLayout(this._layoutId);
 var form=this._findForm(this._form.getName(), win);
 this._populateForm(this._form, form);
 };

 OvaSimpleFormUI.prototype.setElementUI=function(val){
 	this._elementUI=val;
 };

 OvaSimpleFormUI.prototype.getElementUI=function(){
 	return this._elementUI;
 };

 OvaSimpleFormUI.prototype.setMessage=function(val){
 	this._message=val;
 };

 OvaSimpleFormUI.prototype.getMessage=function(){
 	return this._message;
 };

 OvaSimpleFormUI.prototype.setMessageColor=function(val){
 	this._messageColor=val;
 };

 OvaSimpleFormUI.prototype.getMessageColor=function(){
 	return this._messageColor;
 };

 OvaSimpleFormUI.prototype.redraw=function(){ 
/* COMMENTO PER CAPIRE A CHE SERVONO QUESTE DUE RIGHE IN QUESTO METODO BY FG
var vc=this.fw.getVideoControl();
vc.fullScreen();
*/		
	 if(this.fw.OMC_LOGGER_ENABLED) omc.logger.addEntry("OvaSimpleFormUI.redraw");
 var layoutManager=this.fw.getLayoutManager();
 /* _layoutId vale "homeTvLayout" */
 /* se commento questa riga, non parte il portale */
 layoutManager.setLayout(this._layoutId);
//  top.getFetcher().sendDebugTrap("Ci sono: ");
 /* non entra */
 if(this._statusBarVisible!=null){
	//top.getFetcher().sendDebugTrap("Ci sono: ");
 	this._drawStatusBar();
 }
 this._redrawByTagName("ova:label", null, this._getLabel, this);
 if(this._error){
// 	top.getFetcher().sendDebugTrap("Ci sono: ");
 	var data=this.getErrorElement(this._error);
 	var content=data.content;
 	var err = "<span style='color:red; '>" + content + "</span>";
 	layoutManager.writeBlock(this._layoutId, "message", err, "html");
 } else if (this._message!=null&&this._message!=''){
// 	top.getFetcher().sendDebugTrap("Ci sono2: ");
 	var msgColor=(this._messageColor==null ? 'black':this._messageColor);
 	var msg = "<span style='color:" + msgColor + ";'>" + this._message + "</span>";
 	layoutManager.writeBlock(this._layoutId, "message", msg, 'html');
 } else {/* entra qui */
// 	top.getFetcher().sendDebugTrap("Ci sono3: ");
	layoutManager.writeBlock(this._layoutId, "message", '', 'html');
 }
 /* _layoutId vale "homeTvLayout" */
 /* win sarà homeTvLayout.html */
 var win=layoutManager.getLayout(this._layoutId);
 /* _form è stato settato in fase inizializzazione .create ed è riferito a OvaForm.js */
 /* Questa è definita in OvaBaseUI.js */
 this._bindForm(this._form, win);
 if(this._hasLockedField()){
// 	top.getFetcher().sendDebugTrap("Ci sono3: ");
 	this._focusOnLockedField();
 } else {/* entro qui */
 	this._focusOnInput();
 }
 // this._drawVideo();
  };
 
  OvaSimpleFormUI.prototype._drawVideo=function(){ 
  var vc=this.fw.getVideoControl();
  vc.background(0x00FF00, 0xF0F0F0);
 };
 
 
 OvaSimpleFormUI.prototype.setLockedField=function(formName, fieldName){
 	this._setLockedField(formName, fieldName);
 };

 OvaSimpleFormUI.prototype.fin=function(){ 
 this._setLockedField(null, null);
 var layoutManager=this.fw.getLayoutManager();
 var win=layoutManager.getLayout(this._layoutId);
 this._unbindForm(this._form, win);
 this._layoutId=null;
 this._form=null;
 this._message='';
 };

 OvaSimpleFormUI.prototype.setError=function(error){
 this._error=error;
 };

 OvaSimpleFormUI.prototype.getErrorElement=function(errorObj){
 return ({ content: errorObj.number+':'+errorObj.message, type: "text", styles: [ "error" ] });
 };

 OvaSimpleFormUI.prototype.stopVideo = function() {
	var vc = this.fw.getVideoControl();
	vc.setPlayRate(vc.MODE_STOP);
	this.fw.getBTVTuner().setActive(false);
};

OvaSimpleFormUI.prototype.hideVideo = function() {
	var vc = this.fw.getVideoControl();
	//vc.videoOff();
	vc.setWindow(0, 720, 1, 1);
	
	
	//TELSEY//
	//vc.setWindow(0, 0, 0, 0);
};

OvaSimpleFormUI.prototype.drawVideoWindow = function() 
{

 // this.isPreviewInFullScreen = false;
  var vc = this.fw.getVideoControl();
  vc.setWindow(476,98, 145, 112,true);
  //vc.setWindow(475, 518, 160, 120,true);

};

  