#!/bin/sh

#############################
#                           #
#      courtesy message     #
#                           #
#############################

. /etc/stb.env

if [ -e /usr/share/sendtrap/sendtrap.functions ] ; then
	. /usr/share/sendtrap/sendtrap.functions
	SEND_UPG_TRAP=send_upgrade_trap
else
	SEND_UPG_TRAP=/bin/echo
fi


# check for new software
MSG_CHECKNEWIMAGE="0"
# aggiornamento disponibile
MSG_NEWIMAGE="1"
# Nessun aggiornamento disponibile
MSG_NONEWIMAGE="2"
# download in corso
MSG_DOWNLOAD="3"
# blink square image
DOWNLOAD_BLINK="0"

#
# Message Type
#
if [ "$1" != "" ];
then
    message="$1"
else
    message="empty"
fi

#
# downloaded packets number
#
if [ "$2" != "" ];
then
    packets="$2"
else
    packets="empty"
fi


case "$message" in
  #"$MSG_CHECKNEWIMAGE" )
  # Nothing to do
  # ;;
 "$MSG_NEWIMAGE" )
    # If we came from standby, start a daemon that will display a courtesy screen,
    # if the user presses the standby key.
    if [ "$START_IN_STANDBY_MODE" -eq "1" ] ; then
        /bin/keypress -t 0 -k KEY_PIRELLISTB_RC_POWER -l KEY_POWER -s /etc/init.d/upgrade-courtesy &
    else
        /bin/zcat /opt/splashes/aggiornamentodisponibile.pcx.gz > /tmp/image.pcx 2>/dev/null
        /usr/bin/tfbu -f /tmp/image.pcx -x 35 -y 105 2>&1 >/dev/null
        /bin/rm /tmp/image.pcx 2>&1 >/dev/null
        /bin/touch /tmp/upgrade-is-available
    fi
 ;;
 
 "$MSG_DOWNLOAD" )
  if [ "$START_IN_STANDBY_MODE" -ne "1"  -a ! -e /tmp/mclient.wait_drawing ] ; then
    if [ -e /tmp/mclient.blink ];
    then
        /usr/bin/tfbu -x 430 -y 350 -h 25 -w 20 -C FFCC00 2>&1 >/dev/null
        /bin/rm -rf /tmp/mclient.blink
    else
        /usr/bin/tfbu -x 430 -y 350 -h 25 -w 20 -C 0 2>&1 >/dev/null
        /bin/echo "blink" > /tmp/mclient.blink
    fi
  fi
  if [ ! -e /tmp/mclient.first100 ] ; then
    # Send only once the "upgrade in progress" trap
    /bin/touch /tmp/mclient.first100
    /bin/echo "Received first 100 packets"
    $SEND_UPG_TRAP step_in_progress
  fi
  ;;
esac
