/*******************************************************************************
 * ***************************************************************************
 * 
 * 
 * APPLICATION: BaseApp.js OWNER: Salemme Luciano DESCRIPTION: Questa
 * applicazione viene ereditata da tutte le altre presenti sulla piattaforma.
 * FEATURES: 20.07 sono state inserite delle funzionalit� per inserire
 * direttamente le immagini negli iframes della applicazione corrente 20.11
 * aggiunta funzionalit� di gestione degli errori centralizzata tutte le
 * applicazioni chiamano l'handleError della BaseApp
 ******************************************************************************/

// var FirstTime = 0;
BaseApp.prototype._currentSessionLocaleCode = "en_US";

// Array utilizzati per la gestione degli errori centralizzata.
BaseApp.prototype._urlFetchArray = new Array();
BaseApp.prototype.matriceFetcher = new Array();

function BaseApp() {
	this.changePage = ""; // azzero il numerino da gestire per il popup di
							// cambio pagina
	this.num_cifre = 0; // azzero contatore cifre per il popup di cambio pagina
	this._indiceTimer = null;
	this.velocita_ripetizione = 3000; // prime 2 cifre
	this.velocita_ripetizione_finale = 1500; // ultima cifra
	this.chiudi_digitazione_err = 2500; // ultima cifra
	this._isStreamLost = true;
	this.errors;
	this.newOvaVer = "0.0";
	this.currOvaVer = "0.0";
	this.newFwVer = "0.0.0";
	this.currFwVer = "0.0.0";
	this.altStandBy = true;
	
	this.timerINFOSEPG = null;
	this.attivatoListaPreferiti= false;

}

// metodo che richiama l'API navigator.DeleteMarkedImages() per ripulire la
// memoria dalle immagini
BaseApp.prototype.DeleteMarkedImages = function() {
	if ((this.fw.getAppManager().SelectPlatform()).toLowerCase() == 'pirelli_dtt'
			&& this.fw.currentFwVersion == "1.5.12") {
		try {
			navigator.DeleteMarkedImages();
		} catch (e) {
			this.fw.LoggerApp
					.debugLog("API-NOT-PRESENT:navigator.DeleteMarkedImages()");
		}
	}
	return true;
};

BaseApp.prototype.trimAll = function(sString) {
	while (sString.substring(0, 1) == ' ') {
		sString = sString.substring(1, sString.length);
	}
	while (sString.substring(sString.length - 1, sString.length) == ' ') {
		sString = sString.substring(0, sString.length - 1);
	}
	return sString;
};

BaseApp.prototype.isDTTEnabled = function() {
	try {
		if (this.fw.getOSD().isPC()) {
			return false;
		} else {
			var checkVersion = false;
			try {
				checkVersion = this.isDTTFWVersion(navigator.Get_sw_version());
			} catch (ecc) {
				checkVersion = true;
			}

			return (checkVersion == true
					&& this.fw.getConfig().DTT_ENABLED == 'true'
					&& (this.fw.getAppManager().SelectPlatform()).toLowerCase() == 'pirelli_dtt' && this.fw.UserEnableDTT == 'Y');
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'isDTTEnabled';
		this._objErrorInfo._obException = ecc;
		return false;
	}
};

BaseApp.prototype.keyLock = function(lockEvent) {
	if (!this.fw.lockArray) {
		this.fw.lockArray = new Array();
	}
	this.fw.lockArray[lockEvent] = true;
};

BaseApp.prototype.keyUnlock = function(lockEvent) {
	if (!this.fw.lockArray) {
		this.fw.lockArray = new Array();
	}
	this.fw.lockArray[lockEvent] = false;
};

BaseApp.prototype.isKeyLocked = function(lockEvent) {
	if (!this.fw.lockArray) {
		return false;
	} else if (!this.fw.lockArray[lockEvent]) {
		return false;
	} else {
		return this.fw.lockArray[lockEvent];
	}
};

BaseApp.prototype.clearLockArray = function() {
	this.fw.lockArray = new Array();
};

BaseApp.prototype.isDTTFWVersion = function(version) {
	var toRet = false;
	try {

		var actualVersion = (this.fw.getConfig().FIRMWARE_VERSION_DTT == null) ? "1.5.0"
				: this.fw.getConfig().FIRMWARE_VERSION_DTT;
		var newVersion = version;

		var actualVersionSplitted = actualVersion.split(".");

		var newVersionSplitted = newVersion.split(".");

		if (newVersionSplitted[0] > actualVersionSplitted[0]) {
			toRet = true;
		} else if (newVersionSplitted[0] == actualVersionSplitted[0]) {
			if (newVersionSplitted[1] > actualVersionSplitted[1]) {
				toRet = true;
			} else if (newVersionSplitted[1] == actualVersionSplitted[1]) {
				if (newVersionSplitted[2] >= actualVersionSplitted[2]) {
					toRet = true;
				}

			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'isDTTFWVersion';
		this._objErrorInfo._obException = ecc;
		return true;
	}
	return toRet;
};

BaseApp.prototype.eventKeyUp = function() {
	try {
		var ret = false;
		if (this._ui.prevInput) {
			this._ui.prevInput();
			ret = true;
		}
		ret = false;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'eventKeyUp';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return ret;
	}
};

BaseApp.prototype.eventKeyDown = function() {
	try {
		var ret = false;
		if (this._ui.nextInput) {
			this._ui.nextInput();
			ret = true;
		}
		ret = false;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'eventKeyDown';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return ret;
	}
};

BaseApp.prototype.eventKeyLeft = function() {
	try {
		var ret = false;
		if (this._ui.prevInput) {
			this._ui.prevInput();
			ret = true;
		}
		ret = false;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'eventKeyLeft';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return ret;
	}
};

BaseApp.prototype.eventKeyRight = function() {
	try {
		var ret = false;
		if (this._ui.nextInput) {
			this._ui.nextInput();
			ret = true;
		}
		ret = false;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'eventKeyRight';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return ret;
	}
};

BaseApp.prototype.eventKeyWeb = function() {
	return true;
};

BaseApp.prototype.eventChangeUserStart = function() {
	try {
		this._ui.setChangeUserMode(true);
		this._oldHotKeys = this._ui.getHotKeys(true);
		var pinForm = this.fw.createForm("pinForm");
		pinForm.addField( {
			name :'pinInput',
			type :pinForm.TYPE_PASSWORD,
			value :''
		});
		this.fw.getChangeUser().setPinForm(pinForm);
		this._ui.redraw();
	} catch (ecc) {
		return true;
	} finally {
		return true;
	}
};

BaseApp.prototype.eventChangeUserInvalidPIN = function(usr, pin) {
	this._ui.redraw();
	return true;
};

BaseApp.prototype.eventChangeUserFocusUser = function(usr) {
	this._ui.redraw();
	return true;
};

BaseApp.prototype.eventPinDialogAccept = function() {
	try {
		this._ui.populatePinForm();
		this.fw.getPinDialog().getPinForm().submit();
	} catch (ecc) {
		return true;
	} finally {
		return true;
	}
};

BaseApp.prototype.eventPinDialogValidPIN = function() {
	try {
		return (this.eventValidPin) ? this.eventValidPin() : true;
	} catch (ecc) {
		return true;
	} finally {
		return true;
	}
};

BaseApp.prototype.eventPinDialogInvalidPIN = function() {
	try {
		return (this.eventInvalidPin) ? this.eventInvalidPin() : true;
	} catch (ecc) {
		return true;
	} finally {
		return true;
	}
};

/*******************************************************************************
 * FUNCTION: eventStreamLost PARAMETER: Nessuno DESCRIPTION: Questo evento viene
 * generato dal framework quando si verifica una perdita del flusso video. Nel
 * metodo bisogna inviare una trap di StramLost specificando se ci troviamo nel
 * caso di BTV, PPV o VOD
 ******************************************************************************/
BaseApp.prototype.eventStreamLost = function() {
	try {
		// Trap di STREAM_LOST disabilitate per Multicast e PPV
		this._isStreamLost = true;
	} catch (ecc) {
		return true;
	} finally {
		return true;
	}
};

BaseApp.prototype.getProgramSlot3 = function(chanRecid) {
	try {
		time = this.fw.getOSD().getTime();
		epg = this.fw.getBTVTuner().getEPG();
		// var idx=epg.findSlotIndexByTime(chanRecid,timei);
		var idx = epg.findSlotIndexByTime(chanRecid, time);
		var schd = epg.getChannelSchedule(chanRecid);
		
		if (schd != null && 0 <= idx && idx < schd.length) {
			
			return schd[idx];
		} else
			return null;
	} catch (e) {
		this._objErrorInfo._methodName = 'getProgramSlot3';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

/*******************************************************************************
 * FUNCTION: eventVideoInitFailed PARAMETER: reason DESCRIPTION: Questo evento
 * viene generato dal framework quando fallisce l'inizializzazione di un video
 ******************************************************************************/
BaseApp.prototype.eventVideoInitFailed = function(reason) {
	try {
		this.fw.Video = false;
		if (this.fw.getBTVTuner().getActive()
				&& this.fw.getBTVTuner().getCurrentChannel()) { // se il vc �
																// attivo allota
																// l'evento si �
																// verificato
																// per un BTV
			var canale = this.fw.getBTVTuner().getCurrentChannel().recid;
			var slot = this.getProgramSlot3(canale);
			if (slot != null && slot.program.type != null
					&& slot.program.type == "PPV") {
				this.fw.LoggerApp.ppvStreamErrorLog('STREAM_INIT_FAILED');
			} else {
				this.fw.LoggerApp.multicastStreamErrorLog('STREAM_INIT_FAILED');
			}
		}
	} catch (ecc) {
		return true;
	} finally {
		return true;
	}
};

BaseApp.prototype.writeOnPopUp = function(popUpHandle, _frameHandle, imgSrc,
		imgId) {
	try {

		imgSrc = this.advForceUrl(imgSrc);

		this.fw.getLayoutManager().getLayout(popUpHandle).window.document.images[imgId].src = imgSrc;
		if (_frameHandle)
			this.fw.getLayoutManager().getLayout(_frameHandle).window.focus();
	} catch (ecc) {
		this.fw.LoggerApp.debugLog("writeOnPopUp: popUpHandle: " + popUpHandle
				+ " _frameHandle: " + _frameHandle);
	} finally {
		return true;
	}
};

/*******************************************************************************
 * FUNCTION: eventVideoUnavailable PARAMETER: reason DESCRIPTION: Questo evento
 * viene generato dal framework nel caso di video non disponibile, viene
 * richiamato eventStreamLost()
 ******************************************************************************/
BaseApp.prototype.eventVideoUnavailable = function(reason) {
	try {
		var tuner = this.fw.getBTVTuner().getDefaultHandler();
		if (reason == tuner.AC_PROGRAM_NOT_SUBSCRIBED
				|| reason == tuner.AC_NOT_RATED_FOR_PROGRAM
				|| reason == tuner.AC_NOT_RATED_FOR_CHANNEL) { // Caso
																// not_subscribed
																// o rating
			// riprendo le informazioni sul currentProgram e su isVisible in
			// modo da averle aggiornate
			this._epg = this.fw.getBTVTuner().getEPG();
			var epgSlot = this._epg.getSelected();
			if (epgSlot && epgSlot.program) {
				this.currentProgram = epgSlot.program;
				// localZappingId=this.fw.zappingArray[this.fw._currIndexForZapping].ZappingId;
				// localChanIndex=this.fw.inverseZappingArray[localZappingId];
				localZapperId = this.fw.zapper[this.fw._currIndexForZapper].ZappingId;
				localChanIndex = this.fw.inverseZappingArray[localZapperId];
				this.prevProgramVisible = this.isVisible;
				this.isVisible = this.isPPVSkyVisible(this.currentProgram,
						localChanIndex);
			} else {
				this.currentProgram = null;
				this.isVisible = true; // se non ho schedulazione posso vedere
										// il contenuto
			}
			if (this.isVisible) {
				this.fw.getBTVTuner().setDefaultAccess(true);
				this.fw.getBTVTuner().overrideAccessCheck();
				// this.isVisible = false;
			} else {
				this.fw.Video = false;
				return this.eventStreamLost();
			}
		} else {
			this.fw.Video = false;
			return this.eventStreamLost();
		}
	} catch (ecc) {
		return true;
	} finally {
		return true;
	}
};

/*******************************************************************************
 * FUNCTION: eventVideoAvailable PARAMETER: reason DESCRIPTION: Questo evento
 * viene generato dal framework nel caso il video diviene disponibile e viene
 * richiamato eventStreamAcquired()
 ******************************************************************************/
BaseApp.prototype.eventVideoAvailable = function(reason) {
	try {

		this.eventStreamAcquired();
	} catch (ecc) {
		return true;
	} finally {
		return true;
	}
};

BaseApp.prototype.eventTunerChanged = function(reason) {
	try {
		var tuner = this.fw.getBTVTuner().getDefaultHandler();
		switch (reason) {
		case tuner.AC_DEFAULT_ACCESS_GRANT:
		case tuner.AC_CHECK_OVERRIDDEN:
		case tuner.AC_ACCESS_GRANTED:
			this.eventStreamAcquired();
			break;

		case tuner.AC_NOT_RATED_FOR_PROGRAM:
		case tuner.AC_NOT_RATED_FOR_CHANNEL:
		case tuner.AC_PROGRAM_UNAVAILABLE:
			// ********************************************************************************
			// commentando questo caso e spostandolo sopra si permette la
			// visione dei BTV a prescindere dal proprio rating
			// da scommentare successivamente quando si gester� il rating
			// case tuner.AC_NOT_RATED_FOR_PROGRAM:
			// case tuner.AC_NOT_RATED_FOR_CHANNEL:
			// ********************************************************************************
		case tuner.AC_DEFAULT_ACCESS_DENY:
		case tuner.AC_CHANNEL_BLOCKED_FOR_ACCOUNT:
		case tuner.AC_CHANNEL_BLOCKED_FOR_USER:
		case tuner.AC_PROGRAM_NOT_SUBSCRIBED:
		case tuner.AC_CHANNEL_UNAVAILABLE:
		case tuner.AC_PROGRAM_CANCELLED:
		case tuner.AC_CHANNEL_OFFLINE:
			this.eventVideoUnavailable(reason);
			break;
		}
	} catch (ecc) {
		return true;
	} finally {
		return true;
	}
};

/*******************************************************************************
 * FUNCTION: eventStreamAcquired PARAMETER: Nessuno DESCRIPTION: Evento generato
 * dal framework appena viene acquisito il flusso video. Non bisogna inviare
 * alcuna trap.
 ******************************************************************************/
BaseApp.prototype.eventStreamAcquired = function() {
	try {
		if (this._isStreamLost) {
			this._ui.redraw();
		}
		this.fw.Video = true;
		this._isStreamLost = false;
	} catch (ecc) {
		return true;
	} finally {
		return true;
	}
};

BaseApp.prototype.eventDialogStart = function(dlg) {
	try {
		var dlgui = this.fw.createDialogUI("dialogLayout");
		dlgui.setDialog(dlg);
		dlgui.redraw();
	} catch (ecc) {
		return true;
	} finally {
		return true;
	}
};

BaseApp.prototype.eventDialogDismiss = function(dlg) {
	try {
		this.fw.getLayoutManager().lastLayout();
	} catch (ecc) {
		return true;
	} finally {
		return true;
	}
};

/*******************************************************************************
 * FUNCTION: prepareErroInfo PARAMETER: objErrorInfo 1 -
 * objErrorInfo._applicationName - Nome dell'applicazione che ha generato
 * l'errore 2 - objErrorInfo._methodName - Nome del metodo che ha generato
 * l'errore DESCRIPTION: Questo metodo serve per formattare la stringa da
 * inviare nella trap di errore
 ******************************************************************************/
BaseApp.prototype.prepareErroInfo = function(objErrorInfo) {
	try {
		if (objErrorInfo) {
			// se non viene specificato il nome dell'apllicazione si prende
			// quello di default
			if (objErrorInfo._applicationName == ""
					|| objErrorInfo._applicationName == null) {
				objErrorInfo._applicationName = "Generic_application";
			}
			// se non viene specificato il nome del metodo si prende quello di
			// default
			if (objErrorInfo._methodName == ""
					|| objErrorInfo._methodName == null) {
				objErrorInfo._methodName = "Generic_method";
			}
			if (objErrorInfo.message_id == ""
					|| objErrorInfo.message_id == null) {
				objErrorInfo.message_id = "505"; // codice presente nel
													// message_id quando
													// ovaErrorCode � null
			}
			if (objErrorInfo._obException) {
				objErrorInfo.message = objErrorInfo._obException.message;

			} else
				objErrorInfo.message = '';
		} else {
			objErrorInfo = new Object();
			objErrorInfo._applicationName = "Generic_application";
			objErrorInfo._methodName = "Generic_method";
		}
	} catch (ecc) {
		objErrorInfo._methodName = "prepareErrorInfo";
	}
	return objErrorInfo;

};

BaseApp.prototype.eventKeyHot2 = function() {
	return true;
	/*
	try {
		this.loadApp("/ovaServices/getapp/GetApp.html");

	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyHot2";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
	*/
};

BaseApp.prototype.setCurrentLocaleCode = function(aLocaleCode) {
	try {
		this._currentSessionLocaleCode = aLocaleCode;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'setCurrentLocaleCode';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.getCurrentLocaleCode = function() {
	try {
		return this._currentSessionLocaleCode;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'getCurrentLocaleCode';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.eventKeyStop = function() {
	return true;
};

BaseApp.prototype.eventKeyScrollUp = function() {
	return true;
};

BaseApp.prototype.eventKeyScrollDown = function() {
	return true;
};

BaseApp.prototype.setPlogger = function() {
	return true;
};

/*******************************************************************************
 * FUNCTION: eventKeyNumeric PARAMETER: 1 - digit: numero corrispondente al
 * tasto premuto dal telecomando o tastiera DESCRIPTION: Questo evento viene
 * generato quando si digita un pulsante numerico dal telecomando o dalla
 * tastiera.
 ******************************************************************************/
BaseApp.prototype.eventKeyNumeric = function(digit) {
	try {

		// Quando sono dentro Vod - Tasto Guida, non deve apparire la scelta
		// canale da tastierina
		if (this.getActivity() != 4)
			this.callDigit(digit);
	} catch (ecc) {
		objErrorInfo._methodName = "eventKeyNumeric";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

BaseApp.prototype.getchangePage = function(digit) {
	return this.changePage;
}

BaseApp.prototype.EnterNumericDigit = function() {
	try {
		this.changeApp();
		this.timeOut();
	} catch (ecc) {
		this._objErrorInfo._methodName = 'EnterNumericDigit';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*******************************************************************************
 * FUNCTION: changeApp PARAMETER: nessuno DESCRIPTION: Questa funzione effettua
 * il cambio canale dopo averelo digitato da telecomendo attualmente sono attivi
 * solo i canali della menu 100,200,300,400,500 e sky
 ******************************************************************************/
BaseApp.prototype.changeApp = function() {
	try {
		var currApp = "";
		var indice = -1;

		if (this.fw.getAppManager()
				&& this.fw.getAppManager().getCurrentAppUrl())
			currApp = this.fw.getAppManager().getCurrentAppUrl();
		// 		
		if (this.changePage != null
				&& this.changePage != undefined
				&& this.fw.inverseZapper[parseInt(this.changePage, 10)] != null
				&& this.fw.inverseZapper[parseInt(this.changePage, 10)] != undefined)
			indice = this.fw.inverseZapper[parseInt(this.changePage, 10)];

		if (indice >= 0 && this.changePage != null
				&& this.changePage != undefined) {
			if (currApp == this.getHomeUrl()) {

				this.jumpToChannelByZappingId(parseInt(this.changePage, 10));
				this.takeInfoSEPG();
				this.timerINFOSEPG = this.fw.getTimer().setTimeout(2500,this.aggiornaSEPG,this);
				
				/* 2 --> corrisponde SEPG */
				this.activateLayout(2);
			} else {
				this.loadApp(this.getHomeUrl(), null, 3, parseInt(
						this.changePage, 10));
			}
		} else {
			this.timeOut();
			if (this.fw.getEventManager() && this.fw.getLayoutManager()) {
				this.fw.getEventManager().disableNav();
				this.fw.getLayoutManager().setLayoutVisible(
						"digitazioneErrataLayout", true);
			}
			this._indiceTimerErr = this.fw.getTimer().setTimeout(
					this.chiudi_digitazione_err, this.chiudiDigitazioneErrata,
					this);
			return true;
		}

		this.timeOut();
		this.pulisciDigitazioneErrata();
		this.fw.getEventManager().enableNav();
	} catch (ecc) {
		this._objErrorInfo._methodName = "changeApp";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;

};

BaseApp.prototype.pulisciDigitazioneErrata = function() {
	try {
		myLayout = new Object();
		myLayout = this.fw.getLayoutManager().getLayout(
				"digitazioneErrataLayout");
		if (myLayout) {
			var i = 0;
			for (i = 0; i < myLayout.window.document.images.length; i++)
				myLayout.window.document.images[i].src = "/ovaImages/1pixelclear.gif";
			i = 0;
			myLayout = null;
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "pulisciDigitazioneErrata";
		this._objErrorInfo._obException = ecc;
		// this.handleError();
	}
	return true;
};

BaseApp.prototype.chiudiDigitazioneErrata = function() {
	try {
		if (this.fw.getLayoutManager() && this.fw.getEventManager()) {
			this.pulisciDigitazioneErrata();
			this.fw.getLayoutManager().setLayoutVisible(
					"digitazioneErrataLayout", false);
			/*
			 * var layoutManager1 = this.fw.getLayoutManager();
			 * layoutManager1.setLayoutVisible("digitazioneErrataLayout",false);
			 */
			if (this._indiceTimerErr) {
				this.fw.getTimer().clearTimeout(this._indiceTimerErr);
			}
			this._indiceTimerErr = null;
			this.fw.getEventManager().enableNav();
		}

	} catch (ecc) {
		this._objErrorInfo._methodName = "chiudiDigitazioneErrata";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

// //////////////////FUNZIONI PER GESTIRE IL TASTIERINO
// NUMERICO///////////////////
// ////////////////////////////////////////////////////////////////////////////////*
/*******************************************************************************
 * LE FUNZIONI SERVONO A CENTRALIZZARE IL METODO DI OGNI JS PER LA GESTIONE DEL
 * TASTIERINO NUMERICO. * * DeleteNumericDigit: INSERITO NEGLI EVENTI ESC DELLA
 * APPLICAZIONI * CASO 1: CHIUDE LA DIGITAZIONE NUMERICA * CASO 2: ELIMINA UN
 * NUMERO DALLA DIGITAZIONE * EnterNumericDigit: INSERITO NEGLI EVENTI ENTER
 * DELLE APPLICAZINI * CONSENTE DI CONFERMARE I NUMERI INSERITI IN MODO MANUALE. *
 * PER CONTROLLARE LA DIGITAZIONE NUMERICA SE ATTIVA * E' STATO UTILIZZATO UN
 * FLAG: this.BoxChangeChannel * TRUE: FINESTRA DIGITAZIONE NUMERICA ATTIVA * *
 */// //////////////////////////////////////////////////////////////////////////////
BaseApp.prototype.DeleteNumericDigit = function() {
	try {
		switch (this.num_cifre) {
		case 0:
			break;
		case 1:
			this.timeOut();
			break;
		case 2:
			this.num_cifre--;
			this.writeTopIndex(null, null);
			this.chiudiDigitazioneErrata();
			this.changePage = this.changePage.substring(0, 1);
			this.writeTopIndex(this.changePage, 1);
			break;
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'DeleteNumericDigit';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*******************************************************************************
 * FUNCTION: writeTopIndex PARAMETER: 1- cifra: La cifra numerica che � stata
 * digitata e deve essere visualizzata 2- posizione: La posizione dove deve
 * essere stampata la cifra digitata DESCRIPTION: Questo metodo permette di
 * stampare in alto il canale digitato dal telecomando (max 3 cifre)
 ******************************************************************************/
BaseApp.prototype.writeTopIndex = function(cifra, posizione) {
	try {

		var layoutManager = this.fw.getLayoutManager();
		layoutDigit = layoutManager.getLayout("pinAcquistoLayoutZ3");
		if (layoutDigit) {
			if (cifra != null && cifra != undefined && posizione
					&& posizione > 0 && posizione < 4) {
				layoutDigit.window.document.images[posizione - 1].src = "/ovaImages/digit_"
						+ cifra.toString() + "Res.png";
			} else {// ripulisco il pop-up
				layoutDigit.window.document.images[0].src = "/ovaImages/1pixelclear.gif";
				layoutDigit.window.document.images[1].src = "/ovaImages/1pixelclear.gif";
				layoutDigit.window.document.images[2].src = "/ovaImages/1pixelclear.gif";
			}

		}
		layoutManager.setLayoutVisible("pinAcquistoLayoutZ3", true);

	} catch (ecc) {
		this._objErrorInfo._methodName = "writeTopIndex";
		this._objErrorInfo._obException = ecc;
		this.recoveryWriteTopIndex();
	}
	return true;
};

BaseApp.prototype.recoveryWriteTopIndex = function() {
	try {

		var layoutManager = this.fw.getLayoutManager();
		layoutDigit = layoutManager.getLayout("pinAcquistoLayoutZ3");
		if (layoutDigit && layoutDigit.window && layoutDigit.window.document
				&& layoutDigit.window.document.images
				&& layoutDigit.window.document.images[0]
				&& layoutDigit.window.document.images[0].src
				&& layoutDigit.window.document.images[1]
				&& layoutDigit.window.document.images[1].src
				&& layoutDigit.window.document.images[2]
				&& layoutDigit.window.document.images[2].src) {
			layoutDigit.window.document.images[0].src = "/ovaImages/1pixelclear.gif";
			layoutDigit.window.document.images[1].src = "/ovaImages/1pixelclear.gif";
			layoutDigit.window.document.images[2].src = "/ovaImages/1pixelclear.gif";
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "recoveryWriteTopIndex";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.timeOut = function() {
	try {
		this.num_cifre = 0;
		this.BoxChangeChannel = false;
		
		this.changePage = "";
		var layoutManager = this.fw.getLayoutManager();
		this.writeTopIndex(this.changePage, 0);
		layoutManager.setLayoutVisible("pinAcquistoLayoutZ3", false);
		this.fw.getTimer().clearTimeout(this._indiceTimer);
		this._indiceTimer = null;
		this.blocker = false;
	} catch (ecc) {
		this._objErrorInfo._methodName = "timeOut";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.eventKeyMenu = function() {
	try {

		this.goToHomePage();

	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyMenu";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

// gestione tasto back: se si vuole disabilitare tasto back commentare in
// LoadMenuApp e in backFunction le righe marcate nel commento con ***
/*******************************************************************************
 * FUNCTION: printBackHistory PARAMETER: nessuno DESCRIPTION: stampa l'history
 * del back
 ******************************************************************************/
BaseApp.prototype.printBackHistory = function() {
	try {
		this.fw.getAppManager().printBackHistory(); // ***se si vuole
													// disabilitare il back
													// commentare questa riga
	} catch (ecc) {
		this._objErrorInfo._methodName = "printBackHistory";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.printCurrUrlParam = function() {
	try {
		var string_url_param = this.fw.getAppManager().deepPrintBackHistory(); // ***se
																				// si
																				// vuole
																				// disabilitare
																				// il
																				// back
																				// commentare
																				// questa
																				// riga
		return string_url_param;
	} catch (ecc) {
		this._objErrorInfo._methodName = "printCurrUrlParam";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

/*******************************************************************************
 * FUNCTION: flushBack PARAMETER: nessuno DESCRIPTION: azzera la history del
 * back
 ******************************************************************************/
BaseApp.prototype.flushBack = function() {
	try {
		this.fw.getAppManager().flushBack(); // ***se si vuole disabilitare
												// il back commentare questa
												// riga
	} catch (ecc) {
		this._objErrorInfo._methodName = "flushBack";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.LoadMenuApp = function(cat_number) {
	try {
		this.fw.getAppManager().storeMenuApp(cat_number); // ***se si vuole
															// disabilitare il
															// back commentare
															// questa riga
	} catch (ecc) {
		this._objErrorInfo._methodName = "LoadMenuApp";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;

};

BaseApp.prototype.backFunction = function() {
	try {

		var parametri = this.getBackAppParam();
		var currApp = this.fw.getAppManager().getCurrentAppUrl();

		if (currApp != '/ovaServices/getapp/GetApp.html' && parametri != null
				&& parametri[0] == '/ovaServices/getapp/GetApp.html'

		) {

			stringa = 'this.loadApp(parametri[0]';
			for (i = 1; i < parametri.length; i++) {
				stringa = stringa + ',parametri[' + i + ']';
			}
			stringa = stringa + ')';
			eval(stringa);
			this.fw.getAppManager().deleteLastBackApp();
		} else if (currApp != '/ovaServices/getapp/GetApp.html'
				&& parametri != null
				&& parametri[0] == '/ovaServices/getapp/GetApp.html') {

			stringa = 'this.loadApp(parametri[0]';
			for (i = 1; i < parametri.length; i++) {
				stringa = stringa + ',parametri[' + i + ']';
			}
			stringa = stringa + ')';
			eval(stringa);
			this.fw.getAppManager().deleteLastBackApp();
		} else {
			if (this.fw.getAppManager().argumentsArr[1]
					&& this.fw.getAppManager().argumentsArr[1][0] == '/ovaServices/getapp/GetApp.html'
					&& this.fw.getAppManager().argumentsArr[1][1]) {
				this.fw.getAppManager().argumentsArr[1][1] = null;
			}

			this.fw.getAppManager().tastoBack(); // ***se si vuole
													// disabilitare il back
													// commentare questa riga
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "backFunction";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.sendLoadAppTrap = function(appname) {
	try {
		/*
		 * Inizialmente callerApp risulta essere "StartupApp" e appname =
		 * "StartupApp"
		 */
		this.fw.LoggerApp.loadAppTrap(this.fw.callerApp, appname); // chiamata
																	// al metodo
																	// di Logger
																	// per
																	// //inviare
																	// la trap
		this.fw.callerApp = appname; // valorizzare la variabile di framework
	} catch (ecc) {
		this._objErrorInfo._methodName = "sendLoadAppTrap";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.sendStatTrap = function(teamA, teamB) {
	try {
		this.fw.LoggerApp.statTrap(teamA, teamB);
	} catch (ecc) {
		this._objErrorInfo._methodName = "sendStatTrap";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.getBackAppUrl = function() {
	try {
		return this.fw.getAppManager().getNextAppUrl(); // ritorna la url
														// dell'App su cui
														// atterra con il back
	} catch (ecc) {
		this._objErrorInfo._methodName = "getBackAppUrl";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

BaseApp.prototype.getBackAppFullScreenUrl = function() {
	try {
		return this.fw.getAppManager().getNextAppFullScreenUrl(); // ritorna
																	// la url
																	// dell'App
																	// su cui
																	// atterra
																	// con il
																	// back
	} catch (ecc) {
		this._objErrorInfo._methodName = "getBackAppFullScreenUrl";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

BaseApp.prototype.getBackAppParam = function() {
	try {
		return this.fw.getAppManager().getNextAppParam(); // ritorna i
															// parametri
															// dell'App su cui
															// atterra con il
															// back
	} catch (ecc) {
		this._objErrorInfo._methodName = "getBackAppParam";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

// se l'applicazione destinazione non � HomeTvApp usa il normale back e
// restituisce false
// altrimenti viene gestita localmente (in MenuApp) e restituisce true
BaseApp.prototype.backMenuAppFunction = function() {
	try {
		var parametri = this.getBackAppParam();
		var currApp = this.fw.getAppManager().getCurrentAppUrl();
		if (currApp != '/ovaServices/getapp/GetApp.html' && parametri != null
				&& parametri[0] == '/ovaServices/getapp/GetApp.html'

		) {

			stringa = 'this.loadApp(parametri[0]';
			for (i = 1; i < parametri.length; i++) {
				stringa = stringa + ',parametri[' + i + ']';
			}
			stringa = stringa + ')';
			eval(stringa);
			this.fw.getAppManager().deleteLastBackApp();
		} else if (currApp != '/ovaServices/getapp/GetApp.html'
				&& parametri != null
				&& parametri[0] == '/ovaServices/getapp/GetApp.html') {

			stringa = 'this.loadApp(parametri[0]';
			for (i = 1; i < parametri.length; i++) {
				stringa = stringa + ',parametri[' + i + ']';
			}
			stringa = stringa + ')';
			eval(stringa);
			this.fw.getAppManager().deleteLastBackApp();
		} else {
			var ret = false;
			if (this.fw.getAppManager().tastoBackMenuApp()) { // ***se si
																// vuole
																// disabilitare
																// il back
																// commentare
																// questa riga
				this.MenuAppInitChannel = this.fw.getAppManager().MenuAppChannel; // ***se
																					// si
																					// vuole
																					// disabilitare
																					// il
																					// back
																					// commentare
																					// questa
																					// riga
				ret = true; // ***se si vuole disabilitare il back commentare
							// questa riga
			} else { // ***se si vuole disabilitare il back commentare questa
						// riga
				ret = false;
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "backMenuAppFunction";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return ret;
};
// FINE gestione tasto back

BaseApp.prototype.eventKeyHot3 = function() {
	return true;
/*
	try {
		this.loadApp("/ovaServices/getapp/GetApp.html");
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyHot3";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
	*/
};


BaseApp.prototype.eventKeyHot4 = function() {
	return true;
};

BaseApp.prototype.eventKeyHot1 = function() {
	return true;
};

/*******************************************************************************
 * FUNCTION : ReferInitHoriz PARAMETERS : context - viene passato dalla
 * applicazione figlia, deve essere valorizzato DESCRIPTION : deve settare il
 * focus del menu orizzontale in funzione della sezione che chiama la funzione.
 * Il context che viene passato all'applicazione indica la sezione.
 ******************************************************************************/
BaseApp.prototype.ReferInitHoriz = function(context, layout, imgname) {
	try {
		var stringone = "";
		stringone = "{catId:'1000',catName:'novita'},"
				+ "{catId:'100',catName:'tv'},"
				+ "{catId:'200',catName:'intrattenimento'},"
				+ "{catId:'300',catName:'film'},"
				+ "{catId:'400',catName:'documentari'},"
				+ "{catId:'500',catName:'notizie'}";

		this.catList = "[" + stringone + "]";
		this.catList = eval(this.catList);
		if (context != null) {
			switch (context) {
			case 1000:
				this.ReferFillHorizMenu(layout, imgname);
				break;
			case 100:
				this.ReferRotateInitLeft(layout, imgname);
				break;
			case 200:
				this.ReferRotateInitLeft(layout, imgname);
				this.ReferRotateInitLeft(layout, imgname);
				break;
			case 300:
				this.ReferRotateInitLeft(layout, imgname);
				this.ReferRotateInitLeft(layout, imgname);
				this.ReferRotateInitLeft(layout, imgname);
				break;
			case 400:
				this.ReferRotateInitRight(layout, imgname);
				this.ReferRotateInitRight(layout, imgname);
				break;
			case 500:
				this.ReferRotateInitRight(layout, imgname);
				break;
			}
		}
		this.ReferFillHorizMenu(layout, imgname);
	} catch (ecc) {
		this._objErrorInfo._methodName = "ReferInitHoriz";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.ReferRotateInitLeft = function(layout, imgname) {
	try {
		var app = null;
		app = this.catList[0];
		this.catList[0] = this.catList[1];
		this.catList[1] = this.catList[2];
		this.catList[2] = this.catList[3];
		this.catList[3] = this.catList[4];
		this.catList[4] = this.catList[5];
		this.catList[5] = app;
		this.ReferFillHorizMenu(layout, imgname);
	} catch (ecc) {
		this._objErrorInfo._methodName = "ReferRotateInitLeft";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.ReferRotateInitRight = function(layout, imgname) {
	try {
		var app = null;
		app = this.catList[5];
		this.catList[5] = this.catList[4];
		this.catList[4] = this.catList[3];
		this.catList[3] = this.catList[2];
		this.catList[2] = this.catList[1];
		this.catList[1] = this.catList[0];
		this.catList[0] = app;
		this.ReferFillHorizMenu(layout, imgname);
	} catch (ecc) {
		this._objErrorInfo._methodName = "ReferRotateInitRight";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.ReferFillHorizMenu = function(layout, imgname) {
	try {
		testlabel1 = '/ovaImages/menu/lb_' + this.catList[0].catId + '_small_mid.png';
		this.referImageToLayout(layout, imgname, testlabel1);

	} catch (ecc) {
		this._objErrorInfo._methodName = "ReferFillHorizMenu";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*******************************************************************************
 * FUNCTION : setInitHoriz PARAMETERS : context - viene passato dalla
 * applicazione figlia, deve essere valorizzato DESCRIPTION : deve settare il
 * focus del menu orizzontale in funzione della sezione che chiama la funzione.
 * Il context che viene passato all'applicazione indica la sezione.
 ******************************************************************************/
BaseApp.prototype.setInitHoriz = function(context) {
	try {
		this._ui.setLabelText("./ITEM_1_LABEL", "");
		var stringone = "";
		stringone = "{catId:'1000',catName:'novita'},"
				+ "{catId:'100',catName:'tv'},"
				+ "{catId:'200',catName:'intrattenimento'},"
				+ "{catId:'300',catName:'film'},"
				+ "{catId:'400',catName:'documentari'},"
				+ "{catId:'500',catName:'notizie'}";

		this.catList = "[" + stringone + "]";
		this.catList = eval(this.catList);
		if (context != null) {
			switch (context) {
			case 1000:
				this.fillHorizMenu();
				break;
			case 100:
				this.rotateInitLeft();
				break;
			case 200:
				this.rotateInitLeft();
				this.rotateInitLeft();
				break;
			case 300:
				this.rotateInitLeft();
				this.rotateInitLeft();
				this.rotateInitLeft();
				break;
			case 400:
				this.rotateInitRight();
				this.rotateInitRight();
				break;
			case 500:
				this.rotateInitRight();
				break;
			}
		}
		this.fillHorizMenu();
	} catch (ecc) {
		this._objErrorInfo._methodName = "setInitHoriz";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.fillHorizMenu = function() {
	try {
		testlabel1 = '<img src="/ovaImages/menu/lb_' + this.catList[0].catId + '_small_mid.png">';
		this._ui.setLabelHtml("./ITEM_1_LABEL", testlabel1);
		this._ui.redraw();
	} catch (ecc) {
		this._objErrorInfo._methodName = "fillHorizMenu";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*******************************************************************************
 * FUNCTION : setHorizMidFocus PARAMETERS : DESCRIPTION : deve settare
 * l'immagine di focus mid in funzione della categoria this.catList[0].catId
 ******************************************************************************/
BaseApp.prototype.setHorizMidFocus = function() {
	try {
		testlabel100 = '<img src="/ovaImages/menu/lb_' + this.catList[0].catId + '_small_mid.png">';
		this._ui.setLabelHtml("./ITEM_1_LABEL", testlabel100);
		this._ui.redraw();
	} catch (ecc) {
		this._objErrorInfo._methodName = "setHorizMidFocus";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*******************************************************************************
 * FUNCTION : setHorizOnFocus PARAMETERS : DESCRIPTION : deve settare l'immagine
 * di focus on in funzione della categoria this.catList[0].catId
 ******************************************************************************/
BaseApp.prototype.setHorizOnFocus = function() {
	try {
		testlabel100 = '<img src="/ovaImages/menu/lb_' + this.catList[0].catId + '_small_on.png">';
		this._ui.setLabelHtml("./ITEM_1_LABEL", testlabel100);
		this._ui.redraw();
	} catch (ecc) {
		this._objErrorInfo._methodName = "setHorizOnFocus";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.rotateHorizLeft = function() {
	try {
		var dest = 0;
		if (this.context != null) {
			switch (this.context) {
			case 500:
				dest = 1000;
				break;
			case 1000:
				dest = 100;
				break;
			default:
				dest = this.context + 100;
			}
		}
		this.loadApp("/ovaServices/getapp/GetApp.html", dest);
	} catch (ecc) {
		this._objErrorInfo._methodName = "rotateHorizLeft";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.rotateInitLeft = function() {
	try {
		var app = null;
		app = this.catList[0];
		this.catList[0] = this.catList[1];
		this.catList[1] = this.catList[2];
		this.catList[2] = this.catList[3];
		this.catList[3] = this.catList[4];
		this.catList[4] = this.catList[5];
		this.catList[5] = app;
		// this.fillHorizMenu();
	} catch (ecc) {
		this._objErrorInfo._methodName = "rotateInitLeft";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.rotateInitRight = function() {
	try {
		var app = null;
		app = this.catList[5];
		this.catList[5] = this.catList[4];
		this.catList[4] = this.catList[3];
		this.catList[3] = this.catList[2];
		this.catList[2] = this.catList[1];
		this.catList[1] = this.catList[0];
		this.catList[0] = app;
		// this.fillHorizMenu();
	} catch (ecc) {
		this._objErrorInfo._methodName = "rotateInitRight";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.rotateHorizRight = function() {
	try {
		var dest = 0;
		if (this.context != null) {
			switch (this.context) {
			case 1000:
				dest = 500;
				break;
			case 100:
				dest = 1000;
				break;
			default:
				dest = this.context - 100;
				break;
			}
		}
		this.loadApp("/ovaServices/getapp/GetApp.html", dest);
	} catch (ecc) {
		this._objErrorInfo._methodName = "rotateHorizRight";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*******************************************************************************
 * FUNCTION : getTimew PARAMETERS : nessuno DESCRIPTION : Questo metodo
 * restituisce un time stamp che cambia ogni DELTA minuti. dove delta � un
 * valore impostato su sys_prop
 ******************************************************************************/
BaseApp.prototype.getTimew = function() {
	try {
		var delta = 1; // si puo' settare il refresh dei fetcher ogni multiplo
						// intero di RELOAD_INTERVAL_ACCOUNT
		// di default settato nel DB a 15 minuti-->1*15Minuti
		if (this.fw.getConfig().TIME_WINDOW_DELTA != null)
			delta = this.fw.getConfig().TIME_WINDOW_DELTA; // -->delta*TIME_WINDOW_DELTA

		var gmtTime = this.fw.getOSD().getTime(); // restituisce l'ora
													// aggiornata dal framework
													// ogni
		// RELOAD_INTERVAL_ACCOUNT dove:
		// OvaConfig.RELOAD_INTERVAL_ACCOUNT=15*60 (15 minuti)
		// si legge il valore come:
		// this.fw.getConfig().RELOAD_INTERVAL_ACCOUNT
		var time_refresh = this.fw.getConfig().RELOAD_INTERVAL_ACCOUNT * delta
				* 1000;
		var date = new Date();
		date.setTime(gmtTime);
		var ris = date.getTime();
		var resto = ris % (time_refresh);
		// ottiene il resto della divisione tra data attuale
		// del server e intervallo di sensibilit�
		// (delta*RELOAD_INTERVAL_ACCOUNT)
		// entro cui � aggiornata la data
		var ts_normalizzato = (ris - resto) / (time_refresh);
		return ts_normalizzato;
	} catch (ecc) {
		this._objErrorInfo._methodName = "getTimew";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

/*******************************************************************************
 * FUNCTION : getImagesTimew PARAMETERS : nessuno DESCRIPTION : Questo metodo
 * restituisce un time stamp che cambia ogni DELTA ore. dove delta �
 * configurabile nella tabella SYS_PRO
 ******************************************************************************/
BaseApp.prototype.getImagesTimew = function() {
	try {
		var delta = this.fw.getConfig().RELOAD_IMAGES_TIME; // espresso in s

		// si puo' settare il refresh dei fetcher ogni multiplo intero di
		// RELOAD_INTERVAL_ACCOUNT
		// di default settato nel DB a 15 minuti-->1*15Minuti

		var time_refresh = delta * 1000;

		// var date=new Date();
		// var ris=date.getTime();
		var ris = this.fw.getOSD().getTime();

		var resto = ris % (time_refresh);
		// ottiene il resto della divisione tra data attuale
		// del server e intervallo di sensibilit�
		// (delta*RELOAD_INTERVAL_ACCOUNT)
		// entro cui � aggiornata la data
		var ts_normalizzato = (ris - resto) / (time_refresh);
		return ts_normalizzato;
	} catch (ecc) {
		this._objErrorInfo._methodName = "getImagesTimew";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

/*******************************************************************************
 * FUNCTION : getEpgGridTimew PARAMETERS : nessuno DESCRIPTION : Questo metodo
 * restituisce un time stamp che cambia ogni DELTA ore. dove delta �
 * configurabile nella tabella SYS_PROP. Questo timestamp viene usato per non
 * cachare il fetcher della griglia
 ******************************************************************************/
BaseApp.prototype.getEpgGridTimew = function() {
	try {
		var delta = (this.fw.getConfig().RELOAD_EPGGRID_INTERVAL != null) ? (parseInt(this.fw
				.getConfig().RELOAD_EPGGRID_INTERVAL) * 60)
				: 7200; // espresso in s

		var time_refresh = delta * 1000;
		var ris = this.fw.getOSD().getTime();

		var resto = ris % (time_refresh);
		// ottiene il resto della divisione tra data attuale
		// del server e intervallo di sensibilit�
		// (delta*RELOAD_INTERVAL_ACCOUNT)
		// entro cui � aggiornata la data
		var ts_normalizzato = (ris - resto) / (time_refresh);
		return ts_normalizzato;
	} catch (ecc) {
		this._objErrorInfo._methodName = "getEpgGridTimew";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

/*******************************************************************************
 * FUNCTION : getOvaVer PARAMETERS : nessuno DESCRIPTION : funzione che
 * restituisce la versione di OVA corrente
 ******************************************************************************/
BaseApp.prototype.getOvaVer = function() {
	try {
		// prendo dal framework la costante che identifica il valore
		var currVal = "0.0";
		if (this.fw.getConfig().STB_CURR_OVA_VERSION != null) {
			currVal = "" + this.fw.getConfig().STB_CURR_OVA_VERSION;
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "getOvaVer";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return currVal;
};

/*******************************************************************************
 * FUNCTION : getFirmwareVer PARAMETERS : nessuno DESCRIPTION : funzione che
 * restituisce la versione del firmware (telsey) corrente
 ******************************************************************************/
BaseApp.prototype.getFirmwareVer = function() {
	try {
		// prendo dal framework la costante che identifica il valore
		var currVal = "0.0.0";
		if (this.fw.getConfig().STB_CURR_FW_VERSION != null) {
			// gestiscovSTB PIRELLI
			var platformType = this.fw.getAppManager()._path;
			if (platformType == "pirelli_sd" || platformType == "pirelli_dtt") {
				currVal = "" + this.fw.getConfig().STB_CURR_FW_VERSION_PIRELLI;
			} else {
				currVal = "" + this.fw.getConfig().STB_CURR_FW_VERSION;

			}
		}

	} catch (ecc) {
		this._objErrorInfo._methodName = "getFirmwareVer";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return currVal;
};

BaseApp.prototype.eventKeyEye = function() {
	try {
		this.goToHomePage();
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyEye";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};
// mappato nel tasto ESC della tastiera
BaseApp.prototype.eventKeyBack = function() {
	try {
		// /////////////////////////////CONTROLLO DEL TASTIERINO
		// NUMERICO//////////////////
		if (this.BoxChangeChannel == true) {
			this.DeleteNumericDigit();
			// ////////////////////////////////////////////////////////////////////////////////
		} else {
			this.backFunction();
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyBack";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

// mappato nel tasto ESC del telecomando
BaseApp.prototype.eventKeyEsc = function() {
	try {
		// /////////////////////////////CONTROLLO DEL TASTIERINO
		// NUMERICO//////////////////
		if (this.BoxChangeChannel == true) {
			this.DeleteNumericDigit();
			// ////////////////////////////////////////////////////////////////////////////////
		} else {
			this.backFunction();
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyEsc";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

/*******************************************************************************
 * FUNCTION : hide_Video PARAMETERS : nessuno DESCRIPTION : nasconde il video
 ******************************************************************************/
BaseApp.prototype.hide_Video = function() {
	try {
		var vc = this.fw.getVideoControl();
		vc.setWindow(0, 720, 1, 1);
	} catch (ecc) {
		this._objErrorInfo._methodName = "hide_Video";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*******************************************************************************
 * FUNCTION : hide_Video PARAMETERS : nessuno DESCRIPTION : leave del video
 ******************************************************************************/
BaseApp.prototype.stop_Video = function() {
	try {
		if (this.fw.getBTVTuner().getCurrentChannel()
				&& this.fw.getBTVTuner().getCurrentChannel().ecmInfo != null) {
			var drm = this.fw.getDRM();
			drm._unloadChannel();
		}
		var vc = this.fw.getVideoControl();
		vc._unload();
	} catch (ecc) {
		this._objErrorInfo._methodName = "stop_Video";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*******************************************************************************
 * FUNCTION : unload_Video PARAMETERS : nessuno DESCRIPTION : leave del video
 ******************************************************************************/
BaseApp.prototype.unload_Video = function() {
	try {
		if (this.fw.getBTVTuner().getCurrentChannel()
				&& this.fw.getBTVTuner().getCurrentChannel().ecmInfo != null) {
			var drm = this.fw.getDRM();
			drm._unloadChannel();
		}
		var vc = this.fw.getVideoControl();
		vc._unload();
		vc.setWindow(0, 720, 1, 1);
		this.fw.getBTVTuner().setActive(false);
		this.trapLeave();
	} catch (ecc) {
		this._objErrorInfo._methodName = "unload_Video";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.eventUserInactive = function() {
	try {
		this.fw.isInactive = true;
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventUserInactive";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

BaseApp.prototype.eventUserActive = function() {
	try {
		this.fw.isInactive = false;
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventUserActive";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

BaseApp.prototype.printProfile = function() {
	try {
		lungz = this.fw.profiler.length;
		for (t = 0; t < lungz; t++)
			this.getPlogger("item" + t + ":" + this.fw.profiler[t]);
	} catch (ecc) {
		this._objErrorInfo._methodName = "printProfile";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.addProfile = function(stringaz) {
	try {
		var timeNow = this.fw.getOSD().getTime();
		var nowTypeDate = new Date(timeNow);
		nowTime = nowTypeDate.getTime();
		this.fw.profiler[this.fw.profilerCounter] = nowTime + "=" + stringaz;
		this.fw.profilerCounter++;
	} catch (ecc) {
		this._objErrorInfo._methodName = "addProfile";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.printProfileFetch = function() {
	try {
		lungz = this.fw.profilerFetch.length;
		for (t = 0; t < lungz; t++)
			this.getPlogger("item" + t + ":" + this.fw.profilerFetch[t]);
	} catch (ecc) {
		this._objErrorInfo._methodName = "printProfileFetch";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.addProfileFetch = function(stringaz) {
	try {
		var timeNow = this.fw.getOSD().getTime();
		var nowTypeDate = new Date(timeNow);
		nowTime = nowTypeDate.getTime();
		this.fw.profilerFetch[this.fw.profilerFetchCounter] = nowTime + "="
				+ stringaz;
		this.fw.profilerFetchCounter++;
	} catch (ecc) {
		this._objErrorInfo._methodName = "addProfileFetch";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.replaceFrameContents = function(layoutId, label, content,
		cssSrc) {
	try {
		var layoutManager = this.fw.getLayoutManager();
		var layout = layoutManager.getLayout(layoutId);
		if (cssSrc) {
			content = "literal:<link rel='stylesheet' type='text/css' href="
					+ cssSrc + ">" + content;
		} else {
			content = "literal:<link rel='stylesheet' type='text/css' href='/ovaUI/pirelli_dtt/TIOva.css'>"
					+ content;
		}
		layout.window.replaceFrameContents(content, label);
	} catch (ecc) {
		this._objErrorInfo._methodName = "replaceFrameContents";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.referImageToIFrame = function(stringa, frame, strina, strinb) {
	try {
		this.pageLayout.frames[frame].document.images[strina].src = strinb;

	} catch (ecc) {
		this._objErrorInfo._methodName = "referImageToIFrame";
		this._objErrorInfo._obException = ecc;
	}
	return true;

};

BaseApp.prototype.referImageToLayout = function(stringa, strina, strinb) {
	try {

		this.pageLayout.document.images[strina].src = strinb;

	} catch (ecc) {
		this._objErrorInfo._methodName = "referImageToLayout";
		this._objErrorInfo._obException = ecc;
	}
	return true
};

BaseApp.prototype.referImageToLayout2 = function(stringa, strina, strinb,
		sizeX, sizeY) {
	try {
		this.pageLayout.document.images[strina].src = strinb;
		this.pageLayout.document.images[strina].width = '180';
		this.pageLayout.document.images[strina].height = '241';
	} catch (ecc) {
		this._objErrorInfo._methodName = "referImageToLayout2";
		this._objErrorInfo._obException = ecc;
	}
	return true
};

// changeIframe -- Metodo per cambiare href degli Iframe
// ritorna true se effettua il cambio dell'href, false altrimenti
// stringa = layout
// frame = nome Iframe
// url_frame = href dell'iframe
BaseApp.prototype.changeIframe = function(stringa, frame, url_frame) {
	try {
		var ret = false;
		var layoutManager = this.fw.getLayoutManager();
		var page = layoutManager.getLayout(stringa);
		var lun = this.page1.frames[frame].location.href.length;
		if (page.frames[frame].location.href.slice(lun - url_frame.length) != url_frame) {
			page.frames[frame].location.href = url_frame;
			ret = true;
		} else {
			ret = false;
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "changeIframe";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return ret;
};

BaseApp.prototype.orarioOk = function() {
	try {
		var stopTime = this.fw.getConfig().VANITY_BLOCK_TIME_START; // Orario
																	// dopo il
																	// quale non
																	// e'
																	// possibile
																	// vedere
																	// contenuti
																	// vanity
		var startTime = this.fw.getConfig().VANITY_BLOCK_TIME_END; // Orario
																	// dopo il
																	// quale e'
																	// possibile
																	// vedere
																	// contenuti
																	// vanity
		var now = this.fw.getOSD().getTime();
		var dnow = new Date();
		dnow.setTime(now);
		var h = dnow.getUTCHours();
		return (h < stopTime || h >= startTime);
	} catch (ecc) {
		this._objErrorInfo._methodName = "orarioOk";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return false;
	}
};

BaseApp.prototype.jumpToChannelByRecid = function(recid) {
	try {
		var canale = this.fw.getBTVTuner().getCurrentChannel();
		if (!canale) {
			canale = new Object();
		}
		// verifica se stiamo effettuando una jump al canale corrente
		// oppure se il btvtuner � non attivo.
		if (canale.recid != recid || this.fw.getBTVTuner().getActive() == false
				|| this.fw.forceJumpToSameRecId == true) {

			this.fw.forceJumpToSameRecId = false; // lo rimetto sempre a false
			var ret = false;
			var vc = this.fw.getVideoControl();
			vc.setPlayRate(vc.MODE_STOP);

			this._epg = this.fw.getBTVTuner().getEPG();
			var channel = new Object();
			channel = this._epg.getChannelByChanRecid(recid);

			if (this.checkForRatingBTV(recid)) {
				// controllo se BTV tuner � attivo (se si invio trap di leave)
				if (this.fw.getBTVTuner().getActive()) {
					this.trapLeave();
				}
				this.fw.getBTVTuner().jumpToChannelByRecid(recid);
				this.fw.getBTVTuner().setActive(true);
				try { // cerco di abilitare i sottotitoli se l'utente li ha
						// impostati attivi
					if (this.fw.getAppManager().SelectPlatform() == 'pirelli_dtt') {
						this.enableLinguaSub = "N"; // disabilitati per pirelli
					} else {
						var zapId = this.getZapperIdByChanrecid(recid);
						if (zapId) {
							var zapElement = this.getZapperElement(zapId);
							if (zapElement
									&& this.chanTypeZapper(zapElement) == 'sky') {
								this.enableLinguaSub = navigator
										.Get_vp_subtitle(); // torna "Y" o "N"
							}
						}
					}
				} catch (ecc) { // per il browserino PC subtitle off di default
					this.enableLinguaSub = "N";
				}

				if (this.enableLinguaSub == "Y") { // se sono abilitati i
													// sottotitoli li mando a
													// video
					this.settaSottotitoli(true)
				} else { // altrimenti li disabilito a video
					this.settaSottotitoli(false);
				}

				this.trapJoin();
				ret = true;
			}
		}

	} catch (ecc) {
		this._objErrorInfo._methodName = "jumpToChannelByRecid";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}

	return ret;
};

/**
 * FUNCTION: checkForRatingBTV PARAMETERS : recid: indica il canale su cui deve
 * essere effettuato il controllo del rating DESCRIPTION : Questa funzione
 * controlla se l'utente � abilitato alla fruizione di un programma, in base al
 * rating. Se il rating del programma � maggiore del rating dell'utente allora
 * verr� visualizzata la pagina di inserimento del PC
 */
BaseApp.prototype.checkForRatingBTV = function(recid) {
	try {
		if (this.fw.ratingCheckBTV) {
			var ret = false;

			time = this.fw.getOSD().getTime();
			// timei=time + parseInt(this.fw.getConfig().OFFSET_ORA_LEGALE);
			// this._epg = this.fw.getBTVTuner().getEPG();
			var idx = this._epg.findSlotIndexByTime(recid, time);
			// var idx=this._epg.findSlotIndexByTime(recid,timei);
			var epgSlot = this.getProgramSlot(recid, idx);
			var user_rating_id = this.fw.getUserInfo().getRatingID();
			var rating_contenuto = 0;
			if (!epgSlot) {
				// Se per il contenuto corrente non � schedulato un programma
				// allora
				// controllo il rating del canale. La propriet�
				// FILTER_CHANNELS_BY_RATING
				// deve essere settata a 'false' in ova_sys_prop.
				if (recid && this._epg.getChannelByChanRecid(recid)) {
					rating_contenuto = this._epg.getChannelByChanRecid(recid).ratingRecid;
				}
			} else {
				if (epgSlot && !(epgSlot.program)) {
					if (recid && this._epg.getChannelByChanRecid(recid)) {
						rating_contenuto = this._epg
								.getChannelByChanRecid(recid).ratingRecid;
					}

				} else {
					// altrimenti uso il rating del programma associato.
					if (epgSlot && (epgSlot.program)) {
						rating_contenuto = epgSlot.program.ratingid;
					}
				}
			}
			// Controllo del rating
			if (user_rating_id < rating_contenuto) {
				var application = this.fw.getAppManager().getCurrentAppUrl();
				var objPC = new Object();
				objPC.url = application;
				objPC.programRatingId = rating_contenuto;
				objPC.activity = this.fw._myActivity;
				// chiamo inserimento PC BTV
				switch (application) {
				case "/ovaServices/getapp/GetApp.html":
					objPC.app = "TvFullScreen";
					// inizializza parametri di tvFullScreen
					if (this.isSKY) {
						objPC.obj = new Object();
						objPC.obj = this._obj;
						objPC.item = new Object();
						objPC.item.channel = this._canali_sky[this._indice_sky].channel;
						objPC._url = this._url;
						objPC.flagLeave = this.flagLeave;

						if (this._canali_sky) {
							objPC._canali_sky = new Array();
							objPC._canali_sky = this._canali_sky;
						} else {
							objPC._canali_sky = null;
						}
					} else {
						objPC.obj = new Object();
						if (this.ob2) {
							objPC.obj = this.ob2[this.attual_position_channel - 1];
							objPC.ob2 = new Array();
							objPC.ob2 = this.ob2;
							objPC.posizione = this.attual_position_channel - 1;
						} else {
							objPC.obj = this._obj;
							objPC.ob2 = null;
						}
						objPC.item = new Object();
						objPC.item.channel = objPC.obj.channel;
						objPC._url = this._url;
						objPC.flagLeave = this.flagLeave;
					}
					break;
				default:

					break;
				}
				// controllo se il PC � settato, altrimenti si avvia il wizard
				var users = this.fw.getUserInfo().getUsers();
				if (users[0].type == "F") {
					this.indexParental = 1;
				} else {
					this.indexParental = 0;
				}
				if (users[this.indexParental].pin.substring(1, 2) == "*") {
					// Avvio il wizard PC
					this.loadApp("/ovaServices/getapp/GetApp.html", objPC);
					ret = false;
				} else {
					if (objPC.app == "") {
						objPC.menupos = 1000;
						objPC.app = "MenuApp";
					} else {
						this.loadApp("/ovaServices/getapp/GetApp.html", objPC);
					}
				}

			} else {
				ret = true;
			}

		} else {
			ret = true;
			this.fw.ratingCheckBTV = true;
		}
		return ret;
	} catch (ecc) {
		this._objErrorInfo._methodName = "checkForRatingBTV";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return ret;
	}
};

BaseApp.prototype.getProgramSlot = function(chanRecid, index) {
	try {

		var schd = this._epg.getChannelSchedule(chanRecid);
		if (schd != null && 0 <= index && index < schd.length) {
			this.maxIndex = schd.length;
			return schd[index];
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'getProgramSlot';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return null;
};

// toglie il quadrato rosso attorno al menu scelto (nei keyUp/keyDown)
BaseApp.prototype.referHorizOnFocus = function(layout, stringa) {
	try {
		stringb = "/ovaImages/menu/lb_" + this.catList[0].catId
				+ "_small_on.png";
		this.referImageToLayout(layout, stringa, stringb);
	} catch (ecc) {
		this._objErrorInfo._methodName = 'referHorizOnFocus';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.referHorizMidFocus = function(layout, stringa) {
	try {
		stringb = "/ovaImages/menu/lb_" + this.catList[0].catId
				+ "_small_mid.png";
		this.referImageToLayout(layout, stringa, stringb);
	} catch (ecc) {
		this._objErrorInfo._methodName = 'referHorizMidFocus';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/**
 * FUNCTION: checkString PARAMETERS : strValue DESCRIPTION : la funzione
 * controlla se il valore della stringa passata come parametro ha il valore ND
 * (bug Alcatel). Si deve chiamare ogni volta che si vuole rappresentare un
 * valore ricevuto da un fetcher dati su DB
 */
BaseApp.prototype.checkString = function(strValue) {
	try {
		var strRet = '';
		if (strValue != null && strValue != 'ND') {
			strRet = strValue;
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'checkString';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return strRet;

};

// metodo per risolvere il problema dello sfasamento degli orari fino al cambio
// dell'ora legale
// parametri:
// timestamp: data dell'evento in millisecondi
BaseApp.prototype.checkOraLegale = function(timestamp) {
	try {
		var giorno = "";
		var mese = "";
		var giornoInizioRange = "";
		var meseInizioRange = "";
		var giornoFineRange = "";
		var meseFineRange = "";
		var time = new Date(timestamp);
		var offset = this.fw.getConfig().OFFSET_LEGALE;
		var data = this.fw.getUtil().formatDate(time, 'DD') + "/"
				+ this.fw.getUtil().formatDate(time, 'MM') + "/"
				+ time.getFullYear() + "  ";
		var dataInizioRange = this.fw.getConfig().DATA_INIZIO_LEGALE_MET
				.split("-");
		var dataFineRange = this.fw.getConfig().DATA_FINE_LEGALE_GMT1
				.split("-");
		var dataDaStampare = timestamp;

		var date = data.split("/");
		giorno = date[0];
		mese = date[1];

		giornoInizioRange = dataInizioRange[0];
		meseInizioRange = dataInizioRange[1];
		giornoFineRange = dataFineRange[0];
		meseFineRange = dataFineRange[1];

		if (((giorno >= giornoInizioRange) && (mese == meseInizioRange))
				|| ((giorno < giornoFineRange) && (mese == meseFineRange))) {
			dataDaStampare = timestamp + parseInt(offset);
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'checkOraLegale';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return dataDaStampare;
};

/*******************************************************************************
 * eventDataFetchStart � sollevato da OvaAppManager quando viene chiamata una
 * loadApp
 ******************************************************************************/
BaseApp.prototype.eventAppLoadStart = function(objUrl) {
	try {
		this.eventDataFetchStart(objUrl, "application")
		var urlFetchSplitted = objUrl.split('?');
		var urlFetchIndex1 = urlFetchSplitted[0].split('/ovaServices/'); // questo
																			// lo
																			// facciamo
																			// per
																			// escludere
																			// eventuali
																			// path
		var urlFetchIndex = ""; // che precedono ovaServices.ESEMPIO in
								// cartaDiCredito
		urlFetchIndex = '/ovaServices/' + urlFetchIndex1[1];
		this.appfetched = urlFetchIndex;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'eventAppLoadStart';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

/*******************************************************************************
 * eventDataFetchStart � sollevato da ovaDataFecther quando preleva dalla coda
 * dei fetcher l'oggetto che ne identifica la richiesta.Tale richiesta viene
 * cos� processata.
 ******************************************************************************/
BaseApp.prototype.eventDataFetchStart = function(objUrl, callerObj) {
	try {
		// this.fw.LoggerApp.debugLog("��������������� "+objUrl);
		var urlFetchSplitted = objUrl.split('?');
		var urlFetchIndex1 = urlFetchSplitted[0].split('/ovaServices/'); // questo
																			// lo
																			// facciamo
																			// per
																			// escludere
																			// eventuali
																			// path
		var urlFetchIndex = "";
		if (urlFetchIndex1.length == 1) {
			urlFetchIndex1 = urlFetchSplitted[0].split('_');
			urlFetchIndex = urlFetchIndex1[0];
		} else {
			// che precedono ovaServices.ESEMPIO in cartaDiCredito
			urlFetchIndex = '/ovaServices/' + urlFetchIndex1[1];
		}

		if (this.appfetched != null && this.appfetched == urlFetchIndex) {
			this.appfetched = null;
			return true;
		} else {
			var ob = new Object();
			ob.urlFetch = objUrl;

			ob.callerObj = callerObj;
			ob.callback = this.fw.getFetcher()._curFetch.callback;
			this._urlFetchArray.push(ob);

		}

	} catch (ecc) {
		this._objErrorInfo._methodName = 'eventDataFetchStart';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};
/*******************************************************************************
 * eventDataFetchComplete � sollevato da ovaDataFecther quando la richiesta di
 * un fetcher � stata completata.
 ******************************************************************************/
/* In generale resultData corrisponde al campo data definito nel file html */
BaseApp.prototype.eventDataFetchComplete = function(resultData, objUrl,
		callerObj) {
	try {

		var ob = new Object();
		ob = this._urlFetchArray.shift();

		if (resultData != null && resultData.account != null) {

			if (objUrl.indexOf("/ovaServices/services/Bootstrap") != -1
					|| objUrl.indexOf("/ovaServices/services/GetAccount") != -1) {
				// Nell' IF sopra, per il refresh della matrice di zapper �
				// stata levata la GetChannelData, in quanto � ridondante

				var currApp = this.fw.getAppManager().getCurrentAppUrl();

				if (currApp.indexOf("ScanDTTApp") == -1
						&& currApp.indexOf("ScanDTTSettingsApp") == -1
						&& currApp.indexOf("StartupApp") == -1) {
					this.fw.userOldPackages = this
							.backupUserPackages(this.fw.userPackages);

					this.fw.userPackages = new Array();

					for ( var i = 0; i < resultData.account.packages.length; i++) {
						this.fw.userPackages[i] = resultData.account.packages[i];
					}

					this.fw.userPackages = this
							.getNormalizedPackages(this.fw.userPackages);
					this.caricaZapperInfoDefault(); // Se l'ultimo fetcher
													// chiamato � il Bootstrap o
													// il GetAccount chiamiamo
													// il fetcher per aggiornare
													// l'array delle label
				}
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'eventDataFetchComplete';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

BaseApp.prototype.sendErrorTrap = function(errorCode) {
	try {
		if (this._objErrorInfo) {
			this._objErrorInfo.message_id = errorCode;
			this.fw.LoggerApp
					.errorLog(this.prepareErroInfo(this._objErrorInfo));
		} else {
			this.fw.LoggerApp.errorLog(errorCode);
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'sendErrorTrap';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.showErrorPage = function(errorCode) {
	try {

		obj = new Object();
		obj.message_id = errorCode;
		obj.url = "/ovaServices/getapp/GetApp.html";
		this.loadApp("/ovaServices/getapp/GetApp.html", obj);
	} catch (ecc) {

	}
	return true;
};

BaseApp.prototype.showErrorPageSCF = function(errorCode) {
	try {
		obj = new Object();
		obj.message_id = errorCode;
		obj.url = "/ovaServices/getapp/GetApp.html";
		obj.scf = true;
		this.loadApp("/ovaServices/getapp/GetApp.html", obj);
	} catch (ecc) {
		this._objErrorInfo._methodName = 'showErrorPageSCF';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

// utilizzato per customizzare la gestione degli errori non causati dai fetcher
// da sovrascrivere nell'applicazione che vuole customizzare la gestione degli
// errori
BaseApp.prototype.handleErrorCustom = function(message_id) {
	try {
		this.showErrorPage(message_id);
	} catch (ecc) {

	}
	return true;
};

BaseApp.prototype.handleError = function(ovaErrorCode) {

	var ob = new Object();
	if (ovaErrorCode) {

		var spl = ovaErrorCode.split('-');
		if (spl[0] == 'OVA') {
			ob = this._urlFetchArray.shift();

		}
	}
	var obj = new Object();
	obj.url = "/ovaServices/getapp/GetApp.html";
	if (!ovaErrorCode || ovaErrorCode == "") {
		obj.message_id = "505";
		obj.message_id_sys = " 003_0001";
		this._objErrorInfo._fetcherName = "";
		this._objErrorInfo.message = this._objErrorInfo._obException.message
				.replace(/\n/g, '');
		this._objErrorInfo.message = this._objErrorInfo.message.replace(/\r/g,
				'');
		this._objErrorInfo._obException.message = this._objErrorInfo.message;
		this.sendErrorTrap(obj.message_id);
		this.handleErrorCustom(obj.message_id);
	} else {
		this._objErrorInfo._methodName = "";
		obj.message_id = ovaErrorCode;
		obj.message_id_sys = ovaErrorCode;
		this._objErrorInfo._obException.message = '';
		this._objErrorInfo._fetcherName = ob.urlFetch;
		if (ob.urlFetch
				.indexOf("/ovaServices/cartadicredito/CartadiCreditoFetcher") != -1
				|| ob.urlFetch
						.indexOf("/ovaServices/sunriseaccount/SetSunriseAccountFetcher") != -1) {
			var urlFetchSplitted = ob.urlFetch.split('?');
			this._objErrorInfo._fetcherName = urlFetchSplitted[0];
		}
		this.sendErrorTrap(obj.message_id);
		/***********************************************************************
		 * Siamo nel caso di un errore ritornato da un fetcher.In un array ,in
		 * cui ogni elemento corrisponde altipo di la gestione prevista per un
		 * fetcher.La gestione puo' essere di due tipi:callback o sielent.Nel
		 * primo caso si forza a tornare alla callback del fetcher,nel secondo
		 * caso non si fa nulla.Quest'ultima gestione � tipica dei fetcher
		 * alcatel
		 **********************************************************************/
		var urlFetchSplitted = ob.urlFetch.split('?');
		var urlFetchIndex1 = urlFetchSplitted[0].split('/ovaServices/'); // questo
																			// lo
																			// facciamo
																			// per
																			// escludere
																			// eventuali
																			// path
		var urlFetchIndex = ""; // che precedono ovaServices.ESEMPIO in
								// cartaDiCredito
		if (urlFetchIndex1.length == 1) {
			urlFetchIndex1 = urlFetchSplitted[0].split('_');
			urlFetchIndex = urlFetchIndex1[0];
		} else {
			urlFetchIndex = '/ovaServices/' + urlFetchIndex1[1]; // https:/../ovaServices/...
		}
		/*
		 * Per esempio nel file RetrieveUserCredentials.html viene settato un
		 * errore, quindi che non dipernde dal fetcher, ma viene settato ed
		 * eseguito la callback
		 */
		if (this.matriceFetcher && this.matriceFetcher[urlFetchIndex]
				&& this.matriceFetcher[urlFetchIndex].actionTodo == 'callback') {
			ob.data = new Object();
			ob.data.errorCode = obj.message_id;
			/*
			 * Nel caso RetrieveUserCredentials.html esiste la callback, quindi
			 * entra
			 */
			if (ob.callback) {
				// top.getFetcher().sendDebugTrap("Ci sono");
				ob.callback.apply(ob.callerObj, [ ob.data ]);
			}
		} else if (this.matriceFetcher && this.matriceFetcher[urlFetchIndex]
				&& this.matriceFetcher[urlFetchIndex].actionTodo == 'sielent') {
			return true;
		} else if (urlFetchIndex.indexOf("EPGGridConfig")) {
			// nel caso in cui vada in errore il fetcher EPGGridConfig nella
			// startApp
			this._gotEpgConfiguration();
		} else if (ovaErrorCode = 'OVA-105') {
			// caso errore 105 per BookMarkResumePos.jsp: da capire bene il
			// comportamento di questo fetcher
			return true;
		} else {
			// per il fecther non � prevista nessuna gestione particolare.
			this.showErrorPage(obj.message_id);
		}
	}
	return true;
};

BaseApp.prototype.creaMatriceFetcher = function() {
	try {
		obj = new Object();
		obj.errorHandling = true;
		obj.actionTodo = 'callback';
		this.matriceFetcher['/ovaImages/GetChannelList_'+this.fw.regioneCanaliDefault+'.html'] = obj;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'creaMatriceFetcher';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/* Esmepio di chiamata: loadApp("/ovaServices/getapp/HomeTvApp.html",null); */
BaseApp.prototype.loadApp = function() {
	try {
		this._arguments = arguments; // valorizzo la variabile con i
										// arguments

		if ((this._arguments)
				&& (this._arguments[0] == "/ovaServices/getapp/GetApp.html"))
			this.fw.getAppManager().flushBack();

		/* entra */
		if (this._arguments)
			this.accessLoadApp(this._arguments[0]);
		/* top.getFetcher().sendDebugTrap("Ci sono"); */
		// contollo per evitare chiamate multiple
		/* entra */

		if (this.accessFlag == true) {
			this.loadHtml(this._arguments);
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'loadApp';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.accessLoadApp = function(arg) {
	try {
		if (this._timerAcces)
			this.fw.getTimer().clearTimeout(this._timerAcces);

		if (arg == this.prew_url) {
			this.accessFlag = false;
		} else {
			this.accessFlag = true;
		}

		this.prew_url = arg;
		this._timerAcces = this.fw.getTimer().setTimeout(1000,
				this.enableAccess, this);

	} catch (ecc) {
		this._objErrorInfo._methodName = 'accessLoadApp';
		this._objErrorInfo._obException = ecc;
	}
};

BaseApp.prototype.enableAccess = function() {
	try {
		this.fw.getTimer().clearTimeout(this._timerAcces);
		this.prew_url = "";
		this.accessFlag = true;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'enableAccess';
		this._objErrorInfo._obException = ecc;
	}
	return true;
};

// chiamata alla loadApp di ovaAppManager
BaseApp.prototype._loadApp = function() {
	try {
		// this.fw.App.debugLog("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$");
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("BaseApp._loadAPP _arguments: " + this._arguments[0]);
		this.fw.getAppManager().loadApp.apply(this.fw.getAppManager(),
				this._arguments);
		// top.getFetcher().sendDebugTrap("Ci sono: "+this.fw.getAppManager());
	} catch (ecc) {
		if (this._arguments.length > 0) {
			// this.fw.LoggerApp.debugLog("methodName:_loadApp-numParam:"+this._arguments.length+"-args[0]:"+this._arguments[0]);
		}
		this._objErrorInfo._methodName = '_loadApp';
		this._objErrorInfo._obException = ecc;
		// this.handleError();
	}
	return true;
};

/*
 * Esempio di chiamata da loadApp con
 * ("/ovaServices/getapp/HomeTvApp.html",null);
 */
BaseApp.prototype.loadHtml = function(arg) {
	try {
		/* nel caso homeTvApp ritorna null null, quindi entra */
		var arrayLayout = this.getHtml(arg);
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("BaseApp.prototype.arrayLayout " + arrayLayout[0]);
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("BaseApp.prototype.arrayLayout " + arrayLayout[1]);
		if (arrayLayout[0] == null && arrayLayout[1] == null) // per le js che
																// non usano il
																// layout
																// ottimizzato
		{

			this._loadApp();
		} else {
			this.layoutManager = this.fw.getLayoutManager().getLayout(
					arrayLayout[0]);
			var url_frame = arrayLayout[1];
			var lun = this.layoutManager.document.location.href.length;
			if (this.layoutManager.document.location.href.slice(lun
					- url_frame.length) == arrayLayout[1]) {
				this._loadApp();
			} else {
				if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("BaseApp.loadHtml  href = " + arrayLayout[1]);
				this.layoutManager.document.location.href = arrayLayout[1];
			}
		}

	} catch (ecc) {
		if (arg.length > 0) {
			this.fw.LoggerApp
					.debugLog("Eccezione methodName:loadHtml-numParam:"
							+ arg.length + "-args[0]:" + arg[0]);
		}
		this._objErrorInfo._methodName = 'loadHtml';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.getHtml = function(arg) {
	try {
		var platformType = this.fw.getAppManager()._path;
		var urlApp = arg[0]; // url dell'applicazione
		// splittare la urlApp passata fino ad ottenere il nome della js
		var appname = "";
		var retArray = new Array();
		var temp = urlApp.split("app1=");
		var lung = temp.length;
		if (lung > 1) {
			var temp2 = temp[1].split("&");
			appname = temp2[0];
		} else {
			if (lung == 1) {
				appname = temp[0];
			}
		}

		switch (appname) {

		case 'HomeImpostazioniApp':
			var platformType = this.fw.getAppManager()._path;
			if (platformType == "pirelli_dtt") {
				retArray[0] = "homeImpostazioniDTTLayout";
				retArray[1] = "/ovaUI/" + platformType
						+ "/impostazioni/homeImpostazioniDTTLayout.html";
			} else {
				retArray[0] = "homeImpostazioniLayout";
				retArray[1] = "/ovaUI/" + platformType
						+ "/impostazioni/homeImpostazioniLayout.html";
			}
			break;

		case 'ScanDTTSettingsApp':
			retArray[0] = "ScanDTTSettingsLayout";
			retArray[1] = "/ovaUI/" + platformType
					+ "/impostazioni/ScanDTTSettingsLayout.html";
			break;
		case 'ScanDTTSettingsVirginApp':
			retArray[0] = "ScanDTTSettingsLayout";
			retArray[1] = "/ovaUI/" + platformType
					+ "/impostazioni/ScanDTTSettingsVirginLayout.html";
			break;
		case 'ScanDTTApp':
			retArray[0] = "popupStarted";
			retArray[1] = "/ovaUI/" + platformType + "/sport/popupStarted.html";
			break;

		case 'ScanDTTSettingApp':
			retArray[0] = "popupStarted";
			retArray[1] = "/ovaUI/" + platformType + "/sport/popupStarted.html";
			break;

		case 'EnableDTTSettingsApp':
			retArray[0] = "EnableDTTSettingsLayout";
			retArray[1] = "/ovaUI/" + platformType
					+ "/impostazioni/EnableDTTSettingsLayout.html";
			break;

		case 'ConfermaDTTApp':
			retArray[0] = "confermaDTTLayout";
			retArray[1] = "/ovaUI/" + platformType
					+ "/impostazioni/confermaDTTLayout.html";
			break;

		case 'PreferitiApp':
			retArray[0] = "PreferitiLayout";
			retArray[1] = "/ovaUI/" + platformType
					+ "/impostazioni/PreferitiLayout.html";
			break;
			
		case 'ModificaCanali':
			retArray[0] = "ModificaCanaliLayout";
			retArray[1] = "/ovaUI/" + platformType
					+ "/impostazioni/ModificaCanaliLayout.html";
			break;

		/** ********************** TiLab ********************* */
		case 'ImpostazioniSTBApp':
			retArray[0] = "impoTVLayout";
			retArray[1] = "/ovaUI/" + platformType
					+ "/impostazioni/impoTVLayout.html";
			break;
		/** ********************** fine TiLab ********************* */

		case 'DTTConfermaApp':
			retArray[0] = "dttConfermaLayout";
			retArray[1] = "/ovaUI/" + platformType
					+ "/impostazioni/dttConfermaLayout.html";
			break;

		case 'HelpRemoteControllerAppRes':
		case 'HelpInstallationAppRes':
		case 'HelpProblemSolveAppRes':
		case 'HelpPreferiti':
		case 'AiutoPreferiti':
			retArray[0] = "HelpAppLayoutRes";  
			retArray[1] = "/ovaUI/"+ platformType +"/help/HelpLayoutRes.html";        
			break;
		default: // per le js che non usano il layout ottimizzato
			retArray[0] = null;
			retArray[1] = null;
			break;
		}		
		return retArray;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'getHtml';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/** **************** inizio TiLab ********************** */
BaseApp.prototype.leggiUsb = function() {
	try {
		return navigator.getUsbData();
	} catch (ecc) {
		this._objErrorInfo._methodName = 'leggiUsb';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
}
BaseApp.prototype.leggiListaPush = function() {
	try {
		return navigator.getListaPush();
	} catch (ecc) {
		this._objErrorInfo._methodName = 'leggiListaPush';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
}

BaseApp.prototype.montaUsb = function() {
	try {
		navigator.montaUsb();
	} catch (ecc) {
		this._objErrorInfo._methodName = 'montaUsb';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
}
BaseApp.prototype.smontaUsb = function() {
	try {
		navigator.smontaUsb();
	} catch (ecc) {
		this._objErrorInfo._methodName = 'smontaUsb';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
}
BaseApp.prototype.getPushObj = function(idObj) {
	try {
		return navigator.getPushObj(idObj);
	} catch (ecc) {
		this._objErrorInfo._methodName = 'getPushObj';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
}
/** **************** fine TiLab ********************** */

BaseApp.prototype.eventDTTScanComplete = function() {
	try {
		this.fw.lastScanSession = this.fw.getOSD().getTime();
		this.refreshZapper(true);
		this.trapServiceList();
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventDTTScanComplete";
		this._objErrorInfo._obException = ecc;
	}
};
BaseApp.prototype.trapServiceList = function() {
	try {

		this.fw.LoggerApp.serviceList_info();
	} catch (ecc) {
		this._objErrorInfo._methodName = 'trapServiceList';
		this._objErrorInfo._obException = ecc;

	}
	return true;
};

BaseApp.prototype.suspendTimer = function() {
	try {
		if (this.fw.epgGrid_Timer)
			this.fw.getTimer().clearTimeout(this.fw.epgGrid_Timer);
		if (this.fw._NewsTimer)
			this.fw.getTimer().clearTimeout(this.fw._NewsTimer);
	} catch (ecc) {
		this._objErrorInfo._methodName = 'suspendTimer';
		this._objErrorInfo._obException = ecc;
		this.handleError();

	}
	return true;
};

/* Inizialmente highPriority vale true */
BaseApp.prototype.epgGridFetch = function(highPriority) {
	try { /* Da index.html RELOAD_EPGGRID_INTERVAL: '120' */
		this.time_epgGridFetch = (this.fw.getConfig().RELOAD_EPGGRID_INTERVAL != null) ? (parseInt(this.fw
				.getConfig().RELOAD_EPGGRID_INTERVAL) * 60 * 1000)
				: 7200000;

		var dnow = new Date(this.fw.getOSD().getTime());

		var giornoS = "" + dnow.getUTCDate();
		if (giornoS.length == 1) {
			var giorno = "0" + giornoS;
		} else {
			var giorno = giornoS;
		}

		var meseS = "" + (dnow.getUTCMonth() + 1);
		if (meseS.length == 1) {
			var mese = "0" + meseS;
		} else {
			var mese = meseS;
		}

		var anno = dnow.getUTCFullYear();

		var oggi = anno + mese + giorno;
		/* Se commento da qui in poi non parte */
		this.fw.getEventManager().handleEvent("eventGotEpgConfiguration");
		if (this.fw.epgGrid_Timer)
			this.fw.getTimer().clearTimeout(this.fw.epgGrid_Timer);
		this.fw.epgGrid_Timer = this.fw.getTimer().setTimeout(
				this.time_epgGridFetch, this.epgGridFetch, this);
		this.fw.arrTimer[3] = this.fw.epgGrid_Timer;// memorizza ID del timer in
													// un array

	} catch (ecc) {
		this._objErrorInfo._methodName = 'epgGridFetch';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;

};

BaseApp.prototype.goToHomePage = function(sectionId) {
	try {
		if (this.fw.zappingArray[this.fw._currIndexForZapping].ZappingId)
			this
					.setIndexForZapping(this.fw.zappingArray[this.fw._currIndexForZapping].ZappingId);

		this.loadApp("/ovaServices/getapp/GetApp.html", sectionId, null, null, null);
	} catch (ecc) {
		this._objErrorInfo._methodName = 'goToHomePage';
		this._objErrorInfo._obException = ecc;
		this.handleError();

	}
	return true;
};

// se dtt_refresh � passato false o non passato: aggiorna la consistenza dei
// canali e la struttura Zapping
// se dtt_refresh � passato a true: evita di aggiornare la consistenza dei
// package e aggiorna solo
// la struttura Zapping (per incloudere i nuovi canli DTT locali)
BaseApp.prototype.refreshZapper = function(dtt_refresh) {
	try {
		if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("###### BaseApp.refreshZapper ## 1 ##  this.fw.ListaFavoriti:"+ this.fw.ListaFavoriti.length);
	
		
		
		this.refreshZapperLocalDTT();

	
	} catch (ecc) {
		var reasonCode = "zapperNotChanged";
		// si lancia l'evento che ci indica la fine dell'elaborazione del
		// refresh
		this.fw.getEventManager().handleEvent("eventZapperChanged", reasonCode);

		this._objErrorInfo._methodName = 'refreshZapper';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

// filtra via i package in cosistenza che non sono previsti nello zapper
// per il filtro usa un parametro in input che contiene tutti i package che
// entrano nello zapper
// il secondo parametro indica i pacchetti in consistenza dell'utente che
// derivano da un api del fw (createZapper)
// oppure dai dati restituiti dal fetcher GetAccount (refreshZapper)
BaseApp.prototype.getNormalizedPackages = function(packageToNormalize) {
	try {
		// solo la prima volta invocando il getNormalizedPackages senza
		// parametri uso la API del framework
		if (!packageToNormalize) {
			packageToNormalize = this.fw.getUserInfo().getPackages();
		}

		var SEP = "|";
		// filtra via i package che non fanno parte dello zapping: serve per
		// costruire la prima volta la matrice di consistenza

		var packageForZappingString = this.fw.getConfig().ALL_PACKAGES;

		var packageList = new Array();
		var index = 0;
		for (i = 0; i < packageToNormalize.length; i++) {
			if (packageForZappingString.indexOf(packageToNormalize[i] + SEP) != -1) {
				packageList[index] = packageToNormalize[i];
				index++;
			}
		}
		return packageList;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'getNormalizedPackages';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

// se chiamata senza parametro ti restituisce l'elemento zapper corrente
// se chiamata con parametro zappingId restituisce l'elmento dello zapper
// corrispondente allo zappingId passato
// se non esiste tale canale restituisce null;
BaseApp.prototype.getZapperElement = function(zappingId) {
	try {

		zapperElement = null;
		if (zappingId) { // se � passato uno specifico zappinId
			// verifica se esiste un canale associato

			if (this.fw.inverseZapper[zappingId] >= 0) {
				zapperElement = this.fw.zapper[this.fw.inverseZapper[zappingId]];
			}
		} else { // prende il canale corrente

			zapperElement = this.fw.zapper[this.fw._currIndexForZapper];
		}

		return zapperElement;

	} catch (ecc) {
		this._objErrorInfo._methodName = 'getZapperElement';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// Metodo che restituisce l'elemento successivo dello zapper
// senza effettuare alcuna jump a canale.
BaseApp.prototype.getNextZapperElement = function() {
	try {
		var zapperElement = null;
		var indice = this.fw._currIndexForZapper + 1;
		// se sto sull'ultimo elemento restituisco il primo
		if (indice >= this.fw.zapper.length) {
			zapperElement = this.fw.zapper[0];
		} else {
			zapperElement = this.fw.zapper[indice];
		}
		return zapperElement;

	} catch (ecc) {
		this._objErrorInfo._methodName = 'getNextZapperElement';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// metodo che restituisce l'elemento di zapper precedente
// senza effettuare la jump al canale
BaseApp.prototype.getPrevZapperElement = function() {
	try {
		var zapperElement = null;
		var indice = this.fw._currIndexForZapper - 1;
		// se sto sul primo restituisco l'ultimo
		if (indice < 0) {
			zapperElement = this.fw.zapper[this.fw.zapper.length - 1];
		} else {
			zapperElement = this.fw.zapper[indice];
		}
		return zapperElement;

	} catch (ecc) {
		this._objErrorInfo._methodName = 'getPrevZapperElement';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// restituisce la matrice di zapper
BaseApp.prototype.getZapper = function() {
	try {
		return this.fw.zapper;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'getZapper';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// restituisce la matrice di zapper
BaseApp.prototype.setZapperSaved = function(zapper) {
	try {
		this.fw.zapperSaved = zapper;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'setZapperSaved';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// restituisce la matrice di zapper
BaseApp.prototype.getZapperSaved = function() {
	try {
		return this.fw.zapperSaved;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'getZapperSaved';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// restituisce la matrice di zapper
BaseApp.prototype.getPreferiti = function() {
	try {
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger
					.addEntry("BaseApp.getPreferiti this.fw.ListaFavoriti.length:"
							+ this.fw.ListaFavoriti.length);
		return this.fw.ListaFavoriti;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'getFavoriti';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

BaseApp.prototype.getPenultimoZappingId = function() {
	try {

		return this.fw.penultimoZappingId;

	} catch (ecc) {
		this._objErrorInfo._methodName = 'getPenultimoZappingId';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// salta al canale corrispodente allo zappingId
// se lo zappingId non � passato: salta all'ultimo canale registrato e se tale
// canale non � valido
// non esegue alcuna operazione
// se un canale non � in consistenza si tratta di un canale di sky e quindi si
// avvia la pagina di acquisto
BaseApp.prototype.jumpToChannelByZappingId = function(zappingId,
		holdPrevChannel) {
	
	try {
		this.attivaSepg = true;
		/* caso homeTvApp, entra */
		if (this.fw.skyPopupStatus == null
				|| this.fw.skyPopupStatus == undefined
				|| this.fw.skyPopupStatus != 0) {
			
			this.fw.skyPopupStatus = 0;
			var currApp = this.fw.getAppManager().getCurrentAppUrl();
			
		}

		// solo nel caso di scrollUp e scrollDown non deve essere memorizzato il
		// precedente perche gi� aggiornato
		/* caso homeTvApp, entra */
		if (!holdPrevChannel) {

			/* imposta il penultimo zappingid */
			this.fw.penultimoZappingId = this.fw.zappingArray[this.fw._currIndexForZapping].ZappingId;
		}
		// in ogni caso se c'� un canale attuale ed � sky
		// torno a no sottotitoli e lingua italiana
		/* caso homeTvApp, non entra */
		if (this.fw.getBTVTuner().getActive() == true) {

			this.ripristinaSottotitoli_Audio(this.getZapperElement());
		}

		/* caso homeTvApp, non entra */
		if (zappingId) { // se non viene passato il parametro si fa la jump
							// al canale corrente

			chanIndex = this.fw.inverseZappingArray[zappingId]; // recupero la
																// posizione del
																// canale nella
																// matrice di
																// zapping
			// attravero l'hash table inversa (con chiave zappingId)
			this._epg = this.fw.getBTVTuner().getEPG();

			// Vedo se il programma schedulato ha una label visibile dall'utente
			var chanZapperIndex = this.fw.inverseZapper[zappingId];
			var chanZapperId = this.fw.zapper[chanZapperIndex].chanrecid;
			var epgSlot = new Object();
			epgSlot = this.getProgramSlot3(chanZapperId);

			if (epgSlot && epgSlot.program) {
				this.currentProgram = epgSlot.program;
				if (this.currentProgram
						&& (this.currentProgram.type == "PPV")
						&& (this
								.chanTypeZapper(this.fw.zapper[chanZapperIndex]) == 'sky')) {
					this.isVisible = this.isPPVSkyVisible(this.currentProgram,
							chanIndex);
				} else {
					this.isVisible = true; // se non � sky o non � un ppv �
											// sempre visibile
				}
			} else {
				this.currentProgram = null;
				this.isVisible = true; // se non ho schedulazione posso vedere
										// il contenuto
			}

			this._zapperInconsistente = false; // variabile che indica se ci
												// troviamo sintonizzati
			// con zapper su di un canale non in consistenza

			if (chanIndex >= 0 && this.isVisible == true) {

				// per canali in consistenza
				// faccio la jump al canale con aggiornamento zapping
				// aggiorno l'indice per lo zapping lineare
				this.fw._currIndexForZapping = chanIndex;
				this.sepgIndex = this.fw._currIndexForZapping;
				// rinfresca l'indice per lo zapper lineare

				this.fw._currIndexForZapper = this.fw.inverseZapper[zappingId];

				this.sepgIndex2 = this.fw._currIndexForZapping;
				var chanId = this.fw.zappingArray[this.fw._currIndexForZapping].chanrecid;
				
				if (this.fw._currIndexForZapping == 'undefined'
						|| this.fw._currIndexForZapping == null) {
					// se per qualunque motivo l'indice non � definito
					
					chanId = this.fw.zappingArray[0].chanrecid;
				}
				
				this.jumpToChannelByRecid(chanId);
				this.fw.getBTVTuner().setActive(true);
			} else if ((this.isVisible == true) && (this.currentProgram)
					&& (this.currentProgram.type == "PPV")) {

				// Il canale ha una label visibile dall'utente e il programma
				// schedulato � un PPV
				// faccio la jump senza aggiornare l'indice di zapping ma solo
				// quello dello zapper

				this.fw._currIndexForZapper = this.fw.inverseZapper[zappingId];

				this._zapperInconsistente = true;
				
				this.jumpToChannelByRecid(chanZapperId);
				this.fw.getBTVTuner().setActive(true);
			} else { // non � un canale in consistenza o non � un programma
						// visibile
				if (!chanIndex) { // canale non in consistenza vado
									// direttamente su home sky

					if (this.gestioneRetailAttiva()) { // gestione con popup

						this.fw.ratingCheckBTV = false; // non faccio il
														// controllo sul
														// parental control se
														// vado in schermo nero
						// questa variabile viene ripristinata dalla
						// jumpToChannelByRecId a true
						this.fw._currIndexForZapper = this.fw.inverseZapper[zappingId];

						this._zapperInconsistente = true;
						// faccio la jump su schermo nero
						
						this.jumpToChannelByRecid(chanZapperId);
						this.fw.getBTVTuner().setActive(true);

						// visualizzo popup di cortesia a video
						if (this.fw.getAppManager().getCurrentAppUrl().indexOf(
								"HomeTvApp") != -1) {
							if (this.fw.isSkyRetailUser == true) {
								this.fw.skyPopupStatus = 1;
							} else {
								this.fw.skyPopupStatus = 2;
							}
							this.takeInfoSEPG();
							this.creaInfoSlot();
						}
					} else { // vecchia gestione con pagina di acquisto sky
								// (solo se no skyRetailUser e no Retail Enable)


						this.fw._currIndexForZapper = this.fw.inverseZapper[zappingId];

						this
								.loadApp(
										"/ovaServices/getapp/GetApp.html",
										this.fw.zapper[this.fw._currIndexForZapper].skyType,
										this.fw._currIndexForZapper);
					}
				} else { // programma non visibile, vado su schermo nero e
							// popup

					this.fw.ratingCheckBTV = false; // non faccio il controllo
													// sul parental control se
													// vado in schermo nero

					this.fw._currIndexForZapper = this.fw.inverseZapper[zappingId];

					if (chanIndex >= 0) {
						// se il canale � in consistenza devo aggiornare anche
						// l'indice di zapping
						this.fw._currIndexForZapping = chanIndex;
					}
					// faccio la jump su schermo nero
					
					this.jumpToChannelByRecid(chanZapperId);
					this.fw.getBTVTuner().setActive(true);

					// visualizzo popup di cortesia a video
					var nomeCanale = ""; // nome del canale
					if (this.getZapperElement(zappingId)) {
						nomeCanale = this.getZapperElement(zappingId).ChanName;
					}
					var nomePacchettoDb = ""; // nome del pacchetto sul db
					if (this.currentProgram && this.currentProgram.episode) {
						nomePacchettoDb = this
								.getPacketNamePPVSky(this.currentProgram.episode);
					}
					var nomePacchetto = nomePacchettoDb;
					this._msgPopUpSky = this.costruisciMsgPopupSky(nomeCanale,
							nomePacchetto);
					if (this.fw.getAppManager().getCurrentAppUrl().indexOf(
							"HomeTvApp") != -1) {
						if (this.fw.isSkyRetailUser == true) {
							this.fw.skyPopupStatus = 3;
						} else {
							this.fw.skyPopupStatus = 4;
						}
						this.takeInfoSEPG();
						this.creaInfoSlot();
					}
				}
			}
		} else { // in caso non � fornito lo zappingId si aggancia all'ultimo
					// canale (sempre che sia valido altrimenti non fa
			// nulla)

			// faccio il controllo se il canale � DVBT di modo che se non �
			// stato
			// scannerizzato non viene joinato e aggiorna il current zapping
			/* ritorna true, ma non fa niente perchè channel(in EPG) è null */
			this.checkDVBTScanned();
			if (this.fw.zappingArray[this.fw._currIndexForZapping].chanrecid) {
				/* non entro */
				if (this.fw._currIndexForZapping == 'undefined'
						|| this.fw._currIndexForZapping == null) {
					// top.getFetcher().sendDebugTrap("Ci sono2: ");
					this.fw._currIndexForZapping = 0 // canale non valido e
														// mi aggancio al primo
					// top.getFetcher().sendDebugTrap("Ci sono3: ");
				}
				this
						.jumpToChannelByZappingId(
								this.fw.zappingArray[this.fw._currIndexForZapping].ZappingId,
								true);
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'jumpToChannelByZappingId';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	
	return true;
};

// Metodo che effettua la jump al canale successivo
BaseApp.prototype.nextZapperChannel = function() {
	try {

		this.fw.penultimoZappingId = this.fw.zappingArray[this.fw._currIndexForZapping].ZappingId;
		
		this.fw._currIndexForZapper++;
		if (this.fw._currIndexForZapper >= this.fw.zapper.length) { // se sto
																	// all'ultimo
																	// vado al
																	// primo
			this.fw._currIndexForZapper = 0;
		}
		this.jumpToChannelByZappingId(
				this.fw.zapper[this.fw._currIndexForZapper].ZappingId, true);
	} catch (ecc) {
		this._objErrorInfo._methodName = 'nextZapperChannel';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// metodo che effettua l'aggancio al canale fruibile successivo
BaseApp.prototype.nextZappingChannel = function(withJump) {
	try {
		if (withJump) {
			this.fw.penultimoZappingId = this.fw.zappingArray[this.fw._currIndexForZapping].ZappingId;

			if (this._zapperInconsistente == true) {
				this.findNextZappingId();
				this._zapperInconsistente = false;
			} else {
				this.fw._currIndexForZapping++;
				if (this.fw._currIndexForZapping >= this.fw.zappingArray.length) { // se
																					// sto
																					// alla
																					// fine
																					// vado
																					// all'inizio
					this.fw._currIndexForZapping = 0;
					this.fw._currIndexForZapper = 1;
				}
			}

			// setto la variabile per la visualizzazione della sepg
			this.attivaSepg = true;
			this
					.jumpToChannelByZappingId(
							this.fw.zappingArray[this.fw._currIndexForZapping].ZappingId,
							true);
		} else {
			if (this.sepgIndex < this.fw.zappingArray.length - 1) {
				this.sepgIndex++;
			} else {
				this.sepgIndex = 0;
			}
			this.takeInfoSEPG(this.fw.zappingArray[this.sepgIndex].ZappingId);
			this.creaInfoSlot();

		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'nextZappingChannel';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// Metodo che effettua la jump al canale successivo
BaseApp.prototype.prevZapperChannel = function() {
	try {

		this.fw.penultimoZappingId = this.fw.zappingArray[this.fw._currIndexForZapping].ZappingId;

		
		this.fw._currIndexForZapper--;
		
		if (this.fw._currIndexForZapper <= 0) { // se sto allinizio vado alla
												// fine
			this.fw._currIndexForZapper = this.fw.zapper.length - 1;
			
		}
		this.jumpToChannelByZappingId(
				this.fw.zapper[this.fw._currIndexForZapper].ZappingId, true);
	} catch (ecc) {
		this._objErrorInfo._methodName = 'prevZapperChannel';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// metodo che effettua l'aggancio al canale fruibile precedente
BaseApp.prototype.prevZappingChannel = function(withJump) {
	try {
		if (withJump) {
			this.fw.penultimoZappingId = this.fw.zappingArray[this.fw._currIndexForZapping].ZappingId;

			if (this._zapperInconsistente == true) {
				this.findPrevZappingId();
				this._zapperInconsistente = false;
			} else {
				this.fw._currIndexForZapping--;
				if (this.fw._currIndexForZapping < 0) { // se sto all'inizio
														// vado alla fine
					this.fw._currIndexForZapping = this.fw.zappingArray.length - 1;
				}
			}
			this.attivaSepg = true;
			this
					.jumpToChannelByZappingId(
							this.fw.zappingArray[this.fw._currIndexForZapping].ZappingId,
							true);

		} else {

			if (this.sepgIndex > 0) {
				this.sepgIndex--;
			} else {
				this.sepgIndex = this.fw.zappingArray.length - 1;
			}

			this.takeInfoSEPG(this.fw.zappingArray[this.sepgIndex].ZappingId);
			this.creaInfoSlot();
		}

	} catch (ecc) {
		this._objErrorInfo._methodName = 'prevZappingChannel';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// verifica se c'e' stato un cambiamento nei pacchetti di zapper dell'utente
BaseApp.prototype.testNewPackages = function(oldPackageList, packageList) {
	var test = true;
	try {
		var SEP = "|";
		if (oldPackageList != null && packageList != null) {
			if (oldPackageList.length != packageList.length) {
				test = true;
			} else { // se hanno la stessa lunghezza non � detto che siano
						// uguali
				// (es: tolgo un package x e aggiungo un package y allo stesso
				// utente con webcam)
				// sorto le strutture in modo che sia possibile utilizzare una
				// semplice comparazione di stringhe
				function sortNumber(a, b) {
					return a - b;
				}
				packageList = packageList.sort(sortNumber);
				oldPackageList = oldPackageList.sort(sortNumber);

				var packageString = packageList.join(SEP) + SEP;
				var packageString_old = oldPackageList.join(SEP) + SEP;
				test = !(packageString == packageString_old);
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'testNewPackages';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}

	return test;
};

// aggiorna lo stato dei canali dtt locali e ricostruisce l'oggetto Zapping
BaseApp.prototype.refreshZapperLocalDTT = function() {
	try {
		
		if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("### BaseApp.refreshZapperLocalDTT ## 1 ##  this.fw.ShowPreferiti:"+ this.fw.ShowPreferiti+ " [1]-preferiti ; [0]default");
		var LOCAL_DTT_START_INDEX = (this.fw.getConfig().LOCAL_DTT_START_INDEX == null) ? 9
				: this.fw.getConfig().LOCAL_DTT_START_INDEX;
		//if(this.fw.ORDINAMENTO_CANALI_FATTO)
		//	LOCAL_DTT_START_INDEX = this.fw.zapper.length+1;
		
		if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("### BaseApp.refreshZapperLocalDTT ## 2 ##  LOCAL_DTT_START_INDEX:"+ LOCAL_DTT_START_INDEX);
		var firstLocalDTTindexForZapper = this.fw.inverseZapper[LOCAL_DTT_START_INDEX];// prende
																						// l'indice
																						// del
																						// primo
																						// canale
		
																						// locale
		if (!firstLocalDTTindexForZapper){// se non sono mai stati creati
											// canali DTT locali: accoda alla
											// fine dell'array
			firstLocalDTTindexForZapper = this.fw.zapper.length;
		
		}
		var tempCurrentZappingId = 1;
		try{
			tempCurrentZappingId = this.fw.zapper[this.fw._currIndexForZapper].ZappingId;
		}catch(e){
			//tempCurrentZappingId = LOCAL_DTT_START_INDEX;
			omc.logger.addEntry("Eccezione BaseApp.refreshZapperLocalDTT :"+e.message);
		}
	
		// numero dei canali DTT locali dal precedente aggiornamento (se � la
		// prima volta vale 0)
		var number_oldLocalDTTChannel = this.fw.zapper.length - firstLocalDTTindexForZapper;
		
		var dttLocalChannels = null;

		// accoda all'array di zapper i canali dtt locali
		if (this.isDTTEnabled()) { // postScan serve per non effettuare il
									// refresh dtt la prima volta
			// infatti bisogna prima fare la scansione dei canali digitali
			// dttLocalChannels=this.fw.getDTT().getChannels();
			dttLocalChannels = this.fw.getDTT().getLocalChannels();
		
		}
		if (dttLocalChannels == null) {
			dttLocalChannels = new Array();
			
		}

		var indexInvZapper = firstLocalDTTindexForZapper;
		
		//if(this.fw.ORDINAMENTO_CANALI_FATTO)
		//	indexInvZapper = this.fw.zapper.length+1;

		var indx_local = 0;					
	
		if (this.fw.ShowPreferiti == 0  || this.fw.BOOT){			
			if(this.fw.OMC_LOGGER_ENABLED)
				omc.logger.addEntry("##########   BaseApp AGGIUNGO CANALI DTT ##################################################");
			for (i = 0; i < dttLocalChannels.length; i++) {
				// da filtrare come in menuApp
				// si filtra solo per il service_type 1 e 2. In oltre se il DTT
				// non � abilitato non viene
				// elaborata la matrice di zapping
				/* Qui entra */
				if ((dttLocalChannels[i].service_type == 1 || dttLocalChannels[i].service_type == 2)) {
					// top.getFetcher().sendDebugTrap("Ci sono");
					var messageId = "CH_" + dttLocalChannels[i].url;
					messageId = messageId.replace(/\./g, '_');

					if (eval("this.fw.getConfig()." + messageId + "==null")) {
						channel = dttLocalChannels[i];
						var nomeCanaleLocale = channel.callLetters;
						//if(nomeCanaleLocale.length > 25)
						//	nomeCanaleLocale = nomeCanaleLocale.substring(0,25);
						
						this.fw.zapper[indexInvZapper] = new Object();
						this.fw.zapper[indexInvZapper].chanrecid = channel.recid;
						this.fw.zapper[indexInvZapper].chanSection = "local";
						this.fw.zapper[indexInvZapper].pkgrecid = channel.pkgrecid;
						this.fw.zapper[indexInvZapper].ChanName = nomeCanaleLocale;
						this.fw.zapper[indexInvZapper].chanType = dttLocalChannels[i].chanType;
						this.fw.zapper[indexInvZapper].ZappingId = parseInt(LOCAL_DTT_START_INDEX)
								+ parseInt(indx_local);
						this.fw.zapper[indexInvZapper].status = true;
						this.fw.inverseZapper[LOCAL_DTT_START_INDEX + i] = indexInvZapper;
						this.fw.zapperChanrecid[this.fw.zapper[indexInvZapper].chanrecid] = indexInvZapper;
						indexInvZapper++;
						indx_local++;
					}
				}
			}
			//this.fw.AGGIUNTI_CANALI_DTT_LOC = true;
			this.fw.BOOT = false;
		}
		
		try {
		
			var firstWrongDTTChannel = number_oldLocalDTTChannel
					- dttLocalChannels.length;
			if (firstWrongDTTChannel > 0) { // se i canali local dtt sono
											// diminuiti
				// occorre eliminare elementi errati di zapper/zapping
				if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("### BaseApp.refreshZapperLocalDTT sono diminuiti i canali dtt -> elimino gli elementi dagli oggetti zapper/zapping : "+firstWrongDTTChannel);
		
				for (i = 0; i < firstWrongDTTChannel; i++) {
					// sfruttando il fatto che i canali dtt locali sono sempre
					// in coda agli array:
					// pop elimina l'ultimo elemento di un array e quindi
					// elimino a ritroso fino a primo elmento da conservare
					this.fw.inverseZapper.pop();
					this.fw.zapper.pop();
					this.fw.zappingArray.pop();
					this.fw.inverseZappingArray.pop();
				}
			}
		} catch (e) {

		}
		// ricostruisce l'oggetto Zapping
		this.fw.zappingArray = new Array(); // array da 0 a n contenente tutti
											// gli oggetti zapping in
											// consistenza
		this.fw.inverseZappingArray = new Array(); // array dal minimo
													// ZappingId al massimo
													// ZappingId che mappano
													// agli indici dell'array di
													// sopra
		this.fw.inverseZapper = new Array();
		this.fw.zapperChanrecid = new Array(); // hash table con chiave il chan
												// recid e restituisce l'indice
												// dell'array di zapper
		var zappingIndx = 0;
		for (i = 0; i < this.fw.zapper.length; i++) {
			//omc.logger.addEntry("AGGIUNGO CANALE :"+this.fw.zapper[i].ChanName+" status: "+this.fw.zapper[i].status);
			if (this.fw.zapper[i].status) { // in consistenza
				// costruisce matrice zapping e matrice inversa zapping
				this.fw.zappingArray[zappingIndx] = new Object();
				this.fw.zappingArray[zappingIndx] = this.fw.zapper[i];
				this.fw.inverseZappingArray[this.fw.zapper[i].ZappingId] = zappingIndx;
				//omc.logger.addEntry("AGGIUNTO CANALE :"+this.fw.zapper[i].ChanName);
				zappingIndx++;
			}
			this.fw.inverseZapper[this.fw.zapper[i].ZappingId] = i;
			this.fw.zapperChanrecid[this.fw.zapper[i].chanrecid] = i;
		}
		// se l'ultimo canale agganciato,prima di refreshare lo Zapper,era un
		// canale DTT Locale:
		// potrebbe non essere presente nello Zapper (non solo non consistente
		// ma fisicamente non presente)
		// ne verifico l'attuale consistenza altrimenti vado sul default channel
		/* Non entra la prima volta */
		
		if (tempCurrentZappingId >= LOCAL_DTT_START_INDEX) {
		
			// top.getFetcher().sendDebugTrap("Ci sono: ");
			if (this.fw.inverseZapper[tempCurrentZappingId]) // se �
																// consistente
																// (automaticamente
																// per i canali
																// DTT locali,
																// lo status � a
																// true)
			{
		
				// ricava i nuovi indici (quello dello Zapper non � cambiato
				// rispetto a prima per costruzione)
				this.fw._currIndexForZapping = this.fw.inverseZappingArray[tempCurrentZappingId];
		
				this.fw._currIndexForZapper = this.fw.inverseZapper[tempCurrentZappingId];
		
			} else // non � pi� presente nello Zapper
			{
		
				this.fw._currIndexForZapping = 0; // il canale di default � il
													// primo della matrice.
		
				this.fw._currIndexForZapper = 0;
			}
		} else { // per tutti gli altri canali (DTT nazionali e BTV)
		
			this.fw._currIndexForZapping = this.fw.inverseZappingArray[tempCurrentZappingId];
		
			this.fw._currIndexForZapper = this.fw.inverseZapper[tempCurrentZappingId];
			// se non � possibile ripristinare l'indice dello zapping abbiamo
			// perso la consistenza: resettta a zero
			if (!this.fw._currIndexForZapping) {
				this.fw._currIndexForZapping = 0;
				
				this.fw._currIndexForZapper = 0;
			}
		}

		if (this.fw.getBTVTuner().getActive()) {
			this.jumpToChannelByZappingId(); // canale vecchio non pi�
												// disponibile salto al canale
												// di default
		}

		// aiuta la garbage collection
		dttLocalChannels = new Array();

	} catch (ecc) {
		omc.logger.addEntry("######################## BaseApp.RefreshDTT ## ECCEZIONE ## :"+ecc.message);
		var reasonCode = "zapperNotChanged";
		this.fw.getEventManager().handleEvent("eventZapperChanged", reasonCode);

		this._objErrorInfo._methodName = 'refreshZapperLocalDTT';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		// top.getFetcher().sendDebugTrap("Ci sono");
		var reasonCode = "zapperChanged";
		/* Se commento non parte dopo l'immagine */
		this.fw.getEventManager().handleEvent("eventZapperChanged", reasonCode);
		return true;
	}
};

// metodo che controlla se � stata fatta la scansione del DVBT corrente, in caso
// contrario
// si va al canale di default.
BaseApp.prototype.checkDVBTScanned = function() {
	try {
		if (this.fw.getBTVTuner().getEPG()
				&& this.fw.zappingArray[this.fw._currIndexForZapping]) { // top.getFetcher().sendDebugTrap("Ci
																			// sono:
																			// ");
			var channel = this.fw
					.getBTVTuner()
					.getEPG()
					.getChannelByChanRecid(
							this.fw.zappingArray[this.fw._currIndexForZapping].chanrecid);
			/* nel caso homeTvApp non entra */
			if ((channel) && (channel.chanType.toLowerCase() == 'dvbt')
					&& (this.fw.getDTT().getChannelByURL(channel.url) == null)) {
				// top.getFetcher().sendDebugTrap("Ci sono: ");
				this.fw._currIndexForZapping = 0; // il canale di default � il
													// primo della matrice.
				if (this.fw.OMC_LOGGER_ENABLED)
					omc.logger
							.addEntry("### BaseApp.checkDVBTScanned ## 1 ##  this.fw._currIndexForZapper:"
									+ this.fw._currIndexForZapper);
				this.fw._currIndexForZapper = 0;
			}
		}
	} catch (ecc) {
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger
					.addEntry("### BaseApp.checkDVBTScanned ## 2 ##  this.fw._currIndexForZapper:"
							+ this.fw._currIndexForZapper);
		this.fw._currIndexForZapping = 0; // il canale di default � il primo
											// della matrice.
		this.fw._currIndexForZapper = 0;
		this._objErrorInfo._methodName = 'checkDVBTScanned';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

// evita interferenza nella copia degli array
BaseApp.prototype.backupUserPackages = function(arr) {
	var tempPackages = new Array();
	try {
		if (arr) {
			for (i = 0; i < arr.length; i++)
				tempPackages[i] = arr[i];
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'backupUserPackages';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return tempPackages;
	}
};

// metodo invocato per effettuare la creazione della matrice di zapper/zapping
// dopo aver invocato il fetcher statico.
BaseApp.prototype.createZapper = function() {
	try {
		
		this.fristZapper = true;
		this.fw.userPackages = this.getNormalizedPackages();
		this.fw.userOldPackages = new Array(); // forza il mismatch tra
												// this.fw.userPackages e
												// this.fw.userOldPackages
		// questo forzer� la consistenza e la creazione dell'oggetto Zapping in
		// refreshZapper

		// costruisce l'inverseZapperArray e setta la consistenza dei canali
		// Abase a true e di tutti gli altri a false
		this.fw.inverseZapper = new Array();
		this.fw.zapperChanrecid = new Array();
		
		for (i = 0; i < this.fw.zapper.length; i++) {
			if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("BaseApp.createZapper CREATO CANALE : "+this.fw.zapper[i].ChanName);
			this.fw.zapper[i].status = true;
			this.fw.inverseZapper[this.fw.zapper[i].ZappingId] = i;
			this.fw.zapperChanrecid[this.fw.zapper[i].chanrecid] = i;
		}

		if (this.fw._currIndexForZapping == undefined)
			this.fw._currIndexForZapping = 0; // indice per l'oggetto zapping
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger
					.addEntry("### BaseApp.createZapper ## 1 ##  this.fw._currIndexForZapper:"
							+ this.fw._currIndexForZapper);

		if (this.fw._currIndexForZapper == undefined)
			this.fw._currIndexForZapper = 0; // indice per l'oggetto zapper

		// aggiorna strutture con i canali DTT locali se abilitate
		// aggiorna la consistenza e crea la matrice di Zapping
		/* Se lo commento non parte dopo l'immagine */
		
		this.refreshZapper();
		

	} catch (ecc) {
		this._objErrorInfo._methodName = 'createZapper';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*
 * //metodo invocato per effettuare la creazione della matrice di zapper/zapping
 * //dopo aver invocato il fetcher statico.
 * BaseApp.prototype.createZapperPreferiti=function(){ try{
 *  // this.fristZapper = true; //
 * this.fw.userPackages=this.getNormalizedPackages(); //
 * this.fw.userOldPackages=new Array(); //forza il mismatch tra
 * this.fw.userPackages e this.fw.userOldPackages // //questo forzer� la
 * consistenza e la creazione dell'oggetto Zapping in // //refreshZapper
 * 
 * //costruisce l'inverseZapperArray e setta la consistenza dei canali Abase a
 * true e di tutti gli altri a false this.fw.inverseZapper=new Array();
 * this.fw.zapperChanrecid=new Array();
 * 
 * for(i=0;i<this.fw.zapper.length;i++){ if(this.fw.zapper[i].pkgrecid==14){
 * this.fw.zapper[i].status=true;//AbaseA di default cosistente }else{
 * this.fw.zapper[i].status=false;//di default non cosistente }
 * this.fw.inverseZapper[this.fw.zapper[i].ZappingId]=i;
 * this.fw.zapperChanrecid[this.fw.zapper[i].chanrecid]=i; }
 * 
 * 
 * this.fw._currIndexForZapping=0; //indice per l'oggetto zapping
 * this.fw._currIndexForZapper=0; //indice per l'oggetto zapper
 * 
 * //aggiorna strutture con i canali DTT locali se abilitate //aggiorna la
 * consistenza e crea la matrice di Zapping // Se lo commento non parte dopo
 * l'immagine this.refreshZapperPreferiti(true);
 * 
 * }catch(ecc){ this._objErrorInfo._methodName = 'createZapperPreferiti';
 * this._objErrorInfo._obException = ecc; this.handleError(); } return true; };
 */

// se dtt_refresh � passato false o non passato: aggiorna la consistenza dei
// canali e la struttura Zapping
// se dtt_refresh � passato a true: evita di aggiornare la consistenza dei
// package e aggiorna solo
// la struttura Zapping (per incloudere i nuovi canli DTT locali)
// BaseApp.prototype.refreshZapperPreferiti=function(dtt_refresh){
// try{
// var SEP="|";
// //le variabili this.fw.userOldPackages e this.fw.userPackages sono aggiornate
// dal metodo
// //eventDataFetchCompleted o CreateZapper
// //entra nel metodo in due condizioni: se c'� un cambiamento nei package
// dell'utente
// // se forzato dall'esterno per rinfrescare i canali dtt
// /* La prima volta entra qui */
// if(this.testNewPackages(this.fw.userOldPackages,this.fw.userPackages) ||
// dtt_refresh || this.fristZapper){
// this.fristZapper = false; //variabile che indica la prima volta che viene
// //effettuato il refresh
// //se dobbiamo solo aggiungere i nuovi canali dtt non occorre aggiornare la
// //consistenza
// /* La prima volta entra qui, cmq dipende dal chiamante se gli passa qualche
// parametro */
// if(!dtt_refresh){
// var packageListString=this.fw.userPackages.join(SEP)+SEP;
// for(i=0;i<this.fw.zapper.length;i++){
// /* Entra qui la prima volta, per diverse volte */
// if(this.fw.zapper[i].pkgrecid!=14){ //il package 14 � sempre in conistenza
// var arr = new Array();
// arr=this.fw.zapper[i].pkgrecid.toString().split("|");
// /* Entra qui la prima volta */
// if(arr.length > 1){ //caso in cui un canale è associato a piu Packages
// this.fw.zapper[i].status = false;
// for(z=0;z<arr.length;z++){
// /* qui non entra */
// if(packageListString.indexOf(arr[z]+SEP) != -1){
// this.fw.zapper[i].status = true;
// break;
// }
// }
// }else{
// this.fw.zapper[i].status =
// (packageListString.indexOf(this.fw.zapper[i].pkgrecid+SEP) != -1);
// }
// }
// }
// }
// /* Qui non entra, perchè è abilitato il DTT */
// if(!this.isDTTEnabled()){ // DTT non abilitato si deve filtrare la matrice di
// zapping eliminando i
// // DVBT
// // top.getFetcher().sendDebugTrap("Ci sono 1: ");
// var tempZapper = new Array();
// var tempZapperIndex = 0;
//			   			   			  			   			   
// //salvo in un array temporaneo solo i canali BTV
// for(i=0;i<this.fw.zapper.length;i++){
// if( this.fw.zapper[i].chantype.toLowerCase()=='btv'){
// tempZapper[tempZapperIndex] = new Object();
// tempZapper[tempZapperIndex] = this.fw.zapper[i];
// tempZapperIndex++;
// }
// }
// //aggiorno l'array di zapper con i canali btv solamente
// this.fw.zapper = new Array();
// this.fw.zapper = tempZapper;
// }
//	    	   
// //aggiorna i canali DTT locali e costruisce la struttura Zapping
// /* se commento non parte dopo l'immagine */
// this.refreshZapperLocalDTTPreferiti();
//   
// }else{ //i cananli non sono cambiati.
// var reasonCode="zapperNotChanged";
// //si lancia l'evento che ci indica la fine dell'elaborazione del refresh
// this.fw.getEventManager().handleEvent("eventZapperChanged", reasonCode);
// }
// }catch(ecc){
// var reasonCode="zapperNotChanged";
// //si lancia l'evento che ci indica la fine dell'elaborazione del refresh
// this.fw.getEventManager().handleEvent("eventZapperChanged", reasonCode);
//
// this._objErrorInfo._methodName = 'refreshZapperPreferiti';
// this._objErrorInfo._obException = ecc;
// this.handleError();
// }
// return true;
// };

// aggiorna lo stato dei canali dtt locali e ricostruisce l'oggetto Zapping
// BaseApp.prototype.refreshZapperLocalDTTPreferiti=function(){
// try{
// var
// tempCurrentZappingId=this.fw.zapper[this.fw._currIndexForZapper].ZappingId;
// //ricostruisce l'oggetto Zapping
// this.fw.zappingArray=new Array(); //array da 0 a n contenente tutti gli
// oggetti zapping in consistenza
// this.fw.inverseZappingArray=new Array(); //array dal minimo ZappingId al
// massimo ZappingId che mappano agli indici dell'array di sopra
// this.fw.inverseZapper = new Array();
// this.fw.zapperChanrecid = new Array(); //hash table con chiave il chan recid
// e restituisce l'indice dell'array di zapper
// var zappingIndx=0;
// omc.logger.addEntry("this.fw.zapper.length: "+this.fw.zapper.length);
// for(i=0;i<this.fw.zapper.length;i++){
// if(this.fw.zapper[i].status){ //in consistenza
// //costruisce matrice zapping e matrice inversa zapping
// this.fw.zappingArray[zappingIndx]=new Object();
// this.fw.zappingArray[zappingIndx]=this.fw.zapper[i];
// this.fw.inverseZappingArray[this.fw.zapper[i].ZappingId]=zappingIndx;
// zappingIndx++;
// }
// this.fw.inverseZapper[this.fw.zapper[i].ZappingId]=i;
// this.fw.zapperChanrecid[this.fw.zapper[i].chanrecid]=i;
// }
//	
// //se l'ultimo canale agganciato,prima di refreshare lo Zapper,era un canale
// DTT Locale:
// //potrebbe non essere presente nello Zapper (non solo non consistente ma
// fisicamente non presente)
// //ne verifico l'attuale consistenza altrimenti vado sul default channel
// /* Non entra la prima volta */
// this.fw._currIndexForZapping=this.fw.inverseZappingArray[tempCurrentZappingId];
// this.fw._currIndexForZapper=this.fw.inverseZapper[tempCurrentZappingId];
// //se non � possibile ripristinare l'indice dello zapping abbiamo perso la
// consistenza: resettta a zero
// if(!this.fw._currIndexForZapping){
// this.fw._currIndexForZapping=0;
// this.fw._currIndexForZapper=0;
// }
//
// }catch(ecc){
// this._objErrorInfo._methodName = 'refreshZapperLocalDTTPreferiti';
// this._objErrorInfo._obException = ecc;
// this.handleError();
// }
// return true;
// };

BaseApp.prototype.spaceBlank = function(stringA) {
	
	//var stringB = stringA.replace(/ /g, "+").replace(/ù/g,"u");
	var stringB = stringA.replace(/\s/g, "%20").replace(/&/g, "%26");
	
	String stringaRipulita = new String("");
	try{
		if(this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("################     BaseApp.spaceBlank stringa PRIMA : "+stringB);
		
		/*
		
	
		//for(c=0; c< stringB.length; c++){
		String ult = new String("");
		ult = stringB.charCodeAt(stringB.length-1);
		if(ult == 249)
			stringaRipulita = stringB.substring(0,stringB.length-1)+"u";
		else
			stringaRipulita = stringB;
		*/
			/*
		switch(ult){
			case 224:
			case 225:
			case 226:
			case 227:
			case 228:
			case 229:
				stringaRipulita = stringB.substring(0,stringB.length-1)+"a";				
				break;
			case 232:
			case 233:
			case 234:
			case 235:
				stringaRipulita = stringB.substring(0,stringB.length-1)+"e";				
				break;
			case 236:
			case 237:
			case 238:
			case 239:
				stringaRipulita = stringB.substring(0,stringB.length-1)+"i";				
				break;
			case 242:
			case 243:
			case 244:
			case 245:
			case 246:
				stringaRipulita = stringB.substring(0,stringB.length-1)+"o";				
				break;
			case 249:
			case 250:
			case 251:
			case 252:
				stringaRipulita = stringB.substring(0,stringB.length-1)+"u";				
				break;
			default:
				stringaRipulita = stringB;
			break;
		}
			*/
	//	}
		
		//stringB = stringB.replace(/à/g, "a").replace(/è/g, "e").replace(/é/g, "e").replace(/ò/g, "o").replace(/ù/g, "u").replace(/ì/g, "i");
		
	
	
		if(this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("################     BaseApp.spaceBlank stringa DOPO: "+stringB);
	}catch(e){
		omc.logger.addEntry("######### ECCEZIONE BaseApp.spaceBlank : "+e.message);
		
	}
	
	return stringB;
};
BaseApp.prototype.spaceBlankHTML = function(stringA) {
	
	var stringB = stringA.replace(/ù/g,"ù");
	String stringaRipulita = new String("");
	try{
		if(this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("################     BaseApp.spaceBlank stringa PRIMA : "+stringB);
		String ult = new String("");
		ult = stringB.charCodeAt(stringB.length-1);
		if(ult == 249)
			stringaRipulita = stringB.substring(0,stringB.length-1)+"ù";
		else
			stringaRipulita = stringB;
	
		if(this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("################     BaseApp.spaceBlank stringa DOPO: "+stringaRipulita);
	}catch(e){
		omc.logger.addEntry("######### ECCEZIONE BaseApp.spaceBlank : "+e.message);
		
	}
	
	return stringB;
};

BaseApp.prototype.creaImmaginiZapperDefault = function() {
	this.fw.cgiHasFinished = false;
	this.salvaFileBootHTML();
	this.canali = this.getZapper();
	var stringaskygrid = 'skygrid_';
	var stringa = '';
	for (i = 0; i < this.canali.length; i++) {
		stringa += this.canali[i].ZappingId + '%20'
				+ this.spaceBlank(this.canali[i].ChanName) + ':'
				+ stringaskygrid + this.canali[i].ZappingId + '_'
				+ this.canali[i].chanrecid + ';';
	}
	
	if(this.fw.OMC_LOGGER_ENABLED)
		omc.logger.addEntry("################     BaseApp.creaImmaginiZapperDefault stringa: "+stringa);
	this.fw.getFetcher().fetchNow(
			'/cgi-bin/cancEcreaImg.cgi?dest='+this.fw.TILAB_ROOT+this.fw.URL_IMG_ZAPP_DEFAULT+'&lista=' + stringa, this,
			this.caricaImmaginiReturn);
}

BaseApp.prototype.caricaImmaginiReturn = function(obj) {
	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("################     BaseApp.creaImmaginiZapperDefault CALLBACK ###################################### codice: "+obj.codice);
	this.fw.getTimer().setTimeout(10, this.caricaImmaginiZapperDefault, this);
	this.fw.getTimer().setTimeout(200, this.cgiHasFinished, this);
	return true;

}


BaseApp.prototype.cgiHasFinished = function() {
	this.fw.cgiHasFinished = true;
	this.fw.getTimer().setTimeout(200, this.salvaFileBootHTML, this);
	
}

BaseApp.prototype.caricaImmaginiZapperDefault = function() {
	/* Precaricamento nella cache del browser delle immagini Zapperone */
	try{
		if(this.getZapper().length == 0)
			return true;
		this.canali = this.getZapper();
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("BaseApp.caricaImmaginiZapperDefault this.canali.length: " + this.canali.length);
		this.fw.ImageLibOnCGI = new Array();
		this.fw.ImageLibOffCGI = new Array();
		for (j = 0; j < this.canali.length; j++) {
			if (this.fw.OMC_LOGGER_ENABLED)
				omc.logger.addEntry("this.fw.ImageLibOnCGI "+this.canali[j].ChanName+" src : "+this.fw.TILAB_ROOT+this.fw.URL_IMG_ZAPP_DEFAULT+ "skygrid_"+ this.canali[j].ZappingId+ "_"+ this.canali[j].chanrecid + "_on.png");
			this.fw.ImageLibOnCGI[this.canali[j].chanrecid] = new Image(200, 34);
			this.fw.ImageLibOnCGI[this.canali[j].chanrecid].src = "file://"+this.fw.TILAB_ROOT+this.fw.URL_IMG_ZAPP_DEFAULT
					+ 'skygrid_'
					+ this.canali[j].ZappingId
					+ '_'
					+ this.canali[j].chanrecid + '_on.png';
			
			this.fw.ImageLibOffCGI[this.canali[j].chanrecid] = new Image(200, 34);
			this.fw.ImageLibOffCGI[this.canali[j].chanrecid].src = "file://"+this.fw.TILAB_ROOT+this.fw.URL_IMG_ZAPP_DEFAULT
					+ 'skygrid_'
					+ this.canali[j].ZappingId
					+ '_'
					+ this.canali[j].chanrecid + '_off.png';
			
			
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("BaseApp.caricaImmaginiZapperDefault imgOn hasLoaded: " + this.fw.ImageLibOnCGI[this.canali[j].chanrecid].complete);
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("BaseApp.caricaImmaginiZapperDefault imgoff hasLoaded: " + this.fw.ImageLibOffCGI[this.canali[j].chanrecid].complete);
			if(this.fw.ImageLibOnCGI[this.canali[j].chanrecid].complete == 0 || this.fw.ImageLibOffCGI[this.canali[j].chanrecid].complete == 0){
				omc.logger.addEntry("BaseApp caricaImmaginiZapperDefault MANCA IMMAGINE RICREO IMMAGINI");
				this.fw.getTimer().setTimeout(10, this.creaImmaginiZapperDefault, this);
				return true;
			}				
			
		}
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("BaseApp.caricaImmaginiZapperDefault Caricamento Immagini CGI  .... Eseguito!!! LUNGHEZZA ARRAY :"+this.fw.ImageLibOffCGI.length);
	}catch(e){
		omc.logger.addEntry("ECCEZIONE BaseApp.caricaImmaginiZapperDefault :"+e.message);
	}
}

BaseApp.prototype.creaImmaginiZapperPreferiti = function() {
	this.fw.cgiHasFinished = false;
	this.salvaFileBootHTML();
	this.preferiti = this.getPreferiti();
	var stringaskygrid = 'skygrid_';
	var stringa = '';
	for (i = 0; i < this.preferiti.length; i++) {
		stringa += (i + 1) + '%20' + this.spaceBlank(this.preferiti[i].ChanName)
				+ ':' + stringaskygrid + (i + 1) + '_'
				+ this.preferiti[i].chanrecid + ';';
	}
	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("################     BaseApp.creaImmaginiZapperPreferiti stringa: "+stringa);
	this.fw.getFetcher().fetchNow(
			'/cgi-bin/cancEcreaImg.cgi?dest='+this.fw.TILAB_ROOT+this.fw.URL_IMG_ZAPP_FAV+'&lista=' + stringa, this,
			this.caricaPreferitiReturn);
};

BaseApp.prototype.caricaPreferitiReturn = function(obj) {
	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("################     BaseApp.caricaPreferitiReturn CALLBACK  ################################## codice: "+obj.codice);
	this.fw.getTimer().setTimeout(10, this.caricaImmaginiZapperPreferiti, this);
	this.fw.getTimer().setTimeout(200, this.cgiHasFinished, this);
	return true;
}

BaseApp.prototype.caricaImmaginiZapperPreferiti = function() {
	try{
		this.preferiti = this.getPreferiti();
		if(this.getPreferiti().length == 0)
			return true;
		this.fw.ImagePreferitiOn = new Array();
		this.fw.ImagePreferitiOff = new Array();
		for (j = 0; j < this.preferiti.length; j++) {
			if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("this.fw.ImagePreferitiOff[this.preferiti[j].ChanName].src : "+ this.fw.URL_IMG_ZAPP_FAV+ 'skygrid_'+ (j + 1)+ '_' + this.preferiti[j].chanrecid + '_off.png');
			if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("this.fw.ImagePreferitiOn[this.preferiti[j].ChanName].src : "+ this.fw.URL_IMG_ZAPP_FAV+ 'skygrid_'+ (j + 1)+ '_' + this.preferiti[j].chanrecid + '_on.png');
			this.fw.ImagePreferitiOff[this.preferiti[j].chanrecid] = new Image(200,34);
			this.fw.ImagePreferitiOn[this.preferiti[j].chanrecid] = new Image(200,34);
			this.fw.ImagePreferitiOff[this.preferiti[j].chanrecid].src = "file://"+this.fw.TILAB_ROOT+this.fw.URL_IMG_ZAPP_FAV
					+ '/skygrid_'
					+ (j + 1)
					+ '_'
					+ this.preferiti[j].chanrecid
					+ '_off.png';
			this.fw.ImagePreferitiOn[this.preferiti[j].chanrecid].src = "file://"+this.fw.TILAB_ROOT+this.fw.URL_IMG_ZAPP_FAV
					+ '/skygrid_'
					+ (j + 1)
					+ '_'
					+ this.preferiti[j].chanrecid
					+ '_on.png';
			
			
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("BaseApp.caricaImmaginiZapperPreferiti imgOn hasLoaded: " +this.fw.ImagePreferitiOn[this.preferiti[j].chanrecid].complete);
			if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("BaseApp.caricaImmaginiZapperPreferiti imgoff hasLoaded: " + this.fw.ImagePreferitiOff[this.preferiti[j].chanrecid].complete);
			if(this.fw.ImagePreferitiOn[this.preferiti[j].chanrecid].complete == 0 || this.fw.ImagePreferitiOff[this.preferiti[j].chanrecid].complete == 0){
				omc.logger.addEntry("BaseApp caricaImmaginiZapperPreferiti MANCA IMMAGINE RICREO IMMAGINI");
				this.fw.getTimer().setTimeout(10, this.creaImmaginiZapperPreferiti, this);
				return true;
			}			
		}
		
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger
				.addEntry("Caricamento Immagini Preferiti on off .... Eseguito!!! ");
		this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", false);
	}catch(e){
		omc.logger.addEntry("ECCEZIONE BaseApp caricaImmaginiZapperPreferiti :"+e.message);
	}
}

BaseApp.prototype.callDigit = function(digit) {
	try {
		this.fw.LoggerApp.debugLog("PREMUTO TASTO =" + digit);
		this.BoxChangeChannel = true;
		this.fw.getTimer().clearTimeout(this._indiceTimer);
		this._indiceTimer = null;
		if (this.num_cifre < 3) {
			this.num_cifre++;
			this.changePage = this.changePage + digit;
			this.writeTopIndex(digit, this.num_cifre);
		}
		if (this.num_cifre == 3) {
			this.fw.getEventManager().disableNav();
			this._indiceTimer = this.fw.getTimer().setTimeout(
					this.velocita_ripetizione_finale, this.changeApp, this);
		} else {
			this._indiceTimer = this.fw.getTimer().setTimeout(
					this.velocita_ripetizione, this.changeApp, this);
		}
	} catch (ecc) {
		objErrorInfo._methodName = "callDigit";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

/*******************************************************************************
 * eventZapperChanged � sollevato da: refreshZapper in caso di non aggiornamento
 * delle strutture Zapper/Zapping, refreshZapperLocalDTT nel caso in cui siano
 * state aggiornate le strutture
 ******************************************************************************/
BaseApp.prototype.eventZapperChanged = function(reasonCode) {
	try {

		if (this.fw.zapper) {
			this.fw.ZappingString = "";

			for (i = 0; i < this.fw.zapper.length; i++) {
				this.fw.ZappingString = this.fw.ZappingString + "|"
						+ this.fw.zapper[i].ZappingId;
			}

			// all'avvio aspetto che il zapper sia aggiornato correttamente
			// prima di
			// chiamare la homeTvApp ed effettuare la jump se � stato premuto
			// occhio rosso
			if (this.fw.getAppManager().getCurrentAppUrl()
					.indexOf("StartupApp") != -1
					&& this.fw.eyePressed) {
				
				this.loadApp("/ovaServices/getapp/GetApp.html", null);
			}
			this.fw.zapperChanged = true;
		}
		return true;

	} catch (ecc) {
		this._objErrorInfo._methodName = 'eventZapperChanged';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// metodo che restituisce lo zappingID di un canale prendendo come input il
// recid del canale
BaseApp.prototype.getZapperIdByChanrecid = function(chanrecid) {
	try {
		var zapperID = null;
		if (chanrecid) {
			if (this.fw.zapperChanrecid[chanrecid] != null
					&& this.fw.zapperChanrecid[chanrecid] != undefined) {
				if (this.fw.zapper[this.fw.zapperChanrecid[chanrecid]] != null
						&& this.fw.zapper[this.fw.zapperChanrecid[chanrecid]] != undefined) {
					zapperID = this.fw.zapper[this.fw.zapperChanrecid[chanrecid]].ZappingId;
				}
			}
		}
		return zapperID;

	} catch (ecc) {
		this._objErrorInfo._methodName = 'getZappingIdByChanrecid';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// aggiornamento degli indici di zapping/zapper senza effettuare la jump al
// canale
BaseApp.prototype.setIndexForZapping = function(zappingId) {
	try {
		if (zappingId) {
			var chanIndex = this.fw.inverseZappingArray[zappingId];
			if (chanIndex >= 0) {
				// rinfresca l'indice per lo zapping lineare
				this.fw._currIndexForZapping = chanIndex;
				// rinfresca l'indice per lo zapper lineare
				if (this.fw.OMC_LOGGER_ENABLED)
					omc.logger
							.addEntry("### BaseApp.setIndexForZapping ## 1 ##  this.fw._currIndexForZapper:"
									+ this.fw._currIndexForZapper);
				this.fw._currIndexForZapper = this.fw.inverseZapper[zappingId];
			} else { // canale non in consistenza aggiorno solo l'indice di
						// zapper
				if (this.fw.OMC_LOGGER_ENABLED)
					omc.logger
							.addEntry("### BaseApp.setIndexForZapping ## 2 ##  this.fw._currIndexForZapper:"
									+ this.fw._currIndexForZapper);
				this.fw._currIndexForZapper = this.fw.inverseZapper[zappingId];
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'setIndexForZapping';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

BaseApp.prototype.eventKeyPower = function(riavvioForzato) {
	try {

		if (riavvioForzato || this.fw.recoveryStatus)
			this.riavvioForzato = true;

		if (this.altStandBy == true) { // controllo per la doppia chiamata in
										// standby
			this.altStandBy = false;
			if (this.fw.power == true || this.fw.power == null) {
				// la funzione spegne il STB

				// la funzione spegne il STB

				this.fw.power = false;
				this.goStandby();

			} else {
				// la funzione riaccende il STB
				this.fw.power = true;
				this.resumeStandby();

			}
			this.fw.getTimer().clearTimeout(this._timePower);
			this._timePower = null;
			this.fw.arrTimer[4] = this._timePower;
			this._timePower = this.fw.getTimer().setTimeout(1000,
					this.abilitaEventKeyPower, this);
		}

		return true;

	} catch (ecc) {
		this._objErrorInfo._methodName = 'eventKeyPower';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

BaseApp.prototype.startSoftBoot = function() {

	try {
		if (this.fw.softBoot) {
			this.fw.getTimer().clearTimeout(this.fw.softBoot)
		}

		var bootstrapURL = this.fw.getConfig().BOOTSTRAP_URL;
		this.fw.getFetcher().fetchNow(bootstrapURL + "?tpcache=N", this,
				this.bootstrapDone);

	} catch (ecc) {
		this._objErrorInfo._methodName = 'eventKeyPower';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}

};

BaseApp.prototype.resumeStandby = function() {
	try {

		this.fw.standby = false;
		if ((this.riavvioForzato != null) || (this.fw.rebootable != null)) {
			if ((this.riavvioForzato) || (this.fw.rebootable == true)) {
				
				navigator.Reboot();
			}
		}
		this.fw.getOSD().powerSetTopBox();
		var vc = this.fw.getVideoControl();
		vc.background(0x00FF00, 0xF0F0F0);

		this.fromInitOrReboot = true; // flag per mandare le trap di activity
										// in ogni caso quando torno da StandBy

		this.jumpToChannelByZappingId();
		this.eventKeyEye();
		this.fw.LoggerApp.startLog("WAKEUP");

		this.fw.isInactive = false;// variabile per l'autoUpdate
		// se scan dtt � in progress viene stoppato
		if (this.isDTTEnabled() && this.fw.getDTT().scanInProgress() == true) {
			this.fw.getDTT().stopScan();
		}
		// distruggo il timer per lo scan dtt in standby
		if (this.fw.scan_delay) {
			this.fw.getTimer().clearTimeout(this.fw.scan_delay);
		}

		if (this.fw.softBoot) {
			this.fw.getTimer().clearTimeout(this.fw.softBoot)
		}

		this._myDelayTimer = (this.fw.getConfig().DELAY_TIMER != null) ? this.fw
				.getConfig().DELAY_TIMER
				: 10000;
		//this.fw.softBoot = this.fw.getTimer().setTimeout(this._myDelayTimer,this.startSoftBoot, this);

	} catch (ecc) {
		this._objErrorInfo._methodName = 'resumeStandby';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

BaseApp.prototype.setReboot = function(obj) {
	try {
		if (obj && obj.errorCode) {
			this.handleErrorCustom(obj.errorCode);
		} else {
			if (obj.content.length > 0) {
				this.newOvaVer = obj.content[0].stb_ova_version;
				this.newFwVer = obj.content[0].stb_fw_version;
			}
			if (this.newOvaVer == this.currOvaVer
					&& this.newFwVer == this.currFwVer) {
				// ---------TRAP---------------------
				var bootstrapURL = this.fw.getConfig().BOOTSTRAP_URL;
				this.fw.getFetcher().fetchNow(bootstrapURL + "?tpcache=N",
						this, this.bootstrapDone);
			} else {
				try {
					
					navigator.Reboot();
				} catch (e) {
					var bootstrapURL = this.fw.getConfig().BOOTSTRAP_URL;
					this.fw.getFetcher().fetchNow(bootstrapURL + "?tpcache=N",
							this, this.bootstrapDone);
				}
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'setReboot';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.bootstrapCallback = function(bootstrapData) {
	if (eval(this.fw.getConfig().SET_FAVOURITES_NOTIFICATIONS))
		this.fw.getUserInfo().setFavouritesNotifications();
	if (eval(this.fw.getConfig().SET_PPV_NOTIFICATIONS))
		this.fw.getUserInfo().setPPVNotifications();
	if (eval(this.fw.getConfig().SET_NVOD_NOTIFICATIONS))
		this.fw.getUserInfo().setNvodNotifications();
};

// metodo utilizzato per ritardare le chiamate di gotChannelData e
// GetProgrammData
// per velocizzare lo standBy
BaseApp.prototype.callEPGFetcher = function() {
	try {
		this.fw.getEPGManager().init(this, this.bootstrapCallback);
		if (this.fw.EPGTimer) {
			this.fw.getTimer().clearTimeout(this.fw.EPGTimer);
		}
		this.fw.EPGTimer = null;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'callEPGFetcher';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

BaseApp.prototype.bootstrapDone = function(bootstrapData) {
	try {
		this.fw.getUserInfo().setUser(bootstrapData.user, true);
		this.fw.getUserInfo().setAccount(bootstrapData.account, true);
		this.fw.getUserInfo().setInventory(bootstrapData.inventory);
		this.fw.getRatings().setData(bootstrapData.ratings);

		this._myDelayTimer = (this.fw.getConfig().DELAY_TIMER != null) ? this.fw
				.getConfig().DELAY_TIMER
				: 10000;

		this.fw.EPGTimer = this.fw.getTimer().setTimeout(this._myDelayTimer,
				this.callEPGFetcher, this);

		// //////////////CONTROLLO PRESENZA E-MAIL
		var users = this.fw.getUserInfo().getUsers();

		if (users[0].type == "F") {
			this.indexAcquisto = 0;
		} else {
			this.indexAcquisto = 1;
		}
		if (users[this.indexAcquisto].pin.substring(0, 2) == "**") {
			// Controllo inserimento CLI da parte dell'utente
			omc.logger.addEntry("bootstrapDone /ovaServices/getapp/GetApp.html");
			this.loadApp("/ovaServices/getapp/GetApp.html");
			return true;
		} else {
			try {
				var Mac = navigator.GetMACAddress();
			} catch (e) {
				var Mac = "00:03:6F:D0:00:A4";
			}
			try {
				var Dhcp = navigator.GetDHCPAddress();
			} catch (e) {
				var Dhcp = "00.00.00.00";
			}
			this._callsunrise = true;
			omc.logger.addEntry("bootstrapDone /ovaServices/sunriseaccount/GetSunriseAccountFetcher.html");
			if (this.fw.checkMail != true) {
				
				this.fw
						.getFetcher()
						.fetchNow(
								"/ovaServices/sunriseaccount/GetSunriseAccountFetcher.html",
								this, this.checkMasterAccount);
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'bootstrapDone';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;

};

BaseApp.prototype.checkMasterAccount = function(obj) {
	try {
		if (obj && (obj.errorCode == "OVA-119" || obj.errorCode == "OVA-130")) {

			this.fw.getTimer().clearTimeout(this._standByTimer);
			this._standByTimer = null;

			var obj1 = new Object();
			obj1.master_account = '';
			obj1.flag_privacy = 'N';

			var content = new Array();
			content[0] = obj1;

			var oggetto = new Object();
			oggetto.content = content;

			this.loadApp("/ovaServices/getapp/GetApp.html", oggetto);

		} else {
			if (obj && obj.errorCode) {
				this.showErrorPageSCF(obj.errorCode);
				// return true;
			} else {

				if (this.checkMail(obj.content[0].master_account)
						&& obj.content[0].flag_privacy == 'N') {
					this.loadApp("/ovaServices/getapp/GetApp.html", obj, 1);
					// return true;
				} else if (!this.checkMail(obj.content[0].master_account)
						&& obj.content[0].flag_privacy == 'N') {
					this.loadApp("/ovaServices/getapp/GetApp.html", obj);
					// return true;
				}

			}
		}

	} catch (ecc) {
		this._objErrorInfo._methodName = 'checkMasterAccount';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.callStandby = function() {

	this.loadApp("/ovaServices/getapp/HomeTvApp.html", null, null, null, true);
	return true;
};

BaseApp.prototype.goStandby = function() {

	try {
		if (this.fw.softBoot) {
			this.fw.getTimer().clearTimeout(this.fw.softBoot)
		}

		if (this.fw.EPGTimer) {
			this.fw.getTimer().clearTimeout(this.fw.EPGTimer);
		}
		this.fw.EPGTimer = null;

		this.fw.standby = true;

		// Blocco solo se Necessario
		if (this.fw.getVideoControl().getState() != 0) {
			this.stop_Video();
			this.fw.getBTVTuner().setActive(false);
			this.trapLeave();
		}

		this.fw.getOSD().powerSetTopBox();

		// se si spegne il stb su un canale con adulFlag=true al resume saltiamo
		// al canale di defaul
		if (this.fw.zappingArray[this.fw._currIndexForZapping]) {
			if (this.fw.zappingArray[this.fw._currIndexForZapping].adultFlag) {
				// aggiornamento della variabile di zapping in modo da saltare
				// al canale corretto al power on
				this.fw._currIndexForZapping = 0;
			}
		}
		// ---------TRAP---------------------
		this.fw.LoggerApp.startLog("STANDBY");

		this.fw.isInactive = true;// variabile per l'autoUpdate

		this.fw.getEPGManager().suspendUpdates();
		this.fw.getNotifications().clearAllProgramNotifications('FAV');
		this.fw.getNotifications().clearAllProgramNotifications('PPV');
		this.fw.getNotifications().clearAllProgramNotifications('NVOD');
		this.fw.getUserInfo().clearUserAccountTimers();

		this.clearAllTimers();

		if (this.isDTTEnabled() && this.fw.recoveryStatus != true) {
			// valorizzazione this.scan_delay_time per scansione dtt in standby
			this.scan_delay_time = (this.fw.getConfig().SCAN_REQUEST_TIME == null) ? 7200
					: this.fw.getConfig().SCAN_REQUEST_TIME;
			// valorizzazione lancio del timer
			this.fw.scan_delay = this.fw.getTimer().setTimeout(
					(this.scan_delay_time * 1000), this.checkScann, this);
		}
		this.callStandby(); // metodo da sovrascrivere in HomeTvApp con return
							// true
	} catch (ecc) {
		this._objErrorInfo._methodName = 'goStandby';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}

};

BaseApp.prototype.checkScann = function() {
	try {

		this.START_TIME = this.fw.getConfig().START_UPDATE_TIME;
		if (this.START_TIME == null) {
			this.START_TIME = 2;
		}
		this.STOP_TIME = this.fw.getConfig().STOP_UPDATE_TIME;
		if (this.STOP_TIME == null) {
			this.STOP_TIME = 6;
		}

		var timeScan = (this.fw.getConfig().CHECK_STANBY_SCAN == null) ? 7
				: parseInt(this.fw.getConfig().CHECK_STANBY_SCAN);
		this.check_scan_time = timeScan * 24 * 60 * 60 * 1000;

		var data_temp = this.fw.getOSD().getTime();

		var orarioFinestra = new Date();
		orarioFinestra.setTime(data_temp);
		var ore = orarioFinestra.getUTCHours();

		if ((ore > this.START_TIME - 1) && (ore <= this.STOP_TIME)) {

			if (this.fw.lastScanSession) {
				// var timeDiff = data_temp -
				// this.fw.getDTT().getLastScanTime();
				var timeDiff = data_temp - this.fw.lastScanSession;

				if (timeDiff > this.check_scan_time) {
					this.fw.getDTT().startScan();
				}

			} else {
				this.fw.getDTT().startScan();
			}

		}

		if (this.fw.scan_delay) {
			this.fw.getTimer().clearTimeout(this.fw.scan_delay);
		}

		this.fw.scan_delay = this.fw.getTimer().setTimeout(
				(this.scan_delay_time * 1000), this.checkScann, this);

	} catch (ecc) {
		this._objErrorInfo._methodName = 'checkScann';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.clearAllTimers = function() {
	try {
		for (id in this.fw.getTimer()._idToTimeoutId) {
			flag = false;
			for (a = 0; a < this.fw.arrTimer.length; a++) {
				if (id == this.fw.arrTimer[a]) {
					flag = true;
				}
			}
			for (a = 0; a < this.fw.arrTimerUpdate.length; a++) {
				if (id == this.fw.arrTimerUpdate[a]) {
					flag = true;
				}
			}

			if (!flag) {
				this.fw.getTimer().clearTimeout(id);
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'clearAllTimers';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

BaseApp.prototype.checkMail = function(mailAddress) {
	try {
		var bRet = false;
		if (mailAddress != null && mailAddress != '') {
			bRet = true;
		}
		return bRet;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'checkMail';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}

};

// Metodo che permette di effettuare il controllo all'ingresso della sezione di
// vabity
// i parametri vengono utilizzati qualora il controllo viene effettuato nella
// pagina di
// guarda, dato che non viene inserita nella back history
BaseApp.prototype.checkForRatingVanity = function(fromGuarda, obj, item) {
	try {
		var oggetto = new Object();
		var user_rating_id = this.fw.getUserInfo().getRatingID();
		if (user_rating_id < 3) {

			// verifica se l'accesso non � gi� stato effettuato in caso negatvo
			// chiama la
			// applicazione di PC oppure il widard se non � stato settato il PC
			if (!this.fw.vanityChecked) {
				// Se � necessario avvio il PC oppure il wizard se non �
				// settato.
				var users = this.fw.getUserInfo().getUsers();
				if (users[0].type == "F") {
					this.indexParental = 1;
				} else {
					this.indexParental = 0;
				}
				if (users[this.indexParental].pin.substring(1, 2) == "*") {
					// Avvio il wizard PC
					this.loadApp("/ovaServices/getapp/GetApp.html");
					return false;
				} else {
					// avvio l'applicazione di parental control
					this.loadApp("/ovaServices/getapp/GetApp.html", fromGuarda,
							obj, item);
					return false;
				}
			}
		}
		return true;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'checkForRatingVanity';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

// BaseApp.prototype.createZapperRecoveryVod =function(){
// this.fw.zapperVod = new Array();
// this.fw.zapperVod[0]=eval({RecIdVod: 1, NomeVod: 'Terminator', GenereVod:
// 'Azione', AnnoVod: '1985', RegiaVod: 'Ronny Savant', Attore1Vod: 'Swcharz',
// Attore2Vod: 'oConnel', Attore3Vod: '', LuogoVod: 'USA', DurataVod:
// '185',BreveTramaVod:
// 'sdfklgjòadfljkgòaldfgjarigjakljgòlakjdgòioerjgjaòlkgjòeriogjakrjg',
// RatingVod: 1, urlVod: '/ovaImages/locandine/50080080.jpg'});
// 
// this.fw.zapperVod[1]=eval({RecIdVod: 2, NomeVod: 'Profondo Rosso', GenereVod:
// 'Horror', AnnoVod: '1979', RegiaVod: 'Dario Argento', Attore1Vod: 'Asia
// Orlandi', Attore2Vod: 'Alessandro Moro', Attore3Vod: '', LuogoVod: 'Italia',
// DurataVod: '98', BreveTramaVod:
// 'peorisdklfjewiotusdklgjweitugsdklgjweitudkj', RatingVod: 2, urlVod:
// '/ovaImages/locandine/50079744.jpg'});
// };

// questo metodo sostituisce la createZapper in caso di anomalie
BaseApp.prototype.createZapperRecovery = function(forced) {
	try {

		// variabile che mi identifica lo stato di recovery
		this.fw.recoveryStatus = true;

		this.fw.zapper = new Array();

		this.fw.zapper[0] = eval( {
			status :true,
			chantype :'BTV',
			ZappingId :107,
			ChanName :'La7',
			pkgrecid :14,
			chanrecid :6
		});
		this.fw.zapper[1] = eval( {
			status :true,
			chantype :'BTV',
			ZappingId :108,
			ChanName :'MTV',
			pkgrecid :14,
			chanrecid :5
		});
		this.fw.zapper[2] = eval( {
			status :true,
			chantype :'BTV',
			ZappingId :225,
			ChanName :'Sport Italia',
			pkgrecid :14,
			chanrecid :147
		});
		this.fw.zapper[3] = eval( {
			status :true,
			chantype :'BTV',
			ZappingId :226,
			ChanName :'Sport Italia Live 24',
			pkgrecid :14,
			chanrecid :169
		});
		this.fw.zapper[4] = eval( {
			status :true,
			chantype :'BTV',
			ZappingId :570,
			ChanName :'Class CNBC',
			pkgrecid :14,
			chanrecid :7
		});
		this.fw.zapper[5] = eval( {
			status :true,
			chantype :'BTV',
			ZappingId :571,
			ChanName :'Class News',
			pkgrecid :14,
			chanrecid :8
		});
		this.fw.zapper[6] = eval( {
			status :true,
			chantype :'BTV',
			ZappingId :721,
			ChanName :'Mtv 2',
			pkgrecid :14,
			chanrecid :154
		});
		this.fw.zapper[7] = eval( {
			status :true,
			chantype :'BTV',
			ZappingId :722,
			ChanName :'Mtv Base',
			pkgrecid :14,
			chanrecid :153
		});
		this.fw.zapper[8] = eval( {
			status :true,
			chantype :'BTV',
			ZappingId :723,
			ChanName :'VH1',
			pkgrecid :14,
			chanrecid :179
		});
		this.fw.zapper[9] = eval( {
			status :true,
			chantype :'BTV',
			ZappingId :724,
			ChanName :'VH1 Classic',
			pkgrecid :14,
			chanrecid :180
		});

		// ricostruzioni di tutti gli oggetti necessari per la navigazione
		this.fw.zappingArray = new Array(); // array da 0 a n contenente tutti
											// gli oggetti zapping in
											// consistenza
		this.fw.inverseZappingArray = new Array(); // array dal minimo
													// ZappingId al massimo
													// ZappingId che mappano
													// agli indici dell'array di
													// sopra
		this.fw.inverseZapper = new Array();
		this.fw.zapperChanrecid = new Array();
		var zappingIndx = 0;
		for (i = 0; i < this.fw.zapper.length; i++) {
			omc.logger.addEntry("AGGIUNGO CANALE :"+this.fw.zapper[i].ChanName+" status: "+this.fw.zapper[i].status);
			if (this.fw.zapper[i].status) { // in consistenza
				// costruisce matrice zapping e matrice inversa zapping
				this.fw.zappingArray[zappingIndx] = new Object();
				this.fw.zappingArray[zappingIndx] = this.fw.zapper[i];
				this.fw.inverseZappingArray[this.fw.zapper[i].ZappingId] = zappingIndx;
				zappingIndx++;
				omc.logger.addEntry("AGGIUNTO CANALE :"+this.fw.zapper[i].ChanName);
			}
			this.fw.inverseZapper[this.fw.zapper[i].ZappingId] = i;
			this.fw.zapperChanrecid[this.fw.zapper[i].chanrecid] = i;
		}

		this.fw._currIndexForZapping = 0; // indice per l'oggetto zapping
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger
					.addEntry("### BaseApp.createZapperRecovery ## 1 ##  this.fw._currIndexForZapper:"
							+ this.fw._currIndexForZapper);
		this.fw._currIndexForZapper = 0; // indice per l'oggetto zapper

		var reasonCode = "zapperDefault";
		// si lancia l'evento che ci indica la fine dell'elaborazione del
		// refresh
		this.fw.getEventManager().handleEvent("eventZapperChanged", reasonCode);

		if (!forced) {
			var zapperinfo_reload_timer = this.fw.getConfig().ZAPPERINFO_RELOAD_TIMER;
			this.timer_reload = this.fw.getTimer().setTimeout(
					zapperinfo_reload_timer, this.reloadZapperInfo, this);
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'createZapperRecovery';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}

	return true;
};

BaseApp.prototype.reloadZapperInfo = function() {
	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("##################### BaseApp.reloadZapperInfo");
	try {
		if (this.timer_reload) {
			this.fw.getTimer().clearTimeout(this.timer_reload);
			this.timer_reload = null;
		}
		if (!this.fw.recoveryStatus) {
			this.fw.recoveryStatus = false;
			if (this.gestioneRetailAttiva()) {
				this.fw.getFetcher().fetchNow(
						"/ovaImages/GetChannelList_"+this.fw.regioneCanaliDefault+".html", this,
						this._gotZapperInfo);
			} else {
				this.fw.getFetcher().fetchNow("/ovaImages/zapperinfo.html",
						this, this._gotZapperInfo);
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'reloadZapperInfo';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*
 * Per esempio nel caso GetChannelDefault_Piemonte.html obj vale zapperObject definito
 * nalla pagina html stessa
 */
BaseApp.prototype._gotZapperInfo = function(obj) {
	try { /* Inizialmente qui non entra */
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("BaseApp._gotZapperInfo");
		if ((obj && obj.errorCode) || !obj || (obj && !obj.zapper)) {
			
			if (this.fw.getEPGManager()._channels == null){
				this.createZapperRecovery(true);
			
			}else{
				this.createZapperRecovery(false);
			
			}
		} else {
			// top.getFetcher().sendDebugTrap("Ci sono");
			this.fw.zapperObj = obj; // memorizzo l�oggetto dello zapper
			
			/* Inizialmente qui non entra */
			if (this.fw.getEPGManager()._channels == null) {
				this.createZapperRecovery(true);
			
			} else {
				// top.getFetcher().sendDebugTrap("Ci sono");
				/* lo zapper è definito nel relativo file html */
				omc.logger.addEntry("##### BaseApp.prototype._gotZapperInfo ## 1 ##");
				
					
				
				this.fw.zapper = this.getZapperSaved();
				if(this.fw.zapper){
					var lunghezzaZapper = this.fw.zapper.length;				
					for(z=0; z<lunghezzaZapper;z++)
						this.fw.zapper.pop();
				}					
				
				omc.logger.addEntry("##### BaseApp.prototype._gotZapperInfo ## 2 ##");
				this.fw.zapper = obj.zapper;			
			
				/* Se lo commento non carica dopo l'immagine */
				this.createZapper();
				this.setZapperSaved(this.fw.zapper);
			
			}
		}
		omc.logger.addEntry("##### BaseApp.prototype._gotZapperInfo COMPLETED!!!!!!");
	} catch (ecc) {
		omc.logger.addEntry("##### ECCEZIONE BaseApp.prototype._gotZapperInfo : "+ecc.message);
		this._objErrorInfo._methodName = '_gotZapperInfo';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*
 * Per esempio nel caso GetChannelDefault_Piemonte.html obj vale zapperObject definito
 * nalla pagina html stessa
 */
BaseApp.prototype._gotZapperPreferiti = function(obj) {
	try { /* Inizialmente qui non entra */
		/* lo zapper è definito nel relativo file html */

		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("Salvo i preferiti ...");
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("Preferiti numero : "
					+ this.fw.ListaFavoriti.length);
		this.fw.ListaFavoriti = obj.zapper;
		
	
	
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger
					.addEntry("BaseApp._gotZapperPreferiti  this.fw.ListaFavoriti:"
							+ this.fw.ListaFavoriti.length);
	} catch (ecc) {
		this._objErrorInfo._methodName = '_gotZapperPreferiti';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

BaseApp.prototype.channelDataRecovery = function() {
	try {

		// Gestisce il recovery della GetChannelData
		this.channelsRecovery = new Array();
		this.channelsRecovery[0] = {
			recid :6,
			pkgrecid :14,
			status :'ONLINE',
			number :6,
			url :'239.192.75.36:8236',
			isPremium :true,
			thumbnailURL :null,
			callLetters :'CH6',
			categoryRecid :103,
			ratingRecid :1,
			ecmInfo :null,
			chanType :'BTV',
			multilingual :false,
			stereo :true,
			macrovision :false,
			categoryForAdultOnly :false
		};
		this.channelsRecovery[1] = {
			recid :5,
			pkgrecid :14,
			status :'ONLINE',
			number :5,
			url :'239.192.75.38:8238',
			isPremium :true,
			thumbnailURL :null,
			callLetters :'CH5',
			categoryRecid :108,
			ratingRecid :2,
			ecmInfo :null,
			chanType :'BTV',
			multilingual :false,
			stereo :true,
			macrovision :false,
			categoryForAdultOnly :false
		};
		this.channelsRecovery[2] = {
			recid :147,
			pkgrecid :14,
			status :'ONLINE',
			number :23,
			url :'239.192.75.75:8290',
			isPremium :true,
			thumbnailURL :null,
			callLetters :'SPORTITALIA1',
			categoryRecid :1,
			ratingRecid :1,
			ecmInfo :null,
			chanType :'BTV',
			multilingual :true,
			stereo :true,
			macrovision :true,
			categoryForAdultOnly :false
		};
		this.channelsRecovery[3] = {
			recid :169,
			pkgrecid :14,
			status :'ONLINE',
			number :43,
			url :'239.192.75.87:8287',
			isPremium :true,
			thumbnailURL :null,
			callLetters :'SPORTITALIA2',
			categoryRecid :1,
			ratingRecid :1,
			ecmInfo :null,
			chanType :'BTV',
			multilingual :false,
			stereo :true,
			macrovision :false,
			categoryForAdultOnly :false
		};
		this.channelsRecovery[4] = {
			recid :7,
			pkgrecid :14,
			status :'ONLINE',
			number :7,
			url :'239.192.75.32:8132',
			isPremium :true,
			thumbnailURL :null,
			callLetters :'CH7',
			categoryRecid :103,
			ratingRecid :1,
			ecmInfo :null,
			chanType :'BTV',
			multilingual :false,
			stereo :true,
			macrovision :false,
			categoryForAdultOnly :false
		};
		this.channelsRecovery[5] = {
			recid :8,
			pkgrecid :14,
			status :'ONLINE',
			number :8,
			url :'239.192.75.34:8134',
			isPremium :true,
			thumbnailURL :null,
			callLetters :'CH8',
			categoryRecid :103,
			ratingRecid :1,
			ecmInfo :null,
			chanType :'BTV',
			multilingual :false,
			stereo :true,
			macrovision :false,
			categoryForAdultOnly :false
		};
		this.channelsRecovery[6] = {
			recid :154,
			pkgrecid :14,
			status :'ONLINE',
			number :29,
			url :'239.192.75.70:8270',
			isPremium :true,
			thumbnailURL :null,
			callLetters :'MTV2',
			categoryRecid :147,
			ratingRecid :3,
			ecmInfo :null,
			chanType :'BTV',
			multilingual :false,
			stereo :true,
			macrovision :false,
			categoryForAdultOnly :false
		};
		this.channelsRecovery[7] = {
			recid :153,
			pkgrecid :14,
			status :'ONLINE',
			number :28,
			url :'239.192.75.69:8269',
			isPremium :true,
			thumbnailURL :null,
			callLetters :'MTV_BASE',
			categoryRecid :147,
			ratingRecid :1,
			ecmInfo :null,
			chanType :'BTV',
			multilingual :false,
			stereo :true,
			macrovision :false,
			categoryForAdultOnly :false
		};
		this.channelsRecovery[8] = {
			recid :179,
			pkgrecid :14,
			status :'ONLINE',
			number :49,
			url :'239.192.75.73:8273',
			isPremium :true,
			thumbnailURL :null,
			callLetters :'MTV_VH1',
			categoryRecid :190,
			ratingRecid :1,
			ecmInfo :null,
			chanType :'BTV',
			multilingual :true,
			stereo :true,
			macrovision :true,
			categoryForAdultOnly :false
		};
		this.channelsRecovery[9] = {
			recid :180,
			pkgrecid :14,
			status :'ONLINE',
			number :50,
			url :'239.192.75.74:8274',
			isPremium :true,
			thumbnailURL :null,
			callLetters :'MTV_VH1_CLASSIC',
			categoryRecid :193,
			ratingRecid :3,
			ecmInfo :null,
			chanType :'BTV',
			multilingual :true,
			stereo :true,
			macrovision :true,
			categoryForAdultOnly :false
		};

		this.fw.getEPGManager()._channels = this.channelsRecovery;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'channeDataRecovery';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}

};

/*******************************************************************************
 * FUNCTION : ripristinaSottotitoli_Audio PARAMETER : zapElement DESCRIPTION :
 * il metodo serve a ripristinare l'audio e i sottotitoli ai valori di default
 * solo se zapElement � un canale sky
 ******************************************************************************/
BaseApp.prototype.ripristinaSottotitoli_Audio = function(zapElement) {
	try {
		// se il canale che sto lasciando � un canale sky
		if (this.chanTypeZapper(zapElement).toLowerCase() == "sky") {
			// se l'audio non � in italiano lo ripristino in italiano
			if (this.linguaggio_audio != "Italiano") {
				this.settaLinguaAudio("Italiano");
			}
			// se i sottotitoli sono attivi li disattivo
			if (this._settaSottotitoliFlag == true) {
				this.settaSottotitoli(false);
			}
			this.enableLinguaSub = "N";
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "ripristinaSottotitoli_Audio";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

/*******************************************************************************
 * FUNCTION : settaSottotitoli PARAMETER : 1) attiva - true o false, indica se i
 * sottotitoli vanno attivati o meno DESCRIPTION : metodo che attiva o disattiva
 * i sottotitoli a video
 ******************************************************************************/
BaseApp.prototype.settaSottotitoli = function(attiva) {
	try {
		// attivo i sottotitoli solo se questi sono disponibili
		if (this.enableLinguaSub == "Y" && attiva == true) {
			flag_sottotitoli = true;
		} else { // in tutti gli altri casi li disattivo
			flag_sottotitoli = false;
		}
		this._settaSottotitoliFlag = flag_sottotitoli;
		if (!this.fw.getOSD().isPC())
			this._videoControl.setSubtitlesEnabled(flag_sottotitoli);
	} catch (ecc) {
		this._objErrorInfo._methodName = 'settaSottotitoli';
		this._settaSottotitoliFlag = false;
	}
	return true;
};

/*******************************************************************************
 * FUNCTION : settaLinguaAudio PARAMETER : 1) lingua_audio - "Italiano" o
 * un'altra stringa qualsiasi per indicare "Altra lingua" DESCRIPTION : metodo
 * che setta la lingua dell'audio in "Italiano" o "Altra lingua"
 ******************************************************************************/
BaseApp.prototype.settaLinguaAudio = function(lingua_audio) {
	try {
		if (lingua_audio == null || lingua_audio == undefined) {
			lingua_audio = "Italiano"; // valore di default
		}
		// l'attributo linguaggio_audio tiene traccia della lingua audio attuale
		this.linguaggio_audio = lingua_audio;

		audioPID = 256;
		if (lingua_audio && lingua_audio != "Italiano") {
			audioPID = 257;
		}

		if (this.currentAudioPID && this.currentAudioPID != audioPID) {
			if (!this.fw.getOSD().isPC()) // non sul browserino
				this._videoControl = this.fw.getVideoControl();
			this._videoControl.setAudioPID(audioPID); // settaggio api lingua
			this.currentAudioPID = audioPID; // PID lingua attualmente attivo
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'settaLinguaAudio';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*******************************************************************************
 * FUNCTION : chanTypeZapper PARAMETER : 1) zapElement - un elemento dello
 * zapper DESCRIPTION : metodo che individua il tipo del canale dello zapElement
 * in particolare identifica i canali sky
 ******************************************************************************/
BaseApp.prototype.chanTypeZapper = function(zapElement) {
	try {
		if (zapElement.chantype != null && zapElement.skyType != null) {
			chanType = zapElement.chantype.toLowerCase();
			// distinguo i canali sky in base alla voce skyType dello zapperinfo
			if (zapElement.skyType.length != 0) {
				chanType = "sky";
			}
		} else {
			chanType = "dvbt"; // sono i dtt locali
		}
		return chanType; // i tipi dvbt e dtt sono restituiti direttamente
							// dallo zapperElement
	} catch (ecc) {
		this._objErrorInfo._methodName = 'chanTypeZapper';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

BaseApp.prototype.trapJoin = function() {
	try {
		this.fw.LoggerApp.debugLog("PRIMA DI FARE LOGGGGGGGG");
		// effettuare il controllo se inviare trap di ppv o multicast
		var slot;
		var BTVtuner;
		try {
			if (this._item && this._item.abbonamento) {
				slot = this.getProgramSlot3(this.canale_schedulato);
			} else {
				BTVtuner = this.fw.getBTVTuner().getCurrentChannel();
				slot = this.getProgramSlot3(BTVtuner.recid);
			}
		} catch (exx) {
			slot = null;
		}
		if (slot && slot.program && slot.program.type
				&& slot.program.type == "PPV" && !this.isSky(BTVtuner)) {
			this.fw.LoggerApp.join_ppvLog();
		} else {
			this.fw.LoggerApp.join_multicastLog();
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'trapJoin';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

BaseApp.prototype.trapLeave = function() {
	try {
		// effettuare il controllo se inviare trap di ppv o multicast
		var slot;
		var BTVtuner;
		try {
			if (this._item && this._item.abbonamento) {
				slot = this.getProgramSlot3(this.canale_schedulato);
			} else {
				BTVtuner = this.fw.getBTVTuner().getCurrentChannel();
				slot = this.getProgramSlot3(BTVtuner.recid);
			}
		} catch (exx) {
			slot = null;
		}

		if (slot && slot.program && slot.program.type
				&& slot.program.type == "PPV" && !this.isSky(BTVtuner)) {
			this.fw.LoggerApp.leave_ppvLog();
		} else {
			this.fw.LoggerApp.leave_multicastLog();
		}

	} catch (ecc) {
		this._objErrorInfo._methodName = 'trapLeave';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

// funzione che permette l'autocompletamento dell canale digitato se non �
// completo
BaseApp.prototype.completeDigit = function() {
	try {

		var index = parseInt(this.fw.ZappingString.indexOf("|"
				+ this.changePage));
		if (index != -1) {
			this.changePage = this.fw.ZappingString.substring(index + 1,
					index + 4);
		}

	} catch (ecc) {
		objErrorInfo._methodName = "completeDigit";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

BaseApp.prototype.abilitaEventKeyPower = function() {
	try {
		this.altStandBy = true;

	} catch (ecc) {
		this._objErrorInfo._methodName = "abilitaEventKeyPower";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return true;
	}

};

/*******************************************************************************
 * FUNCTION : isPPVSkyVisible PARAMETER : 1) program - programma da ricercare 2)
 * chanIndex - indice del canale nella matrice di zapping OUTPUT : visible -
 * boolean che indica se il programma � visibile dall'utente DESCRIPTION :
 * metodo che verifica se un determinato programma � visibile o meno dall'utente
 * attuale.
 ******************************************************************************/
BaseApp.prototype.isPPVSkyVisible = function(program, chanIndex) {
	try {
		var visible = false;
		var trovato = false;
		var validLabel = false;
		if (program) {
			if ((!program.episode)
					|| (program.episode && program.episode.length <= 0)) {
				if (chanIndex >= 0) {
					visible = true; // se non specifico alcuna label allora �
									// visibile, se in consistenza
				}
			} else if (this.fw.userLabel && this.fw.userLabel.length > 0) {
				var listaEpisode = new Array();
				listaEpisode = program.episode.split(";");
				for ( var j = 0; j < listaEpisode.length && trovato == false; j++) {
					for ( var i = 0; i < this.fw.userLabel.length
							&& trovato == false; i++) {
						if (this.fw.userLabel[i].label == listaEpisode[j]) {
							visible = true;
							trovato = true;
						}
					}
				}
				// se il programma non ha ne la label SKYGA ne la label SKYSPO �
				// visibile
				if ((visible == false) && (chanIndex >= 0)) {
					for ( var z = 0; z < listaEpisode.length
							&& validLabel == false; z++) {
						if ((listaEpisode[z].toUpperCase() == "SKYGA")
								|| (listaEpisode[z].toUpperCase() == "SKYSPO")) {
							validLabel = true;
						}
					}
					if (validLabel == false) {
						visible = true;
					}
				}
			}
		} else { // program con label null
			if (chanIndex >= 0) {
				visible = true; // se label nulla allora � visibile, se in
								// consistenza
			}
		}
		return visible;
	} catch (ecc) {
		this._objErrorInfo._methodName = "isPPVSkyVisible";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*******************************************************************************
 * FUNCTION : getPacketNamePPVSky PARAMETER : 1) label - label sky da ricercare
 * OUTPUT : packetName - String DESCRIPTION : metodo che ritorna il primo tra i
 * pacchetti sky associati alla label che gli viene passata in input
 ******************************************************************************/
BaseApp.prototype.getPacketNamePPVSky = function(label) {
	try {
		var packetName = "";
		var trovato = false;

		if (this.fw.labelMap && this.fw.labelMap.length > 0 && label) {
			var listaEpisode = new Array();
			listaEpisode = label.split(";");
			for ( var j = 0; j < listaEpisode.length && trovato == false; j++) {
				if ((listaEpisode[j].toLowerCase() == "skyspo")
						|| (listaEpisode[j].toLowerCase() == "skyga")) {
					for ( var i = 0; i < this.fw.labelMap.length
							&& trovato == false; i++) {
						if (this.fw.labelMap[i].tiSubsType.toLowerCase() == listaEpisode[j]
								.toLowerCase()) {
							packetName = this.fw.labelMap[i].packageName;
							trovato = true;
						}
					}
				}
			}
		}
		return packetName;
	} catch (ecc) {
		this._objErrorInfo._methodName = "getPacketNamePPVSky";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*******************************************************************************
 * FUNCTION : caricaZapperInfoDefault PARAMETER : 1) forceFetcher - boolean
 * DESCRIPTION : metodo che invoca il fetcher retrieveSubsByAccountFetcher, in
 * ogni caso se forceFetcher � true, altrimenti solo se sono stati aggiornati i
 * pacchetti dell'utente
 ******************************************************************************/
/* Di default riceve true, quindi forceFetcher=true */
BaseApp.prototype.caricaZapperInfoDefault = function(forceFetcher) {
	try {
		if(this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("BaseApp.caricaZapperInfoDefault");
		var nomeFile="";
		
		if(
				(this.fw.ORDINAMENTO_CANALI_FATTO) &&
				(this.fw.VERSIONE_MOD_CANALI ==2 || this.fw.VERSIONE_MOD_CANALI ==3)
				
		)
			nomeFile="GetChannelList_Pers.html";
		else{
			nomeFile="GetChannelList_"+this.fw.regioneCanaliDefault+".html";
		}
		if(this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("BaseApp.caricaZapperInfoDefault :"+"file://"+this.fw.TILAB_ROOT+this.fw.URL_HTML + nomeFile);
		this.fw.getFetcher().fetchNow(
				"file://"+this.fw.TILAB_ROOT+this.fw.URL_HTML + nomeFile, this,
				this._gotZapperInfo);
	} catch (ecc) {
		omc.logger.addEntry(" ECCEZIONE BaseApp.caricaZapperInfoDefault ecc: "+ecc.message);
		this._objErrorInfo._methodName = "caricaZapperInfoDefault";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/* Di default riceve true, quindi forceFetcher=true */
BaseApp.prototype.caricaZapperInfoPreferiti = function() {
	try {
		if(this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("BaseApp.caricaZapperInfoPreferiti :"+"file://"+this.fw.TILAB_ROOT+this.fw.URL_HTML + "GetChannelPreferiti.html");
		this.fw.getFetcher().fetchNow("file://"+this.fw.TILAB_ROOT+this.fw.URL_HTML + "GetChannelPreferiti.html", this,this._gotZapperPreferiti);
		
	} catch (ecc) {
		omc.logger.addEntry(" ECCEZIONE BaseApp.caricaZapperInfoDefault ecc: "+ecc.message);
		this._objErrorInfo._methodName = "caricaZapperInfoPreferiti";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*******************************************************************************
 * FUNCTION : costruisciMsgPopupSky PARAMETER : nomeCanale - String con il nome
 * del canale attuale nomePacchetto - String con il nome del pacchetto sky
 * corrispondente alla programmazione attuale OUTPUT : msgOut - String con il
 * messaggio di cortesia DESCRIPTION : metodo che costruisce una stringa con il
 * messaggio dinamico della popup sky per le subscription
 ******************************************************************************/
BaseApp.prototype.costruisciMsgPopupSky = function(nomeCanale, nomePacchetto) {
	try {
		var msgOut = "";
		if (!nomeCanale) {
			nomeCanale = "SKY";
		}
		if (!nomePacchetto) {
			nomePacchetto = "Pacchetto SKY";
		}
		if (this.fw.isSkyRetailUser == true) {
			// utente sky retail e gestione sky retail attivata
			msgOut = "Gentile Cliente, stiamo trasmettendo un evento del<br>&quot;"
					+ nomePacchetto
					+ "&quot; sul canale &quot;"
					+ nomeCanale
					+ "&quot;.<br>"
					+ "Per visualizzare questo evento ti invitiamo a sottoscrivere<br>"
					+ "il relativo Pacchetto chiamando il Servizio Clienti SKY<br>"
					+ "al numero 199.168.166*";
		} else { // utente wholesale o gestione sky retail disattivata
			msgOut = "Gentile Cliente, stiamo trasmettendo un evento del<br>&quot;"
					+ nomePacchetto
					+ "&quot; sul canale &quot;"
					+ nomeCanale
					+ "&quot;.<br>"
					+ "Per visualizzare questo evento ti invitiamo a sottoscrivere<br>"
					+ "il relativo Pacchetto chiamando il Servizio Clienti Alice home TV<br>"
					+ "al numero verde 800.187.800";
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "costruisciMsgPopupSky";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return msgOut;
};

/*******************************************************************************
 * FUNCTION : findNextZappingId DESCRIPTION : metodo che posiziona lo zappingId
 * al canale in consistenza pi� vicino (in avanti) allo zapperId attuale
 ******************************************************************************/
BaseApp.prototype.findNextZappingId = function(direction) {
	try {

		if (this.fw.zapper && this.fw._currIndexForZapper
				&& this.fw.zappingArray) {
			var zappingIdAttuale = this.fw.zapper[this.fw._currIndexForZapper].ZappingId;
			var trovato = false;
			for (i = 0; i < this.fw.zappingArray.length && trovato == false; i++) {
				if (this.fw.zappingArray[i].ZappingId > zappingIdAttuale) {
					this.fw._currIndexForZapping = i;
					trovato = true;
				}
			}
			if (trovato == false) {
				// ho scorso tutto l'array fino alla fine, mi posiziono sul
				// primo
				this.fw._currIndexForZapping = 0;
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "findNextZappingId";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*******************************************************************************
 * FUNCTION : findPrevZappingId DESCRIPTION : metodo che posiziona lo zappingId
 * al canale in consistenza pi� vicino (all'indietro) allo zapperId attuale
 ******************************************************************************/
BaseApp.prototype.findPrevZappingId = function(direction) {
	try {
		if (this.fw.zapper && this.fw._currIndexForZapper
				&& this.fw.zappingArray) {
			var zappingIdAttuale = this.fw.zapper[this.fw._currIndexForZapper].ZappingId;
			var trovato = false;
			for (i = (this.fw.zappingArray.length - 1); i >= 0
					&& trovato == false; i--) {
				if (this.fw.zappingArray[i].ZappingId < zappingIdAttuale) {
					this.fw._currIndexForZapping = i;
					trovato = true;
				}
			}
			if (trovato == false) {
				// ho scorso tutto l'array fino all'inizio, mi posiziono
				// sull'ultimo
				this.fw._currIndexForZapping = (this.fw.zappingArray.length - 1);
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "findPrevZappingId";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*******************************************************************************
 * METHOD: isSky PARAMETER: canaleAttuale - oggetto di tipo channel OUTPUT:
 * isCanaleSky - boolean DESCRIPTION: Questo metodo riconosce se l'oggetto
 * channel che gli si passa � sky o meno (si appoggia a chanTypeZapper e
 * funziona con il pkgrecid)
 ******************************************************************************/
BaseApp.prototype.isSky = function(canaleAttuale) {
	try {
		var isCanaleSky = false;
		if (canaleAttuale && canaleAttuale.recid) {
			var localZapperIndice = this
					.getZapperIdByChanrecid(canaleAttuale.recid);
			if (localZapperIndice != null) {
				var localZapperElement = this
						.getZapperElement(localZapperIndice);
				if (localZapperElement && localZapperElement.skyType != null
						&& localZapperElement.skyType != '') {
					isCanaleSky = true;
				}
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "isSky";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return isCanaleSky;
};

/*******************************************************************************
 * METHOD: refreshSkyUser PARAMETER: objUser DESCRIPTION: Questo metodo
 * distingue se il cliente � un utente SKY Retail o meno impostando di
 * conseguenza la variabile di framework
 ******************************************************************************/
// BaseApp.prototype.refreshSkyUser=function(objUser,diventaSky){
// try{
// // this.fw.isSkyRetailUser=false; //valore di default o in caso di errore
// // /* Non dovrebbe entrare perchè nel file html non è definito niente per
// data */
// // if(objUser && objUser.content && objUser.content[0] &&
// objUser.content[0].isSkyUser == 'Y'){
// // this.fw.isSkyRetailUser=true;
// // }
// /* Non entra inizialmente */
// // else if (diventaSky == true)
// // {
// // this.fw.isSkyRetailUser=true;
// // this.forceFetcher_start=true;
// // }
// /* Inizialmente entra qui */
// // if (this.forceFetcher_start==true && !this.fw.recoveryStatus){ //allo
// startup o quando viene dato Zopska, carico lo zapperinfo corretto
// /* Inizialmente ritorna true ed entra qui */
// // if (this.gestioneRetailAttiva()){
// this.fw.getFetcher().fetchNow("/ovaImages/zapperinfo_skyretail.html",this,
// this._gotZapperInfo);
// // }else{
// // this.fw.getFetcher().fetchNow("/ovaImages/zapperinfo.html",this,
// this._gotZapperInfo);
// // }
// // }
// }catch(ecc){
// this._objErrorInfo._methodName = "refreshSkyUser";
// this._objErrorInfo._obException = ecc;
// this.handleError();
// }
// return true;
// };
/*******************************************************************************
 * METHOD: gestioneRetailAttiva PARAMETER: - DESCRIPTION: Questo metodo ritorna
 * se � attivata o meno la gestione Sky Retail (boolean)
 ******************************************************************************/
BaseApp.prototype.gestioneRetailAttiva = function() {
	try { /* Da index.html si ha SKY_RETAIL_ENABLE: 'Y' */
		if (this.fw.isSkyRetailUser == true
				|| this.fw.getConfig().SKY_RETAIL_ENABLE == "Y")
			return true;
		else
			return false;
	} catch (ecc) {
		this._objErrorInfo._methodName = "gestioneRetailAttiva";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return false;
};

BaseApp.prototype._selectEvent = function(item) {
	try {
		// var mpos=this._getCurrMenuPos();
		// this.fw.lastmposMenuVert=this.getFirstLevelIndex();

		if (item.rat_recid != null) {
			this._rating = item.rat_recid;
		}
		this.category_name = item.category_name;
		var category_temp = item.category_name.split("-");
		this.category = category_temp[0].toLowerCase();
		if (category_temp.length > 1) {
			this.subcategory = category_temp[1].toLowerCase();
		} else {
			this.subcategory = category_temp[0].toLowerCase();
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "_selectEvent";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

/*******************************************************************************
 * METHOD: getHomeTvAppUrl PARAMETER: DESCRIPTION: Questo metodo restituisce
 * l'url della applicazione home
 ******************************************************************************/
BaseApp.prototype.getHomeUrl = function() {
	try {
		var url = "/ovaServices/getapp/HomeTvApp.html";
		return url;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'getHomeUrl';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*******************************************************************************
 * METHOD: userWithSkyZopska PARAMETER: - DESCRIPTION: Questo metodo ritorna se
 * l'utente � non sky retail e gli � stato dato il pacchetto Sky Zopska
 * (funziona con il pkgrecid)
 ******************************************************************************/
BaseApp.prototype.userWithSkyZopska = function(obj) {
	try {
		var trovato = false;
		/* da index.html PKG_RECID_ZOPSKA = 52 */
		var pkgRecidSkyZopska = this.fw.getConfig().PKG_RECID_ZOPSKA; // valore
																		// da
																		// esercizio
																		// 08/10/2007
		/* trovato rimane false */
		if (this.fw.userPackages && this.fw.isSkyRetailUser != true) {
			for ( var i = 0; i < this.fw.userPackages.length && !trovato; i++) {
				if (this.fw.userPackages[i] == pkgRecidSkyZopska) {
					trovato = true;
				}
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'userWithSkyZopska';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return trovato;
};

/*******************************************************************************
 * METHOD: getNextMenuDown PARAMETER: - DESCRIPTION: Questo metodo permette di
 * visualizzare il nodo successivo dell'albero descrittore del menu.
 ******************************************************************************/
BaseApp.prototype.getNextMenuDown = function() {
	try {
		// Aggiorno l'indice del men� verticale
		this.fw.verticalMenuIndex++;
		// ricavo il parentId corretto il problema si pone al primo accesso
		var parentId = this.fw.myIndex;
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger
				.addEntry("BaseApp.getNextMenuDown ----------------------------------------------------------");
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("parentId " + parentId);
		// if( this.fw.menuArray[this.fw.myIndex] &&
		// this.fw.menuArray[this.fw.myIndex].menuParent == -1 )
		// parentId = this.fw.menuArray[this.fw.myIndex].menuChilds[0];
		// controlla la consistenza dell'indice ricavato
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("parentId " + parentId);
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("this.fw.verticalMenuIndex: "
				+ this.fw.verticalMenuIndex);
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("this.fw.menuArray[parentId]: "
				+ this.fw.menuArray[parentId]);
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("this.fw.menuArray[parentId].menuChilds.length: "
				+ this.fw.menuArray[parentId].menuChilds.length);
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger
				.addEntry("----------------------------------------------------------");
		if (this.fw.menuArray[parentId]
				&& this.fw.verticalMenuIndex >= this.fw.menuArray[parentId].menuChilds.length)
			this.fw.verticalMenuIndex = 0;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'getNextMenuDown';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*******************************************************************************
 * METHOD: getNextMenuUp PARAMETER: - DESCRIPTION: Questo metodo permette di
 * visualizzare il nodo precedente dell'albero descrittore del menu.
 ******************************************************************************/
BaseApp.prototype.getNextMenuUp = function() {
	try {
		// Aggiorno l'indice del men� verticale
		this.fw.verticalMenuIndex--;
		// ricavo il parentId corretto il problema si pone al primo accesso
		var nodeId = this.fw.myIndex;

		// if( this.fw.menuArray[this.fw.myIndex] &&
		// this.fw.menuArray[this.fw.myIndex].menuParent == -1 )
		// nodeId = this.fw.menuArray[this.fw.myIndex].menuChilds[0];

		// controlla la consistenza dell'indice ricavato
		if (this.fw.menuArray[nodeId] && this.fw.verticalMenuIndex < 0)
			this.fw.verticalMenuIndex = this.fw.menuArray[nodeId].menuChilds.length - 1;

	} catch (ecc) {
		this._objErrorInfo._methodName = 'getNextMenuUp';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*******************************************************************************
 * METHOD: getPreviousMenuLevel PARAMETER: - DESCRIPTION: Questo metodo permette
 * di visualizzare il livello superiore dell'albero descrittore del menu.
 ******************************************************************************/
BaseApp.prototype.getPreviousMenuLevel = function() {
	try {
		// this.fw.verticalMenuIndex = 0;
		var previousLevelIndex = 0;
		// se sono al primo livello primo elemento devo aggiornare l'indice in
		// modo da farlo puntare al primo elemento figlio
		if (this.fw.menuArray[this.fw.myIndex])
			previousLevelIndex = this.fw.menuArray[this.fw.myIndex].menuParent;
		if (previousLevelIndex == -1)
			previousLevelIndex = 0;
		return previousLevelIndex;
	} catch (ecc) {
		this._objErrorInfo._methodName = 'getPreviousMenuLevel';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*******************************************************************************
 * METHOD: getNextMenuLevel PARAMETER: - DESCRIPTION: Questo metodo permette di
 * visualizzare il livello inferiore dell'albero descrittore del menu.
 ******************************************************************************/
BaseApp.prototype.getNextMenuLevel = function() {
	try {
		// se sono al primo livello primo elemento devo aggiornare l'indice in
		// modo da farlo puntare al primo elemento figlio
		if (this.fw.menuArray[this.fw.myIndex]) {
			if (this.fw.myIndex == 0)
				this.fw.myIndex = this.fw.menuArray[this.fw.myIndex].menuChilds[this.fw.myIndex];
			this.fw.menuArray[this.fw.myIndex].lastChildIndexSelected = this.fw.verticalMenuIndex;
			var nextMenuLevel = this.fw.menuArray[this.fw.myIndex].menuChilds[this.fw.verticalMenuIndex];
			if (nextMenuLevel != null && nextMenuLevel != undefined) {
				this.fw.myIndex = nextMenuLevel;
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'getNextMenuLevel';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

BaseApp.prototype.getChannelTypeString = function(  ){
	try{
		var stringaTipoCanale="";
		switch(this.fw.ShowPreferiti){
		case 0:
			stringaTipoCanale = "Tutti Canali";
			break;
		case 1:
			stringaTipoCanale = "canali Preferiti";
			break		
		}
		return stringaTipoCanale;
	}catch(e){
		omc.logger.addEntry("### ECCEZIONE BAspeApp.getChannelTypeString :"+e.message);
		return "";
		
	}
};

BaseApp.prototype.salvaFileBootHTML = function(  ){
	var prefissoHTML="<html><head><meta http-equiv='cache-control'content='no-cache, must-revalidate, max-age=0'>" +
	"<title>Boot.html</title><script language=\"javascript\">" +
	"var bootObject = {data: {\n";
	var suffissoHTML="},expiration: 1,errorCode: null};top.getFetcher().eventFetchCompleted(bootObject);" +
	"</script></head><body></body></html>";
	var dataBOOT = "firstTime: false,\n"+
					"ordinamentoCanali:"+this.fw.ORDINAMENTO_CANALI_FATTO+",\n"+
					"cgiHasFinished:"+this.fw.cgiHasFinished+",\n"+
					"preferitiON:"+this.fw.ShowPreferiti+"\n";			
	//*********************************************************************************************************************
	try{
		omc.logger.addEntry("############# salvaFileBootHTML file:"+this.fw.URL_HTML + "Boot.html"+" dati: "+dataBOOT);		
		navigator.writeFile(prefissoHTML+dataBOOT+suffissoHTML,this.fw.URL_HTML + "Boot.html");
		this.fw.firstTimeBootBox = false;
	
	}catch(e){
		omc.logger.addEntry("############################# FRESCO SENZA JSEXT NAVIGATOR:writeFile()#############");
		//this.fw.TILAB_ROOT = "/mnt/thttpd/tilab_root/";
		
	}
};

BaseApp.prototype.isAggiornaPrefDopoScansione = function(){
	var trovati  = 0;
	var numeroPreferiti = this.fw.ListaFavoriti.length;
	try{
		for (i = 0; i < numeroPreferiti; i++) {
			var nomePref = this.fw.ListaFavoriti[i].ChanName
			for( d =0 ; d < this.fw.zapper.length;d++){
				if(nomePref ==  this.fw.zapper[d].ChanName){
					trovati = trovati +1;
					break;
				}
			}			
		}		
		if(trovati == numeroPreferiti ){
			omc.logger.addEntry(" #######  BaseApp.isAggiornaPrefDopoScansione NON AGGIORNO");
			return false;
		}else{
			omc.logger.addEntry(" #######  BaseApp.isAggiornaPrefDopoScansione EFFETTUO AGGIORNAMENTO");
			return true;
		}
	}catch(e){
		omc.logger.addEntry(" ####### ECCEZIONE BaseApp.isAggiornaPrefDopoScansione : "+e.message);
		return false;
	}
	
}

BaseApp.prototype.aggiornaPrefDopoScansione = function(){
	try{
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("############################## BaseApp.aggiornaPrefDopoScansione preferiti PRIMA dell'aggiornamento " + this.fw.ListaFavoriti.length);
		
		//svuoto arrau appoggio globale
		var lunghezzaArrayAppoggio =  this.fw.arrayTempFavScansione.length;				
		for (i = 0; i <lunghezzaArrayAppoggio; i++) {
			this.fw.arrayTempFavScansione.pop();						
		}
	
	//	var z = 0;
		//Popolo favoriti con gli elementi buoni dopo la scansione
		for (i = 0; i < this.fw.ListaFavoriti.length; i++) {
			//CONTROLLO
			//var chanreicidPref = this.fw.ListaFavoriti[i].chanrecid;
				var nomePref = this.fw.ListaFavoriti[i].ChanName
				for( d =0 ; d < this.fw.zapper.length;d++){				
//					if ( chanreicidPref== this.fw.zapper[d].chanrecid) {
//						this.fw.arrayTempFavScansione.push(this.fw.ListaFavoriti[i]);					
//					}
					if(nomePref ==  this.fw.zapper[d].ChanName){
						this.fw.ListaFavoriti[i].chanrecid = this.fw.zapper[d].chanrecid;
						this.fw.arrayTempFavScansione.push(this.fw.ListaFavoriti[i]);	
					}
				}			
		}		

		//Svuoto la lista favoriti
		var lunghezzaArrayTemp =  this.fw.ListaFavoriti.length;				
		for (i = 0; i <lunghezzaArrayTemp; i++) {
			this.fw.ListaFavoriti.pop();						
		}
		
		//copio in favoriti gli elementi di appoggio
		lunghezzaArrayAppoggio =  this.fw.arrayTempFavScansione.length;				
		for (i = 0; i <lunghezzaArrayAppoggio; i++) {
			this.fw.ListaFavoriti.push(this.fw.arrayTempFavScansione[i]);						
		}
		
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("############################## BaseApp.aggiornaPrefDopoScansione preferiti DOPO dell'aggiornamento " + this.fw.ListaFavoriti.length);
	
		
		var prefissoHTML = "<html>"
			+ "<head>"
			+ "<meta http-equiv='cache-control' content='no-cache, must-revalidate, max-age=0'>"
			+ "<title>GetChannelPreferiti.html</title>"
			+ "<script language=\"javascript\">"
			+ "var time_ini = new Date();"
			+ "var zapperObject = { data: {zapper: [";
		var suffissoHTML = "]},expiration: 1,errorCode: null};" + "\n"
			+ "zapperObject.data.time_in = time_ini.getTime();" + "\n"
			+ "var time1 = new Date();" + "\n"
			+ "zapperObject.data.time_out = time1.getTime();" + "\n"
			+ "top.getFetcher().eventFetchCompleted(zapperObject);" + "\n"
			+ "</script></head><body></body></html>";
		var stringaCanaliPreferiti = this.costruisciStringaHTMLPreferiti();
		if(stringaCanaliPreferiti !=""){
			this.fw.cgiHasFinished = false;
			this.salvaFileBootHTML();
		}
		navigator.writeFile(prefissoHTML + stringaCanaliPreferiti
				+ suffissoHTML, this.fw.URL_HTML
				+ "GetChannelPreferiti.html");
		if(stringaCanaliPreferiti !=""){
			this.creaImmaginiZapperPreferiti();
		}
	}catch(e){
		omc.logger.addEntry("ECCEZIONE BaseApp.aggiornaPrefDopoScansione :"+e.message);
	}
};
BaseApp.prototype.costruisciStringaHTMLPreferiti = function() {
	var stringa = "";
	try {

		for (p = 0; p < this.fw.ListaFavoriti.length; p++) {
			stringa += "{\n";
			stringa += "chantype:\'" + this.fw.ListaFavoriti[p].chantype
					+ "\',\n";
			// stringa +=
			// "ZappingId:\'"+this.fw.ListaFavoriti[p].ZappingId+"\'\n";
			stringa += "ZappingId:\'" + (p + 1) + "\',\n";
			var nomeCanalePreferiti = this.fw.ListaFavoriti[p].ChanName;
			if(nomeCanalePreferiti.length > 25)
				nomeCanalePreferiti = nomeCanalePreferiti.substring(0,25);
				
			stringa += "ChanName:\'" + nomeCanalePreferiti
					+ "\',\n";
			stringa += "pkgrecid:\'" + this.fw.ListaFavoriti[p].pkgrecid
					+ "\',\n";
			stringa += "chanrecid:\'" + this.fw.ListaFavoriti[p].chanrecid
					+ "\',\n";
			stringa += "skyType:\'" + this.fw.ListaFavoriti[p].skyType
					+ "\',\n";
			stringa += "adultFlag:\'" + this.fw.ListaFavoriti[p].adultFlag
					+ "\',\n";
			stringa += "},\n";
		}
		// if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("#########
		// PreferitiApp.costruisciStringaHTMLPreferiti ---- stringa:"+stringa);

	} catch (ecc) {
		omc.logger.addEntry("ECCEZIONE BaseApp.costruisciStringaHTMLPreferiti :"+ecc.message);
		this._objErrorInfo._methodName = "costruisciStringaHTMLPreferiti";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return stringa;
};